/*
Copyright (c) 2010, Geomatics and Cartographic Research Centre, 
Carleton University, Canada
All rights reserved.

Released under New BSD License.
Details at:
   https://svn.gcrc.carleton.ca/nunaliit2/trunk/sdk/license.txt
   
$Id: license.txt 8178 2012-06-04 20:46:29Z jpfiset $   
*/

;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};function httpJsonError(XMLHttpRequest,defaultStr){if(!JSON||typeof(JSON.parse)!=='function'){return defaultStr;};var text=XMLHttpRequest.responseText;if(!text)return defaultStr;var error=JSON.parse(text);if(!error)return defaultStr;if(!error.reason)return defaultStr;return error.reason;};function fixUserName(userName){return userName.toLowerCase().replace(' ','');};function compareSessionContexts(s1,s2){if(s1===s2){return true;};if(!s1){return false;};if(!s2){return false;};if(s1.name!==s2.name){return false;};var s1Roles={};if(s1.roles){for(var i=0,e=s1.roles.length;i<e;++i){var role=s1.roles[i];s1Roles[role]=true;};};var s2Roles={};if(s2.roles){for(var i=0,e=s2.roles.length;i<e;++i){var role=s2.roles[i];s2Roles[role]=true;};};for(var role in s1Roles){if(!s2Roles[role]){return false;};};for(var role in s2Roles){if(!s1Roles[role]){return false;};};return true;};var Session=$n2.Class({server:null,pathToSession:null,changedContextListeners:null,lastSessionContext:null,initialize:function(server_,sessionInfo_){this.server=server_;this.changedContextListeners=[];this.lastSessionContext=null;if(sessionInfo_){if(sessionInfo_.ok){var context=sessionInfo_.userCtx;this.changeContext(context);};};},getUrl:function(){return this.server.getSessionUrl();},getContext:function(){return this.lastSessionContext;},addChangedContextListener:function(listener){if(typeof(listener)==='function'){this.changedContextListeners.push(listener);if(this.lastSessionContext){listener(this.lastSessionContext);};};},changeContext:function(context){this.lastSessionContext=context;if(this.lastSessionContext){for(var i=0,e=this.changedContextListeners.length;i<e;++i){var listener=this.changedContextListeners[i];try{listener(this.lastSessionContext);}catch(e){};};};},refreshContext:function(opts_){var opts=$.extend({onSuccess:function(context){},onError:$n2.reportErrorForced},opts_);var _this=this;var sessionUrl=this.getUrl();$.ajax({url:sessionUrl,type:'get',async:true,dataType:'json',success:function(res){if(res.ok){var context=res.userCtx;_this.changeContext(context);opts.onSuccess(context);}else{opts.onError('Malformed context reported');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining context: '+errStr);}});},login:function(opts_){var opts=$.extend({name:null,password:null,onSuccess:function(context){},onError:$n2.reportErrorForced},opts_);var _this=this;var sessionUrl=this.getUrl();if(opts.name){var name=fixUserName(opts.name);}else{opts.onError('A name must be supplied when logging in');return;};$.ajax({url:sessionUrl,type:'post',async:true,data:{name:name,password:opts.password},contentType:'application/x-www-form-urlencoded',dataType:'json',success:function(info){if(info&&info.ok){_this.refreshContext({onSuccess:opts.onSuccess,onError:opts.onError});}else{opts.onError('Unknown error during log in');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during log in: '+errStr);}});},logout:function(opts_){var opts=$.extend({onSuccess:function(context){},onError:$n2.reportErrorForced},opts_);var _this=this;var sessionUrl=this.getUrl();$.ajax({url:sessionUrl,type:'DELETE',async:true,dataType:'json',success:function(info){if(info&&info.ok){_this.refreshContext({onSuccess:opts.onSuccess,onError:opts.onError});}else{opts.onError('Unknown error during log out');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during log out: '+errStr);}});}});var designDoc=$n2.Class({ddUrl:null,ddName:null,initialize:function(opts_){var opts=$n2.extend({ddUrl:null,ddName:null,db:null},opts_);this.ddUrl=opts.ddUrl;this.ddName=opts.ddName;this.db=opts.db;},getQueryUrl:function(opts_){var opts=$.extend(true,{viewName:null,listName:null},opts_);if(opts.listName){return this.ddUrl+'_list/'+opts.listName+'/'+opts.viewName;}else{return this.ddUrl+'_view/'+opts.viewName;};},queryView:function(options_){var opts=$.extend(true,{viewName:null,listName:null,viewUrl:null,startkey:null,endkey:null,keys:null,group:null,include_docs:null,limit:null,onlyRows:true,rawResponse:false,reduce:false,onSuccess:function(rows){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to query a view');};var viewUrl=opts.viewUrl;if(!viewUrl){if(opts.listName){viewUrl=this.ddUrl+'_list/'+opts.listName+'/'+opts.viewName;}else{viewUrl=this.ddUrl+'_view/'+opts.viewName;};};var mustBePost=false;var queryCount=0;var query={};var data={};for(var k in opts){if(k==='viewName'||k==='listName'||k==='viewUrl'||k==='onlyRows'||k==='rawResponse'||k==='onSuccess'||k==='onError'||typeof(opts[k])==='undefined'||opts[k]===null){}else if(k==='keys'){mustBePost=true;data[k]=opts[k];}else{++queryCount;query[k]=JSON.stringify(opts[k]);};};var dataType='json';if(opts.rawResponse){dataType='text';};if(mustBePost){var jsonData=JSON.stringify(data);var effectiveUrl=viewUrl;if(queryCount>0){var params=$.param(query);effectiveUrl=viewUrl+'?'+params;};$.ajax({url:effectiveUrl,type:'POST',async:true,data:jsonData,contentType:'application/json',dataType:dataType,success:processResponse,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during view query '+opts.viewName+': '+errStr);}});}else{$.ajax({url:viewUrl,type:'GET',async:true,cache:false,data:query,dataType:dataType,success:processResponse,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during view query '+opts.viewName+': '+errStr);}});};function processResponse(queryResponse){if(opts.onlyRows){if(queryResponse.rows){opts.onSuccess(queryResponse.rows);}else{opts.onError('Unexpected response during view query '+opts.view);};}else{opts.onSuccess(queryResponse);};};}});var ChangeNotifier=$n2.Class({options:null,db:null,listeners:null,lastSequence:null,currentRequest:null,currentWait:null,onError:function(err){$n2.log(err);},initialize:function(db,opts_){this.options=$n2.extend({changeUrl:null,doNotReset:false,include_docs:false,pollInterval:5000,longPoll:false,timeout:20000,style:'all_docs',listeners:null,onSuccess:function(notifier){}},opts_);this.db=db;this.listeners=[];if(this.options.listeners){for(var i=0,e=this.options.listeners.length;i<e;++i){this.listeners.push(this.options.listeners[i]);};delete this.options.listeners;};var onSuccessFn=this.options.onSuccess;delete this.options.onSuccess;var _this=this;if(this.options.doNotReset){finishInitialization();}else{this.resetLastSequence({onSuccess:finishInitialization,onError:finishInitialization});};function finishInitialization(){_this.reschedule();_this.requestChanges();onSuccessFn(_this);};},addListener:function(listener){if(typeof(listener)==='function'){this.listeners.push(listener);this.requestChanges();};},resetLastSequence:function(opt_){var opt=$n2.extend({onSuccess:function(){},onError:function(err){}},opt_);var _this=this;this.db.getInfo({onSuccess:function(dbInfo){_this.lastSequence=dbInfo.update_seq;opt.onSuccess();},onError:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opt.onError('Error during a query of current update sequence: '+errStr);}});},getLastSequence:function(){return this.lastSequence;},_reportChanges:function(changes){if(changes.last_seq){this.lastSequence=changes.last_seq;};if(changes.results&&changes.results.length>0){for(var i=0,e=this.listeners.length;i<e;++i){this.listeners[i](changes);};};},requestChanges:function(){if(!this.listeners||this.listeners.length<1){return;};if(this.currentRequest){return;};if(this.currentWait){return;};var req={feed:'normal',style:this.options.style};if(typeof(this.lastSequence)==='number'){req.since=this.lastSequence;};if(this.options.include_docs){req.include_docs=this.options.include_docs;};if(this.options.longPoll){req.feed='longpoll';req.timeout=this.options.timeout;};this.currentRequest=req;var _this=this;$.ajax({url:this.options.changeUrl,type:'GET',async:true,data:req,dataType:'json',success:function(changes){_this.currentRequest=null;_this._reportChanges(changes);_this.reschedule();},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);_this.onError('Error during a server notifications: '+errStr);_this.reschedule();}});},reschedule:function(){var now=$n2.utils.getCurrentTime();var expected=now+this.options.pollInterval;if(this.currentWait){if(this.currentWait.expected>expected){if(typeof(clearTimeout)==='function'){clearTimeout(this.currentWait.timerId);}
this.currentWait=null;}else{return;};};this.currentWait={delayInMs:this.options.pollInterval,expected:expected};var _this=this;this.currentWait.timerId=setTimeout(function(){_this.currentWait=null;_this.requestChanges();},this.currentWait.delayInMs);}});var DatabaseCallbacks=$n2.Class({onCreatedCallbacks:null,onUpdatedCallbacks:null,onDeletedCallbacks:null,initialize:function(){this.onCreatedCallbacks=[];this.onUpdatedCallbacks=[];this.onDeletedCallbacks=[];},addOnCreatedCallback:function(f){if(typeof(f)==='function'){this.onCreatedCallbacks.push(f);}},addOnUpdatedCallback:function(f){if(typeof(f)==='function'){this.onUpdatedCallbacks.push(f);}},addOnDeletedCallback:function(f){if(typeof(f)==='function'){this.onDeletedCallbacks.push(f);}},_reportOnCreated:function(docInfo){for(var i=0,e=this.onCreatedCallbacks.length;i<e;++i){var f=this.onCreatedCallbacks[i];f(docInfo);};},_reportOnUpdated:function(docInfo){for(var i=0,e=this.onCreatedCallbacks.length;i<e;++i){var f=this.onUpdatedCallbacks[i];f(docInfo);};},_reportOnDeleted:function(docInfo){for(var i=0,e=this.onDeletedCallbacks.length;i<e;++i){var f=this.onUpdatedCallbacks[i];f(docInfo);};}});var Database=$n2.Class({dbUrl:null,dbName:null,server:null,callbacks:null,initialize:function(opts_,server_){var opts=$n2.extend({dbUrl:null,dbName:null},opts_);this.server=server_;this.dbUrl=opts.dbUrl;this.dbName=opts.dbName;if(!this.dbUrl){var pathToServer=server_.getPathToServer();this.dbUrl=pathToServer+this.dbName+'/';};this.callbacks=new DatabaseCallbacks();},getUrl:function(){return this.dbUrl;},getDesignDoc:function(opts_){var ddOpts=$.extend({ddUrl:null,ddName:null},opts_);if(!ddOpts.ddUrl){ddOpts.ddUrl=this.dbUrl+'_design/'+ddOpts.ddName+'/';};ddOpts.db=this;return new designDoc(ddOpts);},getChangeNotifier:function(opt_){var opt=$n2.extend({onSuccess:function(notifier){}},opt_);var changeNotifier=new ChangeNotifier(this,{changeUrl:this.dbUrl+'_changes',onSuccess:opt.onSuccess});return changeNotifier;},getChanges:function(opt_){var opt=$n2.extend({since:null,limit:null,descending:false,include_docs:false,onSuccess:function(changes){},onError:function(msg){$n2.reportErrorForced(msg);}},opt_);var req={feed:'normal'};if(opt.since){req.since=opt.since;};if(opt.limit){req.limit=opt.limit;};if(opt.descending){req.descending=opt.descending;};if(opt.include_docs){req.include_docs=opt.include_docs;};var changeUrl=this.dbUrl+'_changes';$.ajax({url:changeUrl,type:'GET',async:true,data:req,dataType:'json',success:opt.onSuccess,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining database changes: '+errStr);}});},getDocumentUrl:function(doc){if(typeof(doc)==='string'){var docId=doc;}else{docId=doc._id;};return this.dbUrl+docId;},getAttachmentUrl:function(doc,attName){var docUrl=this.getDocumentUrl(doc);var url=docUrl+'/'+encodeURIComponent(attName);return url;},getDocumentRevision:function(opts_){var opts=$.extend({docId:null,onSuccess:function(info){},onError:function(msg){$n2.reportErrorForced(msg);}},opts_);if(!opts.docId){opts.onError('No docId set. Can not retrieve document information');return;};$.ajax({url:this.dbUrl+'_all_docs',type:'get',async:true,data:{startkey:'"'+opts.docId+'"',endkey:'"'+opts.docId+'"',include_docs:false},dataType:'json',success:function(res){if(res.rows&&res.rows[0]&&res.rows[0].value&&res.rows[0].value.rev){opts.onSuccess(res.rows[0].value.rev);}else{opts.onError('Malformed document revision for: '+opts.docId);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining document revision for '+opts.docId+': '+errStr);}});},getDocumentRevisions:function(opts_){var opts=$.extend({docIds:null,onSuccess:function(info){},onError:function(msg){$n2.reportErrorForced(msg);}},opts_);if(!opts.docIds){opts.onError('No docIds set. Can not retrieve document revisions');return;};if(!$n2.isArray(opts.docIds)){opts.onError('docIds must ba an array. Can not retrieve document revisions');return;};var data={keys:opts.docIds};$.ajax({url:this.dbUrl+'_all_docs?include_docs=false',type:'POST',async:true,data:JSON.stringify(data),contentType:'application/json',dataType:'json',success:function(res){if(res.rows){var info={};for(var i=0,e=res.rows.length;i<e;++i){var row=res.rows[i];if(row.id&&row.value&&row.value.rev){if(!row.value.deleted){info[row.id]=row.value.rev;};};};opts.onSuccess(info);}else{opts.onError('Malformed document revisions');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining document revision for '+opts.docId+': '+errStr);}});},buildUploadFileForm:function(jQuerySet,options_){var _this=this;var opts=$.extend({docId:null,rev:null,doc:null,onSuccess:function(res){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);jQuerySet.empty();if(!$.fn.ajaxSubmit){opts.onError('Can not perform file uploads unless jquery.form.js is included');};if(null==opts.docId){if(opts.doc)opts.docId=opts.doc._id;};if(null==opts.docId){opts.onError('Must specify document id when performing file uploads');};if(null==opts.rev){if(opts.doc)opts.rev=opts.doc._rev;};if(null==opts.rev){this.getDocumentRevision({docId:opts.docId,onSuccess:function(docRev){jQuerySet.each(function(i,elem){installForm(elem,opts.docId,docRev);});},onError:opts.onError});}else{jQuerySet.each(function(i,elem){installForm(elem,opts.docId,opts.rev);});};function installForm(elem,docId,docRev){var $elem=$(elem),$form=$('<form method="post"></form>'),$button=$('<input class="n2CouchInputButton" type="button"/>');$form.append($('<input class="n2CouchInputFile" type="file" name="_attachments"/>'));$form.append($('<input type="hidden" name="_rev" value="'+docRev+'"/>'));$button.val(_loc('Upload'));$form.append($button);$elem.append($form);$button.click(function(){$form.ajaxSubmit({type:'post',url:_this.dbUrl+docId,dataType:'json',success:function(res){$elem.find('*').removeAttr('disabled');if(res.error){opts.onError(_loc('Error while uploading: ')+res.error,options_);}else{opts.onSuccess(res,options_);}},error:function(xhr,status,err){$elem.find('*').removeAttr('disabled');opts.onError(_loc('Error while uploading: ')+err,options_);}});$elem.find('.n2CouchInputButton').attr('disabled','disabled');});};},createDocument:function(options_){var opts=$.extend(true,{data:{},onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to create database documents');};var _s=this;var docId=opts.data._id;if(docId){onUuid(docId);}else{this.server.getUniqueId({onSuccess:onUuid,onError:opts.onError});};function onUuid(docId){$.ajax({url:_s.dbUrl+docId,type:'put',async:true,data:JSON.stringify(opts.data),contentType:'application/json',dataType:'json',success:function(docInfo){_s.callbacks._reportOnCreated(docInfo);opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error creating document: '+errStr);}});};},updateDocument:function(options_){var opts=$.extend(true,{data:null,onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to update database documents');return;};if(!opts.data||!opts.data._id||!opts.data._rev){opts.onError('On update, a valid document with _id and _rev attributes must be supplied');return;};var _s=this;$.ajax({url:_s.dbUrl+opts.data._id,type:'PUT',async:true,data:JSON.stringify(opts.data),contentType:'application/json',dataType:'json',success:function(docInfo){_s.callbacks._reportOnUpdated(docInfo);opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error updating document: '+errStr);}});},deleteDocument:function(options_){var opts=$.extend(true,{data:null,onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to delete database documents');return;};if(!opts.data||!opts.data._id||!opts.data._rev){opts.onError('On delete, a valid document with _id and _rev attributes must be supplied');return;};var _s=this;$.ajax({url:_s.dbUrl+opts.data._id+'?rev='+opts.data._rev,type:'DELETE',async:true,dataType:'json',success:function(docInfo){_s.callbacks._reportOnDeleted(docInfo);opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error deleting document: '+errStr);}});},bulkDocuments:function(documents,options_){var opts=$.extend(true,{onSuccess:function(docInfos){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to create database documents');};var data=JSON.stringify({docs:documents});var _s=this;$.ajax({url:_s.dbUrl+'_bulk_docs',type:'POST',async:true,data:data,contentType:'application/json',dataType:'json',success:function(docInfos){opts.onSuccess(docInfos);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error on bulk document operation: '+errStr);}});},getDocument:function(options_){var opts=$.extend(true,{docId:null,rev:null,revs_info:false,revisions:false,conflicts:false,deleted_conflicts:false,onSuccess:function(doc){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(!opts.docId){opts.onError('No docId set. Can not retrieve document');};var data={};if(opts.rev){data.rev=opts.rev;};if(opts.revs_info){data.revs_info='true';};if(opts.revisions){data.revs='true';};if(opts.conflicts){data.conflicts='true';};if(opts.deleted_conflicts){data.deleted_conflicts='true';};var url=this.dbUrl+opts.docId+'/';$.ajax({url:url,type:'get',async:true,data:data,dataType:'json',success:function(res){opts.onSuccess(res);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining document content for '+opts.docId+': '+errStr);}});},getDocuments:function(opts_){var opts=$.extend(true,{docIds:null,onSuccess:function(docs){},onError:function(errorMsg){$n2.log(errorMsg);}},opts_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to query multiple documents');return;};if(!opts.docIds){opts.onError('No docIds set. Can not retrieve documents');return;};var viewUrl=this.dbUrl+'_all_docs?include_docs=true';var data={keys:opts.docIds};$.ajax({url:viewUrl,type:'POST',async:true,data:JSON.stringify(data),contentType:'application/json',dataType:'json',success:function(queryResult){if(queryResult.rows){var docs=[];for(var i=0,e=queryResult.rows.length;i<e;++i){var row=queryResult.rows[i];if(row&&row.doc){docs.push(row.doc);}};opts.onSuccess(docs);}else{opts.onError('Unexpected response during query of multiple documents');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during query of multiple documents: '+errStr);}});},listAllDocuments:function(opts_){var opts=$.extend(true,{onSuccess:function(docIds){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var viewUrl=this.dbUrl+'_all_docs?include_docs=false';$.ajax({url:viewUrl,type:'GET',async:true,dataType:'json',success:function(queryResult){if(queryResult.rows){var docIds=[];for(var i=0,e=queryResult.rows.length;i<e;++i){var row=queryResult.rows[i];if(row&&row.id){docIds.push(row.id);}};opts.onSuccess(docIds);}else{opts.onError('Unexpected response during listing of all documents');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during listing of all documents: '+errStr);}});},getAllDocuments:function(opts_){var opts=$.extend(true,{onSuccess:function(docs){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var viewUrl=this.dbUrl+'_all_docs?include_docs=true';$.ajax({url:viewUrl,type:'GET',async:true,dataType:'json',success:function(queryResult){if(queryResult.rows){var docs=[];for(var i=0,e=queryResult.rows.length;i<e;++i){var row=queryResult.rows[i];if(row&&row.doc){docs.push(row.doc);}};opts.onSuccess(docs);}else{opts.onError('Unexpected response during retrieval of all documents');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during retrieval of all documents: '+errStr);}});},getInfo:function(opts_){var opts=$.extend(true,{onSuccess:function(dbInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);$.ajax({url:this.dbUrl,type:'GET',async:true,dataType:'json',success:function(dbInfo){if(dbInfo.error){opts.onError(dbInfo.error);}else{opts.onSuccess(dbInfo);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during databse infro: '+errStr);}});},queryTemporaryView:function(opts_){var opts=$n2.extend({map:null,reduce:null,onSuccess:function(rows){},onError:$n2.reportErrorForced},opts_);if(!opts.map){opts.onError('"map" must be provided in temporary view');};var data={map:opts.map};if(opts.reduce){data.reduce=opts.reduce;};var viewUrl=this.dbUrl+'_temp_view';$.ajax({url:viewUrl,type:'post',async:true,dataType:'json',data:JSON.stringify(data),contentType:'application/json',success:function(queryResult){if(queryResult.rows){opts.onSuccess(queryResult.rows);}else{opts.onError('Unexpected response during query of temporary view');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during query temporary view: '+errStr);}});}});var UserDb=$n2.Class(Database,{initialize:function(server_,dbName_){if(!dbName_){dbName='_users';};Database.prototype.initialize.call(this,{dbName:dbName_},server_);},createUser:function(opts_){var opts=$.extend({name:null,password:null,onSuccess:function(docInfo){},onError:$n2.reportErrorForced},opts_);var userDbUrl=this.getUrl();if(typeof(hex_sha1)!=='function'){opts.onError('SHA-1 must be installed');return;};if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to create database documents');return;};this.server.getUniqueId({onSuccess:onUuid});function onUuid(uuid){var id='org.couchdb.user:'+fixUserName(opts.name);var salt=uuid;var password_sha=hex_sha1(opts.password+salt);var doc={};for(var key in opts){if(key!=='name'&&key!=='password'&&key!=='onSuccess'&&key!=='onError'){doc[key]=opts[key];};};doc.type="user";doc.name=fixUserName(opts.name);doc.password_sha=password_sha;doc.salt=salt;if(!$n2.isArray(doc.roles)){doc.roles=[];};$.ajax({url:userDbUrl+id,type:'put',async:true,data:JSON.stringify(doc),contentType:'application/json',dataType:'json',success:opts.onSuccess,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during user creation: '+errStr);}});};},updateUser:function(options_){var opts=$.extend(true,{user:null,onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var userDbUrl=this.getUrl();if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to update user documents');return;};if(!opts.user||!opts.user._id){opts.onError('On update, a valid document with _id attribute must be supplied');return;};$.ajax({url:userDbUrl+opts.user._id,type:'PUT',async:true,data:JSON.stringify(opts.user),contentType:'application/json',dataType:'json',success:function(docInfo){opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error updating user: '+errStr);}});},setUserPassword:function(options_){var opts=$.extend(true,{user:null,password:null,onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var userDbUrl=this.getUrl();if(typeof(hex_sha1)!=='function'){opts.onError('SHA-1 must be installed');return;};if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to set user password');return;};if(!opts.user||!opts.user._id||!opts.user._rev){opts.onError('On password change, a valid user document with _id and _rev attributes must be supplied');return;};if(!opts.password){opts.onError('On password change, a valid password must be supplied');return;};this.computeUserPassword({userDoc:opts.user,password:opts.password,onSuccess:function(userDoc){$.ajax({url:userDbUrl+opts.user._id,type:'PUT',async:true,data:JSON.stringify(userDoc),contentType:'application/json',dataType:'json',success:function(docInfo){opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error changing user password: '+errStr);}});},onError:opts.onError});},computeUserPassword:function(options_){var opts=$.extend({userDoc:null,password:null,onSuccess:function(userDoc){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(typeof(hex_sha1)!=='function'){opts.onError('SHA-1 must be installed');return;};if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to set user password');return;};if(!opts.userDoc){opts.onError('On setting password, a user document must be provided');return;};if(!opts.password){opts.onError('On setting change, a valid password must be supplied');return;};this.server.getUniqueId({onSuccess:onUuid});function onUuid(uuid){var salt=uuid;var password_sha=hex_sha1(opts.password+salt);if(opts.userDoc.password)delete opts.userDoc.password;if(opts.userDoc.password_scheme)delete opts.userDoc.password_scheme;if(opts.userDoc.iterations)delete opts.userDoc.iterations;if(opts.userDoc.derived_key)delete opts.userDoc.derived_key;if(opts.userDoc.salt)delete opts.userDoc.salt;if(opts.userDoc.password_sha)delete opts.userDoc.password_sha;opts.userDoc.password_sha=password_sha;opts.userDoc.salt=salt;opts.onSuccess(opts.userDoc);};},deleteUser:function(opts_){var opts=$.extend({user:null,id:null,rev:null,name:null,onSuccess:function(docInfo){},onError:$n2.reportErrorForced},opts_);var userDbUrl=this.getUrl();var id=null;var rev=null;if(opts.user){id=opts.user._id;rev=opts.user._rev;}
if(!id&&opts.id){id=opts.id;}
if(!id&&opts.name){id='org.couchdb.user:'+fixUserName(opts.name);}
if(!rev&&opts.rev){rev=opts.rev;}
$.ajax({url:userDbUrl+id+'?rev='+rev,type:'DELETE',async:true,dataType:'json',success:opts.onSuccess,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during user deletion: '+errStr);}});},getUser:function(options_){var opts=$.extend(true,{name:null,id:null,onSuccess:function(user){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var userDbUrl=this.getUrl();var id=opts.id;if(!id){id='org.couchdb.user:'+fixUserName(opts.name);};$.ajax({url:userDbUrl+id,type:'get',async:true,dataType:'json',success:function(userDoc){opts.onSuccess(userDoc);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError(_loc('Error obtaining user document for {id}: {err}',{id:id,err:errStr}));}});},getUsers:function(options_){var opts=$.extend(true,{names:null,ids:null,onSuccess:function(users){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var _this=this;var effectiveUrl=this.getUrl()+'_all_docs?include_docs=true';var ids=null;if(opts.ids&&opts.ids.length){ids=opts.ids.slice(0);}else{ids=[];};if(opts.names&&opts.names.length){for(var i=0,e=opts.names.length;i<e;++i){ids.push('org.couchdb.user:'+fixUserName(opts.names[i]));};};if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to query multiple users');return;};var data={keys:ids};var users=[];var missingIds={};$.ajax({url:effectiveUrl,type:'POST',async:true,data:JSON.stringify(data),contentType:'application/json',dataType:'json',success:function(res){if(res.rows){var isMissing=false;for(var i=0,e=res.rows.length;i<e;++i){var row=res.rows[i];if(row&&row.doc){if(row.doc._id){users.push(row.doc);}else{isMissing=true;missingIds[row.id]=true;retrieveUser(row.id);};}};if(!isMissing){opts.onSuccess(users);};}else{opts.onError('Unexpected response during query of multiple users');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during query of multiple users: '+errStr);}});function retrieveUser(userId){_this.getUser({id:userId,onSuccess:function(user){if(user._id){users.push(user);};delete missingIds[userId];returnUsers();},onError:function(errorMsg){delete missingIds[userId];returnUsers();}});};function returnUsers(){for(var id in missingIds){return id;};opts.onSuccess(users);};},getAllUsers:function(opts_){var opts=$.extend({onSuccess:function(users){},onError:$n2.reportErrorForced},opts_);var _this=this;if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to query a view');return;};var viewUrl=this.getUrl()+'_all_docs';var data={startkey:JSON.stringify('org.couchdb.user:'),endkey:JSON.stringify('org.couchdb.user='),include_docs:true};var users=[];var missingIds={};$.ajax({url:viewUrl,type:'get',async:true,data:data,dataType:'json',success:function(queryResult){if(queryResult.rows){var isMissing=false;for(var i=0,e=queryResult.rows.length;i<e;++i){var row=queryResult.rows[i];if(row&&row.doc){if(row.doc._id){users.push(row.doc);}else{isMissing=true;missingIds[row.id]=true;retrieveUser(row.id);};}};if(!isMissing){opts.onSuccess(users);};}else{opts.onError('Unexpected response during query of all users');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during query of all users: '+errStr);}});function retrieveUser(userId){_this.getUser({id:userId,onSuccess:function(user){if(user._id){users.push(user);};delete missingIds[userId];returnUsers();},onError:function(errorMsg){delete missingIds[userId];returnUsers();}});};function returnUsers(){for(var id in missingIds){return id;};opts.onSuccess(users);};}});var Server=$n2.Class({options:null,isInitialized:false,uuids:null,userDbName:null,userDb:null,session:null,initListeners:null,initialize:function(options_,initListeners_){this.options=$n2.extend({pathToServer:'../',pathToSession:null,pathToUserDb:null,pathToUuids:null,pathToReplicate:null,pathToActiveTasks:null,pathToAllDbs:null,version:null,skipSessionInitialization:false,userDbName:null,onSuccess:function(server){},onError:function(err){}},options_);this.isInitialized=false;this.uuids=[];this.userDbName=this.options.userDbName;this.userDb=null;this.session=null;this.initListeners=initListeners_;if(!this.initListeners){this.initListeners=[];};var _this=this;getServerVersion();function getServerVersion(){if(_this.options.version){refreshContext();}else{$.ajax({url:_this.options.pathToServer,type:'get',async:true,dataType:'json',success:function(res){if(res.version){_this.options.version=res.version;getUserDbName();}else{errorInitialize('Malformed database welcome message.');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);errorInitialize('Error obtaining database welcome: '+errStr);}});};};function getUserDbName(){if(null!=_this.userDbName){refreshContext(null);}else{var sessionUrl=_this.getSessionUrl();$.ajax({url:sessionUrl,type:'get',async:true,dataType:'json',success:function(res){if(res.ok){if(res&&res.info&&res.info.authentication_db){_this.userDbName=res.info.authentication_db;};refreshContext(res);}else{errorInitialize('Malformed session information message.');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);errorInitialize('Error obtaining session information: '+errStr);}});};}
function refreshContext(sessionInfo){if(_this.options.skipSessionInitialization){finishInitialize();}else{_this.getSession().refreshContext({onSuccess:finishInitialize,onError:errorInitialize});};};function finishInitialize(){_this.isInitialized=true;for(var i=0,e=_this.initListeners;i<e;++i){var listener=_this.initListeners[i];try{listener();}catch(e){}};_this.initListeners=[];_this.options.onSuccess(_this);delete _this.options['onSuccess'];delete _this.options['onError'];};function errorInitialize(err){_this.options.onError(err);delete _this.options['onSuccess'];delete _this.options['onError'];};},getPathToServer:function(){return this.options.pathToServer;},getVersion:function(){return this.options.version;},getReplicateUrl:function(){if(null==this.options.pathToReplicate){return this.options.pathToServer+'_replicate';}
return this.options.pathToReplicate;},getActiveTasksUrl:function(){if(null==this.options.pathToActiveTasks){return this.options.pathToServer+'_active_tasks';}
return this.options.pathToActiveTasks;},getSessionUrl:function(){var result=this.options.pathToSession;if(!result){result=this.options.pathToServer+'_session';};return result;},getUniqueId:function(options_){var opts=$.extend({onSuccess:function(uuid){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var _this=this;if(this.uuids.length>0){var uuid=this.uuids.pop();opts.onSuccess(uuid);return;};var pathUUids=this.options.pathToUuids;if(!pathUUids){pathUUids=this.options.pathToServer+'_uuids';};$.ajax({url:pathUUids,type:'get',async:true,data:{count:10},dataType:'json',success:function(res){if(res.uuids){for(var i=0,e=res.uuids.length;i<e;++i){var uuid=res.uuids[i];_this.uuids.push(uuid);};var uuid=_this.uuids.pop();opts.onSuccess(uuid);return;}
opts.onError('Malformed uuids from database.');},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining new uuids from database: '+errStr);}});},listDatabases:function(options_){var opts=$.extend({onSuccess:function(dbNameArray){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var pathToAllDbs=this.options.pathToAllDbs;if(!pathToAllDbs){pathToAllDbs=this.options.pathToServer+'_all_dbs';};$.ajax({url:pathToAllDbs,type:'get',async:true,dataType:'json',success:opts.onSuccess,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining list of databases: '+errStr);}});},getUserDb:function(){if(!this.userDb){this.userDb=new UserDb(this,this.userDbName);};return this.userDb;},getSession:function(sessionInfo){if(!this.session){this.session=new Session(this,sessionInfo);};return this.session;},getDb:function(opts){return new Database(opts,this);},createDb:function(opts_){var opts=$n2.extend({dbName:null,onSuccess:function(db){},onError:$n2.reportErrorForced},opts_);if(!opts.dbName){opts.onError('"dbName" must be provided when creating a database');return;};var dbUrl=this.getPathToServer()+opts.dbName;var _s=this;$.ajax({url:dbUrl,type:'put',async:true,dataType:'json',success:function(creationInfo){if(creationInfo.ok){var db=_s.getDb({dbUrl:dbUrl});opts.onSuccess(db);}else{opts.onError('Error occurred when creating database: '+creationInfo.error);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error creating database: '+errStr);}});},deleteDb:function(opts_){var opts=$n2.extend({dbName:null,onSuccess:function(){},onError:$n2.reportErrorForced},opts_);if(!opts.dbName){opts.onError('"dbName" must be provided when deleting a database');return;};var dbUrl=this.getPathToServer()+opts.dbName;var _s=this;$.ajax({url:dbUrl,type:'DELETE',async:true,dataType:'json',success:function(info){if(info.ok){opts.onSuccess();}else{opts.onError('Error occurred when deleting database: '+info.error);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error deleting database: '+errStr);}});},replicate:function(opts_){var opts=$n2.extend({source:null,target:null,filter:null,docIds:null,continuous:false,onSuccess:function(db){},onError:$n2.reportErrorForced},opts_);if(!opts.source){opts.onError('"source" must be provided for replication');return;};if(!opts.target){opts.onError('"target" must be provided for replication');return;};var request={source:opts.source,target:opts.target};if(opts.filter){request.filter=opts.filter;};if(opts.continuous){request.continuous=true;};if(opts.docIds){request.doc_ids=opts.docIds;};var serverPath=this.getReplicateUrl();$.ajax({url:serverPath,type:'POST',async:true,data:JSON.stringify(request),contentType:'application/json',dataType:'json',success:function(res){if(res.ok){opts.onSuccess();}else{opts.onError('Error while initiating replication: '+res.error);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error initiating replication: '+errStr);}});},addInitializedListener:function(listener){if(typeof(listener)==='function'){if(this.isInitialized){try{listener();}catch(e){}}else{this.initListeners.push(listener);};};}});function addAttachmentToDocument(opts_){var opts=$n2.extend({doc:null,data:null,attachmentName:null,contentType:'application/binary'},opts_);if(!opts.doc||!opts.data||!opts.attachmentName){return'Invalid parameters';};if(typeof($n2.Base64)=='undefined'){return'Base64 not included';};if(!opts.doc._attachments){opts.doc._attachments={};};opts.doc._attachments[opts.attachmentName]={};opts.doc._attachments[opts.attachmentName].content_type=opts.contentType;opts.doc._attachments[opts.attachmentName].data=$n2.Base64.encode(opts.data);return null;};$n2.couch=$.extend({},{getServer:function(opt_){return new Server(opt_);},DefaultServer:null,defaultInitializeListeners:[],getPathToServer:function(){return $n2.couch.DefaultServer.getPathToServer();},addInitializedListener:function(listener){if($n2.couch.DefaultServer){$n2.couch.DefaultServer.addInitializedListener(listener);}else{if(typeof(listener)==='function'){$n2.couch.defaultInitializeListeners.push(listener);};};},initialize:function(opts_){$n2.couch.DefaultServer=new Server(opts_,$n2.couch.defaultInitializeListeners);},getVersion:function(){return $n2.couch.DefaultServer.getVersion();},getSession:function(){return $n2.couch.DefaultServer.getSession();},getUserDb:function(){return $n2.couch.DefaultServer.getUserDb();},getReplicateUrl:function(){return $n2.couch.DefaultServer.getReplicateUrl();},getActiveTasksUrl:function(){return $n2.couch.DefaultServer.getActiveTasksUrl();},getDb:function(opts){return $n2.couch.DefaultServer.getDb(opts);},getUniqueId:function(options_){$n2.couch.DefaultServer.getUniqueId();},addAttachmentToDocument:addAttachmentToDocument,compareSessionContexts:compareSessionContexts});$.fn.couchUploadFile=function(opts){var db=$n2.couch.getDb(opts);db.buildUploadFileForm(this,opts);return this;};})(jQuery,nunaliit2);var n2utils={isArray:function(o){if(null===o)return false;if(typeof(o)!=='object')return false;if(typeof(o.length)!=='number')return false;if(typeof(o.push)!=='function')return false;if(typeof(o.pop)!=='function')return false;if(typeof(o.concat)!=='function')return false;if(typeof(o.join)!=='function')return false;if(typeof(o.slice)!=='function')return false;if(typeof(o.reverse)!=='function')return false;if(typeof(o.splice)!=='function')return false;if(typeof(o.sort)!=='function')return false;return true;},isArrayOfStrings:function(o){if(!n2utils.isArray(o))return false;for(var i=0,e=o.length;i<e;++i){if(typeof o[i]!=='string')return false;};return true;},isValidBounds:function(b){if(false==n2utils.isArray(b))return false;if(b.length!=4)return false;var minx=b[0],miny=b[1],maxx=b[2],maxy=b[3];if(typeof(minx)!=='number')return false;if(typeof(miny)!=='number')return false;if(typeof(maxx)!=='number')return false;if(typeof(maxy)!=='number')return false;return true;},isValidGeom:function(o){if(typeof(o)!=='object')return false;if(typeof(o.nunaliit_type)!=='string')return false;if(typeof(o.wkt)!=='string')return false;if(o.nunaliit_type!=='geometry')return false;if(o.bbox){if(false==n2utils.isValidBounds(o.bbox))return false;}else{return false;};return true;},geomSize:function(o){if(typeof(o)!=='object')return 0;if(typeof(o.wkt)==='string'){return o.wkt.length;};return 0;},extractLayers:function(doc){var result=null;if(doc.nunaliit_layers&&n2utils.isArray(doc.nunaliit_layers)){var layerMap={};for(var i=0,e=doc.nunaliit_layers.length;i<e;++i){var l=doc.nunaliit_layers[i];if(typeof(l)==='string'){layerMap[l]=true;};};for(var layerId in layerMap){if(!result)result=[];result.push(layerId);};};return result;},excludedSearchTerms:['a','the','of','an','and','or','by','in','to'],extractSearchTerms:function(doc,indexing){var strings=[];n2utils.extractStrings(doc,strings,null,n2utils.excludedSearchAttributes);var map={};for(var i=0,e=strings.length;i<e;++i){n2utils.extractWordsFromString(strings[i],map,indexing);};return map;},excludedSearchAttributes:['_id','_rev','nunaliit_geom'],reWordSplit:/[\x00-\x26\x28-\x2f\x3a-\x40\x5b-\x5e\x60\x7b-\x7f]+/,addWordToMap:function(word,index,map){var word=word.toLowerCase();word=n2utils.removeApostrophe(word);if(word&&word!==''){if(map[word]){map[word].count++;if(index<map[word].index){map[word].index=index;};}else{var folded=n2utils.foldWord(word);map[word]={index:index,count:1,folded:folded};};};},extractWordsFromString:function(str,map,indexing){var words=str.split(n2utils.reWordSplit);for(var i=0,e=words.length;i<e;++i){n2utils.addWordToMap(words[i],i,map);if(indexing){var fragments=words[i].split('_');if(fragments.length>1){for(var j=0,k=fragments.length;j<k;++j){if(fragments[j].length>0){n2utils.addWordToMap(fragments[j],i,map);};};};};};},extractStrings:function(obj,strings,currentPath,excludedPaths){for(var i=0,e=excludedPaths.length;i<e;++i){if(excludedPaths[i]===currentPath)return;};if(null===obj){}else if(typeof(obj)==='string'){strings.push(obj);}else if(n2utils.isArray(obj)){for(var i=0,e=obj.length;i<e;++i){var p=currentPath?currentPath+'.'+i:''+i;n2utils.extractStrings(obj[i],strings,p,excludedPaths);};}else if(typeof(obj)==='object'){for(var key in obj){var p=currentPath?currentPath+'.'+key:''+key;n2utils.extractStrings(obj[key],strings,p,excludedPaths);};};},foldedChars:{0x60:0x27,0xc0:0x61,0xc1:0x61,0xc2:0x61,0xc3:0x61,0xc4:0x61,0xc7:0x63,0xc8:0x65,0xc9:0x65,0xca:0x65,0xcb:0x65,0xcc:0x69,0xcd:0x69,0xce:0x69,0xcf:0x69,0xd1:0x6e,0xd2:0x6f,0xd3:0x6f,0xd4:0x6f,0xd5:0x6f,0xd6:0x6f,0xd8:0x6f,0xd9:0x75,0xda:0x75,0xdb:0x75,0xdc:0x75,0xdd:0x79,0xe0:0x61,0xe1:0x61,0xe2:0x61,0xe3:0x61,0xe4:0x61,0xe7:0x63,0xe8:0x65,0xe9:0x65,0xea:0x65,0xeb:0x65,0xec:0x69,0xed:0x69,0xee:0x69,0xef:0x69,0xf1:0x6e,0xf1:0x6e,0xf2:0x6f,0xf3:0x6f,0xf4:0x6f,0xf5:0x6f,0xf6:0x6f,0xf8:0x6f,0xf9:0x75,0xfa:0x75,0xfb:0x75,0xfc:0x75,0xfd:0x79,0xff:0x79,0x0100:0x61,0x0101:0x61,0x0102:0x61,0x0103:0x61,0x0104:0x61,0x0105:0x61,0x0106:0x63,0x0107:0x63,0x0108:0x63,0x0109:0x63,0x010a:0x63,0x010b:0x63,0x010c:0x63,0x010d:0x63,0x010e:0x64,0x010f:0x64,0x0110:0x64,0x0111:0x64,0x0112:0x65,0x0113:0x65,0x0114:0x65,0x0115:0x65,0x0116:0x65,0x0117:0x65,0x0118:0x65,0x0119:0x65,0x011a:0x65,0x011b:0x65,0x011c:0x67,0x011d:0x67,0x011e:0x67,0x011f:0x67,0x0120:0x67,0x0121:0x67,0x0122:0x67,0x0123:0x67,0x0124:0x68,0x0125:0x68,0x0126:0x68,0x0127:0x68,0x0128:0x69,0x0129:0x69,0x012a:0x69,0x012b:0x69,0x012c:0x69,0x012d:0x69,0x012e:0x69,0x012f:0x69,0x0130:0x69,0x0131:0x69,0x0134:0x6a,0x0135:0x6a,0x0136:0x6b,0x0137:0x6b,0x0138:0x6b,0x0139:0x6c,0x013a:0x6c,0x013b:0x6c,0x013c:0x6c,0x013d:0x6c,0x013e:0x6c,0x013f:0x6c,0x0140:0x6c,0x0141:0x6c,0x0142:0x6c,0x0143:0x6e,0x0144:0x6e,0x0145:0x6e,0x0146:0x6e,0x0147:0x6e,0x0148:0x6e,0x0149:0x6e,0x014a:0x6e,0x014b:0x6e,0x014c:0x6f,0x014d:0x6f,0x014e:0x6f,0x014f:0x6f,0x0150:0x6f,0x0151:0x6f,0x0154:0x72,0x0155:0x72,0x0156:0x72,0x0157:0x72,0x0158:0x72,0x0159:0x72,0x015a:0x73,0x015b:0x73,0x015c:0x73,0x015d:0x73,0x015e:0x73,0x015f:0x73,0x0160:0x73,0x0161:0x73,0x0162:0x74,0x0163:0x74,0x0164:0x74,0x0165:0x74,0x0166:0x74,0x0167:0x74,0x0168:0x75,0x0169:0x75,0x016a:0x75,0x016b:0x75,0x016c:0x75,0x016d:0x75,0x016e:0x75,0x016f:0x75,0x0170:0x75,0x0171:0x75,0x0172:0x75,0x0173:0x75,0x0174:0x77,0x0175:0x77,0x0176:0x79,0x0177:0x79,0x0178:0x79,0x0179:0x7a,0x017a:0x7a,0x017b:0x7a,0x017c:0x7a,0x017d:0x7a,0x017e:0x7a,0x2018:0x27,0x2019:0x27,0x201b:0x27,0x2032:0x27,0x2035:0x27},foldWord:function(word){var r=[];word=word.toLowerCase();for(var i=0,e=word.length;i<e;++i){var c=word.charCodeAt(i);if(c===c){var s=n2utils.foldedChars[c];if(s){r.push(String.fromCharCode(s));}else{r.push(String.fromCharCode(c));};};};return r.join('');},removeApostrophe:function(word){if(word.length>1&&n2utils.isApostropheCodeChar(word.charCodeAt(0))){word=word.substr(1,word.length-1);};if(word.length>1&&n2utils.isApostropheCodeChar(word.charCodeAt(word.length-1))){word=word.substr(0,word.length-1);};if(word.length>2&&word[word.length-1]==='s'&&n2utils.isApostropheCodeChar(word.charCodeAt(word.length-2))){word=word.substr(0,word.length-2);};return word;},isApostropheCodeChar:function(code){return(code===0x27||code===0x60||code===0x2018||code===0x2019||code===0x201b||code===0x2032||code===0x2035);},extractTypes:function(obj,result){if(null===obj){}else if(n2utils.isArray(obj)){for(var i=0,e=obj.length;i<e;++i){n2utils.extractTypes(obj[i],result);};}else if(typeof(obj)==='object'){if(obj.nunaliit_type){result[obj.nunaliit_type]=1;};for(var key in obj){var value=obj[key];n2utils.extractTypes(value,result);};};},extractSpecificType:function(obj,type,result){if(null===obj){}else if(n2utils.isArray(obj)){for(var i=0,e=obj.length;i<e;++i){n2utils.extractSpecificType(obj[i],type,result);};}else if(typeof(obj)==='object'){if(obj.nunaliit_type&&obj.nunaliit_type===type){result.push(obj);}else{for(var key in obj){var value=obj[key];n2utils.extractSpecificType(value,type,result);};};};},extractLinks:function(obj,links){n2utils.extractSpecificType(obj,'reference',links);},extractGeometries:function(obj,geometries){n2utils.extractSpecificType(obj,'geometry',geometries);},getAtlasRole:function(n2Atlas,role){if(!n2Atlas){return role;}else if(typeof(n2Atlas.name)==='string'){return n2Atlas.name+'_'+role;};return role;},validateDocumentStructure:function(doc,errorFn){n2utils.validateTypes(doc,errorFn);if(doc.nunaliit_schema&&typeof doc.nunaliit_schema!=='string'){errorFn('If nunaliit_schema is specified, it must be a string');};var geometries=[];n2utils.extractGeometries(doc,geometries);for(var i=0,e=geometries.length;i<e;++i){var geometry=geometries[i];if(!n2utils.isValidGeom(geometry)){errorFn('Invalid geometry');}};if(doc.nunaliit_created){if(typeof doc.nunaliit_created!=='object'){errorFn('Field "nunaliit_created" must be an object');};if(doc.nunaliit_created.nunaliit_type!=='actionstamp'){errorFn('"nunaliit_created" must be of type "actionstamp"');};if(typeof doc.nunaliit_created.time!=='number'){errorFn('"nunaliit_created.time" must be a number');};if(doc.nunaliit_created.action!=='created'){errorFn('"nunaliit_created.action" must be a "created"');};};if(doc.nunaliit_last_updated){if(typeof doc.nunaliit_last_updated!=='object'){errorFn('Field "nunaliit_last_updated" must be an object');};if(doc.nunaliit_last_updated.nunaliit_type!=='actionstamp'){errorFn('"nunaliit_last_updated" must be of type "actionstamp"');};if(typeof doc.nunaliit_last_updated.time!=='number'){errorFn('"nunaliit_last_updated.time" must be a number');};if(doc.nunaliit_last_updated.action!=='updated'){errorFn('"nunaliit_last_updated.action" must be a "updated"');};};var actionStamps=[];n2utils.extractSpecificType(doc,'actionstamp',actionStamps);for(var i=0,e=actionStamps.length;i<e;++i){var as=actionStamps[i];if(typeof as.name!=='string'){errorFn('Action stamps must have a string field named: "name"');};if(typeof as.time!=='number'){errorFn('Action stamps must have a number field named: "time"');};};if(doc.nunaliit_layers){if(!n2utils.isArray(doc.nunaliit_layers)){errorFn('nunaliit_layers must be an array');};for(var i=0,e=doc.nunaliit_layers.length;i<e;++i){if(typeof(doc.nunaliit_layers[i])!=='string'){errorFn('nunaliit_layers must be an array of strings');};};};if('translationRequest'===doc.nunaliit_type){if(typeof doc.str!=='string'){errorFn('Translation requests must have a string "str"');}
if(typeof doc.lang!=='string'){errorFn('Translation requests must have a string "lang"');}
if(doc.trans){if(typeof doc.trans!=='string'){errorFn('Translation requests providing "trans" field must be string');}}};if(doc.nunaliit_css){if(typeof doc.nunaliit_css!=='object'){errorFn('CSS fragments must have an object structure');};if(doc.nunaliit_css.nunaliit_type!=='css'){errorFn('CSS fragments must have a type of "css"');};if(typeof(doc.nunaliit_css.name)!=='string'){errorFn('CSS fragments must have a string "name" property.');};if(typeof(doc.nunaliit_css.css)!=='undefined'&&typeof(doc.nunaliit_css.css)!=='string'){errorFn('CSS fragments must have a string "css" property.');};};if(doc.nunaliit_submission){if(typeof doc.nunaliit_submission!=='object'){errorFn('Submission documents must have an object structure');};if(typeof doc.nunaliit_submission.state!=='string'){errorFn('Submission documents must include a state');};if(typeof doc.nunaliit_submission.submitter_name!=='string'){errorFn('Submission documents must include the name of the submitter');};if(false==n2utils.isArrayOfStrings(doc.nunaliit_submission.submitter_roles)){errorFn('Submission documents must include the roles of the submitter');};if(doc.nunaliit_submission.original_reserved){if(typeof doc.nunaliit_submission.original_reserved!=='object'){errorFn('Submission documents must have an object for field "original_reserved"');};if(typeof doc.nunaliit_submission.original_reserved.id!=='string'){errorFn('Submission documents must include the original identifier');};};if(typeof doc.nunaliit_submission.original_doc!=='object'&&typeof doc.nunaliit_submission.original_doc!=='undefined'){errorFn('In a submission document, if specified, "original_doc" must be an object');};if(typeof doc.nunaliit_submission.submitted_reserved!=='object'&&typeof doc.nunaliit_submission.submitted_reserved!=='undefined'){errorFn('In a submission document, if specified, "submitted_reserved" must be an object');};if(typeof doc.nunaliit_submission.submitted_doc!=='object'&&typeof doc.nunaliit_submission.submitted_doc!=='undefined'){errorFn('In a submission document, if specified, "submitted_doc" must be an object');};if(typeof doc.nunaliit_submission.deletion!=='boolean'&&typeof doc.nunaliit_submission.deletion!=='undefined'){errorFn('In a submission document, if specified, "deletion" must be a boolean');};if(!doc.nunaliit_submission.deletion){if(!doc.nunaliit_submission.submitted_reserved){errorFn('In a submission document, if not a deletion, then "submitted_reserved" must be specified');};};if(!doc.nunaliit_submission.submitted_reserved&&!doc.nunaliit_submission.original_reserved){errorFn('In a submission document, one of "submitted_reserved" or "original_reserved" must be specified');};};if(doc.nunaliit_attachments){if(typeof doc.nunaliit_attachments!=='object'){errorFn('"nunaliit_attachments" must be an object structure');};if(doc.nunaliit_attachments.nunaliit_type!=='attachment_descriptions'){errorFn('"nunaliit_attachments" must be of type "attachment_descriptions"');};if(typeof doc.nunaliit_attachments.files!=='object'){errorFn('"nunaliit_attachments" must have an object structure named "files"');};for(var attName in doc.nunaliit_attachments.files){var att=doc.nunaliit_attachments.files[attName];if(typeof att!=='object'){errorFn('Attachment descriptors must be of type "object"');};if(att.attachmentName!==attName){errorFn('Attachment descriptors must have a duplicate name in "attachmentName"');};if(typeof att.status!=='string'){errorFn('Attachment descriptors must have a "status" string');};};};},validateTypes:function(obj,errorFn){if(null===obj){}else if(n2utils.isArray(obj)){for(var i=0,e=obj.length;i<e;++i){if(n2utils.validateTypes(obj[i],errorFn)){return true;};};}else if(typeof(obj)==='object'){if(obj.nunaliit_type){if(typeof obj.nunaliit_type!=='string'){errorFn('Fields named "nunaliit_type" must be strings');return true;};};for(var key in obj){var value=obj[key];if(n2utils.validateTypes(value,errorFn)){return true;};};};return false;}};if(typeof(exports)==='object'){exports.isArray=n2utils.isArray;exports.isArrayOfStrings=n2utils.isArrayOfStrings;exports.isValidBounds=n2utils.isValidBounds;exports.isValidGeom=n2utils.isValidGeom;exports.extractLayers=n2utils.extractLayers;exports.extractLinks=n2utils.extractLinks;exports.extractSearchTerms=n2utils.extractSearchTerms;exports.addWordToMap=n2utils.addWordToMap;exports.extractStrings=n2utils.extractStrings;exports.foldWord=n2utils.foldWord;exports.removeApostrophe=n2utils.removeApostrophe;exports.isApostropheCodeChar=n2utils.isApostropheCodeChar;exports.extractTypes=n2utils.extractTypes;exports.extractSpecificType=n2utils.extractSpecificType;exports.extractGeometries=n2utils.extractGeometries;exports.getAtlasRole=n2utils.getAtlasRole;exports.validateDocumentStructure=n2utils.validateDocumentStructure;exports.validateTypes=n2utils.validateTypes;};if(typeof(nunaliit2)==='function'){nunaliit2.couchUtils={};nunaliit2.couchUtils.isArray=n2utils.isArray;nunaliit2.couchUtils.isArrayOfStrings=n2utils.isArrayOfStrings;nunaliit2.couchUtils.isValidBounds=n2utils.isValidBounds;nunaliit2.couchUtils.isValidGeom=n2utils.isValidGeom;nunaliit2.couchUtils.extractLayers=n2utils.extractLayers;nunaliit2.couchUtils.extractLinks=n2utils.extractLinks;nunaliit2.couchUtils.extractSearchTerms=n2utils.extractSearchTerms;nunaliit2.couchUtils.addWordToMap=n2utils.addWordToMap;nunaliit2.couchUtils.extractStrings=n2utils.extractStrings;nunaliit2.couchUtils.foldWord=n2utils.foldWord;nunaliit2.couchUtils.removeApostrophe=n2utils.removeApostrophe;nunaliit2.couchUtils.isApostropheCodeChar=n2utils.isApostropheCodeChar;nunaliit2.couchUtils.extractTypes=n2utils.extractTypes;nunaliit2.couchUtils.extractSpecificType=n2utils.extractSpecificType;nunaliit2.couchUtils.extractGeometries=n2utils.extractGeometries;nunaliit2.couchUtils.getAtlasRole=n2utils.getAtlasRole;nunaliit2.couchUtils.validateDocumentStructure=n2utils.validateDocumentStructure;nunaliit2.couchUtils.validateTypes=n2utils.validateTypes;};var n2tiles={format4326_65K:null,format4326_200:null,format4326_25M:null,makeFormat:function(minx,miny,maxx,maxy,resx,resy){var tilesX=(maxx-minx)*resx;var tilesY=(maxy-miny)*resy;var tiles=tilesX*tilesY;var incx=(maxx-minx)/tilesX;var incy=(maxy-miny)/tilesY;return{minx:minx,miny:miny,maxx:maxx,maxy:maxy,resx:resx,resy:resy,tiles:tiles,nx:tilesX,ny:tilesY,incx:incx,incy:incy};},getBoundsFromTile:function(format,tileNumber){var coordX=tileNumber%format.nx;var coordY=(tileNumber-coordX)/format.nx;var minx=((coordX*format.incx)+format.minx);var miny=((coordY*format.incy)+format.miny);return{minx:minx,miny:miny,maxx:(minx+format.incx),maxy:(miny+format.incy)};},getTileFromPosition:function(format,x,y){return(y*format.nx)+x;},getTilePositionFromCoords:function(format,x,y){var coordX=Math.floor((x-format.minx)/format.incx);var coordY=Math.floor((y-format.miny)/format.incy);if(coordX<0)coordX=0;if(coordX>=format.nx)coordX=format.nx-1;if(coordY<0)coordY=0;if(coordY>=format.ny)coordY=format.ny-1;return{x:coordX,y:coordY,tile:n2tiles.getTileFromPosition(format,coordX,coordY)};},getTileFromCoords:function(format,x,y){var coordX=Math.floor((x-format.minx)/format.incx);var coordY=Math.floor((y-format.miny)/format.incy);if(coordX<0)coordX=0;if(coordX>=format.nx)coordX=format.nx-1;if(coordY<0)coordY=0;if(coordY>=format.ny)coordY=format.ny-1;return n2tiles.getTileFromPosition(format,coordX,coordY);},getTilesFromBounds:function(format,minx,miny,maxx,maxy,maxTiles){var blTilePosition=n2tiles.getTilePositionFromCoords(format,minx,miny);var trTilePosition=n2tiles.getTilePositionFromCoords(format,maxx,maxy);var leftX=blTilePosition.x;var rightX=trTilePosition.x;var trTile=trTilePosition.tile;var result=[];var done=0;var x=blTilePosition.x;var y=blTilePosition.y;var tile=n2tiles.getTileFromPosition(format,x,y);while(!done){result.push(tile);if(tile==trTile){done=1;}else if(x==rightX){x=leftX;y=y+1;while(y>=format.ny){y=y-format.ny;};}else{x=x+1;while(x>=format.nx){x=x-format.nx;};}
tile=n2tiles.getTileFromPosition(format,x,y);if(result.length>format.tiles)return[];if(maxTiles&&result.length>maxTiles)return[];};return result;},getApproxTilesForBounds:function(format,minx,miny,maxx,maxy){var cX=(maxx>minx)?((maxx-minx)/format.incx):(((format.maxx-maxx)+(minx-format.minx))/format.incx);var cY=(maxy>miny)?((maxy-miny)/format.incy):(((format.maxy-maxy)+(miny-format.miny))/format.incy);return(Math.floor(cX)+1)*(Math.floor(cY)+1);}};n2tiles.format4326_200={minx:-180,miny:-90,maxx:180,maxy:90,resx:0.05,resy:0.05,tiles:162,nx:18,ny:9,incx:20,incy:20};n2tiles.format4326_65K={minx:-180,miny:-90,maxx:180,maxy:90,resx:1,resy:1,tiles:64800,nx:360,ny:180,incx:1,incy:1};n2tiles.format4326_25M={minx:-180,miny:-90,maxx:180,maxy:90,resx:20,resy:20,tiles:25920000,nx:7200,ny:3600,incx:0.05,incy:0.05};if(typeof(exports)==='object'){exports.makeFormat=n2tiles.makeFormat;exports.getBoundsFromTile=n2tiles.getBoundsFromTile;exports.getTileFromCoords=n2tiles.getTileFromCoords;exports.getTilesFromBounds=n2tiles.getTilesFromBounds;exports.getApproxTilesForBounds=n2tiles.getApproxTilesForBounds;exports.format4326_65K=n2tiles.format4326_65K;exports.format4326_200=n2tiles.format4326_200;exports.format4326_25M=n2tiles.format4326_25M;};if(typeof(nunaliit2)==='function'){nunaliit2.tiles={};nunaliit2.tiles.makeFormat=n2tiles.makeFormat;nunaliit2.tiles.getBoundsFromTile=n2tiles.getBoundsFromTile;nunaliit2.tiles.getTilePositionFromCoords=n2tiles.getTilePositionFromCoords;nunaliit2.tiles.getTileFromCoords=n2tiles.getTileFromCoords;nunaliit2.tiles.getTilesFromBounds=n2tiles.getTilesFromBounds;nunaliit2.tiles.getApproxTilesForBounds=n2tiles.getApproxTilesForBounds;nunaliit2.tiles.format4326_65K=n2tiles.format4326_65K;nunaliit2.tiles.format4326_200=n2tiles.format4326_200;nunaliit2.tiles.format4326_25M=n2tiles.format4326_25M;};;(function($,$n2){var CouchSchemaRepository=$n2.Class($n2.schema.SchemaRepository,{couchOptions:null,initialize:function(opts_){$n2.schema.SchemaRepository.prototype.initialize.apply(this);this.couchOptions=$n2.extend({db:null,designDoc:null,viewNameSchemas:'schemas',viewNameRootSchemas:'schemas-root',dispatchService:null,preload:false,preloadedCallback:function(){}},opts_);var _this=this;this.loadSchemasFn=function(o){_this._loadSchemas(o);};var dispatcher=this._getDispatcher();if(dispatcher){var dispatcherHandle=dispatcher.getHandle('n2.couchSchema');var f=function(m){_this._handle(m);};dispatcher.register(dispatcherHandle,'documentContentCreated',f);dispatcher.register(dispatcherHandle,'documentContentUpdated',f);};if(this.couchOptions.preload){this._preload();};},_loadSchemas:function(opt_){var opt=$n2.extend({names:null,rootSchemas:false,onSuccess:function(schemaDefinitions){},onError:function(err){$n2.reportError(err);}},opt_);var viewRequest={viewName:this.couchOptions.viewNameSchemas,include_docs:true,onSuccess:function(rows){var defs=[];for(var i=0,e=rows.length;i<e;++i){defs.push(rows[i].doc);};opt.onSuccess(defs);},onError:opt.onError};if(opt.names){viewRequest.keys=opt.names;};if(opt.rootSchemas){viewRequest.viewName=this.couchOptions.viewNameRootSchemas;};this.couchOptions.designDoc.queryView(viewRequest);},_handle:function(m){if('documentContentCreated'===m.type||'documentContentUpdated'===m.type){var doc=m.doc;if(doc.nunaliit_type==='schema'){this.addSchemas({schemas:[doc],onError:function(err){$n2.log('Error adding created/updated schema ('+doc._id+') to repository: '+err);}});};};},_getDispatcher:function(){return this.couchOptions.dispatchService;},_preload:function(){var _this=this;this.couchOptions.designDoc.queryView({viewName:this.couchOptions.viewNameSchemas,include_docs:true,onSuccess:function(rows){var defs=[];for(var i=0,e=rows.length;i<e;++i){defs.push(rows[i].doc);};_this.addSchemas({schemas:defs});_this.rootSchemasQueried=true;_this.couchOptions.preloadedCallback();},onError:function(){}});}});$n2.couchSchema={CouchSchemaRepository:CouchSchemaRepository};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch-import',args);};var StatusLogger=$n2.Class({divId:null,initialize:function(opts_){var opts=$n2.extend({div:null},opts_);if(opts.div){var $div=$(opts.div);var id=$div.attr('id');if(!id){id=$n2.getUniqueId();$div.attr('id',id);};this.divId=id;};},log:function(text){var $log=this._getLog();var id=$n2.getUniqueId();$('<div class="data_import_status"></div>').attr('id',id).text(text).appendTo($log);return id;},error:function(text){var $log=this._getLog();var id=$n2.getUniqueId();$('<div class="data_import_status data_import_error"></div>').attr('id',id).text('Error: '+text).appendTo($log);return id;},empty:function(){var $log=this._getLog();$log.empty();},_getLog:function(){return $('#'+this.divId);}});$n2.OneToManyDataImporter=$n2.Class('$n2.OneToManyDataImporter',{options:{db:null,designDoc:null,atlasDesign:null,dataArray:[],statusDiv:null,logger:null,eraseStatusDiv:true,containsGeometry:[false],descriptiveLabels:[''],viewNames:[''],keyValueFns:[function(entry){return null;}],jsonPropertiesVerifyFn:function(entry){return true;},convertJsonForUpload:function(entry){return[entry];},incrementalUpdateFns:[function(docId,uploadArray){return;}]},statusId:1,initialize:function(opts_){this.options=$n2.extend({},this.options,opts_);if(this.options.logger){this.logger=this.options.logger;}else if(this.options.statusDiv){this.logger=new StatusLogger({div:this.options.statusDiv});};if(this.options.eraseStatusDiv&&this.logger){this.logger.empty();};},loadEntry:function(aIndex){if(aIndex>=this.options.dataArray.length){this.postStatusMsgImmediate(_loc('Done'));return;};var entry=this.options.dataArray[aIndex];var designDoc=this.options.designDoc;var _t_viewNames=this.options.viewNames.slice(0);var _t_keyValueFns=this.options.keyValueFns.slice(0);var _t_descriptiveLabels=this.options.descriptiveLabels.slice(0);var entryStatusId=this.allocateStatusMsgSpace();confirmDocumentsDoNotExist(this,entry,function(caller){caller.createEntry(aIndex,entry);});function confirmDocumentsDoNotExist(caller,entry,doNotExistFn){if(_t_viewNames.length<=0||_t_keyValueFns.length<=0||_t_descriptiveLabels.length<=0){doNotExistFn(caller);return;};var currKeyValFn=_t_keyValueFns.shift();var currViewName=_t_viewNames.shift();var currDescriptiveLabel=_t_descriptiveLabels.shift();if(!$n2.isDefined(currKeyValFn)||!$n2.isDefined(currViewName)){confirmDocumentsDoNotExist(caller,entry,doNotExistFn);return;};var keyVal=currKeyValFn(entry);if(null===keyVal){caller.loadEntry(aIndex+1);return;};designDoc.queryView({viewName:currViewName,startkey:keyVal,endkey:keyVal,onSuccess:function(rows){if(rows.length>0){var locStr=_loc('{label} definition ({key}) already exists - not loaded or updated',{label:_loc(currDescriptiveLabel),key:keyVal});caller.updateStatusMsgAsynch(locStr,entryStatusId);caller.loadEntry(aIndex+1);}else{confirmDocumentsDoNotExist(caller,entry,doNotExistFn);};},onError:function(errorMsg){var locStr=_loc('Error: query error while verifying {label} definition ({key})',{label:_loc(currDescriptiveLabel),key:keyVal});caller.updateStatusMsgAsynch(locStr,entryStatusId);caller.loadEntry(aIndex+1);}});};},createEntry:function(aIndex,entry){var uploadDataArray=[];var db=this.options.db;var atlasDesign=this.options.atlasDesign;if(this.options.jsonPropertiesVerifyFn(entry)){uploadDataArray=this.options.convertJsonForUpload(entry);if(!$n2.isArray(uploadDataArray)){uploadDataArray=[uploadDataArray];};var _t_descriptiveLabels=this.options.descriptiveLabels.slice(0);var _t_incrementalUpdateFns=this.options.incrementalUpdateFns.slice(0);var _t_containsGeometry=this.options.containsGeometry.slice(0);createEntryUpdateSubsequentEntries(this);}else{this.postStatusMsgImmediate(_loc('Required fields missing for ')+
this.options.descriptiveLabels[0]+_loc(' definition: ')+aIndex);next(this);};function next(caller){if(uploadDataArray.length>0){createEntryUpdateSubsequentEntries(caller);}else{caller.loadEntry(aIndex+1);};};function createEntryUpdateSubsequentEntries(caller){if(uploadDataArray.length<=0){return;};var entryStatusId=caller.allocateStatusMsgSpace();var nextUpload=uploadDataArray.shift();var currDescriptiveLabel=_t_descriptiveLabels.shift();var currContainsGeometry=_t_containsGeometry.shift();var currIncrementalUpdateFn=null;if(uploadDataArray.length>=1){currIncrementalUpdateFn=_t_incrementalUpdateFns.shift();};if(!$n2.isDefined(nextUpload)){caller.postStatusMsgImmediate(currDescriptiveLabel+_loc(' definition null and skipped.'));next(caller);return;};$n2.couchDocument.adjustDocument(nextUpload);db.createDocument({data:nextUpload,onSuccess:function(docInfo){caller.updateStatusMsgAsynch(currDescriptiveLabel+_loc(' definition (')+docInfo.id+')',entryStatusId);if($n2.isDefined(currIncrementalUpdateFn)){var uploadedDoc=$n2.extend({},nextUpload,{_id:docInfo.id,_rev:docInfo.rev});currIncrementalUpdateFn(docInfo.id,uploadDataArray,uploadedDoc);};queryViews(atlasDesign,caller,currContainsGeometry,next);},onError:function(err){$n2.log('Error creating document: '+err,nextUpload);caller.updateStatusMsgAsynch(_loc('Error creating ')+currDescriptiveLabel+
_loc(' definition (index: ')+aIndex+_loc('). STOPPING: ')+err,entryStatusId);}});};},setDataArray:function(data){this.options.dataArray=data;},postStatusMsgImmediate:function(msg){if(this.logger){return this.logger.log(msg);};return null;},allocateStatusMsgSpace:function(){if(this.logger){return this.logger.log('');};return null;},updateStatusMsgAsynch:function(msg,id){if(id)$('#'+id).text(msg);}});$n2.DataImporter=$n2.Class('$n2.DataImporter',{options:{db:null,designDoc:null,atlasDesign:null,dataArray:[],containsGeometry:false,statusDiv:null,logger:null,descriptiveLabel:'',viewName:'',keyValueFn:function(entry){return null;},jsonPropertiesVerifyFn:function(entry){return true;},convertJsonForUpload:function(entry){return entry;}},importer:null,initialize:function(opts_){this.options=$n2.extend({},this.options,opts_);this.importer=new $n2.OneToManyDataImporter({db:this.options.db,designDoc:this.options.designDoc,atlasDesign:this.options.atlasDesign,dataArray:this.options.dataArray,containsGeometry:[this.options.containsGeometry],statusDiv:this.options.statusDiv,logger:this.options.logger,descriptiveLabels:[this.options.descriptiveLabel],viewNames:[this.options.viewName],keyValueFns:[this.options.keyValueFn],jsonPropertiesVerifyFn:this.options.jsonPropertiesVerifyFn,convertJsonForUpload:this.options.convertJsonForUpload,incrementalUpdateFns:[]});},loadEntry:function(aIndex){this.importer.loadEntry(aIndex);},setDataArray:function(data){this.options.dataArray=data;this.importer.setDataArray(data);}});$n2.JSONInputPlugInForDataImport=$n2.Class('$n2.JSONInputPlugInForDataImport',{options:{jsonFile:'',importer:null,entriesFromData:function(data){return data;}},initialize:function(opts_){this.options=$n2.extend({},this.options,opts_);},loadJson:function(){var this_=this;$.getJSON(this.options.jsonFile,function(data,textStatus){var entries=null;if(data){entries=this_.options.entriesFromData(data);};if(entries&&$n2.isArray(entries)){this_.options.importer.setDataArray(entries);this_.options.importer.loadEntry(0);};});}});$n2.GeoJSONInputPlugInForDataImport=$n2.Class('$n2.GeoJSONInputPlugInForDataImport',{options:{jsonFile:'',importer:null,crs:'EPSG:4326'},geojsonParser:null,initialize:function(opts_){this.options=$n2.extend({},this.options,opts_);this.geojsonParser=new OpenLayers.Format.GeoJSON();},loadGeoJson:function(){var this_=this;$.getJSON(this.options.jsonFile,function(data,textStatus){if($n2.isDefined(data)&&$n2.isDefined(data.crs)&&$n2.isDefined(data.crs.type)&&'name'===data.crs.type&&$n2.isDefined(data.crs.properties)&&$n2.isDefined(data.crs.properties.name)){this_.options.crs=data.crs.properties.name;};if($n2.isDefined(data)&&$n2.isDefined(data.type)&&'featurecollection'===data.type.toLowerCase()&&$n2.isDefined(data.features)&&$n2.isArray(data.features)){var dataArray=[];for(var i=0,len=data.features.length;i<len;i++){var olVector=this_.geojsonParser.read(data.features[i],"Feature",null);dataArray.push(olVector);};this_.options.importer.setDataArray(dataArray);this_.options.importer.loadEntry(0);};});},convertGeomToWkt:function(olVector){var wkt=olVector.geometry.toString();var bounds=olVector.geometry.getBounds();var xmin=bounds.left;var xmax=bounds.right;var ymin=bounds.bottom;var ymax=bounds.top;return{nunaliit_geom:{nunaliit_type:"geometry",wkt:wkt,bbox:[xmin,ymin,xmax,ymax]}};}});function queryViews(atlasDesign,caller,containsGeometry,doNextEntryFn){var viewsToQuery;function doViewCheck(firstCall){if(firstCall){tilingViews=['geom-layer-tile200','geom-layer-tile25m','geom-layer-tile65k','geom-tile200','geom-tile25m','geom-tile65k'];};if(!containsGeometry||tilingViews.length<1){doNextEntryFn(caller);}else{var viewName=tilingViews.pop();atlasDesign.queryView({viewName:viewName,limit:1,onSuccess:function(){doViewCheck(false);},onError:function(err){$('#status').append($('<div>'+
_loc('STOPPING: Failed verifying view ')+
viewName+' ('+err+')'));}});};};doViewCheck(true);};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var ConfigService=$n2.Class('ConfigurationService',{serverUrl:null,initialize:function(opts_){var opts=$n2.extend({url:null},opts_);this.serverUrl=opts.url;},getNunaliitServerRoles:function(opts_){var opts=$n2.extend({onSuccess:function(roles){},onError:function(err){}},opts_);$.ajax({url:this.serverUrl+'getServerRoles',type:'GET',dataType:'json',success:function(data,textStatus,jqXHR){if(data&&data.roles){opts.onSuccess(data.roles);}else{opts.onError(_loc('Invalid server response'));};},error:function(jqXHR,textStatus,errorThrown){var err=$n2.utils.parseHttpJsonError(jqXHR,textStatus);opts.onError(err);}});}});function Configure(options_){var options=$n2.extend({couchServerUrl:null,atlasDbUrl:null,atlasDesignName:'atlas',siteDesignName:'site',progressServerUrl:null,mediaUrl:null,uploadServerUrl:null,exportServerUrl:null,configServerUrl:null,userServerUrl:null,submissionDbUrl:null,submissionServerUrl:null,dateServerUrl:null,onSuccess:function(config){}},options_);var configuration={directory:{}};configuration.start=function(){if(configuration.directory.dispatchService){configuration.directory.dispatchService.send('n2.couchConfiguration',{type:'start'});};};configuration.directory.dispatchService=new $n2.dispatch.Dispatcher();configuration.directory.historyMonitor=new $n2.history.Monitor({directory:configuration.directory});configuration.directory.historyTracker=new $n2.history.Tracker({directory:configuration.directory});configuration.directory.eventService=new $n2.couchEvents.EventSupport({directory:configuration.directory});configuration.directory.customService=new $n2.custom.CustomService({directory:configuration.directory});configuration.directory.configService=new ConfigService({url:options.configServerUrl});$.cometd={init:function(){},subscribe:function(){},publish:function(){}};$n2.couch.initialize({pathToServer:options.couchServerUrl,onSuccess:couchInitialized});function couchInitialized(){configuration.couchServer=$n2.couch.DefaultServer;configuration.directory.couchServer=configuration.couchServer;configuration.atlasDb=configuration.couchServer.getDb({dbUrl:options.atlasDbUrl});configuration.atlasDesign=configuration.atlasDb.getDesignDoc({ddName:options.atlasDesignName});configuration.siteDesign=configuration.atlasDb.getDesignDoc({ddName:options.siteDesignName});if(options.submissionDbUrl){configuration.submissionDb=configuration.couchServer.getDb({dbUrl:options.submissionDbUrl});};configuration.dataSources=[];var couchDbDs=null;if(configuration.submissionDb){couchDbDs=new $n2.couchDocument.CouchDataSourceWithSubmissionDb({id:'main',db:configuration.atlasDb,submissionDb:configuration.submissionDb,submissionServerUrl:options.submissionServerUrl,dispatchService:configuration.directory.dispatchService});}else{couchDbDs=new $n2.couchDocument.CouchDataSource({id:'main',db:configuration.atlasDb,dispatchService:configuration.directory.dispatchService});};configuration.dataSources.push(couchDbDs);configuration.documentSource=couchDbDs;if($n2.couchHelp&&$n2.couchHelp.CheckBrowserCompliance){$n2.couchHelp.CheckBrowserCompliance({db:configuration.atlasDb});};configuration.directory.schemaRepository=new $n2.couchSchema.CouchSchemaRepository({db:configuration.atlasDb,designDoc:configuration.atlasDesign,dispatchService:configuration.directory.dispatchService,preload:true,preloadedCallback:schemasPreloaded});};function schemasPreloaded(){configuration.directory.authService=new $n2.couchAuth.AuthService({onSuccess:authInitialized,atlasDb:configuration.atlasDb,schemaRepository:configuration.directory.schemaRepository,directory:configuration.directory,userServerUrl:options.userServerUrl});};function authInitialized(){configuration.atlasDb.getChangeNotifier({onSuccess:function(notifier){configuration.directory.notifierService=notifier;notifierInitialized();}});};function notifierInitialized(){$n2.couchL10n.Configure({db:configuration.atlasDb,designDoc:configuration.atlasDesign});configuration.directory.progressService=new $n2.progress.ProgressServer({url:options.progressServerUrl});configuration.directory.uploadService=new $n2.upload.Upload({url:options.uploadServerUrl,progressServer:configuration.directory.progressService});configuration.directory.exportService=new $n2.couchExport.Export({url:options.exportServerUrl});configuration.directory.dateService=new $n2.dateService.DateService({url:options.dateServerUrl});configuration.directory.searchService=new $n2.couchSearch.SearchServer({designDoc:configuration.atlasDesign,db:configuration.atlasDb,dateService:configuration.directory.dateService,directory:configuration.directory});configuration.mediaRelativePath=options.mediaUrl;configuration.directory.requestService=new $n2.couchRequests({db:configuration.atlasDb,userDb:$n2.couch.getUserDb(),designDoc:configuration.atlasDesign,dispatchService:configuration.directory.dispatchService,userServerUrl:options.userServerUrl});configuration.directory.dispatchSupport=new $n2.couchDispatchSupport.DispatchSupport({db:configuration.atlasDb,directory:configuration.directory});configuration.directory.languageService=new $n2.languageSupport.LanguageService({directory:configuration.directory});configuration.directory.attachmentService=new $n2.couchAttachment.AttachmentService({mediaRelativePath:options.mediaUrl});configuration.directory.showService=new $n2.couchShow.Show({db:configuration.atlasDb,documentSource:configuration.documentSource,requestService:configuration.directory.requestService,notifierService:configuration.directory.notifierService,dispatchService:configuration.directory.dispatchService,schemaRepository:configuration.directory.schemaRepository,customService:configuration.directory.customService});configuration.directory.createDocProcess=new $n2.couchRelatedDoc.CreateRelatedDocProcess({documentSource:configuration.documentSource,schemaRepository:configuration.directory.schemaRepository,uploadService:configuration.directory.uploadService,showService:configuration.directory.showService,authService:configuration.directory.authService});configuration.directory.schemaEditorService=new $n2.CouchEditor.SchemaEditorService({documentSource:configuration.documentSource,showService:configuration.directory.showService,searchService:configuration.directory.searchService,dispatchService:configuration.directory.dispatchService});configuration.couchEditor=new $n2.CouchEditor.Editor({documentSource:configuration.documentSource,schemaRepository:configuration.directory.schemaRepository,uploadService:configuration.directory.uploadService,showService:configuration.directory.showService,authService:configuration.directory.authService,dispatchService:configuration.directory.dispatchService,searchService:configuration.directory.searchService,schemaEditorService:configuration.directory.schemaEditorService,customService:configuration.directory.customService});configuration.directory.userService=new $n2.couchUser.UserService({userDb:$n2.couch.getUserDb(),configService:configuration.directory.configService,schemaRepository:configuration.directory.schemaRepository,schemaEditorService:configuration.directory.schemaEditorService,userServerUrl:options.userServerUrl});configuration.contributions=new $n2.couchContributions({db:configuration.atlasDb,designDoc:configuration.atlasDesign,showService:configuration.directory.showService,uploads:configuration.directory.uploadService});$n2.mapAndControls.DefaultPopupHtmlFunction=function(opt_){var feature=opt_.feature;if(feature.cluster&&feature.cluster.length===1){feature=feature.cluster[0];};if(feature.cluster){var $tmp=$('<span></span>');$tmp.text(_loc('This cluster contains {count} features',{count:feature.cluster.length}));var $wrapper=$('<div></div>');$wrapper.append($tmp);var html=$wrapper.html();opt_.onSuccess(html);}else{var doc=opt_.feature.data;var $tmp=$('<span></span>');configuration.directory.showService.displayBriefDescription($tmp,{},doc);var $wrapper=$('<div></div>');$wrapper.append($tmp);var html=$wrapper.html();opt_.onSuccess(html);};};configuration.directory.serverSideNotifier=new $n2.couchServerSide.Notifier({dbChangeNotifier:configuration.directory.notifierService,directory:configuration.directory});configuration.directory.hoverSoundService=new $n2.couchSound.HoverSoundService({db:configuration.atlasDb,serviceDirectory:configuration.directory});var geoNamesOptions={};if(window.nunaliit_custom&&window.nunaliit_custom.geoNames){if(window.nunaliit_custom.geoNames.username){geoNamesOptions.username=window.nunaliit_custom.geoNames.username;};};configuration.directory.geoNamesService=new $n2.GeoNames.Service(geoNamesOptions);callCustomConfiguration();};function callCustomConfiguration(){if(window&&window.nunaliit_custom&&typeof(window.nunaliit_custom.configuration)==='function'){window.nunaliit_custom.configuration(configuration,configurationDone);}else{configurationDone();};};function configurationDone(){if(configuration.directory.showService){configuration.directory.showService.fixElementAndChildren($('body'));};$n2.log('nunaliit configuration',configuration);options.onSuccess(configuration);};};$n2.couchConfiguration={Configure:Configure,ConfigService:ConfigService};})(jQuery,nunaliit2);;(function($n2){$n2.couchGeom=$n2.extend({},{getCouchGeometry:function(geom){var bounds=geom.getBounds();var wkt=geom.toString();return{nunaliit_type:'geometry',wkt:wkt,bbox:[bounds.left,bounds.bottom,bounds.right,bounds.top]};},adjustBboxOnCouchGeom:function(couchGeom){if(OpenLayers&&OpenLayers.Geometry&&OpenLayers.Geometry.fromWKT){var olGeom=OpenLayers.Geometry.fromWKT(couchGeom.wkt);var bounds=olGeom.getBounds();couchGeom.bbox=[bounds.left,bounds.bottom,bounds.right,bounds.top];};},getOpenLayersGeometry:function(options_){var opts=$n2.extend({couchGeom:null,onError:function(errorMsg){$n2.reportError(errorMsg);}},options_);if(OpenLayers&&OpenLayers.Geometry&&OpenLayers.Geometry.fromWKT){var olGeom=OpenLayers.Geometry.fromWKT(opts.couchGeom.wkt);return olGeom;}else{opts.onError('OpenLayers must be installed to update document geometries');};},updateDocumentWithWktGeometry:function(doc,options_){var opts=$n2.extend({wkt:null,onError:function(errorMsg){$n2.reportError(errorMsg);}},options_);if(!opts.wkt){opts.onError('Attribute "wkt" not provided while updating a geometry document');return;}
if(OpenLayers&&OpenLayers.Geometry&&OpenLayers.Geometry.fromWKT){var olGeom=OpenLayers.Geometry.fromWKT(opts.wkt);}else{opts.onError('OpenLayers must be installed to update document geometries');return;};var couchGeom=$n2.couchGeom.getCouchGeometry(olGeom);doc.nunaliit_geom=couchGeom;},selectTileViewFromBounds:function(viewOptions,bb,layer,fids){var views=[{tile:$n2.tiles.format4326_25M,name:'geom-tile25m',list:'noduplicate',layer:false,fid:false},{tile:$n2.tiles.format4326_25M,name:'geom-layer-tile25m',list:'noduplicate',layer:true,fid:false},{tile:$n2.tiles.format4326_65K,name:'geom-tile65k',list:'noduplicate',layer:false,fid:false},{tile:$n2.tiles.format4326_65K,name:'geom-layer-tile65k',list:'noduplicate',layer:true,fid:false},{tile:$n2.tiles.format4326_200,name:'geom-tile200',list:'noduplicate',layer:false,fid:false},{tile:$n2.tiles.format4326_200,name:'geom-layer-tile200',list:'noduplicate',layer:true,fid:false},{tile:null,name:'geom-layer-fid',layer:true,fid:true},{tile:null,name:'geom-layer',layer:true,fid:false},{tile:null,name:'geom',layer:false,fid:true}];if(bb&&fids)bb=null;for(var i=0,e=views.length;i<e;++i){var v=views[i];if(bb&&v.tile&&layer&&v.layer){if($n2.tiles.getApproxTilesForBounds(v.tile,bb[0],bb[1],bb[2],bb[3])<500){viewOptions.viewName=v.name;var tiles=$n2.tiles.getTilesFromBounds(v.tile,bb[0],bb[1],bb[2],bb[3]);viewOptions.keys=[];for(var j=0,k=tiles.length;j<k;++j){viewOptions.keys.push([layer,tiles[j]]);};if(v.list)viewOptions.listName=v.list;return true;};}else if(bb&&v.tile&&!layer&&!v.layer){if($n2.tiles.getApproxTilesForBounds(v.tile,bb[0],bb[1],bb[2],bb[3])<500){viewOptions.viewName=v.name;viewOptions.keys=$n2.tiles.getTilesFromBounds(v.tile,bb[0],bb[1],bb[2],bb[3]);if(v.list)viewOptions.listName=v.list;return true;};}else if(fids&&v.fid&&layer&&v.layer){viewOptions.viewName=v.name;viewOptions.keys=[];for(var j=0,k=fids.length;j<k;++j){viewOptions.keys.push([layer,fids[j]]);};if(v.list)viewOptions.listName=v.list;return true;}else if(fids&&v.fid&&!layer&&!v.layer){viewOptions.viewName=v.name;viewOptions.keys=fids;if(v.list)viewOptions.listName=v.list;return true;}else if(!fids&&!v.fid&&layer&&v.layer){viewOptions.viewName=v.name;viewOptions.keys=[layer];if(v.list)viewOptions.listName=v.list;return true;}else if(!bb&&!fids&&!layer&&!v.fid&&!v.layer&&!v.tile){viewOptions.viewName=v.name;if(v.list)viewOptions.listName=v.list;return true;};};return false;},queryGeometries:function(atlasDesignDoc,viewOptions){var bounds=null;var data={};data.viewName='geom';data.listName='noduplicate';for(var key in viewOptions){if(key==='bounds'){bounds=viewOptions[key];}else{data[key]=viewOptions[key];};};if(bounds){$n2.couchGeom.selectTileViewFromBounds(data,bounds);};atlasDesignDoc.queryView(data);},extractLinks:function(obj){var links=[];_extractLinks(obj,links);return links;function _extractLinks(obj,result){if(null===obj){}else if($n2.isArray(obj)){for(var i=0,e=obj.length;i<e;++i){_extractLinks(obj[i],result);};}else if(typeof(obj)==='object'){if(obj.nunaliit_type==='reference'){result.push(obj);}else{for(var key in obj){var value=obj[key];_extractLinks(value,result);};};};}}});})(nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchShow';var couchUserPrefix='org.couchdb.user:';function noop(){};var reUrl=/(^|\s)(https?:\/\/[^\s]*)(\s|$)/;var DomStyler=$n2.Class({db:null,documentSource:null,showService:null,displayFunction:null,editFunction:null,deleteFunction:null,viewLayerFunction:null,initialize:function(opts_){var opts=$n2.extend({db:null,documentSource:null,showService:null,displayFunction:null,editFunction:null,deleteFunction:null,viewLayerFunction:null},opts_);this.db=opts.db;this.documentSource=opts.documentSource;this.showService=opts.showService;this.displayFunction=opts.displayFunction;this.editFunction=opts.editFunction;this.deleteFunction=opts.deleteFunction;this.viewLayerFunction=opts.viewLayerFunction;},fixElementAndChildren:function($elem,opt,contextDoc){var _this=this;var $set=$elem.find('*').addBack();$set.filter('.n2_localize').each(function(){var $jq=$(this);_this._localize($jq,opt);$jq.removeClass('n2_localize').addClass('n2_localized');});$set.filter('.n2s_localize').each(function(){var $jq=$(this);_this._localize($jq,opt);$jq.removeClass('n2s_localize').addClass('n2s_localized');});$set.filter('.n2_briefDisplay').each(function(){var $jq=$(this);_this._briefDisplay($jq,opt);$jq.removeClass('n2_briefDisplay').addClass('n2_briefDisplayed');});$set.filter('.n2s_referenceLink').each(function(){var $jq=$(this);_this._insertReferenceLink($jq,opt);$jq.removeClass('n2s_referenceLink').addClass('n2s_insertedReferenceLink');});$set.filter('.n2s_insertTime').each(function(){var $jq=$(this);_this._insertTime($jq,opt);$jq.removeClass('n2s_insertTime').addClass('n2s_insertedTime');});$set.filter('.n2s_insertUserName').each(function(){var $jq=$(this);_this._insertUserName($jq,opt);$jq.removeClass('n2s_insertUserName').addClass('n2s_insertedUserName');});$set.filter('.n2s_insertLayerName').each(function(){var $jq=$(this);_this._insertLayerName($jq,opt);$jq.removeClass('n2s_insertLayerName').addClass('n2s_insertedLayerName');});$set.filter('.n2s_insertMediaView').each(function(){var $jq=$(this);_this._insertMediaView(contextDoc,$jq,opt);$jq.removeClass('n2s_insertMediaView').addClass('n2s_insertedMediaView');});$set.filter('.n2s_insertHoverSoundIcon').each(function(){var $jq=$(this);_this._insertHoverSoundIcon(contextDoc,$jq,opt);$jq.removeClass('n2s_insertHoverSoundIcon').addClass('n2s_insertedHoverSoundIcon');});$set.filter('.n2s_externalMediaLink').each(function(){var $jq=$(this);_this._adjustExternalMediaLink(contextDoc,$jq,opt);$jq.removeClass('n2s_externalMediaLink').addClass('n2s_adjustedExternalMediaLink');});$set.filter('.n2s_insertExternalMediaLink').each(function(){var $jq=$(this);_this._insertExternalMediaLink(contextDoc,$jq,opt);$jq.removeClass('n2s_insertExternalMediaLink').addClass('n2s_insertedExternalMediaLink');});$set.filter('.n2s_convertTextUrlToLink').each(function(){var $jq=$(this);_this._convertTextUrlToLink(contextDoc,$jq,opt);$jq.removeClass('n2s_convertTextUrlToLink').addClass('n2s_convertedTextUrlToLink');});$set.filter('.n2s_clickFindGeometryOnMap').each(function(){var $jq=$(this);_this._clickFindGeometryOnMap(contextDoc,$jq,opt);$jq.removeClass('n2s_clickFindGeometryOnMap').addClass('n2s_findGeometryOnMap');});$set.filter('.n2s_clickAddLayerFromDefinition').each(function(){var $jq=$(this);_this._clickAddLayerFromDefinition(contextDoc,$jq,opt);$jq.removeClass('n2s_clickAddLayerFromDefinition').addClass('n2s_addLayerFromDefinition');});$set.filter('.n2s_clickEdit').each(function(){var $jq=$(this);_this._clickEdit(contextDoc,$jq,opt);$jq.removeClass('n2s_clickEdit').addClass('n2s_edit');});$set.filter('.n2s_clickDelete').each(function(){var $jq=$(this);_this._clickDelete(contextDoc,$jq,opt);$jq.removeClass('n2s_clickDelete').addClass('n2s_delete');});$set.filter('.n2s_handleHover').each(function(){var $jq=$(this);_this._handleHover(contextDoc,$jq,opt);$jq.removeClass('n2s_handleHover').addClass('n2s_handledHover');});$set.filter('.n2s_installMaxHeight').each(function(){var $jq=$(this);_this._installMaxHeight(contextDoc,$jq,opt);$jq.removeClass('n2s_installMaxHeight').addClass('n2s_installedMaxHeight');});$set.filter('.n2s_preserveSpaces').each(function(){var $jq=$(this);_this._preserveSpaces($jq,opt);$jq.removeClass('n2s_preserveSpaces').addClass('n2s_preservedSpaces');});},_localize:function($jq,opt_){var text=$jq.text();var locText=_loc(text);if(locText){$jq.text(locText);};},_preserveSpaces:function($jq,opt_){$jq.each(function(){performPreserveSpace(this);});function performPreserveSpace(parent){var node=parent.firstChild;while(node){if(node.nodeType===3){$(node.parentNode).css('white-space','pre-wrap');node=node.nextSibling;}else{performPreserveSpace(node);node=node.nextSibling;};};};},_briefDisplay:function($jq,opt_){var docId=$jq.text();this.showService.printBriefDescription($jq,docId);},_insertReferenceLink:function($jq,opt_){var _this=this;var docId=$jq.text();this.showService.printBriefDescription($jq,docId);$jq.click(function(){var dispatchService=_this.showService.dispatchService;if(dispatchService){dispatchService.send(DH,{type:'userSelect',docId:docId});};if(_this.displayFunction){_this.displayFunction(docId,opt_);};return false;});},_insertTime:function($jq,opt_){var time=1*$jq.text();var timeStr=(new Date(time)).toString();$jq.text(timeStr);},_insertUserName:function($jq,opt_){var userName=$jq.text();this.showService.printUserName($jq,userName,{showHandle:true});},_insertLayerName:function($jq,opt_){var layerIdentifier=$jq.text();this.showService.printLayerName($jq,layerIdentifier);},_insertMediaView:function(data,$insertView,opt_){var _this=this;var attachmentName=$insertView.attr('nunaliit-attachment');if(!attachmentName){attachmentName=$insertView.text();};$insertView.empty();var attachment=null;if(data._attachments&&data._attachments[attachmentName]){attachment=data._attachments[attachmentName];};var attDesc=null;if(data&&data.nunaliit_attachments&&data.nunaliit_attachments.files){attDesc=data.nunaliit_attachments.files[attachmentName];};if(attDesc&&attDesc.status==='attached'&&attachment){var attUrl=this.db.getAttachmentUrl(data,attachmentName);var linkDiv=null;if(attDesc.thumbnail&&data._attachments[attDesc.thumbnail]){var thumbUrl=this.db.getAttachmentUrl(data,attDesc.thumbnail);linkDiv=$('<div class="n2Show_thumb_wrapper"><img src="'+thumbUrl+'"/></div>');}else if(attDesc.fileClass==='image'){linkDiv=$('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_image"></div></div>');}else if(attDesc.fileClass==='audio'){linkDiv=$('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_audio"></div></div>');}else if(attDesc.fileClass==='video'){linkDiv=$('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_video"></div></div>');}else{linkDiv=$('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_file"></div></div>');};if(null!=linkDiv){$insertView.append(linkDiv);var cb=createMediaCallback(attDesc.fileClass,attUrl,data,attachmentName);linkDiv.click(cb);};};function createMediaCallback(uploadType,attachmentUrl,doc,attachmentName){return function(evt){var mediaOptions={url:attachmentUrl};var attachment=null;if(doc._attachments&&doc._attachments[attachmentName]){attachment=doc._attachments[attachmentName];};if(attachment){mediaOptions.mimeType=attachment.content_type;};var attDesc=doc.nunaliit_attachments.files[attachmentName];if(attDesc&&attDesc.data&&attDesc.data.title){mediaOptions.title=attDesc.data.title;}else if(doc.nunaliit_contribution&&doc.nunaliit_contribution.title){mediaOptions.title=doc.nunaliit_contribution.title;};if(attDesc){if(attDesc.width){mediaOptions.width=attDesc.width;};if(attDesc.height){mediaOptions.height=attDesc.height;};};var $temp=$('<div></div>');_this.showService._displayDocumentBrief($temp,doc,{onDisplayed:function(){var html=$temp.html();mediaOptions.metaDataHtml=html;mediaOptions.type=uploadType;$n2.mediaDisplay.displayMedia(mediaOptions);}});return false;};};},_insertHoverSoundIcon:function(data,$insertHoverSoundIcon,opt_){var _this=this;var playSound=false;if($n2.couchSound&&$n2.couchSound.DocumentContainsHoverSound&&$n2.couchSound.DocumentContainsHoverSound(data)){$insertHoverSoundIcon.append($('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_speaker"></div></div>'));$insertHoverSoundIcon.find('.n2Show_icon_speaker').click(function(){toggleHoverSound();return false;});};function toggleHoverSound(){var dispatchService=_this.showService.dispatchService;if(dispatchService){if(!playSound){dispatchService.send(DH,{type:'playHoverSoundOn',doc:data});playSound=true;}else{dispatchService.send(DH,{type:'playHoverSoundOff',doc:data});playSound=false;};};};},_adjustExternalMediaLink:function(data,$externalLink,opt_){var attachmentName=$externalLink.attr('href');var attachment=null;if(data._attachments&&data._attachments[attachmentName]){attachment=data._attachments[attachmentName];};var attDesc=null;if(data&&data.nunaliit_attachments&&data.nunaliit_attachments.files){attDesc=data.nunaliit_attachments.files[attachmentName];};if(attDesc&&attDesc.status==='attached'&&attachment){var attUrl=this.db.getAttachmentUrl(data,attachmentName);$externalLink.attr('href',attUrl);$externalLink.click(function(e){if(confirm(_loc('You are about to leave this page. Do you wish to continue?'))){return true;};return false;});}else{$externalLink.click(function(e){alert(_loc('File is not currently available'));return false;});};},_insertExternalMediaLink:function(data,$div,opt_){var attachmentName=$div.attr('nunaliit-attachment');$div.empty();var attachment=null;if(data._attachments&&data._attachments[attachmentName]){attachment=data._attachments[attachmentName];};var attDesc=null;if(data&&data.nunaliit_attachments&&data.nunaliit_attachments.files){attDesc=data.nunaliit_attachments.files[attachmentName];};if(attDesc&&attDesc.status==='attached'&&attachment){var attUrl=this.db.getAttachmentUrl(data,attachmentName);if(attDesc.originalAttachment&&data._attachments[attDesc.originalAttachment]){attUrl=this.db.getAttachmentUrl(data,attDesc.originalAttachment);};var $a=$('<a></a>').addClass('n2s_adjustedExternalMediaLink').attr('href',attUrl).click(function(e){if(confirm(_loc('You are about to leave this page. Do you wish to continue?'))){return true;};return false;}).appendTo($div);var name=attDesc.originalName;if(!name){name=attachmentName;};$('<span></span>').addClass('n2s_externalMediaLinkName').text(name).appendTo($a);};},_convertTextUrlToLink:function(data,$jq,opt_){$jq.each(function(){performTextUrlToLink(this);});function performTextUrlToLink(parent){var node=parent.firstChild;while(node){if(node.nodeType===3){nextSibling=node.nextSibling;convertTextElement(parent,node);node=nextSibling;}else{performTextUrlToLink(node);node=node.nextSibling;};};};function convertTextElement(parent,textNode){var text=textNode.nodeValue;var m=reUrl.exec(text);var after=null;while(m){after=m[3]+text.substr(m.index+m[0].length);var before=text.substr(0,m.index)+m[1];if(before.length>0){var t2=parent.ownerDocument.createTextNode(before);parent.insertBefore(t2,textNode);};var aNode=parent.ownerDocument.createElement('a');aNode.setAttribute('href',m[2]);aNode.setAttribute('class','n2s_convertedUrl');var t1=parent.ownerDocument.createTextNode(m[2]);aNode.appendChild(t1);parent.insertBefore(aNode,textNode);text=after;m=reUrl.exec(text);};if(after){var t3=parent.ownerDocument.createTextNode(after);parent.insertBefore(t3,textNode);parent.removeChild(textNode);};};},_clickFindGeometryOnMap:function(data,$jq,opt){var dispatcher=this.showService.dispatchService;if(data&&data.nunaliit_geom&&dispatcher&&dispatcher.isEventTypeRegistered('findOnMap')){var x=(data.nunaliit_geom.bbox[0]+data.nunaliit_geom.bbox[2])/2;var y=(data.nunaliit_geom.bbox[1]+data.nunaliit_geom.bbox[3])/2;$jq.click(function(){dispatcher.send(DH,{type:'findOnMap',fid:data._id,srsName:'EPSG:4326',x:x,y:y});return false;});}else{$jq.remove();};},_clickAddLayerFromDefinition:function(contextDoc,$jq,opt){var _this=this;var viewLayerFunction=this.viewLayerFunction;var dispatchService=_this.showService.dispatchService;if(viewLayerFunction||dispatchService){if(contextDoc&&contextDoc.nunaliit_layer_definition){$jq.click(function(){var layerDefinition=contextDoc.nunaliit_layer_definition;if(viewLayerFunction){viewLayerFunction(contextDoc);};if(dispatchService){var layerId=layerDefinition.id;if(!layerId){layerId=contextDoc._id;};var layerDef={name:layerDefinition.name,type:'couchdb',options:{layerName:layerId,documentSource:_this.documentSource}};dispatchService.send(DH,{type:'addLayerToMap',layer:layerDef,options:{setExtent:{bounds:layerDefinition.bbox,crs:'EPSG:4326'}}});};return false;});}else{$jq.remove();};}else{$jq.remove();};},_clickEdit:function(contextDoc,$jq,opt){var _this=this;if(this.editFunction){$jq.click(function(){_this.editFunction(contextDoc,opt);return false;});}else{$jq.empty();};},_clickDelete:function(contextDoc,$jq,opt){var _this=this;if(this.deleteFunction){$jq.click(function(){_this.deleteFunction(contextDoc,opt);return false;});}else{$jq.empty();};},_installMaxHeight:function(contextDoc,$jq,opt){var maxHeight=$jq.attr('_maxheight');if(!maxHeight){$jq.attr('n2s_error','Attribute _maxheight not found');$n2.log('n2Show installMaxHeight: Attribute _maxHeight not found');}else if($jq.height()>maxHeight){var showText=_loc('More');var hideText=_loc('Less');var id=$n2.getUniqueId();var $children=$jq.contents();var $content=$('<div class="n2show_maxHeightContent n2show_maxHeight_truncated"></div>').attr('id',id);$jq.append($content);$children.each(function(){$(this).appendTo($content);});$content.css({overflow:'hidden',height:maxHeight+'px'});var $link=$('<a href="#" class="n2show_maxHeightLink"></a>').text(showText).click(function(e){e.preventDefault();var $link=$(this);var $content=$('#'+id);if($content.height()>maxHeight){$link.text(showText);$content.css('height',maxHeight+'px').addClass('n2show_maxHeight_truncated').removeClass('n2show_maxHeight_full');}else{$link.text(hideText);$content.css('height','auto').addClass('n2show_maxHeight_full').removeClass('n2show_maxHeight_truncated');};return false;});$('<div class="n2show_maxHeightLinkContainer"></div>').append($link).appendTo($jq);};},_handleHover:function(contextDoc,$jq,opt){var dispatchService=this.showService.dispatchService;if(dispatchService){$jq.hover(function(){dispatchService.send(DH,{type:'userFocusOn',docId:contextDoc._id,doc:contextDoc});},function(){dispatchService.send(DH,{type:'userFocusOff',docId:contextDoc._id,doc:contextDoc});});};}});var Show=$n2.Class({options:null,db:null,documentSource:null,requestService:null,notifierService:null,dispatchService:null,schemaRepository:null,customService:null,defaultSchema:null,displayFunction:null,editFunction:null,deleteFunction:null,viewLayerFunction:null,preprocessDocument:null,eliminateDeniedMedia:null,eliminateNonApprovedMedia:null,domStyler:null,postProcessDisplayFns:null,initialize:function(opts_){var opts=$n2.extend({db:null,documentSource:null,requestService:null,notifierService:null,dispatchService:null,schemaRepository:null,customService:null,defaultSchema:null,displayFunction:null,editFunction:null,deleteFunction:null,viewLayerFunction:null,preprocessDocument:null,eliminateDeniedMedia:false,eliminateNonApprovedMedia:false},opts_);var _this=this;this.options={};this.db=opts.db;this.documentSource=opts.documentSource;this.requestService=opts.requestService;this.notifierService=opts.notifierService;this.dispatchService=opts.dispatchService;this.schemaRepository=opts.schemaRepository;this.customService=opts.customService;this.defaultSchema=opts.defaultSchema;this.displayFunction=opts.displayFunction;this.editFunction=opts.editFunction;this.deleteFunction=opts.deleteFunction;this.viewLayerFunction=opts.viewLayerFunction;this.options.preprocessDocument=opts.preprocessDocument;this.eliminateDeniedMedia=opts.eliminateDeniedMedia;this.eliminateNonApprovedMedia=opts.eliminateNonApprovedMedia;this.postProcessDisplayFns=[];this.domStyler=new DomStyler({db:this.db,documentSource:this.documentSource,showService:this,displayFunction:this.displayFunction,editFunction:this.editFunction,deleteFunction:this.deleteFunction,viewLayerFunction:this.viewLayerFunction});var requestService=this.requestService;if(requestService){requestService.addUserListener(function(userDoc){_this._displayUserDocument(userDoc);});requestService.addDocumentListener(function(doc){_this._displayDocument(doc);});};var notifierService=this.notifierService;if(notifierService){notifierService.addListener(function(change){_this._notifierUpdate(change);});};var dispatchService=this.dispatchService;if(dispatchService){var f=function(msg,address,dispatchService){_this._handleDispatch(msg,address,dispatchService);};dispatchService.register(DH,'start',f);};},addPostProcessDisplayFunction:function(fn){if(typeof(fn)==='function'){this.postProcessDisplayFns.push(fn);};},fixElementAndChildren:function($elem,opt,contextDoc){this.domStyler.fixElementAndChildren($elem,opt,contextDoc);},displayBriefDescription:function($elem,opt,doc){if(doc&&doc._id){$elem.addClass('n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(doc._id));$elem.addClass('n2ShowDocBrief');};this._displayDocumentBrief($elem,doc,opt);},displayDocument:function($elem,opt,doc){if(doc&&doc._id){$elem.addClass('n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(doc._id));};this._displayDocumentFull($elem,doc,opt);},printUserName:function($elem,userName,opts){$elem.addClass('n2ShowUser_'+$n2.utils.stringToHtmlId(userName));if(opts&&opts.showHandle){$elem.addClass('n2ShowUserDisplayAndHandle');}else{$elem.addClass('n2ShowUserDisplay');};$elem.text('('+userName+')');this._requestUser(userName);},printBriefDescription:function($elem,docId,opts){$elem.addClass('n2ShowDoc_'+$n2.utils.stringToHtmlId(docId));$elem.addClass('n2ShowDocBrief');$elem.text(docId);this._requestDocument(docId);},printDocument:function($elem,docId,opts_){var opts=$n2.extend({eliminateNonApprovedMedia:false,eliminateDeniedMedia:false},opts_);$elem.addClass('n2ShowDoc_'+$n2.utils.stringToHtmlId(docId));if(opts.eliminateNonApprovedMedia){$elem.addClass('n2NoShowNonApprovedMedia');};if(opts.eliminateDeniedMedia){$elem.addClass('n2NoShowDenied');};$elem.text(docId);this._requestDocument(docId);},printLayerName:function($elem,layerIdentifier,opts_){$elem.addClass('n2ShowLayerName_'+$n2.utils.stringToHtmlId(layerIdentifier));$elem.text(layerIdentifier);this._requestDocument(layerIdentifier);},_displayUserDocument:function(userDoc){var id=userDoc._id;var displayName=userDoc.display;var userName=null;if(id.substr(0,couchUserPrefix.length)===couchUserPrefix){userName=id.substr(couchUserPrefix.length);};if(userName){$('.n2ShowUser_'+$n2.utils.stringToHtmlId(userName)).each(function(i,elem){var $elem=$(elem);if($elem.hasClass('n2ShowUserDisplay')){if(displayName){$elem.text(displayName);};}else if($elem.hasClass('n2ShowUserDisplayAndHandle')){if(displayName&&userName){$elem.text(displayName+' ('+userName+')');};}else{if(displayName){$elem.text(displayName);};};});};},_displayDocument:function(doc){var _this=this;var id=doc._id;var showClass='n2ShowDoc_'+$n2.utils.stringToHtmlId(id);$('.'+showClass).each(function(i,elem){var $elem=$(elem);$elem.removeClass(showClass).addClass('n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(id));if(_this.eliminateNonApprovedMedia){if($n2.couchMap.documentContainsMedia(doc)&&false==$n2.couchMap.documentContainsApprovedMedia(doc)){$elem.empty();return;};}else if(_this.eliminateDeniedMedia){if($n2.couchMap.documentContainsMedia(doc)&&true==$n2.couchMap.documentContainsDeniedMedia(doc)){$elem.empty();return;};};if($elem.hasClass('n2ShowDocBrief')){_this._displayDocumentBrief($elem,doc);return;};_this._displayDocumentFull($elem,doc);});if(doc.nunaliit_layer_definition&&doc.nunaliit_layer_definition.name){var name=_loc(doc.nunaliit_layer_definition.name);var layerClass='n2ShowLayerName_'+$n2.utils.stringToHtmlId(id);$('.'+layerClass).each(function(i,elem){var $elem=$(elem);$elem.text(name);});};},_updateDocument:function(doc){var _this=this;var id=doc._id;var updateClass='n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(id);$('.'+updateClass).each(function(i,elem){var $elem=$(elem);if($elem.hasClass('n2ShowDocBrief')){_this._displayDocumentBrief($elem,doc);return;};_this._displayDocumentFull($elem,doc);});},_displayDocumentBrief:function($elem,doc,opt_){var opt=$n2.extend({onDisplayed:function($elem,doc,opt_){},schemaName:null},opt_);var _this=this;doc=this._preprocessDocument(doc);if(opt.schemaName){_this.schemaRepository.getSchema({name:opt.schemaName,onSuccess:function(schema_){printBrief($elem,schema_);},onError:function(){displayError($elem);}});}else if(doc.nunaliit_schema){_this.schemaRepository.getSchema({name:doc.nunaliit_schema,onSuccess:function(schema_){printBrief($elem,schema_);},onError:function(){displayError($elem);}});}else if(_this.defaultSchema){printBrief($elem,_this.defaultSchema);}else{displayError($elem);};function printBrief($elem,schema){schema.brief(doc,$elem);_this.fixElementAndChildren($elem,{},doc);_this._postProcessDisplay($elem,doc);opt.onDisplayed($elem,doc,schema,opt_);};function displayError($elem){$elem.text(_loc('Unable to display brief description'));opt.onDisplayed($elem,doc,null,opt_);};},_displayDocumentFull:function($elem,doc,opt_){var opt=$n2.extend({onDisplayed:function($elem,doc,opt_){},schemaName:null},opt_);var _this=this;doc=this._preprocessDocument(doc);if(opt.schemaName){_this.schemaRepository.getSchema({name:opt.schemaName,onSuccess:function(schema){displaySchema($elem,schema);},onError:function(){displayError($elem);}});}else if(doc.nunaliit_schema){_this.schemaRepository.getSchema({name:doc.nunaliit_schema,onSuccess:function(schema){displaySchema($elem,schema);},onError:function(){displayError($elem);}});}else if(_this.defaultSchema){displaySchema($elem,_this.defaultSchema);}else{displayError($elem);};function displaySchema($elem,schema){schema.display(doc,$elem);_this.fixElementAndChildren($elem,{},doc);_this._postProcessDisplay($elem,doc);opt.onDisplayed($elem,doc,schema,opt_);};function displayError($elem){$elem.text(_loc('Unable to display document'));};},_preprocessDocument:function(doc_){var doc=doc_;if(this.options&&this.options.preprocessDocument){doc=this.options.preprocessDocument(doc);};return doc;},_postProcessDisplay:function($sElem,data){for(var i=0,e=this.postProcessDisplayFns.length;i<e;++i){var fn=this.postProcessDisplayFns[i];fn(data,$sElem);};},_requestUser:function(userName){var requestService=this.requestService;if(requestService){requestService.requestUser(userName);};},_requestDocument:function(docId,cbFn){var requestService=this.requestService;if(requestService){requestService.requestDocument(docId,cbFn);};},_notifierUpdate:function(change){var _this=this;var updatedDocIds={};var deletedDocIds={};if(change&&change.results&&change.results.length){for(var i=0,e=change.results.length;i<e;++i){var docId=change.results[i].id;var isDeleted=false;if(change.results[i].deleted){isDeleted=true;};if(isDeleted){deletedDocIds[docId]=true;if(updatedDocIds[docId]){delete updatedDocIds[docId];};}else{updatedDocIds[docId]=true;};};};for(var docId in deletedDocIds){var escaped=$n2.utils.stringToHtmlId(docId);$('.n2ShowDoc_'+escaped).remove();$('.n2ShowUpdateDoc_'+escaped).remove();};var requestDocIds=[];for(var docId in updatedDocIds){var $elems=$('.n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(docId));if($elems.length>0){requestDocIds.push(docId);};};for(var i=0,e=requestDocIds.length;i<e;++i){this._requestDocument(requestDocIds[i],function(doc){_this._updateDocument(doc);});};},_handleDispatch:function(m,address,dispatchService){if('start'===m.type){var customService=this.customService;if(customService){var postProcessFns=customService.getOption('displayPostProcessFunctions');if(postProcessFns){for(var i=0,e=postProcessFns.length;i<e;++i){var fn=postProcessFns[i];this.addPostProcessDisplayFunction(fn);};};};};}});$n2.couchShow={Show:Show};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchEdit';function getDefaultCouchProjection(){var defaultCouchProj=null;if(typeof(OpenLayers)!=='undefined'&&OpenLayers.Projection){defaultCouchProj=new OpenLayers.Projection('EPSG:4326');};return defaultCouchProj;};function isKeyEditingAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;if(selectors[0]==='__n2Source')return false;return true;}
function isValueEditingAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;if(selectors[0]==='__n2Source')return false;return true;};function isKeyDeletionAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;if(selectors[0]==='__n2Source')return false;return true;};function searchForDocumentId(options_){var options=$n2.extend({searchServer:null,showService:null,onSelected:function(docId){},onReset:function(){}},options_);var shouldReset=true;var dialogId=$n2.getUniqueId();var inputId=$n2.getUniqueId();var searchButtonId=$n2.getUniqueId();var displayId=$n2.getUniqueId();var $dialog=$('<div id="'+dialogId+'" class="editorSelectDocumentDialog">'
+'<div><label for="'+inputId+'">'+_loc('Search:')+'</label>'
+'<input id="'+inputId+'" type="text"/>'
+'<button id="'+searchButtonId+'">'+_loc('Search')+'</button></div>'
+'<div  class="editorSelectDocumentDialogResults" id="'+displayId+'"></div>'
+'<div><button class="cancel">'+_loc('Cancel')+'</button></div>'
+'</div>');$dialog.find('button.cancel').button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);$dialog.dialog('close');return false;});var dialogOptions={autoOpen:true,title:_loc('Select Document'),modal:true,width:370,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();if(shouldReset){options.onReset();};}};$dialog.dialog(dialogOptions);options.searchServer.installSearch({textInput:$('#'+inputId),searchButton:$('#'+searchButtonId),displayFn:displaySearch,onlyFinalResults:true});function displaySearch(displayData){if(!displayData){reportError('Invalid search results returned');}else if('wait'===displayData.type){$('#'+displayId).empty();}else if('results'===displayData.type){var $table=$('<table></table>');$('#'+displayId).empty().append($table);for(var i=0,e=displayData.list.length;i<e;++i){var docId=displayData.list[i].id;var $tr=$('<tr></tr>');$table.append($tr);$td=$('<td class="n2_search_result olkitSearchMod2_'+(i%2)+'">'
+'<a href="#'+docId+'" alt="'+docId+'"></a></td>');$tr.append($td);if(options.showService){options.showService.printBriefDescription($td.find('a'),docId);}else{$td.find('a').text(docId);};$td.find('a').click(createClickHandler(docId));};}else{reportError('Invalid search results returned');};};function createClickHandler(docId){return function(e){options.onSelected(docId);shouldReset=false;var $dialog=$('#'+dialogId);$dialog.dialog('close');return false;};};};function selectLayersDialog(opts_){var opts=$n2.extend({currentLayers:[],cb:function(selectedLayerIds){},resetFn:function(){},documentSource:null,showService:null,dispatchService:null},opts_);var layers={};if(typeof(opts.currentLayers)==='string'){var layerNames=currentLayers.split(',');for(var i=0,e=layerNames.length;i<e;++i){layers[$n2.trim(layerNames[i])]={currentlySelected:true};};}else if($n2.isArray(opts.currentLayers)){for(var i=0,e=opts.currentLayers.length;i<e;++i){layers[$n2.trim(opts.currentLayers[i])]={currentlySelected:true};};};var shouldReset=true;var dialogId=$n2.getUniqueId();var $dialog=$('<div id="'+dialogId+'" class="editorSelectLayerDialog">'
+'<div class="editorSelectLayerContent"></div>'
+'<div class="editorSelectLayerButtons"><button class="ok">'+_loc('OK')+'</button>'
+'<button class="cancel">'+_loc('Cancel')+'</button></div>'
+'</div>');$dialog.find('button.cancel').button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);$dialog.dialog('close');return false;});$dialog.find('button.ok').button({icons:{primary:'ui-icon-check'},disabled:true});var dialogOptions={autoOpen:true,title:_loc('Select Layers'),modal:true,width:370,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();if(shouldReset){opts.resetFn();};}};$dialog.dialog(dialogOptions);if(opts.documentSource){opts.documentSource.getLayerDefinitions({onSuccess:function(layerDefs){var layerIdentifiers={};for(var i=0,e=layerDefs.length;i<e;++i){var layerId=layerDefs[i].id;if(!layers[layerId]){layers[layerId]={currentlySelected:false};};};getInnerLayers();},onError:function(errorMsg){reportError(errorMsg);}});}else{getInnerLayers();};function getInnerLayers(){var m={type:'mapGetLayers',layers:{}};opts.dispatchService.synchronousCall(DH,m);for(var layerId in m.layers){if(!layers[layerId]){layers[layerId]={currentlySelected:false};};};displayLayers();};function displayLayers(){var $diag=$('#'+dialogId);var $c=$diag.find('.editorSelectLayerContent');$c.empty();for(var layerId in layers){var inputId=$n2.getUniqueId();var $div=$('<div><input id="'+inputId+'" class="layer" type="checkbox"/><label for="'+inputId+'"></label></div>');$c.append($div);$div.find('input').attr('name',layerId);$div.find('label').text(layerId);if(layers[layerId].currentlySelected){$div.find('input').attr('checked','checked');};if(opts.showService){opts.showService.printLayerName($div.find('label'),layerId);};};$diag.find('button.ok').button('option','disabled',false).click(function(){var selectedLayers=[];var $diag=$('#'+dialogId);$diag.find('input.layer').each(function(){var $input=$(this);if($input.is(':checked')){var layerId=$input.attr('name');selectedLayers.push(layerId);};});opts.cb(selectedLayers);shouldReset=false;$diag.dialog('close');});};function reportError(err){$('#'+dialogId).find('.editorSelectLayerContent').text('Error: '+err);};};var CouchSimpleDocumentEditor=$n2.Class({elemId:null,editedDocument:null,schema:null,defaultEditSchema:null,schemaRepository:null,schemaEditorService:null,dispatchService:null,editors:null,geomName:null,couchProj:null,treeEditor:null,slideEditor:null,isInsert:null,editorsContainerId:null,initialize:function(opts_){var opts=$n2.extend({elem:null,elemId:null,doc:null,schema:null,defaultEditSchema:null,schemaRepository:null,schemaEditorService:null,dispatchService:null,editors:null,geomName:'nunaliit_geom',couchProj:null},opts_);this.elemId=opts.elemId;if(opts.elem){var $elem=$(opts.elem);this.elemId=$elem.attr('id');if(!this.elemId){this.elemId=$n2.getUniqueId();$elem.attr('id',this.elemId);};};this.editedDocument=opts.doc;this.schema=opts.schema;this.defaultEditSchema=opts.defaultEditSchema;this.schemaRepository=opts.schemaRepository;this.schemaEditorService=opts.schemaEditorService;this.dispatchService=opts.dispatchService;this.editors=opts.editors;this.geomName=opts.geomName;this.couchProj=opts.couchProj;this.isInsert=false;if(!this.couchProj){this.couchProj=getDefaultCouchProjection();};if(this.dispatchService){var f=function(m){_this._handle(m);};this.dispatchService.register(DH,'editGeometryModified',f);};if(!this.editors){this.editors=[$n2.CouchEditor.Constants.FORM_EDITOR,$n2.CouchEditor.Constants.TREE_EDITOR,$n2.CouchEditor.Constants.SLIDE_EDITOR,$n2.CouchEditor.Constants.RELATION_EDITOR];};this._edit();},_getDiv:function(){return $('#'+this.elemId);},_edit:function(){var _this=this;this.isInsert=(typeof this.editedDocument._id==='undefined'||this.editedDocument._id===null);this._selectSchema(schemaSelected);function schemaSelected(schema){if(_this.isInsert){if(schema){var template=schema.createObject({});$n2.extend(true,_this.editedDocument,template);};};_this._displayEditor(schema);};},_displayEditor:function(selectedSchema){var _this=this;var data=this.editedDocument;this._synchronousCall({type:'editorStartDocumentEdit',doc:data});$n2.couchDocument.adjustDocument(data);var accordionNeeded=false;var relationEditorNeeded=false;var editorCount=0;for(var i=0,e=this.editors.length;i<e;++i){var editorDesc=this.editors[i];if($n2.CouchEditor.Constants.FORM_EDITOR===editorDesc){if(selectedSchema&&this.schemaEditorService){++editorCount;};}else if($n2.CouchEditor.Constants.TREE_EDITOR===editorDesc){++editorCount;}else if($n2.CouchEditor.Constants.SLIDE_EDITOR===editorDesc){++editorCount;}else if($n2.CouchEditor.Constants.RELATION_EDITOR===editorDesc){relationEditorNeeded=true;};};if(editorCount>1){accordionNeeded=true;};var $div=this._getDiv();$div.empty();this.editorsContainerId=$n2.getUniqueId();var $editorsContainer=$('<div id="'+this.editorsContainerId+'" class="n2CouchEditor_container"></div>');$div.append($editorsContainer);for(var i=0,e=this.editors.length;i<e;++i){var editorDesc=this.editors[i];if($n2.CouchEditor.Constants.FORM_EDITOR===editorDesc&&selectedSchema&&this.schemaEditorService){$n2.schema.GlobalAttributes.disableKeyUpEvents=true;if(accordionNeeded){var $schemaHeader=$('<h3>').appendTo($editorsContainer);$('<a>').attr('href','#').text(_loc('Form View')).appendTo($schemaHeader);};var $schemaContainer=$('<div class="n2CouchEditor_schema"></div>').addClass('n2CouchEditor_schema').appendTo($editorsContainer);this.schemaEditor=this.schemaEditorService.editDocument({doc:data,schema:selectedSchema,$div:$schemaContainer,onChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.treeEditor){_this.treeEditor.refresh();};if(_this.slideEditor){_this.slideEditor.refresh();};_this._refreshRelations(data);_this._onEditorObjectChanged(data);}});}else if($n2.CouchEditor.Constants.TREE_EDITOR===editorDesc){if(accordionNeeded){var $treeHeader=$('<h3>').appendTo($editorsContainer);$('<a>').attr('href','#').text(_loc('Tree View')).appendTo($treeHeader);};var $treeContainer=$('<div>').addClass('n2CouchEditor_tree').appendTo($editorsContainer);var editorOptions={onObjectChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.slideEditor){_this.slideEditor.refresh();};if(_this.schemaEditor){_this.schemaEditor.refresh();};_this._refreshRelations(data);_this._onEditorObjectChanged(data);},isKeyEditingAllowed:isKeyEditingAllowed,isValueEditingAllowed:isValueEditingAllowed,isKeyDeletionAllowed:isKeyDeletionAllowed};var objectTree=new $n2.tree.ObjectTree($treeContainer,data,editorOptions);this.treeEditor=new $n2.tree.ObjectTreeEditor(objectTree,data,editorOptions);}else if($n2.CouchEditor.Constants.SLIDE_EDITOR===editorDesc){if(accordionNeeded){var $slideHeader=$('<h3>').appendTo($editorsContainer);$('<a>').attr('href','#').text(_loc('Editor View')).appendTo($slideHeader);};var $slideContainer=$('<div>').addClass('n2CouchEditor_slide').appendTo($editorsContainer);var slideEditorOptions={onObjectChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.treeEditor){_this.treeEditor.refresh();};if(_this.schemaEditor){_this.schemaEditor.refresh();};_this._refreshRelations(data);_this._onEditorObjectChanged(data);},isKeyEditingAllowed:isKeyEditingAllowed,isValueEditingAllowed:isValueEditingAllowed,isKeyDeletionAllowed:isKeyDeletionAllowed};this.slideEditor=new $n2.slideEditor.Editor($slideContainer,data,slideEditorOptions);};};if(accordionNeeded){$editorsContainer.accordion({collapsible:true});};if(relationEditorNeeded){var $displayRelationsDiv=$('<div class="editorDisplayRelations"></div>');$editorsContainer.append($displayRelationsDiv);this._refreshRelations(data);};},_selectSchema:function(callbackFn){var _this=this;if(this.editedDocument.nunaliit_schema){this.schemaRepository.getSchema({name:this.editedDocument.nunaliit_schema,onSuccess:function(schema){callbackFn(schema);},onError:function(err){$n2.log('Error fetching schema: '+_this.editedDocument.nunaliit_schema,err);callbackFn(null);}});}else if(this.schema&&this.isInsert){if($n2.CouchEditor.Constants.ALL_SCHEMAS===this.schema){this.schemaRepository.getRootSchemas({onSuccess:function(schemas){selectFromSchemas(schemas);},onError:function(err){$n2.log('Error fetching root schemas',err);callbackFn(null);}});}else if($n2.isArray(this.schema)){selectFromSchemas(this.schema);}else{callbackFn(this.schema);};}else if(this.defaultEditSchema&&!this.isInsert){callbackFn(this.defaultEditSchema);}else{callbackFn(null);};function selectFromSchemas(schemas){if(schemas.length<1){callbackFn(null);return;}else if(schemas.length==1){callbackFn(schemas[0]);return;};var dialogId=$n2.getUniqueId();var selectId=$n2.getUniqueId();var $dialog=$('<div id="'+dialogId+'" class="editorSelectSchemaDialog">'
+'<label for="'+selectId+'">'+_loc('Select a schema:')+'</label>'
+'<select id="'+selectId+'"></select>'
+'<div><button>'+_loc('OK')+'</button><button>'+_loc('Cancel')+'</button></div>'
+'</div>');var $select=$dialog.find('select');for(var i=0,e=schemas.length;i<e;++i){$select.append($('<option>'+schemas[i].name+'</option>'));}
var cancelOnClose=true;$dialog.find('button').first().button({icons:{primary:'ui-icon-check'}}).click(function(){var $dialog=$('#'+dialogId);var $select=$dialog.find('select');var schemaName=$select.val();$n2.log('schemaName',schemaName);_this.schemaRepository.getSchema({name:schemaName,onSuccess:function(schema){callbackFn(schema);},onError:function(err){reportError('Unable to get selected schema: '+err);_this._cancelEdit();}});cancelOnClose=false;$dialog.dialog('close');return false;}).next().button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);$dialog.dialog('close');return false;});var dialogOptions={autoOpen:true,title:_loc('Select Document Schema'),modal:true,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();if(cancelOnClose){_this._cancelEdit();};}};$dialog.dialog(dialogOptions);};},_dispatch:function(m){if(this.dispatchService){this.dispatchService.send(DH,m);};},_synchronousCall:function(m){if(this.dispatchService){this.dispatchService.send(DH,m);};},_handle:function(m,address,dispatcher){var $div=this._getDiv();if($div.length<1){dispatcher.deregister(address);};if(m.type==='editGeometryModified'){if(m._origin!==this){this._featureModified(m.docId,m.geom,m.proj);};};},_adjustInternalValues:function(obj){if(typeof(OpenLayers)!=='undefined'){var geomData=obj[this.geomName];if(geomData){if(this.currentGeometryWkt!=geomData.wkt){$n2.couchGeom.adjustBboxOnCouchGeom(geomData);};};};},_refreshRelations:function(data){var _this=this;var $div=this._getDiv();var $displayRelationsDiv=$div.find('.editorDisplayRelations');if($displayRelationsDiv.length<1)return;var showService=this.showService;if(!showService)return;var docIdMap={};if(data&&data.nunaliit_relations&&data.nunaliit_relations.length){for(var i=0,e=data.nunaliit_relations.length;i<e;++i){var ref=data.nunaliit_relations[i];if(ref.doc){docIdMap[ref.doc]=true;};};};if(data&&data.nunaliit_source&&data.nunaliit_source.doc){docIdMap[data.nunaliit_source.doc]=true;};$displayRelationsDiv.find('.editorDisplayRelation').each(function(){var $display=$(this);var relDocId=$display.attr('nunaliitRelationDocId');if(!docIdMap[relDocId]){$display.remove();}else{delete docIdMap[relDocId];};});var removeRelationFn=function(e){var $btn=$(this);var $removeRelationDiv=$btn.parents('.editorDisplayRelation');if($removeRelationDiv.length>0){var relDocId=$removeRelationDiv.attr('nunaliitRelationDocId');_this._removeRelation(relDocId);$removeRelationDiv.remove();};return false;};for(var relDocId in docIdMap){var $displayRelationDiv=$('<div class="editorDisplayRelation"></div>');$displayRelationsDiv.append($displayRelationDiv);$displayRelationDiv.attr('nunaliitRelationDocId',relDocId);$('<span></span>').text(_loc('Relation: ')).appendTo($displayRelationDiv);var $brief=$('<span></span>').text(relDocId).appendTo($displayRelationDiv);if(showService){showService.printBriefDescription($brief,relDocId);};$('<button class="editorDisplayRelationButton"></button>').text(_loc('Remove')).appendTo($displayRelationDiv).button({icons:{primary:'ui-icon-trash'}}).click(removeRelationFn);};},_onEditorObjectChanged:function(obj){var geomData=obj[this.geomName];if(!geomData)return;if(typeof(OpenLayers)==='undefined')return;if(this.currentGeometryWkt!==geomData.wkt){this.currentGeometryWkt=geomData.wkt;var olGeom=$n2.couchGeom.getOpenLayersGeometry({couchGeom:geomData});this._dispatch({type:'editGeometryModified',docId:obj._id,geom:olGeom,proj:this.couchProj,_origin:this});};},_featureModified:function(docId,geom,proj){if(proj.getCode()!=this.couchProj.getCode()){geom=geom.clone();geom.transform(proj,this.options.couchProj);};var geomData=this.editedDocument[this.geomName];geomData.wkt=geom.toString();this.currentGeometryWkt=geomData.wkt;if(this.schemaEditor){this.schemaEditor.refresh();};if(this.treeEditor){this.treeEditor.refresh();};if(this.slideEditor){this.slideEditor.refresh();};}});var CouchDocumentEditor=$n2.Class({panelName:null,uploadService:null,searchService:null,showService:null,schemaEditorService:null,schemaRepository:null,customService:null,dispatchService:null,geomName:null,initialLayers:null,schema:null,defaultEditSchema:null,documentSource:null,couchProj:null,onFeatureInsertedFn:null,onFeatureUpdatedFn:null,onFeatureDeletedFn:null,onCancelFn:null,onCloseFn:null,enableAddFile:null,relatedDocProcess:null,schemaEditor:null,treeEditor:null,slideEditor:null,attachmentEditor:null,editedDocument:null,editedFeature:null,currentGeometryWkt:null,editorContainerId:null,isInsert:null,userButtons:null,editorSuppressSlideView:null,editorSuppressTreeView:null,editorSuppressFormView:null,initialize:function(opts_){var opts=$n2.extend({panelName:null,uploadService:null,searchService:null,showService:null,schemaEditorService:null,schemaRepository:null,customService:null,dispatchService:null,geomName:null,initialLayers:['public'],schema:null,defaultEditSchema:null,documentSource:null,couchProj:null,onFeatureInsertedFn:function(fid,feature){},onFeatureUpdatedFn:function(fid,feature){},onFeatureDeletedFn:function(fid,feature){},onCancelFn:function(feature){},onCloseFn:function(){},enableAddFile:false,relatedDocProcess:null},opts_);this.panelName=opts.panelName;this.uploadService=opts.uploadService;this.searchService=opts.searchService;this.showService=opts.showService;this.schemaEditorService=opts.schemaEditorService;this.schemaRepository=opts.schemaRepository;this.customService=opts.customService;this.dispatchService=opts.dispatchService;this.geomName=opts.geomName;this.initialLayers=opts.initialLayers;this.schema=opts.schema;this.defaultEditSchema=opts.defaultEditSchema;this.documentSource=opts.documentSource;this.couchProj=opts.couchProj;this.onFeatureInsertedFn=opts.onFeatureInsertedFn;this.onFeatureUpdatedFn=opts.onFeatureUpdatedFn;this.onFeatureDeletedFn=opts.onFeatureDeletedFn;this.onCancelFn=opts.onCancelFn;this.onCloseFn=opts.onCloseFn;this.enableAddFile=opts.enableAddFile;this.relatedDocProcess=opts.relatedDocProcess;this.userButtons=[];var label='button';for(var key in opts){if(key.substr(0,label.length)===label){this.userButtons.push(opts[key]);};};this.editorSuppressSlideView=false;this.editorSuppressTreeView=false;this.editorSuppressFormView=false;var cs=this.customService;if(cs){this.editorSuppressSlideView=cs.getOption('editorSuppressSlideView',false);this.editorSuppressTreeView=cs.getOption('editorSuppressTreeView',false);this.editorSuppressFormView=cs.getOption('editorSuppressFormView',false);var flag=cs.getOption('editorEnableAddFile',false);if(flag){this.enableAddFile=true;};};},startFeatureEditing:function(feature_){var _this=this;this.editedFeature=feature_;this.editedDocument=feature_.data;this.currentGeometryWkt=null;if(this.editedDocument&&this.editedDocument[this.geomName]){this.currentGeometryWkt=this.editedDocument[this.geomName].wkt;};this.isInsert=(typeof(this.editedFeature.fid)==='undefined'||this.editedFeature.fid===null);if(this.isInsert){var geom=this.convertFeatureGeometryForDb(this.editedFeature);var g=$n2.couchGeom.getCouchGeometry(geom);this.editedDocument[this.geomName]=g;if(this.initialLayers&&this.initialLayers.length>0){this.editedDocument.nunaliit_layers=this.initialLayers;};};this._selectSchema(schemaSelected);function schemaSelected(schema){if(_this.isInsert){if(schema){var template=schema.createObject({});$n2.extend(true,_this.editedDocument,template);};var geom=_this.convertFeatureGeometryForDb(_this.editedFeature);var g=$n2.couchGeom.getCouchGeometry(geom);_this.editedDocument[_this.geomName]=g;if(_this.initialLayers&&_this.initialLayers.length>0){_this.editedDocument.nunaliit_layers=_this.initialLayers;};};_this._displayEditor(schema);};},startDocumentEditing:function(doc_){var _this=this;this.editedDocument=doc_;this.isInsert=(typeof(this.editedDocument._id)==='undefined'||this.editedDocument._id===null);this._selectSchema(schemaSelected);function schemaSelected(schema){if(_this.isInsert){if(schema){var template=schema.createObject({});$n2.extend(true,_this.editedDocument,template);};};_this._displayEditor(schema);};},_selectSchema:function(callbackFn){var _this=this;if(this.editedDocument.nunaliit_schema){this.schemaRepository.getSchema({name:this.editedDocument.nunaliit_schema,onSuccess:function(schema){callbackFn(schema);},onError:function(err){$n2.log('Error fetching schema: '+_this.editedDocument.nunaliit_schema,err);callbackFn(null);}});}else if(this.schema&&this.isInsert){if($n2.CouchEditor.Constants.ALL_SCHEMAS===this.schema){this.schemaRepository.getRootSchemas({onSuccess:function(schemas){_this.relatedDocProcess.selectSchemaDialog({schemas:schemas,onSuccess:callbackFn});},onError:function(err){$n2.log('Error fetching root schemas',err);callbackFn(null);}});}else if($n2.isArray(this.schema)){this.relatedDocProcess.selectSchemaDialog({schemas:this.schema,onSuccess:callbackFn});}else{callbackFn(this.schema);};}else if(this.defaultEditSchema&&!this.isInsert){callbackFn(this.defaultEditSchema);}else{callbackFn(null);};function selectFromSchemas(schemas){if(schemas.length<1){callbackFn(null);return;}else if(schemas.length==1){callbackFn(schemas[0]);return;};var dialogId=$n2.getUniqueId();var selectId=$n2.getUniqueId();var $dialog=$('<div id="'+dialogId+'" class="editorSelectSchemaDialog">'
+'<label for="'+selectId+'">'+_loc('Select a schema:')+'</label>'
+'<select id="'+selectId+'"></select>'
+'<div><button>'+_loc('OK')+'</button><button>'+_loc('Cancel')+'</button></div>'
+'</div>');var $select=$dialog.find('select');for(var i=0,e=schemas.length;i<e;++i){$select.append($('<option>'+schemas[i].name+'</option>'));};var cancelOnClose=true;$dialog.find('button').first().button({icons:{primary:'ui-icon-check'}}).click(function(){var $dialog=$('#'+dialogId);var $select=$dialog.find('select');var schemaName=$select.val();$n2.log('schemaName',schemaName);_this.schemaRepository.getSchema({name:schemaName,onSuccess:function(schema){callbackFn(schema);},onError:function(err){reportError('Unable to get selected schema: '+err);_this._cancelEdit();}});cancelOnClose=false;$dialog.dialog('close');return false;}).next().button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);$dialog.dialog('close');return false;});var dialogOptions={autoOpen:true,title:_loc('Select Document Schema'),modal:true,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();if(cancelOnClose){_this._cancelEdit();};}};$dialog.dialog(dialogOptions);};},_displayEditor:function(selectedSchema){var _this=this;$('body').addClass('nunaliit_editing');$('.n2_disable_on_edit').attr('disabled','disabled');var data=this.editedDocument;this._synchronousCall({type:'editorStartDocumentEdit',doc:data});$n2.couchDocument.adjustDocument(data);var showFormView=false;var showTreeView=false;var showSlideView=false;var viewCount=0;var showAccordion=false;var schemaEditorService=this.schemaEditorService;if(!this.editorSuppressFormView&&selectedSchema&&schemaEditorService){showFormView=true;++viewCount;};if(!this.editorSuppressTreeView){showTreeView=true;++viewCount;};if(!this.editorSuppressTreeView){showSlideView=true;++viewCount;};if(viewCount>1){showAccordion=true;};var attributeDialog=$('#'+this.panelName);attributeDialog.empty();this.editorContainerId=$n2.getUniqueId();var $editorContainer=$('<div id="'+this.editorContainerId+'" class="n2CouchEditor_container"></div>');attributeDialog.append($editorContainer);if(showFormView){$n2.schema.GlobalAttributes.disableKeyUpEvents=true;if(showAccordion){var $schemaHeader=$('<h3>').appendTo($editorContainer);$('<a>').attr('href','#').text(_loc('Form View')).appendTo($schemaHeader);};var $schemaContainer=$('<div>').addClass('n2CouchEditor_schema').appendTo($editorContainer);this.schemaEditor=schemaEditorService.editDocument({doc:data,schema:selectedSchema,$div:$schemaContainer,onChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.treeEditor){_this.treeEditor.refresh();};if(_this.slideEditor){_this.slideEditor.refresh();};if(_this.attachmentEditor){_this.attachmentEditor.refresh();};_this._refreshRelations(data);_this.onEditorObjectChanged(data);}});};if(showTreeView){if(showAccordion){var $treeHeader=$('<h3>').appendTo($editorContainer);$('<a>').attr('href','#').text(_loc('Tree View')).appendTo($treeHeader);};var $treeContainer=$('<div>').addClass('n2CouchEditor_tree').appendTo($editorContainer);var editorOptions={onObjectChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.slideEditor){_this.slideEditor.refresh();};if(_this.schemaEditor){_this.schemaEditor.refresh();};if(_this.attachmentEditor){_this.attachmentEditor.refresh();};_this._refreshRelations(data);_this.onEditorObjectChanged(data);},isKeyEditingAllowed:isKeyEditingAllowed,isValueEditingAllowed:isValueEditingAllowed,isKeyDeletionAllowed:isKeyDeletionAllowed};var objectTree=new $n2.tree.ObjectTree($treeContainer,data,editorOptions);this.treeEditor=new $n2.tree.ObjectTreeEditor(objectTree,data,editorOptions);};if(showSlideView){if(showAccordion){var $slideHeader=$('<h3>').appendTo($editorContainer);$('<a>').attr('href','#').text(_loc('Editor View')).appendTo($slideHeader);};var $slideContainer=$('<div>').addClass('n2CouchEditor_slide').appendTo($editorContainer);var slideEditorOptions={onObjectChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.treeEditor){_this.treeEditor.refresh();};if(_this.schemaEditor){_this.schemaEditor.refresh();};if(_this.attachmentEditor){_this.attachmentEditor.refresh();};_this._refreshRelations(data);_this.onEditorObjectChanged(data);},isKeyEditingAllowed:isKeyEditingAllowed,isValueEditingAllowed:isValueEditingAllowed,isKeyDeletionAllowed:isKeyDeletionAllowed};this.slideEditor=new $n2.slideEditor.Editor($slideContainer,data,slideEditorOptions);};if(showAccordion){$editorContainer.accordion({collapsible:true});};$('<div>').addClass('editorDisplayRelations').appendTo($editorContainer);this._refreshRelations(data);{var disableAttachmentEditorButtons=!this.enableAddFile;var $attachmentsDiv=$('<div>').addClass('editorAttachments').appendTo($editorContainer);this.attachmentEditor=new AttachmentEditor({doc:data,elem:$attachmentsDiv,documentSource:this.documentSource,uploadService:this.uploadService,disableAddFile:disableAttachmentEditorButtons,disableRemoveFile:disableAttachmentEditorButtons,onChangedFn:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.schemaEditor){_this.schemaEditor.refresh();};if(_this.treeEditor){_this.treeEditor.refresh();};if(_this.slideEditor){_this.slideEditor.refresh();};_this._refreshRelations(data);_this.onEditorObjectChanged(data);}});};var formButtons=$('<div class="editorButtons"></div>');$editorContainer.append(formButtons);var saveBtn=$('<button class="save">'+_loc('Save')+'</button>');formButtons.append(saveBtn);saveBtn.button({icons:{primary:'ui-icon-check'}});saveBtn.click(function(){_this._save();return false;});if(!this.isInsert&&$n2.couchMap.canDeleteDoc(data)){var deleteBtn=$('<button class="delete">'+_loc('Delete')+'</button>');formButtons.append(deleteBtn);deleteBtn.button({icons:{primary:'ui-icon-trash'}});deleteBtn.click(function(evt){if(confirm(_loc('Do you really want to delete this feature?'))){deletion(data);};return false;});};if(this.attachmentEditor){this.attachmentEditor.printButtons({elem:formButtons});};var addRelationBtn=$('<button class="relation">'+_loc('Add Relation')+'</button>');formButtons.append(addRelationBtn);addRelationBtn.button({icons:{primary:'ui-icon-plusthick'}});addRelationBtn.click(function(){_this._addRelationDialog();return false;});var layersBtn=$('<button class="layers">'+_loc('Layers')+'</button>');formButtons.append(layersBtn);layersBtn.button({icons:{primary:'ui-icon-link'}});layersBtn.click(function(){_this._manageLayersDialog();return false;});var cancelBtn=$('<button class="cancel">'+_loc('Cancel')+'</button>');formButtons.append(cancelBtn);cancelBtn.button({icons:{primary:'ui-icon-cancel'}});cancelBtn.click(function(){_this._cancelEdit();return false;});for(var i=0,e=this.userButtons.length;i<e;++i){var userButton=this.userButtons[i];var $uBtn=$('<button>'+_loc(''+userButton.label)+'</button>');if(userButton.buttonClass){$uBtn.addClass(userButton.buttonClass);};if(userButton.before){var $anchor=formButtons.find('button.'+userButton.before);$anchor.before($uBtn);}else if(userButton.after){var $anchor=formButtons.find('button.'+userButton.after);$anchor.after($uBtn);}else{formButtons.append($uBtn);};$uBtn.button(userButton.options);installUserButtonClick($uBtn,userButton);};function deletion(editedDocument){_this.documentSource.deleteDocument({doc:_this.editedDocument,onSuccess:function(){_this.onFeatureDeletedFn(editedDocument._id,_this.editedFeature);_this._discardEditor({deleted:true});},onError:function(err){_this._enableControls();$n2.reportErrorForced('Unable to delete document: '+err);}});};function installUserButtonClick($uBtn,userButton){$uBtn.click(function(){if(userButton.click){return userButton.click(_this.editedDocument,_this,userButton);};return false;});};},_save:function(){var _this=this;this._disableControls();if(this.uploadService){this.uploadService.getWelcome({onSuccess:function(){preSaveAttachmentEditor();},onError:function(err){_this._enableControls();$n2.reportErrorForced('Server is not available: '+err);}});}else{preSaveAttachmentEditor();};function preSaveAttachmentEditor(){if(_this.attachmentEditor){_this.attachmentEditor.performPreSavingActions({onSuccess:function(doc){removeCompulsoryAttachmentFlag();},onError:function(err){_this._enableControls();$n2.reportErrorForced(err);}});}else{removeCompulsoryAttachmentFlag();};};function removeCompulsoryAttachmentFlag(){if(_this.editedDocument&&_this.editedDocument.nunaliit_attachments){if(typeof _this.editedDocument.nunaliit_attachments._compulsory!=='undefined'){delete _this.editedDocument.nunaliit_attachments._compulsory;};if(_this.editedDocument.nunaliit_attachments.files){for(var attName in _this.editedDocument.nunaliit_attachments.files){var att=_this.editedDocument.nunaliit_attachments.files[attName];if(typeof att._compulsory!=='undefined'){delete att._compulsory;};};};};updateDocument();};function updateDocument(){if(_this.isInsert){var isSubmissionDs=false;if(_this.documentSource.isSubmissionDataSource){isSubmissionDs=true;};_this.documentSource.createDocument({doc:_this.editedDocument,onSuccess:function(updatedDoc){if(isSubmissionDs){postSaveAttachmentEditor(updatedDoc,false);}else{postSaveAttachmentEditor(updatedDoc,true);};},onError:function(err){_this._enableControls();$n2.reportErrorForced(_loc('Unable to submit document: {err}',{err:err}));}});}else{_this.documentSource.updateDocument({doc:_this.editedDocument,onSuccess:function(updatedDoc){postSaveAttachmentEditor(updatedDoc,false);},onError:function(err){_this._enableControls();$n2.reportErrorForced(_loc('Unable to submit document: {err}',{err:err}));}});};};function postSaveAttachmentEditor(editedDocument,inserted){if(_this.attachmentEditor){_this.attachmentEditor.performPostSavingActions({onSuccess:function(doc){completeSave(editedDocument,inserted);},onError:function(err){_this._enableControls();$n2.reportErrorForced(err);}});}else{completeSave(editedDocument,inserted);};};function completeSave(editedDocument,inserted){var discardOpts={saved:true};if(inserted){_this.onFeatureInsertedFn(editedDocument._id,_this.editedFeature);discardOpts.inserted=true;}else{_this.onFeatureUpdatedFn(editedDocument._id,_this.editedFeature);discardOpts.updated=true;};_this._discardEditor(discardOpts);};},_addRelationDialog:function(){var _this=this;searchForDocumentId({searchServer:this.searchService,showService:this.showService,onSelected:function(docId){_this._addRelation(docId);}});},_addRelation:function(relDocId){var data=this.editedDocument;if(data&&data.nunaliit_source&&data.nunaliit_source.doc===relDocId){return;};if(data&&data.nunaliit_relations&&data.nunaliit_relations.length){for(var i=0,e=data.nunaliit_relations.length;i<e;++i){var rel=data.nunaliit_relations[i];if(rel.doc===relDocId){return;};};};if(data){if(!data.nunaliit_relations){data.nunaliit_relations=[];};data.nunaliit_relations.push({nunaliit_type:'reference',doc:relDocId});this.refresh();};},_removeRelation:function(relDocId){var data=this.editedDocument;var refreshRequired=false;if(data&&data.nunaliit_source&&data.nunaliit_source.doc===relDocId){delete data.nunaliit_source;refreshRequired=true;};if(data&&data.nunaliit_relations&&data.nunaliit_relations.length){var relRemoved=false;var newRels=[];for(var i=0,e=data.nunaliit_relations.length;i<e;++i){var rel=data.nunaliit_relations[i];if(rel.doc===relDocId){relRemoved=true;}else{newRels.push(rel);};};if(newRels.length<1){delete data.nunaliit_relations;refreshRequired=true;}else if(relRemoved){data.nunaliit_relations=newRels;refreshRequired=true;};};if(refreshRequired){this.refresh();};},_manageLayersDialog:function(){var _this=this;var data=this.editedDocument;var layers=data.nunaliit_layers;if(!layers){layers=[];};selectLayersDialog({currentLayers:layers,cb:function(selectedLayers){if(selectedLayers.length<1){if(data.nunaliit_layers){delete data.nunaliit_layers;};}else{data.nunaliit_layers=selectedLayers;};_this.refresh();},documentSource:this.documentSource,showService:this.showService,dispatchService:this.dispatchService});},_removeAttachment:function(attNameToRemove){var data=this.editedDocument;var keys={};if(data&&data.nunaliit_attachments&&data.nunaliit_attachments.files){for(var attName in data.nunaliit_attachments.files){var att=data.nunaliit_attachments.files[attName];if(attName===attNameToRemove){keys[attName]=true;}else if(att.source===attNameToRemove){keys[attName]=true;};};};var refreshRequired=false;var attName=null;for(attName in keys){if(data._attachments&&data._attachments[attName]){delete data._attachments[attName];refreshRequired=true;};if(data.nunaliit_attachments.files[attName]){delete data.nunaliit_attachments.files[attName];refreshRequired=true;};};if(data._attachments){var empty=true;for(attName in data._attachments){empty=false;};if(empty){delete data._attachments;refreshRequired=true;};};if(data.nunaliit_attachments){var empty=true;if(data.nunaliit_attachments.files){for(attName in data.nunaliit_attachments.files){empty=false;};};if(empty){delete data.nunaliit_attachments;refreshRequired=true;};};if(refreshRequired){this.refresh();};},_cancelEdit:function(){this._dispatch({type:'editCancel',doc:this.editedDocument});},performCancellation:function(opts_){var opts=$n2.extend({suppressEvents:false},opts_);if(null==this.editedDocument){return;};this.onCancelFn(this.editedFeature);this._discardEditor({cancelled:true,suppressEvents:opts.suppressEvents});},_discardEditor:function(opts_){var opts=$n2.extend({saved:false,inserted:false,updated:false,deleted:false,cancelled:false,suppressEvents:false},opts_);if(null==this.editedDocument){return;};var $editorContainer=this._getEditorContainer();$editorContainer.remove();this.onCloseFn(this.editedDocument,this);if(!opts.suppressEvents){var docId=null;var doc=null;if(this.editedDocument._id){doc=this.editedDocument;docId=doc._id;};this._dispatch({type:'editClosed',docId:docId,doc:doc,saved:opts.saved,inserted:opts.inserted,updated:opts.updated,deleted:opts.deleted,cancelled:opts.cancelled});};this.editedDocument=null;this.editedFeature=null;this.editorContainerId=null;$('body').removeClass('nunaliit_editing');$('.n2_disable_on_edit').removeAttr('disabled');},refresh:function(){this._adjustInternalValues(this.editedDocument);if(this.treeEditor){this.treeEditor.refresh();};if(this.slideEditor){this.slideEditor.refresh();};if(this.schemaEditor){this.schemaEditor.refresh();};this._refreshRelations(this.editedDocument);this.onEditorObjectChanged(this.editedDocument);},_adjustInternalValues:function(obj){if(typeof(OpenLayers)!=='undefined'){var geomData=obj[this.geomName];if(geomData){if(this.currentGeometryWkt!=geomData.wkt){$n2.couchGeom.adjustBboxOnCouchGeom(geomData);};};};},_refreshRelations:function(data){var _this=this;var $editorContainer=this._getEditorContainer();var $displayRelationsDiv=$editorContainer.find('.editorDisplayRelations');if($displayRelationsDiv.length<1)return;var showService=this.showService;var docIdMap={};if(data&&data.nunaliit_relations&&data.nunaliit_relations.length){for(var i=0,e=data.nunaliit_relations.length;i<e;++i){var ref=data.nunaliit_relations[i];if(ref.doc){docIdMap[ref.doc]=true;};};};if(data&&data.nunaliit_source&&data.nunaliit_source.doc){docIdMap[data.nunaliit_source.doc]=true;};$displayRelationsDiv.find('.editorDisplayRelation').each(function(){var $display=$(this);var relDocId=$display.attr('nunaliitRelationDocId');if(!docIdMap[relDocId]){$display.remove();}else{delete docIdMap[relDocId];};});var removeRelationFn=function(e){var $btn=$(this);var $removeRelationDiv=$btn.parents('.editorDisplayRelation');if($removeRelationDiv.length>0){var relDocId=$removeRelationDiv.attr('nunaliitRelationDocId');_this._removeRelation(relDocId);$removeRelationDiv.remove();};return false;};for(var relDocId in docIdMap){var $displayRelationDiv=$('<div class="editorDisplayRelation"></div>');$displayRelationsDiv.append($displayRelationDiv);$displayRelationDiv.attr('nunaliitRelationDocId',relDocId);$('<span></span>').text(_loc('Relation: ')).appendTo($displayRelationDiv);var $brief=$('<span></span>').text(relDocId).appendTo($displayRelationDiv);if(showService){showService.printBriefDescription($brief,relDocId);};$('<button class="editorDisplayRelationButton"></button>').text(_loc('Remove')).appendTo($displayRelationDiv).button({icons:{primary:'ui-icon-trash'}}).click(removeRelationFn);};},onEditorObjectChanged:function(obj){var geomData=obj[this.geomName];if(!geomData)return;if(typeof(OpenLayers)==='undefined')return;if(this.currentGeometryWkt!==geomData.wkt){this.currentGeometryWkt=geomData.wkt;var olGeom=$n2.couchGeom.getOpenLayersGeometry({couchGeom:geomData});this._dispatch({type:'editGeometryModified',docId:obj._id,geom:olGeom,proj:this.couchProj,_origin:this});};},convertFeatureGeometryForDb:function(feature){var mapProj=feature.layer.map.projection;if(mapProj.getCode()!=this.couchProj.getCode()){var geom=feature.geometry.clone();geom.transform(mapProj,this.couchProj);return geom;};return feature.geometry;},_featureModified:function(docId,geom,proj){if(proj.getCode()!=this.couchProj.getCode()){geom=geom.clone();geom.transform(proj,this.couchProj);};var geomData=this.editedDocument[this.geomName];geomData.wkt=geom.toString();this.currentGeometryWkt=geomData.wkt;if(this.schemaEditor){this.schemaEditor.refresh();};if(this.treeEditor){this.treeEditor.refresh();};if(this.slideEditor){this.slideEditor.refresh();};},_getEditorContainer:function(){var $editorContainer=$('#'+this.editorContainerId);return $editorContainer;},_disableControls:function(){var $editorContainer=this._getEditorContainer();$editorContainer.find('button').attr('disabled','disabled');$editorContainer.find('input:text').attr('disabled','disabled');$editorContainer.find('.editorAttachFile').find('input:text').removeAttr('disabled');},_enableControls:function(){var $editorContainer=this._getEditorContainer();$editorContainer.find('button').removeAttr('disabled');$editorContainer.find('input:text').removeAttr('disabled');},_dispatch:function(m){var dispatcher=this.dispatchService;if(dispatcher){dispatcher.send(DH,m);};},_synchronousCall:function(m){var dispatcher=this.dispatchService;if(dispatcher){dispatcher.synchronousCall(DH,m);};},_handle:function(m){if(m.type==='editGeometryModified'){if(m._origin!==this){this._featureModified(m.docId,m.geom,m.proj);};};}});var CouchEditor=$n2.Class({options:null,documentSource:null,panelName:null,geomName:null,couchProj:null,schema:null,defaultEditSchema:null,schemaRepository:null,uploadService:null,showService:null,authService:null,dispatchService:null,searchService:null,schemaEditorService:null,customService:null,enableAddFile:null,initialLayers:null,userButtons:null,relatedDocProcess:null,isFormEditor:null,currentEditor:null,initialize:function(opts_){var opts=$n2.extend({documentSource:null,panelName:null,geomName:'nunaliit_geom',couchProj:null,schema:null,defaultEditSchema:null,schemaRepository:null,uploadService:null,showService:null,authService:null,dispatchService:null,searchService:null,schemaEditorService:null,customService:null,enableAddFile:false,initialLayers:['public']},opts_);var _this=this;this.options={};this.documentSource=opts.documentSource;this.panelName=opts.panelName;this.geomName=opts.geomName;this.couchProj=opts.couchProj;this.options.schema=opts.schema;this.defaultEditSchema=opts.defaultEditSchema;this.enableAddFile=opts.enableAddFile;this.initialLayers=opts.initialLayers;this.schemaRepository=opts.schemaRepository;this.uploadService=opts.uploadService;this.showService=opts.showService;this.authService=opts.authService;this.dispatchService=opts.dispatchService;this.searchService=opts.searchService;this.schemaEditorService=opts.schemaEditorService;this.customService=opts.customService;this.isFormEditor=true;if(!this.couchProj){this.couchProj=getDefaultCouchProjection();};var dispatcher=this.dispatchService;if(dispatcher){var f=function(m){_this._handle(m);};dispatcher.register(DH,'editGeometryModified',f);dispatcher.register(DH,'editInitiate',f);dispatcher.register(DH,'editCancel',f);};this.relatedDocProcess=new $n2.couchRelatedDoc.CreateRelatedDocProcess({documentSource:this.documentSource,schemaRepository:this.schemaRepository,uploadService:this.uploadService,showService:this.showService,authService:this.authService});this.userButtons={};var label='button';for(var key in opts){if(key.substr(0,label.length)===label){this.userButtons[key]=opts[key];};};},_showAttributeForm:function(feature_,editorOptions_){if(null!=this.currentEditor){this.currentEditor.performCancellation();this.currentEditor=null;};this.currentEditor=this._createEditor(editorOptions_);this.currentEditor.startFeatureEditing(feature_);},showDocumentForm:function(document_,editorOptions_){if(null!=this.currentEditor){this.currentEditor.performCancellation();this.currentEditor=null;};this.currentEditor=this._createEditor(editorOptions_);this.currentEditor.startDocumentEditing(document_);},_createEditor:function(o_){o_=o_?o_:{};var opts={panelName:o_.panelName?o_.panelName:this.panelName,geomName:o_.geomName?o_.geomName:this.geomName,initialLayers:o_.initialLayers?o_.initialLayers:this.initialLayers,enableAddFile:o_.enableAddFile?o_.enableAddFile:this.enableAddFile,schema:o_.schema?o_.schema:this.options.schema,onFeatureInsertedFn:o_.onFeatureInsertedFn,onFeatureUpdatedFn:o_.onFeatureUpdatedFn,onFeatureDeletedFn:o_.onFeatureDeletedFn,onCancelFn:o_.onCancelFn,onCloseFn:o_.onCloseFn,uploadService:this.uploadService,searchService:this.searchService,showService:this.showService,schemaEditorService:this.schemaEditorService,schemaRepository:this.schemaRepository,customService:this.customService,dispatchService:this.dispatchService,defaultEditSchema:this.defaultEditSchema,documentSource:this.documentSource,couchProj:this.couchProj,relatedDocProcess:this.relatedDocProcess};for(var key in this.userButtons){opts[key]=this.userButtons[key];};var label='button';for(var key in o_){if(key.substr(0,label.length)===label){opts[key]=o_[key];};};var editor=new CouchDocumentEditor(opts);return editor;},cancelDocumentForm:function(opts){if(null!=this.currentEditor){this.currentEditor.performCancellation(opts);this.currentEditor=null;};},setPanelName:function(panelName){this.panelName=panelName;},setSchemas:function(schemas){this.options.schema=schemas;},getInitialLayerIds:function(){return this.initialLayers;},setInitialLayerIds:function(layerIds){this.initialLayers=layerIds;},_handle:function(m){if('editInitiate'===m.type){if(m.feature){this._showAttributeForm(m.feature);}else{this.showDocumentForm(m.doc);};}else if('editCancel'===m.type){this.cancelDocumentForm();}else if(null!=this.currentEditor){this.currentEditor._handle(m);};}});var SchemaEditor=$n2.Class({doc:null,schema:null,$div:null,onChanged:null,formEditor:null,postProcessFns:null,showService:null,initialize:function(opts_){var opts=$n2.extend({doc:null,schema:null,$div:null,onChanged:function(){},funcMap:null,postProcessFns:null,showService:null},opts_);var _this=this;this.doc=opts.doc;this.schema=opts.schema;this.$div=opts.$div;this.onChanged=opts.onChanged;this.postProcessFns=opts.postProcessFns;this.showService=opts.showService;this.formEditor=this.schema.form(this.doc,this.$div,{},function(){_this.onChanged();},opts.funcMap);var showService=this.showService;if(showService){showService.fixElementAndChildren(this.$div,{},this.doc);};this._performPostProcess();},refresh:function(){this.formEditor.refresh();var showService=this.showService;if(showService){showService.fixElementAndChildren(this.$div,{},this.doc);};this._performPostProcess();},_performPostProcess:function(){for(var i=0,e=this.postProcessFns.length;i<e;++i){var fn=this.postProcessFns[i];if(typeof(fn)==='function'){fn(this.doc,this.$div);};};}});var _defaultOnChanged=function(){};var SchemaEditorService=$n2.Class({documentSource:null,showService:null,searchService:null,dispatchService:null,funcMap:null,postProcessFunctions:null,documentSource:null,initialize:function(opts_){var opts=$n2.extend({funcMap:{},postProcessFn:null,documentSource:null,showService:null,searchService:null,dispatchService:null},opts_);var _this=this;this.postProcessFunctions=[];this.documentSource=opts.documentSource;this.showService=opts.showService;this.searchService=opts.searchService;this.dispatchService=opts.dispatchService;this.funcMap={};for(var key in opts.funcMap){var fn=opts.funcMap[key];if(typeof(fn)==='function'){this.funcMap[key]=fn;};};if(!this.funcMap['getDocumentId']){this.funcMap['getDocumentId']=function(cb,resetFn){_this._searchForDocumentId(cb,resetFn);};};if(!this.funcMap['getLayers']){this.funcMap['getLayers']=function(currentLayers,cb,resetFn){selectLayersDialog({currentLayers:currentLayers,cb:cb,resetFn:resetFn,showService:_this.showService,dispatchService:_this.dispatchService});};};if(opts.postProcessFn){this.postProcessFunctions.push(opts.postProcessFn);};},editDocument:function(opts_){var opts=$n2.extend({doc:null,schema:null,$div:null,onChanged:_defaultOnChanged},opts_);var editor=new SchemaEditor({doc:opts.doc,schema:opts.schema,$div:opts.$div,onChanged:opts.onChanged,funcMap:this.funcMap,postProcessFns:this.postProcessFunctions,showService:this.showService});return editor;},addFunctionMap:function(fnName,fn){if(typeof(fn)==='function'){this.funcMap[fnName]=fn;};},addPostProcessFunction:function(fn){if(typeof(fn)==='function'){this.postProcessFunctions.push(fn);};},_searchForDocumentId:function(cb,resetFn){var searchServer=this.searchService;var showService=this.showService;searchForDocumentId({searchServer:searchServer,showService:showService,onSelected:cb,onReset:resetFn});}});var AttachmentEditor=$n2.Class({doc:null,elemId:null,documentSource:null,uploadService:null,onChangedFn:null,creationAttachmentNames:null,compulsoryAttachmentNames:null,disableAddFile:null,disableRemoveFile:null,initialize:function(opts_){var opts=$n2.extend({doc:null,elem:null,documentSource:null,uploadService:null,onChangedFn:function(){},disableAddFile:false,disableRemoveFile:false},opts_);this.doc=opts.doc;this.documentSource=opts.documentSource;this.uploadService=opts.uploadService;this.onChangedFn=opts.onChangedFn;this.disableAddFile=opts.disableAddFile;this.disableRemoveFile=opts.disableRemoveFile;this.creationAttachmentNames=[];this.compulsoryAttachmentNames=[];var $elem=$(opts.elem);$elem.addClass('attachmentEditor');this.elemId=$n2.utils.getElementIdentifier($elem);var compulsory=true;if(this.doc&&!this.doc._rev&&this.doc.nunaliit_attachments){if(typeof this.doc.nunaliit_attachments._compulsory!=='undefined'){compulsory=this.doc.nunaliit_attachments._compulsory;};if(this.doc.nunaliit_attachments.files){for(var attName in this.doc.nunaliit_attachments.files){var att=this.doc.nunaliit_attachments.files[attName];var attCompulsory=compulsory;if(typeof att._compulsory!=='undefined'){attCompulsory=att._compulsory;};this.creationAttachmentNames.push(attName);if(attCompulsory){this.compulsoryAttachmentNames.push(attName);};att.attachmentName=attName;att.status="waiting for upload";if(!att.data){att.data={};};};};};this.refresh();},refresh:function(){var $elem=this._getElem();if($elem.length<1)return;var _this=this;var attachments={};if(this.doc.nunaliit_attachments&&this.doc.nunaliit_attachments.files){for(var attName in this.doc.nunaliit_attachments.files){var att=this.doc.nunaliit_attachments.files[attName];attachments[attName]=att;};};var discountAttNames=[];for(var attName in attachments){var att=attachments[attName];var sourceName=att.source;if(sourceName&&attachments[sourceName]){discountAttNames.push(attName);};};for(var i=0,e=discountAttNames.length;i<e;++i){var attName=discountAttNames[i];delete attachments[attName];};var attNames=[];for(var attName in attachments){attNames.push(attName);};attNames.sort();$elem.find('.attachmentEditor_att').each(function(){var $div=$(this);var attName=$div.attr('n2AttName');if(!attName){$div.remove();}else if(!attachments[attName]){$div.remove();};});for(var i=0,e=attNames.length;i<e;++i){var attName=attNames[i];var className='attachmentEditor_att_'+$n2.utils.stringToHtmlId(attName);var $div=$elem.find('.'+className);if($div.length<1){var label=_loc('File');if(this.creationAttachmentNames.indexOf(attName)>=0){this._addCreationAttachmentElement({attName:attName,label:label});}else if(!this.disableRemoveFile){this._addFileElement({attName:attName,label:label});};};};},printButtons:function(opts_){var opts=$n2.extend({elem:null,classNames:null},opts_);var _this=this;if(this.disableAddFile){return;};var $elem=$(opts.elem);var attachBtn=$('<button>').text(_loc('Add File')).appendTo($elem).click(function(){_this._openAddFileDialog();return false;});if(opts.classNames){attachBtn.addClass(opts.classNames);};attachBtn.button({icons:{primary:'ui-icon-plusthick'}});},performPreSavingActions:function(opts_){var opts=$n2.extend({onSuccess:function(){},onError:function(err){}},opts_);var _this=this;var documentSource=this.documentSource;var $elem=this._getElem();var missingAttachment=null;for(var i=0,e=this.compulsoryAttachmentNames.length;i<e;++i){var attName=this.compulsoryAttachmentNames[i];var $form=$elem.find('.attachmentEditor_att_'+$n2.utils.stringToHtmlId(attName));var $file=$form.find('input[type="file"]');var fileName=$file.val();if(!fileName){missingAttachment=attName;};};if(missingAttachment){opts.onError(_loc('A file must be selected'));return;};var $forms=$elem.find('form');var formCount=$forms.length;if(formCount<1){opts.onSuccess();return;};var uuids=[];getUuids();function getUuids(){if(uuids.length>=formCount){onUuids();}else{documentSource.getUniqueIdentifier({onSuccess:function(uuid){uuids.push(uuid);getUuids();},onError:function(err){opts.onError(_loc('Unable to reach server: {err}',{err:err}));}});};};function onUuids(){var doc=_this.doc;$forms.each(function(){var $form=$(this);var attName=$form.attr('n2AttName');var uuid=uuids.pop();var att=null;if(doc&&doc.nunaliit_attachments&&doc.nunaliit_attachments.files){att=doc.nunaliit_attachments.files[attName];};if(att){att.uploadId=uuid;if(doc._id){$('<input type="hidden">').attr('name','id').attr('value',doc._id).prependTo($form);};if(doc._rev){$('<input type="hidden">').attr('name','rev').attr('value',doc._rev).prependTo($form);};if(uuid){$('<input type="hidden">').attr('name','uploadId').attr('value',uuid).prependTo($form);};}else{$form.remove();};});opts.onSuccess();};},performPostSavingActions:function(opts_){var opts=$n2.extend({onSuccess:function(doc){},onError:function(err){}},opts_);var _this=this;var $elem=this._getElem();var $forms=$elem.find('form');var formCount=$forms.length;if(formCount<1){opts.onSuccess();return;};var $form=$forms.first();var attName=$form.attr('n2AttName');var uploadId=null;var att=null;if(this.doc&&this.doc.nunaliit_attachments&&this.doc.nunaliit_attachments.files&&attName&&this.doc.nunaliit_attachments.files[attName]){att=this.doc.nunaliit_attachments.files[attName];uploadId=att.uploadId;};var $fileInput=$form.find('input[type="file"]');var filename=$fileInput.val();if(!filename||!att||!uploadId){$form.remove();continueUpload();}else{this.uploadService.submitForm({form:$form,suppressInformationDialog:true,onSuccess:function(){$form.remove();continueUpload();},onError:function(err){opts.onError(_loc('Unable to upload file. Cause: {err}',{err:err}));}});};function continueUpload(){_this.performPostSavingActions(opts_);};},_getElem:function(){return $('#'+this.elemId);},_openAddFileDialog:function(){var _this=this;var $elem=this._getElem();if($elem.length<1){return;};var dialogId=$n2.getUniqueId();var addFileFormId=$n2.getUniqueId();var $addFileDialog=$('<div>').attr('id',dialogId).addClass('attachmentEditor_dialog');var $content=$('<div>').addClass('attachmentEditor_dialog_content').appendTo($addFileDialog);var $addFileForm=$('<form>').attr('id',addFileFormId).addClass('attachmentEditor_form').appendTo($content);$('<input type="file">').attr('name','media').appendTo($addFileForm);var $buttons=$('<div>').addClass('attachmentEditor_dialog_buttons').appendTo($addFileDialog);var $addBtn=$('<button>').text(_loc('Attach')).appendTo($buttons).click(function(){var $addFileDialog=$('#'+dialogId);var $addFileForm=$('#'+addFileFormId);var $input=$addFileForm.find('input');var filename=$input.val();if(filename){_this._addFileForm($addFileForm);$addFileDialog.dialog('close');}else{alert(_loc('You must select a file'));};return false;});$addBtn.button({icons:{primary:'ui-icon-plusthick'}});var $cancelBtn=$('<button>').text(_loc('Cancel')).appendTo($buttons).click(function(){var $addFileDialog=$('#'+dialogId);$addFileDialog.dialog('close');return false;});$cancelBtn.button({icons:{primary:'ui-icon-cancel'}});$addFileDialog.dialog({autoOpen:true,title:_loc('Add File'),modal:true,width:740,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}});},_addFileForm:function($addFileForm){if(!this.doc){return;};if(!this.doc.nunaliit_attachments){this.doc.nunaliit_attachments={nunaliit_type:'attachment_descriptions',files:{}};};if(!this.doc.nunaliit_attachments.files){this.doc.nunaliit_attachments.files={};};var attName='media';if(this.doc.nunaliit_attachments.files[attName]){var prefix='media_';var count=0;while(this.doc.nunaliit_attachments.files[attName]){++count;attName=prefix+count;if(count>100){$n2.log('Unable to compute attachment name for new attachment');return;};};};this.doc.nunaliit_attachments.files[attName]={attachmentName:attName,status:"waiting for upload",data:{}};$addFileForm.attr('n2AttName',attName);$addFileForm.addClass('attachmentEditor_form');this._addFileElement({attName:attName,label:_loc('New File'),form:$addFileForm});this.onChangedFn();},_removeAttachment:function(attName){var docChanged=false;var derivedNames=[];if(this.doc&&this.doc.nunaliit_attachments&&this.doc.nunaliit_attachments.files){if(this.doc.nunaliit_attachments.files[attName]){delete this.doc.nunaliit_attachments.files[attName];docChanged=true;};for(var otherName in this.doc.nunaliit_attachments.files){var att=this.doc.nunaliit_attachments.files[otherName];if(attName===att.source){derivedNames.push(otherName);};};for(var i=0,e=derivedNames.length;i<e;++i){var derivedName=derivedNames[i];delete this.doc.nunaliit_attachments.files[derivedName];docChanged=true;};var count=0;for(otherName in this.doc.nunaliit_attachments.files){++count;};if(count<1){delete this.doc.nunaliit_attachments;};};if(this.doc&&this.doc._attachments){if(this.doc._attachments[attName]){delete this.doc._attachments[attName];docChanged=true;};for(var i=0,e=derivedNames.length;i<e;++i){var derivedName=derivedNames[i];if(this.doc._attachments[derivedName]){delete this.doc._attachments[derivedName];docChanged=true;};};};if(docChanged){this.refresh();this.onChangedFn();};},_addCreationAttachmentElement:function(opts_){var opts=$n2.extend({attName:null,label:null},opts_);var _this=this;var $elem=this._getElem();var attName=opts.attName;var className='attachmentEditor_att_'+$n2.utils.stringToHtmlId(attName);var $div=$('<div>').addClass('attachmentEditor_att').addClass(className).attr('n2AttName',attName).appendTo($elem);var $form=$('<form>').addClass('attachmentEditor_creationForm').attr('n2AttName',attName).appendTo($div);$('<span>').addClass('attachmentEditor_label').text(opts.label).appendTo($form);$('<input type="file">').attr('name','media').appendTo($form);},_addFileElement:function(opts_){var opts=$n2.extend({attName:null,label:null,form:null},opts_);var _this=this;var $elem=this._getElem();var attName=opts.attName;var className='attachmentEditor_att_'+$n2.utils.stringToHtmlId(attName);var $div=$('<div>').addClass('attachmentEditor_att').addClass(className).attr('n2AttName',attName).appendTo($elem);$('<span>').addClass('attachmentEditor_label').text(opts.label).appendTo($div);if(opts.form){var fileName=opts.form.find('input[type="file"]').val();if(fileName){var index=fileName.lastIndexOf('/');if(index>=0){fileName=fileName.substr(index+1);};};if(fileName){var index=fileName.lastIndexOf('\\');if(index>=0){fileName=fileName.substr(index+1);};};$('<span>').addClass('attachmentEditor_attName').text(fileName).appendTo($div);}else{$('<span>').addClass('attachmentEditor_attName').text(attName).appendTo($div);};$('<a>').attr('href','#').attr('n2AttName',attName).addClass('attachmentEditor_delete').text(_loc('Remove')).appendTo($div).click(function(){var $a=$(this);var attName=$a.attr('n2AttName');if(attName){_this._removeAttachment(attName);};return false;});if(opts.form){opts.form.appendTo($div);};}});$n2.CouchEditor={Editor:CouchEditor,SchemaEditorService:SchemaEditorService,CouchSimpleDocumentEditor:CouchSimpleDocumentEditor,Constants:{ALL_SCHEMAS:{},FORM_EDITOR:{},TREE_EDITOR:{},SLIDE_EDITOR:{},RELATION_EDITOR:{}},AttachmentEditor:AttachmentEditor};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var CreateDocWidget=$n2.Class({elemId:null,schemaNames:null,allSchemas:null,label:null,dialogPrompt:null,createDocProcess:null,initialize:function(opts_){var opts=$n2.extend({elem:null,schemaNames:null,allSchemas:false,label:null,dialogPrompt:null,createDocProcess:null},opts_);this.createDocProcess=opts.createDocProcess;this.schemaNames=opts.schemaNames;this.allSchemas=opts.allSchemas;this.label=opts.label;this.dialogPrompt=opts.dialogPrompt;this.elemId=$n2.utils.getElementIdentifier(opts.elem);if(!this.label){this.label=_loc('Create Document');};this._refresh();},_getElem:function(){return $('#'+this.elemId);},_refresh:function(){var _this=this;var $elem=this._getElem();$elem.empty();$('<button>').text(this.label).appendTo($elem).click(function(){_this._createDocClicked();});},_createDocClicked:function(){this.createDocProcess.createDocumentFromSchemaNames({schemaNames:this.schemaNames,allSchemas:this.allSchemas,prompt:this.dialogPrompt});}});var CreateRelatedDocProcess=$n2.Class({documentSource:null,schemaRepository:null,uploadService:null,showService:null,authService:null,initialize:function(opts_){var opts=$n2.extend({documentSource:null,schemaRepository:null,uploadService:null,showService:null,authService:null},opts_);this.documentSource=opts.documentSource;this.schemaRepository=opts.schemaRepository;this.uploadService=opts.uploadService;this.showService=opts.showService;this.authService=opts.authService;},getCreateWidget:function(opts_){var opts=$n2.extend({elem:null,schemaNames:null,allSchemas:false,label:null,dialogPrompt:null},opts_);return new CreateDocWidget({elem:opts.elem,schemaNames:opts.schemaNames,allSchemas:opts.allSchemas,label:opts.label,dialogPrompt:opts.dialogPrompt,createDocProcess:this});},createDocumentFromSchema:function(opt_){var _this=this;var authService=this.authService;if(authService&&false==authService.isLoggedIn()){authService.showLoginForm({onSuccess:function(result,options){_this.createDocumentFromSchema(opt_);}});return;};var opt=$n2.extend({schema:null,relatedDocId:null,originDocId:null,prompt:null,onSuccess:function(docId){},onError:$n2.reportErrorForced,onCancel:function(){}},opt_);if(opt.schema&&opt.schema.isSchema){}else{opt.onError(_loc('A valid schema must be provided'));return;};this.uploadService.checkWelcome({onSuccess:uploadServiceAvailable,onError:function(err){alert(_loc('Upload service can not be reached. Unable to submit a related document.'));}});function uploadServiceAvailable(){var obj=opt.schema.createObject();if(opt.relatedDocId){obj.nunaliit_source={nunaliit_type:'reference',doc:opt.relatedDocId,category:'attachment'};};if(opt.originDocId){obj.nunaliit_origin={nunaliit_type:'reference',doc:opt.originDocId};};var prompt=opt.prompt;if(!prompt){if(opt.originDocId){prompt=_loc('Fill Out Reply');}else if(opt.relatedDocId){prompt=_loc('Fill Out Related Document');}else{prompt=_loc('Fill out content of new document');};};new Editor({documentSource:_this.documentSource,uploadService:_this.uploadService,showService:_this.showService,obj:obj,schema:opt.schema,prompt:prompt,onSuccess:opt.onSuccess,onError:opt.onError,onCancel:opt.onCancel});};},createDocumentFromSchemaNames:function(opt_){var _this=this;var authService=this.authService;if(authService&&false==authService.isLoggedIn()){authService.showLoginForm({onSuccess:function(result,options){_this.createDocumentFromSchemaNames(opt_);}});return;};var opt=$n2.extend({schemaNames:[],allSchemas:false,relatedDocId:null,originDocId:null,prompt:null,onSuccess:function(docId){},onError:$n2.reportErrorForced,onCancel:function(){}},opt_);if(opt.allSchemas){this.schemaRepository.getRootSchemas({onSuccess:function(schemas){_this.selectSchemaDialog({schemas:schemas,onSuccess:selectedSchema,onError:opt.onError,onCancel:opt.onCancel});},onError:opt.onError});}else{this.selectSchemaFromNamesDialog({schemaNames:opt.schemaNames,onSuccess:selectedSchema,onError:opt.onError,onCancel:opt.onCancel});};function selectedSchema(schema){_this.createDocumentFromSchema({schema:schema,relatedDocId:opt.relatedDocId,originDocId:opt.originDocId,prompt:opt.prompt,onSuccess:opt.onSuccess,onError:opt.onError,onCancel:opt.onCancel});};},replyToDocument:function(opt_){var _this=this;var authService=this.authService;if(authService&&false==authService.isLoggedIn()){authService.showLoginForm({onSuccess:function(result,options){_this.replyToDocument(opt_);}});return;};var opt=$n2.extend({doc:null,schema:null,originDocId:null,onSuccess:function(docId){},onError:$n2.reportErrorForced,onCancel:function(){}},opt_);if(opt.schema&&opt.schema.isSchema){}else{opt.onError(_loc('A valid schema must be provided'));return;};var originDocId=null;if(opt.originDocId){originDocId=opt.originDocId;}else if(opt.doc.nunaliit_origin&&opt.doc.nunaliit_origin.doc){originDocId=opt.doc.nunaliit_origin.doc;}else if(opt.doc.nunaliit_source&&opt.doc.nunaliit_source.doc){originDocId=opt.doc.nunaliit_source.doc;};this.createDocumentFromSchema({schema:opt.schema,relatedDocId:opt.doc._id,originDocId:originDocId,onSuccess:opt.onSuccess,onError:opt.onError,onCancel:opt.onCancel});},selectSchemaFromNamesDialog:function(opt_){var opt=$n2.extend({schemaNames:[],onSuccess:function(schema){},onError:$n2.reportErrorForced,onCancel:function(){}},opt_);var _this=this;this.schemaRepository.getSchemas({names:opt.schemaNames,onSuccess:function(schemas){_this.selectSchemaDialog({schemas:schemas,onSuccess:opt.onSuccess,onError:opt.onError,onCancel:opt.onCancel});},onError:opt.onError});},selectSchemaDialog:function(opt_){var opt=$n2.extend({schemas:[],onSuccess:function(schema){},onError:$n2.reportErrorForced,onCancel:function(){}},opt_);var _this=this;if(!opt.schemas.length){opt.onCancel();return;}
if(opt.schemas.length==1){opt.onSuccess(opt.schemas[0]);return;}
var diagId=$n2.getUniqueId();var $dialog=$('<div id="'+diagId+'"></div>');var $label=$('<span></span>');$label.text(_loc('Select schema')+': ');$dialog.append($label);var $select=$('<select></select>');$dialog.append($select);for(var i=0,e=opt.schemas.length;i<e;++i){var schema=opt.schemas[i];var schemaName=schema.name;var schemaLabel=schema.getLabel();$('<option>').text(schemaLabel).val(schemaName).appendTo($select);};$dialog.append($('<br/>'));var $ok=$('<button></button>');$ok.text(_loc('OK'));$ok.button({icons:{primary:'ui-icon-check'}});$dialog.append($ok);$ok.click(function(){var $diag=$('#'+diagId);var schemaName=$diag.find('select').val();$diag.dialog('close');_this.schemaRepository.getSchema({name:schemaName,onSuccess:opt.onSuccess,onError:function(err){opt.onError(_loc('Unable to fetch schema'));}});return false;});var $cancel=$('<button></button>');$cancel.text(_loc('Cancel'));$cancel.button({icons:{primary:'ui-icon-cancel'}});$dialog.append($cancel);$cancel.click(function(){$('#'+diagId).dialog('close');opt.onCancel();return false;});var dialogOptions={autoOpen:true,title:_loc('Select a schema'),modal:true,width:740,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$dialog.dialog(dialogOptions);}});var Editor=$n2.Class({documentSource:null,uploadService:null,showService:null,obj:null,schema:null,prompt:null,onSuccess:null,onError:null,onCancel:null,diagId:null,attachmentUploadHandler:null,initialize:function(opts_){var opts=$n2.extend({documentSource:null,uploadService:null,showService:null,obj:null,schema:null,prompt:null,onSuccess:function(docId){},onError:$n2.reportErrorForced,onCancel:function(){}},opts_);this.documentSource=opts.documentSource;this.uploadService=opts.uploadService;this.showService=opts.showService;this.obj=opts.obj;this.schema=opts.schema;this.prompt=opts.prompt;this.onSuccess=opts.onSuccess;this.onError=opts.onError;this.onCancel=opts.onCancel;var _this=this;var diagId=$n2.getUniqueId();this.diagId=diagId;var $dialog=$('<div>').attr('id',diagId).addClass('n2RelatedDoc_dialog').appendTo($('body'));var obj=this.obj;var schema=this.schema;var $form=$('<div></div>');$dialog.append($form);schema.form(obj,$form);if(this.showService){this.showService.fixElementAndChildren($form,{},obj);};var $fileElement=$('<div></div>');$dialog.append($fileElement);this.attachmentUploadHandler=new $n2.CouchEditor.AttachmentEditor({doc:obj,elem:$fileElement,documentSource:this.documentSource,uploadService:this.uploadService,disableAddFile:true,disableRemoveFile:true});var $ok=$('<button></button>');$ok.text(_loc('OK'));$ok.button({icons:{primary:'ui-icon-check'}});$dialog.append($ok);$ok.click(function(){_this._clickOK();return false;});var $cancel=$('<button></button>');$cancel.text(_loc('Cancel'));$cancel.button({icons:{primary:'ui-icon-cancel'}});$dialog.append($cancel);$cancel.click(function(){_this._clickCancel();return false;});var dialogOptions={autoOpen:true,title:_loc('Fill Out Related Document'),modal:true,width:740,close:function(event,ui){var diag=$('#'+diagId);diag.remove();}};$dialog.dialog(dialogOptions);},_clickOK:function(){var _this=this;var obj=this.obj;this.attachmentUploadHandler.performPreSavingActions({doc:obj,documentSource:this.documentSource,onSuccess:function(){_this._saveObj();},onError:function(err){alert(err);}});},_clickCancel:function(){$('#'+this.diagId).dialog('close');this.onCancel();},_saveObj:function(){var _this=this;var obj=this.obj;$n2.couchDocument.adjustDocument(obj);this.documentSource.createDocument({doc:obj,onSuccess:function(updatedDoc){_this._uploadFile(updatedDoc);},onError:function(err){_this.onError(_loc('Unable to reach database to submit document: {err}',{err:err}));}});},_uploadFile:function(doc){var _this=this;this.attachmentUploadHandler.performPostSavingActions({doc:doc,onSuccess:function(){_this._success(doc._id);},onError:function(err){_this.onError(_loc('Error occurred after related document was created. Error: {err}',{err:err}));}});},_success:function(docId){$('#'+this.diagId).dialog('close');this.onSuccess(docId);}});$n2.couchRelatedDoc={CreateRelatedDocProcess:CreateRelatedDocProcess};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchDisplay';function docCreationTimeSort(lhs,rhs){var timeLhs=0;var timeRhs=0;if(lhs&&lhs.doc&&lhs.doc.nunaliit_created&&lhs.doc.nunaliit_created.time){timeLhs=lhs.doc.nunaliit_created.time;}
if(rhs&&rhs.doc&&rhs.doc.nunaliit_created&&rhs.doc.nunaliit_created.time){timeRhs=rhs.doc.nunaliit_created.time;}
if(timeLhs<timeRhs)return-1;if(timeLhs>timeRhs)return 1;return 0;};function startsWith(s,prefix){var left=s.substr(0,prefix.length);return(left===prefix);};function boolOption(optionName,options,customService){var flag=false;if(options[optionName]){flag=true;};if(customService&&!flag){var o=customService.getOption(optionName);if(o){flag=true;};};return flag;};var Display=$n2.Class({options:null,documentSource:null,displayPanelName:null,currentFeature:null,createRelatedDocProcess:null,defaultSchema:null,displayRelatedInfoProcess:null,displayOnlyRelatedSchemas:null,displayBriefInRelatedInfo:null,restrictAddRelatedButtonToLoggedIn:null,restrictReplyButtonToLoggedIn:null,classDisplayFunctions:null,showService:null,uploadService:null,customService:null,authService:null,requestService:null,dispatchService:null,schemaRepository:null,initialize:function(opts_){var _this=this;var opts=$n2.extend({documentSource:null,displayPanelName:null,showService:null,uploadService:null,serviceDirectory:null,displayRelatedInfoFunction:null,displayRelatedInfoProcess:null,classDisplayFunctions:{},displayOnlyRelatedSchemas:false,displayBriefInRelatedInfo:false,restrictAddRelatedButtonToLoggedIn:false,restrictReplyButtonToLoggedIn:false},opts_);this.documentSource=opts.documentSource;this.displayPanelName=opts.displayPanelName;this.uploadService=opts.uploadService;this.classDisplayFunctions=opts.classDisplayFunctions;if(opts.serviceDirectory){this.showService=opts.serviceDirectory.showService;this.customService=opts.serviceDirectory.customService;this.authService=opts.serviceDirectory.authService;this.requestService=opts.serviceDirectory.requestService;this.schemaRepository=opts.serviceDirectory.schemaRepository;this.dispatchService=opts.serviceDirectory.dispatchService;};if(!this.showService){this.showService=opts.showService;};this.displayOnlyRelatedSchemas=boolOption('displayOnlyRelatedSchemas',opts,this.customService);this.displayBriefInRelatedInfo=boolOption('displayBriefInRelatedInfo',opts,this.customService);this.restrictAddRelatedButtonToLoggedIn=boolOption('restrictAddRelatedButtonToLoggedIn',opts,this.customService);this.restrictReplyButtonToLoggedIn=boolOption('restrictReplyButtonToLoggedIn',opts,this.customService);var customService=this.customService;var dispatcher=this.dispatchService;if(dispatcher){var f=function(msg){_this._handleDispatch(msg);};dispatcher.register(DH,'selected',f);dispatcher.register(DH,'searchResults',f);dispatcher.register(DH,'documentDeleted',f);dispatcher.register(DH,'authLoggedIn',f);dispatcher.register(DH,'authLoggedOut',f);dispatcher.register(DH,'editClosed',f);dispatcher.register(DH,'documentContentCreated',f);dispatcher.register(DH,'documentContentUpdated',f);};if(this.requestService){this.requestService.addDocumentListener(function(doc){_this._refreshDocument(doc);_this._populateWaitingDocument(doc);});};if(opts.displayRelatedInfoProcess){this.displayRelatedInfoProcess=opts.displayRelatedInfoProcess;};if(!this.displayRelatedInfoProcess&&opts.displayRelatedInfoFunction){this.displayRelatedInfoProcess=new LegacyDisplayRelatedFunctionAdapter(opts.displayRelatedInfoFunction);};if(!this.displayRelatedInfoProcess&&customService){var displayRelatedProcess=customService.getOption('displayRelatedInfoProcess');if(displayRelatedProcess){this.displayRelatedInfoProcess=displayRelatedProcess;};};if(!this.displayRelatedInfoProcess&&customService){var displayRelatedFn=customService.getOption('displayRelatedInfoFunction');if(typeof displayRelatedFn==='function'){this.displayRelatedInfoProcess=new LegacyDisplayRelatedFunctionAdapter(displayRelatedFn);};};if(!this.displayRelatedInfoProcess){if(this.displayOnlyRelatedSchemas){this.displayRelatedInfoProcess=new LegacyDisplayRelatedFunctionAdapter(DisplayRelatedInfo);}else{this.displayRelatedInfoProcess=new LegacyDisplayRelatedFunctionAdapter(DisplayLinkedInfo);};};this.createRelatedDocProcess=new $n2.couchRelatedDoc.CreateRelatedDocProcess({documentSource:this.documentSource,schemaRepository:this.schemaRepository,uploadService:this.uploadService,showService:this.showService,authService:this.authService});},setSchema:function(schema){this.defaultSchema=schema;},_displayDocument:function($set,doc){var _this=this;$set.empty();this._displayObject($set,doc,{onUpdated:function(){_this._displayDocument($set,doc);},onDeleted:function(){$set.empty();}});},_shouldSuppressNonApprovedMedia:function(){return this.showService.eliminateNonApprovedMedia;},_shouldSuppressDeniedMedia:function(){return this.showService.eliminateDeniedMedia;},_getDisplayDiv:function(){var divId=this.displayPanelName;return $('#'+divId);},_displayObject:function($side,data,opt_){var _this=this;var opt=$n2.extend({onUpdated:function(){},onDeleted:function(){},suppressContributionReferences:false,showContributionReplyButton:false,showAddContributionButton:false,showRelatedContributions:false},opt_);var docId=data._id;var $elem=$('<div class="couchDisplay_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$side.append($elem);var $sElem=$('<div class="n2s_handleHover"></div>');$elem.append($sElem);this.showService.displayDocument($sElem,{onDisplayed:onDisplayed},data);if(data.nunaliit_schema){var schemaRepository=_this.schemaRepository;if(schemaRepository){schemaRepository.getSchema({name:data.nunaliit_schema,onSuccess:function(schema){continueDisplay(schema);},onError:function(){continueDisplay(null);}});}else{continueDisplay(null);};}else{continueDisplay(null);};function continueDisplay(schema){_this._addAttachmentProgress($elem,data);_this._addButtons($elem,data,{schema:schema,related:true,reply:true,geom:true,edit:true,'delete':true,addLayer:true,treeView:true});var $div=$('<div>').addClass('n2Display_relatedInfo couchDisplayRelated_'+$n2.utils.stringToHtmlId(data._id)).appendTo($elem);var relatedInfoId=$n2.utils.getElementIdentifier($div);_this.displayRelatedInfoProcess.display({divId:relatedInfoId,display:_this,doc:data,schema:schema});};function onDisplayed($sElem,data,schema,opt_){if(_this.classDisplayFunctions){for(var className in _this.classDisplayFunctions){var fn=_this.classDisplayFunctions[className];var jqCallback=eachFunctionForClass(className,fn,data,opt);$sElem.find('.'+className).each(jqCallback);};};};function eachFunctionForClass(className,fn,data,opt){return function(){var $jq=$(this);fn(data,$jq,opt);$jq.removeClass(className);};};},_addButtons:function($elem,data,opt_){var _this=this;var opt=$n2.extend({schema:null,focus:false,related:false,reply:false,geom:false,edit:false,'delete':false,addLayer:false,treeView:false},opt_);var $buttons=$('<div></div>');$buttons.addClass('n2Display_buttons');$buttons.addClass('n2Display_buttons_'+$n2.utils.stringToHtmlId(data._id));$elem.append($buttons);var optionClass='options';if(opt.focus)optionClass+='_focus';if(opt.edit)optionClass+='_edit';if(opt.related)optionClass+='_related';if(opt.reply)optionClass+='_reply';if(opt.geom)optionClass+='_geom';if(opt['delete'])optionClass+='_delete';if(opt.addLayer)optionClass+='_addLayer';if(opt.treeView)optionClass+='_treeView';$buttons.addClass(optionClass);var opts={doc:data,schema:opt.schema,focus:opt.focus,edit:opt.edit,related:opt.related,reply:opt.reply,geom:opt.geom,addLayer:opt.addLayer,treeView:opt.treeView};opts['delete']=opt['delete'];this._displayButtons($buttons,opts);},_refreshButtons:function($elem){var _this=this;var docId=null;var fFocus=false;var fEdit=false;var fRelated=false;var fReply=false;var fGeom=false;var fDelete=false;var fAddLayer=false;var fTreeView=false;var classAttr=$elem.attr('class');var classes=classAttr.split(' ');for(var i=0,e=classes.length;i<e;++i){var className=classes[i];if(startsWith(className,'n2Display_buttons_')){var escapedDocId=className.substr('n2Display_buttons_'.length);docId=$n2.utils.unescapeHtmlId(escapedDocId);}else if(startsWith(className,'options')){var options=className.split('_');for(var j=0,k=options.length;j<k;++j){var o=options[j];if('focus'===o){fFocus=true;}
else if('edit'===o){fEdit=true;}
else if('related'===o){fRelated=true;}
else if('reply'===o){fReply=true;}
else if('geom'===o){fGeom=true;}
else if('addLayer'===o){fAddLayer=true;}
else if('treeView'===o){fTreeView=true;}
else if('delete'===o){fDelete=true;};};};};if(docId){this.documentSource.getDocument({docId:docId,onSuccess:getSchema,onError:function(){}});};function getSchema(doc){if(doc.nunaliit_schema){var schemaRepository=_this.schemaRepository;if(schemaRepository){schemaRepository.getSchema({name:doc.nunaliit_schema,onSuccess:function(schema){drawButtons(doc,schema);},onError:function(){drawButtons(doc,null);}});}else{drawButtons(doc,null);};}else{drawButtons(doc,null);};};function drawButtons(doc,schema){var opts={doc:doc,schema:schema,focus:fFocus,edit:fEdit,related:fRelated,reply:fReply,geom:fGeom,addLayer:fAddLayer,treeView:fTreeView};opts['delete']=fDelete;$elem.empty();_this._displayButtons($elem,opts);};},_displayButtons:function($buttons,opt){var _this=this;var data=opt.doc;var schema=opt.schema;var dispatcher=this.dispatchService;var schemaRepository=_this.schemaRepository;if(opt.focus&&data&&data._id){var $focusButton=$('<a href="#"></a>');var focusText=_loc('More Info');$focusButton.text(focusText);$buttons.append($focusButton);$focusButton.click(function(){_this._dispatch({type:'userSelect',docId:data._id})
return false;});addClasses($focusButton,focusText);};if(opt.edit&&$n2.couchMap.canEditDoc(data)){var $editButton=$('<a href="#"></a>');var editText=_loc('Edit');$editButton.text(editText);$buttons.append($editButton);$editButton.click(function(){_this._performDocumentEdit(data,opt);return false;});addClasses($editButton,editText);};if(opt['delete']&&$n2.couchMap.canDeleteDoc(data)){var $deleteButton=$('<a href="#"></a>');var deleteText=_loc('Delete');$deleteButton.text(deleteText);$buttons.append($deleteButton);$deleteButton.click(function(){_this._performDocumentDelete(data,opt);return false;});addClasses($deleteButton,deleteText);};if(opt.related&&this.displayRelatedInfoProcess){this.displayRelatedInfoProcess.addButton({display:this,div:$buttons[0],doc:data,schema:opt.schema});};if(opt.reply&&opt.schema&&opt.schema.options&&opt.schema.options.enableReplies){var showReplyButton=true;if(this.restrictReplyButtonToLoggedIn){var sessionContext=$n2.couch.getSession().getContext();if(!sessionContext||!sessionContext.name){showReplyButton=false;};};if(showReplyButton){var $replyButton=$('<a href="#"></a>');var replyText=_loc('Reply');$replyButton.text(replyText);$buttons.append($replyButton);$replyButton.click(function(){_this._replyToDocument(data,opt.schema);return false;});addClasses($replyButton,'reply');};};if(dispatcher&&opt.geom&&data&&data.nunaliit_geom&&dispatcher.isEventTypeRegistered('findOnMap')){var showFindOnMapButton=false;if(data.nunaliit_layers&&data.nunaliit_layers.length>0){var m={type:'mapGetLayers',layers:{}};dispatcher.synchronousCall(DH,m);for(var i=0,e=data.nunaliit_layers.length;i<e;++i){var layerId=data.nunaliit_layers[i];if(m.layers[layerId]){showFindOnMapButton=true;};};};if(showFindOnMapButton){var $findGeomButton=$('<a href="#"></a>');var findGeomText=_loc('Find on Map');$findGeomButton.text(findGeomText);$buttons.append($findGeomButton);var x=(data.nunaliit_geom.bbox[0]+data.nunaliit_geom.bbox[2])/2;var y=(data.nunaliit_geom.bbox[1]+data.nunaliit_geom.bbox[3])/2;$findGeomButton.click(function(){var visible=false;var layerIdToTurnOn=null;var m={type:'mapGetLayers',layers:{}};dispatcher.synchronousCall(DH,m);for(var i=0,e=data.nunaliit_layers.length;i<e;++i){var layerId=data.nunaliit_layers[i];if(m.layers[layerId]){if(m.layers[layerId].visible){visible=true;}else{layerIdToTurnOn=layerId;};};};if(!visible){_this._dispatch({type:'setMapLayerVisibility',layerId:layerIdToTurnOn,visible:true});};_this._dispatch({type:'findOnMap',fid:data._id,srsName:'EPSG:4326',x:x,y:y});return false;});addClasses($findGeomButton,findGeomText);};};if(opt.addLayer&&data&&data.nunaliit_layer_definition&&dispatcher&&dispatcher.isEventTypeRegistered('addLayerToMap')){var $addLayerButton=$('<a href="#"></a>');var btnText=_loc('Add Layer');$addLayerButton.text(btnText);$buttons.append($addLayerButton);var layerDefinition=data.nunaliit_layer_definition;var layerId=layerDefinition.id;if(!layerId){layerId=data._id;};var layerDef={name:layerDefinition.name,type:'couchdb',options:{layerName:layerId,documentSource:this.documentSource}};$addLayerButton.click(function(){_this._dispatch({type:'addLayerToMap',layer:layerDef,options:{setExtent:{bounds:layerDefinition.bbox,crs:'EPSG:4326'}}});return false;});addClasses($addLayerButton,btnText);};if(opt.treeView&&data){var $treeViewButton=$('<a>').attr('href','#').text(_loc('Tree View')).appendTo($buttons).click(function(){_this._performDocumentTreeView(data);return false;});addClasses($treeViewButton,'tree_view');};function addClasses(elem,tag){elem.addClass('nunaliit_form_link');var compactTag=tag;var spaceIndex=compactTag.indexOf(' ');while(-1!==spaceIndex){compactTag=compactTag.slice(0,spaceIndex)+'_'+
compactTag.slice(spaceIndex+1);spaceIndex=compactTag.indexOf(' ');};elem.addClass('nunaliit_form_link_'+compactTag.toLowerCase());};},_addAttachmentProgress:function($elem,data){var $progress=$('<div></div>').addClass('n2Display_attProgress').addClass('n2Display_attProgress_'+$n2.utils.stringToHtmlId(data._id)).appendTo($elem);this._refreshAttachmentProgress($progress,data);},_refreshAttachmentProgress:function($progress,data){var status=null;$progress.empty();if(data.nunaliit_attachments&&data.nunaliit_attachments.files){for(var attName in data.nunaliit_attachments.files){var att=data.nunaliit_attachments.files[attName];if(!att.source){if(att.status&&'attached'!==att.status){if(!status){status={};};status[att.status]=true;};};};};if(status){var $outer=$('<div></div>').addClass('n2Display_attProgress_outer').appendTo($progress);$('<div></div>').addClass('n2Display_attProgress_icon').appendTo($outer);if(status['waiting for approval']){$outer.addClass('n2Display_attProgress_waiting');$('<div></div>').addClass('n2Display_attProgress_message').text(_loc('Attachment is waiting for approval')).appendTo($outer);}else if(status['denied']){$outer.addClass('n2Display_attProgress_denied');$('<div></div>').addClass('n2Display_attProgress_message').text(_loc('Attachment has been denied')).appendTo($outer);}else{$outer.addClass('n2Display_attProgress_busy');$('<div></div>').addClass('n2Display_attProgress_message').text(_loc('Attachment is being processed')).appendTo($outer);};$('<div></div>').addClass('n2Display_attProgress_outer_end').appendTo($outer);};},_addRelatedDocument:function(docId,relatedSchemaNames){var _this=this;this.createRelatedDocProcess.createDocumentFromSchemaNames({schemaNames:relatedSchemaNames,relatedDocId:docId,onSuccess:function(docId){}});},_getAllReferences:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(refInfo){},onError:function(err){}},opts_);var _this=this;var doc=opts.doc;var refInfo={};var references=[];$n2.couchUtils.extractLinks(doc,references);for(var i=0,e=references.length;i<e;++i){var linkDocId=references[i].doc;if(!refInfo[linkDocId]){refInfo[linkDocId]={};};refInfo[linkDocId].forward=true;};this.documentSource.getReferencesFromId({docId:doc._id,onSuccess:function(refIds){for(var i=0,e=refIds.length;i<e;++i){var id=refIds[i];if(!refInfo[id]){refInfo[id]={};};refInfo[id].reverse=true;};getRefSchemas();},onError:getRefSchemas});function getRefSchemas(){var requestDocIds=[];for(var requestDocId in refInfo){requestDocIds.push(requestDocId);};_this.documentSource.getDocumentInfoFromIds({docIds:requestDocIds,onSuccess:function(infos){for(var i=0,e=infos.length;i<e;++i){var requestDocId=infos[i].id;refInfo[requestDocId].exists=true;if(infos[i].schema){refInfo[requestDocId].schema=infos[i].schema;};};opts.onSuccess(refInfo);},onError:opts.onError});};},_replyToDocument:function(doc,schema){var _this=this;this.createRelatedDocProcess.replyToDocument({doc:doc,schema:schema,onSuccess:function(docId){}});},_refreshDocument:function(doc){var _this=this;var schemaRepository=this.schemaRepository;if(doc.nunaliit_schema&&schemaRepository){schemaRepository.getSchema({name:doc.nunaliit_schema,onSuccess:function(schema){refreshDocWithSchema(doc,schema);},onError:function(){refreshDocWithSchema(doc,null);}});}else{refreshDocWithSchema(doc,null);};function refreshDocWithSchema(doc,schema){var docId=doc._id;$('.displayRelatedButton_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $buttonDiv=$(this);$buttonDiv.empty();_this._addButtons($buttonDiv,doc,{schema:schema,focus:true,geom:true,reply:true,treeView:true});});$('.n2Display_attProgress_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $progress=$(this);_this._refreshAttachmentProgress($progress,doc);});if(_this._shouldSuppressNonApprovedMedia()){if($n2.couchMap.documentContainsMedia(doc)&&false==$n2.couchMap.documentContainsApprovedMedia(doc)){$('.n2SupressNonApprovedMedia_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $div=$(this);var $parent=$div.parent();$div.remove();_this._fixDocumentList($parent);});};}else if(_this._shouldSuppressDeniedMedia()){if($n2.couchMap.documentContainsMedia(doc)&&$n2.couchMap.documentContainsDeniedMedia(doc)){$('.n2SupressDeniedMedia_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $div=$(this);var $parent=$div.parent();$div.remove();_this._fixDocumentList($parent);});};};};},_populateWaitingDocument:function(doc){var _this=this;if(doc){var docId=doc._id;var escaped=$n2.utils.stringToHtmlId(docId);var cName='couchDisplayWait_'+escaped;$('.'+cName).each(function(){var $set=$(this);$set.removeClass(cName).addClass('couchDisplayAdded_'+escaped);_this._displayDocument($set,doc);});};},_fixDocumentList:function($elem){if($elem.hasClass('_n2DocumentListParent')){var $relatedDiv=$elem;}else{$relatedDiv=$elem.parents('._n2DocumentListParent');};if($relatedDiv.length>0){var $docDiv=$relatedDiv.find('._n2DocumentListEntry');var count=$docDiv.length;$relatedDiv.find('._n2DisplayDocCount').text(''+count);$docDiv.each(function(i){var $doc=$(this);$doc.removeClass('olkitSearchMod2_0');$doc.removeClass('olkitSearchMod2_1');$doc.addClass('olkitSearchMod2_'+(i%2));});};},_performDocumentEdit:function(data,options_){var _this=this;this.documentSource.getDocument({docId:data._id,onSuccess:function(doc){_this._dispatch({type:'editInitiate',docId:doc._id,doc:doc});},onError:function(errorMsg){$n2.log('Unable to load document: '+errorMsg);}});},_performDocumentDelete:function(data,options_){var _this=this;if(confirm(_loc('You are about to delete this document. Do you want to proceed?'))){this.documentSource.deleteDocument({doc:data,onSuccess:function(){if(options_.onDeleted){options_.onDeleted();};}});};},_performDocumentTreeView:function(data){new TreeDocumentViewer({doc:data});},_displayDocumentId:function($set,docId){var _this=this;$set.empty();this.documentSource.getDocument({docId:docId,onSuccess:function(doc){_this._displayDocument($set,doc);},onError:function(err){$set.empty();$('<div>').addClass('couchDisplayWait_'+$n2.utils.stringToHtmlId(docId)).text(_loc('Unable to retrieve document')).appendTo($set);}});},_handleDispatch:function(msg){var _this=this;var $div=this._getDisplayDiv();if($div.length<1){dispatcher.deregister(addr);return;};if(msg.type==='selected'){if(msg.doc){this._displayDocument($div,msg.doc);}else if(msg.docId){this._displayDocumentId($div,msg.docId);}else if(msg.docs){this._displayMultipleDocuments($div,msg.docs);}else if(msg.docIds){$div.empty();this._displayMultipleDocumentIds($div,msg.docIds)};}else if(msg.type==='searchResults'){this._displaySearchResults(msg.results);}else if(msg.type==='documentDeleted'){var docId=msg.docId;this._handleDocumentDeletion(docId);}else if(msg.type==='authLoggedIn'||msg.type==='authLoggedOut'){$('.n2Display_buttons').each(function(){var $elem=$(this);_this._refreshButtons($elem);});}else if(msg.type==='editClosed'){var deleted=msg.deleted;if(!deleted){var doc=msg.doc;if(doc){this._displayDocument($div,doc);};};}else if(msg.type==='documentContentCreated'){this._handleDocumentCreation(msg.doc);this._populateWaitingDocument(msg.doc);}else if(msg.type==='documentContentUpdated'){this._refreshDocument(msg.doc);this._populateWaitingDocument(msg.doc);};},_displayMultipleDocuments:function($container,docs){var _this=this;var $list=$('<div class="_n2DocumentListParent"></div>');$container.append($list);for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];var $div=$('<div></div>').addClass('_n2DocumentListEntry').addClass('_n2DocumentListEntry_'+$n2.utils.stringToHtmlId(docId)).addClass('olkitSearchMod2_'+(i%2)).addClass('n2SupressNonApprovedMedia_'+$n2.utils.stringToHtmlId(docId)).addClass('n2SupressDeniedMedia_'+$n2.utils.stringToHtmlId(docId));$list.append($div);var $contentDiv=$('<div class="n2s_handleHover"></div>');$div.append($contentDiv);this.showService.displayBriefDescription($contentDiv,{},doc);var $buttonDiv=$('<div></div>');$div.append($buttonDiv);this._addButtons($buttonDiv,doc,{focus:true,geom:true});};},_displayMultipleDocumentIds:function($container,docIds){var _this=this;var $list=$('<div class="_n2DocumentListParent"></div>');$container.append($list);for(var i=0,e=docIds.length;i<e;++i){var docId=docIds[i];var $div=$('<div></div>').addClass('_n2DocumentListEntry').addClass('_n2DocumentListEntry_'+$n2.utils.stringToHtmlId(docId)).addClass('olkitSearchMod2_'+(i%2)).addClass('n2SupressNonApprovedMedia_'+$n2.utils.stringToHtmlId(docId)).addClass('n2SupressDeniedMedia_'+$n2.utils.stringToHtmlId(docId));$list.append($div);var $contentDiv=$('<div class="n2s_handleHover"></div>');$div.append($contentDiv);this.showService.printBriefDescription($contentDiv,docId);if(this.requestService){var $progressDiv=$('<div class="n2Display_attProgress n2Display_attProgress_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$div.append($progressDiv);var $buttonDiv=$('<div class="displayRelatedButton displayRelatedButton_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$div.append($buttonDiv);this.requestService.requestDocument(docId);};};},_displaySearchResults:function(results){var ids=[];if(results&&results.sorted&&results.sorted.length){for(var i=0,e=results.sorted.length;i<e;++i){ids.push(results.sorted[i].id);};};var $div=this._getDisplayDiv();$div.empty();if(ids.length<1){$div.append($('<div>'+_loc('Search results empty')+'</div>'));}else{var $results=$('<div class="n2_search_result"></div>').appendTo($div);this._displayMultipleDocumentIds($results,ids);};},_dispatch:function(m){var dispatcher=this.dispatchService;if(dispatcher){dispatcher.send(DH,m);};},_handleDocumentDeletion:function(docId){var _this=this;var $elems=$('.couchDisplay_'+$n2.utils.stringToHtmlId(docId));$elems.remove();var $elems=$('.couchDisplayWait_'+$n2.utils.stringToHtmlId(docId));$elems.remove();var $entries=$('._n2DocumentListEntry_'+$n2.utils.stringToHtmlId(docId));$entries.each(function(){var $entry=$(this);var $p=$entry.parent();$entry.remove();_this._fixDocumentList($p);});},_handleDocumentCreation:function(doc){var _this=this;var links=$n2.couchGeom.extractLinks(doc);for(var i=0,e=links.length;i<e;++i){var refDocId=links[i].doc;if(refDocId){var $elems=$('.couchDisplayRelated_'+$n2.utils.stringToHtmlId(refDocId));if($elems.length>0){refreshRelatedInfo(refDocId,$elems);};};};function refreshRelatedInfo(docId,$elems){var request=_this.requestService;if(request){request.requestDocument(docId,function(d){loadedData(d,$elems);});};};function loadedData(data,$elems){var schemaName=data.nunaliit_schema?data.nunaliit_schema:null;var schemaRepository=_this.schemaRepository;if(schemaName&&schemaRepository){schemaRepository.getSchema({name:schemaName,onSuccess:function(schema){loadedSchema(data,schema,$elems);},onError:function(){loadedSchema(data,null,$elems);}});}else{loadedSchema(data,null,$elems);};};function loadedSchema(data,schema,$elems){$elems.each(function(){var $e=$(this);$e.empty();_this.displayRelatedInfoProcess.display({div:$e,display:_this,doc:data,schema:schema});});};}});var LegacyDisplayRelatedFunctionAdapter=$n2.Class({legacyFunction:null,initialize:function(legacyFunction){this.legacyFunction=legacyFunction;},display:function(opts_){return this.legacyFunction(opts_);},addButton:function(opts_){var opts=$n2.extend({display:null,div:null,doc:null,schema:null},opts_);var display=opts.display;var data=opts.doc;var schema=opts.schema;var $buttons=$(opts.div);var schemaRepository=display.schemaRepository;if(schema&&schema.relatedSchemaNames&&schema.relatedSchemaNames.length){var showRelatedButton=true;if(display.restrictAddRelatedButtonToLoggedIn){var sessionContext=$n2.couch.getSession().getContext();if(!sessionContext||!sessionContext.name){showRelatedButton=false;};};if(showRelatedButton){var selectId=$n2.getUniqueId();var $addRelatedButton=$('<select>').attr('id',selectId).appendTo($buttons);$('<option>').text(_loc('Add Related Item')).val('').appendTo($addRelatedButton);for(var i=0,e=schema.relatedSchemaNames.length;i<e;++i){var schemaName=schema.relatedSchemaNames[i];$('<option>').text(schemaName).val(schemaName).appendTo($addRelatedButton);if(schemaRepository){schemaRepository.getSchema({name:schemaName,onSuccess:function(schema){$('#'+selectId).find('option').each(function(){var $option=$(this);if($option.val()===schema.name){$option.text(schema.getLabel());};});}});};};$addRelatedButton.change(function(){var val=$(this).val();$(this).val('');display._addRelatedDocument(data._id,[val]);return false;});$addRelatedButton.addClass('nunaliit_form_link');$addRelatedButton.addClass('nunaliit_form_link_add_related_item');$addRelatedButton.menuselector();};};}});function _displayRelatedDocuments(display_,contId,relatedSchemaName,relatedDocIds){var $container=$('#'+contId);if(!relatedDocIds||relatedDocIds.length<1){$container.remove();return;};blindDisplay();function blindDisplay(){var blindId=$n2.getUniqueId();var $blindWidget=$('<div id="'+blindId+'" class="_n2DocumentListParent"><h3></h3><div style="padding-left:0px;padding-right:0px;"></div></div>');$container.append($blindWidget);var bw=$n2.blindWidget($blindWidget,{data:relatedDocIds,onBeforeOpen:beforeOpen});bw.setHtml('<span class="_n2DisplaySchemaName"></span> (<span class="_n2DisplayDocCount"></span>)');if(null==relatedSchemaName){$blindWidget.find('._n2DisplaySchemaName').text(_loc('Uncategorized'));}else{$blindWidget.find('._n2DisplaySchemaName').text(relatedSchemaName);};$blindWidget.find('._n2DisplayDocCount').text(''+relatedDocIds.length);var schemaRepository=display_.schemaRepository;if(schemaRepository&&relatedSchemaName){schemaRepository.getSchema({name:relatedSchemaName,onSuccess:function(schema){var $blindWidget=$('#'+blindId);$blindWidget.find('._n2DisplaySchemaName').text(_loc(schema.getLabel()));}});};function beforeOpen(info){var $div=info.content;var $dataloaded=$div.find('.___n2DataLoaded');if($dataloaded.length>0){return;};var docIds=info.data;$div.empty();$div.append($('<div class="___n2DataLoaded" style="display:none;"></div>'));for(var i=0,e=docIds.length;i<e;++i){var docId=docIds[i];var $docWrapper=$('<div></div>');$div.append($docWrapper);if(0===i){$docWrapper.addClass('_n2DocumentListStart');};if((e-1)===i){$docWrapper.addClass('_n2DocumentListEnd');};$docWrapper.addClass('_n2DocumentListEntry').addClass('_n2DocumentListEntry_'+$n2.utils.stringToHtmlId(docId)).addClass('olkitSearchMod2_'+(i%2)).addClass('n2SupressNonApprovedMedia_'+$n2.utils.stringToHtmlId(docId)).addClass('n2SupressDeniedMedia_'+$n2.utils.stringToHtmlId(docId));var $doc=$('<div></div>');$docWrapper.append($doc);if(display_.showService){if(display_.displayBriefInRelatedInfo){display_.showService.printBriefDescription($doc,docId);}else{display_.showService.printDocument($doc,docId);};}else{$doc.text(docId);};if(display_.requestService){var $progressDiv=$('<div class="n2Display_attProgress n2Display_attProgress_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$docWrapper.append($progressDiv);var $buttonDiv=$('<div class="displayRelatedButton displayRelatedButton_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$docWrapper.append($buttonDiv);display_.requestService.requestDocument(docId);};};};};};function DisplayRelatedInfo(opts_){var opts=$n2.extend({divId:null,div:null,display:null,doc:null,schema:null},opts_);var doc=opts.doc;var docId=doc._id;var display=opts.display;var schema=opts.schema;var $elem=opts.div;if(!$elem){$elem=$('#'+opts.divId);};if(!$elem.length){return;};if(!schema||!schema.relatedSchemaNames||!schema.relatedSchemaNames.length){return;};var schemaInfoByName={};for(var i=0,e=schema.relatedSchemaNames.length;i<e;++i){var relatedSchemaName=schema.relatedSchemaNames[i];schemaInfoByName[relatedSchemaName]={docIds:[]};};display._getAllReferences({doc:doc,onSuccess:showSections});function showSections(refInfo){for(var requestDocId in refInfo){if(refInfo[requestDocId].exists&&refInfo[requestDocId].reverse&&refInfo[requestDocId].schema){var schemaName=refInfo[requestDocId].schema;var schemaInfo=schemaInfoByName[schemaName];if(schemaInfo){schemaInfo.docIds.push(requestDocId);};};};for(var schemaName in schemaInfoByName){var schemaInfo=schemaInfoByName[schemaName];if(schemaInfo.docIds.length>0){var contId=$n2.getUniqueId();var $div=$('<div id="'+contId+'"></div>');$elem.append($div);var relatedDocIds=schemaInfo.docIds;_displayRelatedDocuments(display,contId,schemaName,relatedDocIds);};};};};function DisplayLinkedInfo(opts_){var opts=$n2.extend({divId:null,div:null,display:null,doc:null,schema:null},opts_);var display=opts.display;var doc=opts.doc;var docId=doc._id;var $elem=opts.div;if(!$elem){$elem=$('#'+opts.divId);};if(!$elem.length){return;};display._getAllReferences({doc:doc,onSuccess:showSections});function showSections(refInfo){var relatedDocsFromSchemas={};var uncategorizedDocIds=[];for(var requestDocId in refInfo){if(refInfo[requestDocId].exists){var schemaName=refInfo[requestDocId].schema;if(schemaName){if(!relatedDocsFromSchemas[schemaName]){relatedDocsFromSchemas[schemaName]={docIds:[]};};relatedDocsFromSchemas[schemaName].docIds.push(requestDocId);}else{uncategorizedDocIds.push(requestDocId);};};};for(var schemaName in relatedDocsFromSchemas){var contId=$n2.getUniqueId();var $div=$('<div id="'+contId+'"></div>');$elem.append($div);var relatedDocIds=relatedDocsFromSchemas[schemaName].docIds;_displayRelatedDocuments(display,contId,schemaName,relatedDocIds);};if(uncategorizedDocIds.length>0){var contId=$n2.getUniqueId();var $div=$('<div id="'+contId+'"></div>');$elem.append($div);_displayRelatedDocuments(display,contId,null,uncategorizedDocIds);};};};var CommentRelatedInfo=$n2.Class({commentSchema:null,dispatchService:null,lastDoc:null,lastDivId:null,lastDisplay:null,initialize:function(opts_){var opts=$n2.extend({schema:null,dispatchService:null},opts_);var _this=this;this.commentSchema=opts.schema;this.dispatchService=opts.dispatchService;if(this.dispatchService){var f=function(msg,addr,dispatcher){_this._handleDispatch(msg,addr,dispatcher);};this.dispatchService.register(DH,'documentContent',f);};},display:function(opts_){var opts=$n2.extend({divId:null,div:null,display:null,doc:null,schema:null},opts_);var _this=this;var display=opts.display;var doc=opts.doc;var docId=doc._id;var documentSource=display.documentSource;var showService=display.showService;var $elem=opts.div;if(!$elem){$elem=$('#'+opts.divId);};if(!$elem.length){return;};if(!showService){$n2.log('Show service not available for comment process');return;};this.lastDoc=doc;this.lastDivId=$n2.utils.getElementIdentifier($elem);this.lastDisplay=display;documentSource.getReferencesFromOrigin({docId:docId,onSuccess:loadedDocIds});function loadedDocIds(refDocIds){documentSource.getDocumentInfoFromIds({docIds:refDocIds,onSuccess:loadedDocInfos});};function loadedDocInfos(docInfos){docInfos.sort(function(a,b){var aTime=a.updatedTime;if(!aTime){aTime=a.createdTime;};var bTime=b.updatedTime;if(!bTime){bTime=b.createdTime;};if(aTime&&bTime){return bTime-aTime;};if(aTime)return-1;if(bTime)return 1;if(a.id>b.id){return 1;}
return-1;});$elem.empty();for(var i=0,e=docInfos.length;i<e;++i){var docInfo=docInfos[i];var docId=docInfo.id;var $commentDiv=$('<div>').addClass('n2DisplayComment_doc n2DisplayComment_doc_'+$n2.utils.stringToHtmlId(docId)).attr('n2DocId',docId).appendTo($elem);var $content=$('<div>').addClass('n2DisplayComment_content').appendTo($commentDiv);showService.printDocument($content,docId);var $buttons=$('<div>').addClass('n2DisplayComment_buttons').appendTo($commentDiv);$('<a>').attr('href','#').text(_loc('Reply')).addClass('n2DisplayComment_button_reply').appendTo($buttons).click(function(){var docId=$(this).parents('.n2DisplayComment_doc').attr('n2DocId');_this._addReply(docId,display);return false;});$('<a>').attr('href','#').text(_loc('More Details')).addClass('n2DisplayComment_button_focus').appendTo($buttons).click(function(){var docId=$(this).parents('.n2DisplayComment_doc').attr('n2DocId');_this._changeFocus(docId,display);return false;});};};},addButton:function(opts_){var opts=$n2.extend({display:null,div:null,doc:null,schema:null},opts_);var _this=this;var display=opts.display;var doc=opts.doc;var $buttons=$(opts.div);var $button=$('<a href="#"></a>').text(_loc('Add Comment')).appendTo($buttons).click(function(){_this._addComment(doc,display);return false;});$button.addClass('nunaliit_form_link');$button.addClass('nunaliit_form_link_add_related_item');},_addComment:function(doc,display){var createRelatedDocProcess=display.createRelatedDocProcess;createRelatedDocProcess.replyToDocument({doc:doc,schema:this.commentSchema,origin:doc._id});},_addReply:function(docId,display){var _this=this;var documentSource=display.documentSource;var createRelatedDocProcess=display.createRelatedDocProcess;documentSource.getDocument({docId:docId,onSuccess:function(doc){createRelatedDocProcess.replyToDocument({doc:doc,schema:_this.commentSchema});}});},_changeFocus:function(docId,display){var _this=this;display._dispatch({type:'userSelect',docId:docId});},_handleDispatch:function(m,address,dispatcher){if('documentContent'===m.type){var doc=m.doc;this._handleDocumentContent(doc);};},_handleDocumentContent:function(doc){if(doc.nunaliit_origin){if(doc.nunaliit_origin.doc===this.lastDoc._id){var $section=$('#'+this.lastDivId);if($section.length>0){var $entry=$section.find('.n2DisplayComment_doc_'+$n2.utils.stringToHtmlId(doc._id));if($entry.length<1){this.display({divId:this.lastDivId,display:this.lastDisplay,doc:this.lastDoc,schema:null});};};};};}});var TreeDocumentViewer=$n2.Class({doc:null,initialize:function(opts_){var opts=$n2.extend({doc:null},opts_);this.doc=opts.doc;this._display();},_display:function(){var $dialog=$('<div>').addClass('n2Display_treeViewer_dialog');var diagId=$n2.utils.getElementIdentifier($dialog);var $container=$('<div>').addClass('n2Display_treeViewer_content').appendTo($dialog);new $n2.tree.ObjectTree($container,this.doc);var $buttons=$('<div>').addClass('n2Display_treeViewer_buttons').appendTo($dialog);$('<button>').text(_loc('Close')).appendTo($buttons).click(function(){var $diag=$('#'+diagId);$diag.dialog('close');return false;});$dialog.dialog({autoOpen:true,title:_loc('Tree View'),modal:true,width:370,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}});}});$n2.couchDisplay={Display:Display,CommentRelatedInfo:CommentRelatedInfo,TreeDocumentViewer:TreeDocumentViewer};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchDisplayTiles';function docCreationTimeSort(lhs,rhs){var timeLhs=0;var timeRhs=0;if(lhs&&lhs.doc&&lhs.doc.nunaliit_created&&lhs.doc.nunaliit_created.time){timeLhs=lhs.doc.nunaliit_created.time;}
if(rhs&&rhs.doc&&rhs.doc.nunaliit_created&&rhs.doc.nunaliit_created.time){timeRhs=rhs.doc.nunaliit_created.time;}
if(timeLhs<timeRhs)return-1;if(timeLhs>timeRhs)return 1;return 0;};function startsWith(s,prefix){var left=s.substr(0,prefix.length);return(left===prefix);};var GridTemplateDocument=$n2.Class({height:null,tileHeight:null,initialize:function(height,tileHeight){this.height=(height?height:0);this.tileHeight=(tileHeight?tileHeight:150);},get:function(numCols,targetTiles){targetTiles=targetTiles+12;var numRows=Math.ceil(targetTiles/numCols),rects=[],x,y,i;var firstTileHeight=Math.max(1,Math.ceil(this.height/this.tileHeight));var firstTileWidth=2;rects.push(new Tiles.Rectangle(0,0,firstTileWidth,firstTileHeight));x=firstTileWidth-1;y=0;for(i=1;i<targetTiles;++i){x=x+1;while(x>=numCols){y=y+1;x=0;if(y<firstTileHeight){x=firstTileWidth;};};rects.push(new Tiles.Rectangle(x,y,1,1));};return new Tiles.Template(rects,numCols,numRows);}});var TiledDisplay=$n2.Class({documentSource:null,displayPanelName:null,showService:null,editor:null,uploadService:null,authService:null,requestService:null,schemaRepository:null,customService:null,dispatchService:null,boolOptions:null,restrictAddRelatedButtonToLoggedIn:null,currentDetails:null,displayedDocumentsOrder:null,displayedDocuments:null,grid:null,createRelatedDocProcess:null,requestService:null,defaultSchema:null,relatedDocumentDiscoveryProcess:null,documentInfoFunction:null,sortFunction:null,filterFactory:null,filter:null,hoverInFn:null,hoverOutFn:null,hoverDocId:null,initialize:function(opts_){var opts=$n2.extend({documentSource:null,displayPanelName:null,showService:null,editor:null,uploadService:null,authService:null,requestService:null,schemaRepository:null,customService:null,dispatchService:null,displayRelatedInfoFunction:null,displayOnlyRelatedSchemas:false,displayBriefInRelatedInfo:false,restrictAddRelatedButtonToLoggedIn:false,relatedDocumentDiscoveryProcess:null,documentInfoFunction:null,sortFunction:null,filterFactory:null},opts_);var _this=this;this.currentDetails={};this.displayedDocuments={};this.displayedDocumentsOrder=null;this.documentSource=opts.documentSource;this.displayPanelName=opts.displayPanelName;this.showService=opts.showService;this.editor=opts.editor;this.uploadService=opts.uploadService;this.authService=opts.authService;this.requestService=opts.requestService;this.schemaRepository=opts.schemaRepository;this.customService=opts.customService;this.dispatchService=opts.dispatchService;this._getDisplayDiv();this.boolOptions={displayOnlyRelatedSchemas:opts.displayOnlyRelatedSchemas,displayBriefInRelatedInfo:opts.displayBriefInRelatedInfo};this.restrictAddRelatedButtonToLoggedIn=opts.restrictAddRelatedButtonToLoggedIn;if(!this.restrictAddRelatedButtonToLoggedIn&&this.customService){this.restrictAddRelatedButtonToLoggedIn=this.customService.getOption('restrictAddRelatedButtonToLoggedIn',false);};var dispatcher=this.dispatchService;if(dispatcher){var f=function(msg,addr,d){_this._handleDispatch(msg,addr,d);};dispatcher.register(DH,'selected',f);dispatcher.register(DH,'searchResults',f);dispatcher.register(DH,'documentDeleted',f);dispatcher.register(DH,'authLoggedIn',f);dispatcher.register(DH,'authLoggedOut',f);dispatcher.register(DH,'editClosed',f);dispatcher.register(DH,'documentContent',f);dispatcher.register(DH,'documentContentCreated',f);dispatcher.register(DH,'documentContentUpdated',f);};if(!opts.displayRelatedInfoFunction){var flag=this._getBooleanOption('displayOnlyRelatedSchemas');if(flag){opts.displayRelatedInfoFunction=function(opts_){_this._displayRelatedInfo(opts_);};}else{opts.displayRelatedInfoFunction=function(opts_){_this._displayLinkedInfo(opts_);};};};this.createRelatedDocProcess=new $n2.couchRelatedDoc.CreateRelatedDocProcess({documentSource:opts.documentSource,schemaRepository:this.schemaRepository,uploadService:this.uploadService,showService:this.showService,authService:this.authService});this.relatedDocumentDiscoveryProcess=opts.relatedDocumentDiscoveryProcess;if(!this.relatedDocumentDiscoveryProcess&&this.customService){this.relatedDocumentDiscoveryProcess=this.customService.getOption('relatedDocumentDiscoveryProcess',null);};if(!this.relatedDocumentDiscoveryProcess){this.relatedDocumentDiscoveryProcess=new ReferenceRelatedDocumentDiscovery({documentSource:this.documentSource});};this.documentInfoFunction=opts.documentInfoFunction;if(!this.documentInfoFunction&&this.customService){var docInfoFn=this.customService.getOption('displayDocumentInfoFunction');if(typeof docInfoFn==='function'){this.documentInfoFunction=docInfoFn;};};if(!this.documentInfoFunction){this.documentInfoFunction=function(opts_){var opts=$n2.extend({docIds:null,display:null,onSuccess:function(docInfos){},onError:function(err){}},opts_);var ds=opts.display.documentSource;ds.getDocumentInfoFromIds({docIds:opts.docIds,onSuccess:opts.onSuccess,onError:opts.onError});};};this.sortFunction=opts.sortFunction;if(!this.sortFunction&&this.customService){var sortFn=this.customService.getOption('displaySortFunction');if(typeof sortFn==='function'){this.sortFunction=sortFn;};};if(!this.sortFunction){this.sortFunction=function(infos){infos.sort(function(a,b){if(a.updatedTime&&b.updatedTime){if(a.updatedTime>b.updatedTime){return-1;};if(a.updatedTime<b.updatedTime){return 1;};};if(a.id>b.id){return-1;};if(a.id<b.id){return 1;};return 0;});};};this.filterFactory=opts.filterFactory;if(!this.filterFactory&&this.customService){var factory=this.customService.getOption('displayFilterFactory');if(factory&&typeof factory.get==='function'){this.filterFactory=factory;};};if(!this.filterFactory){this.filterFactory=new SchemaFilterFactory({schemaRepository:this.schemaRepository});};this.hoverInFn=function(){var $tile=$(this);var docId=$tile.attr('n2DocId');if(docId&&docId!==_this.hoverDocId){_this.hoverDocId=docId;_this._dispatch({type:'userFocusOn',docId:docId});};};this.hoverOutFn=function(){var $tile=$(this);var docId=$tile.attr('n2DocId');if(docId&&docId===_this.hoverDocId){_this.hoverDocId=null;_this._dispatch({type:'userFocusOff',docId:docId});};};var intervalID=window.setInterval(function(){var $set=_this._getDisplayDiv();if($set.length<0){window.clearInterval(intervalID);}else{_this._performIntervalTask();};},500);},setSchema:function(schema){this.defaultSchema=schema;},_handleDispatch:function(msg,addr,dispatcher){var $div=this._getDisplayDiv();if($div.length<1){dispatcher.deregister(addr);return;};if(msg.type==='selected'){if(msg.doc){this._displayDocument(msg.doc._id,msg.doc);}else if(msg.docId){this._displayDocument(msg.docId,null);}else if(msg.docs){var ids=[];for(var i=0,e=msg.docs.length;i<e;++i){ids.push(msg.docs[i]._id);};this._displayMultipleDocuments(ids,msg.docs);}else if(msg.docIds){this._displayMultipleDocuments(msg.docIds,null);};}else if(msg.type==='searchResults'){this._displaySearchResults(msg.results);}else if(msg.type==='documentDeleted'){}else if(msg.type==='authLoggedIn'||msg.type==='authLoggedOut'){if(this.currentDetails&&this.currentDetails.docId&&this.currentDetails.doc){this._receiveDocumentContent(this.currentDetails.doc);this._displayDocumentButtons(this.currentDetails.doc,this.currentDetails.schema);};}else if(msg.type==='editClosed'){var deleted=msg.deleted;if(!deleted){var doc=msg.doc;if(doc){this._displayDocument(doc._id,doc);};};}else if(msg.type==='documentContent'){this._receiveDocumentContent(msg.doc);}else if(msg.type==='documentContentCreated'){this._receiveDocumentContent(msg.doc);}else if(msg.type==='documentContentUpdated'){this._receiveDocumentContent(msg.doc);};},_displayDocument:function(docId,doc){this._reclaimDisplayDiv();if(this.currentDetails&&this.currentDetails.docId===docId){return;};this.currentDetails={docId:docId};this._addDisplayedDocument(docId,doc);var $set=this._getDisplayDiv();var $current=$set.find('.n2DisplayTiled_info');$current.hide();this.grid.template=null;this.grid.templateFactory=new GridTemplateDocument();this._adjustCurrentTile(docId);if(doc){this._receiveDocumentContent(doc);}else{this._requestDocumentWithId(docId);};},_displaySearchResults:function(results){this._reclaimDisplayDiv();var ids=[];if(results&&results.sorted&&results.sorted.length){for(var i=0,e=results.sorted.length;i<e;++i){ids.push(results.sorted[i].id);};};this._displayMultipleDocuments(ids,null);if(ids.length<1){var $set=this._getDisplayDiv();var $current=$set.find('.n2DisplayTiled_info');$current.text(_loc('Empty search results')).show();};},_displayMultipleDocuments:function(ids,docs){this._reclaimDisplayDiv();var $set=this._getDisplayDiv();var $current=$set.find('.n2DisplayTiled_info');$current.hide();this.currentDetails={docIds:ids,docs:{}};this.grid.template=null;this.grid.templateFactory=Tiles.UniformTemplates;this._adjustCurrentTile(null);var docsById={};if(docs){for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];this.currentDetails.docs[doc._id]=doc;docsById[doc._id]=doc;};};this._changeDisplayedDocuments(ids,docsById);},_displayDocumentButtons:function(doc,schema){var _this=this;if(doc&&doc._id&&this.currentDetails.docId===doc._id){var $set=this._getDisplayDiv();var $btnDiv=$set.find('.n2DisplayTiled_current_buttons').empty();if($n2.couchMap.canEditDoc(doc)){$('<a href="#"></a>').addClass('n2DisplayTiled_current_button n2DisplayTiled_current_button_edit').text(_loc('Edit')).appendTo($btnDiv).click(function(){_this._performDocumentEdit(doc);return false;});};if($n2.couchMap.canDeleteDoc(doc)){$('<a href="#"></a>').addClass('n2DisplayTiled_current_button n2DisplayTiled_current_button_delete').text(_loc('Delete')).appendTo($btnDiv).click(function(){_this._performDocumentDelete(doc);return false;});};if(schema&&schema.relatedSchemaNames&&schema.relatedSchemaNames.length){var showAddRelatedButton=true;if(this.restrictAddRelatedButtonToLoggedIn){var isLoggedIn=false;if(this.dispatchService){var m={type:'authIsLoggedIn',isLoggedIn:false};this.dispatchService.synchronousCall(DH,m);isLoggedIn=m.isLoggedIn;};if(!isLoggedIn){showAddRelatedButton=false;};};if(showAddRelatedButton){var selectId=$n2.getUniqueId();var $addRelatedButton=$('<select>').addClass('n2DisplayTiled_current_button n2DisplayTiled_current_button_add_related_item').attr('id',selectId).appendTo($btnDiv);$('<option>').text(_loc('Add Related Item')).val('').appendTo($addRelatedButton);for(var i=0,e=schema.relatedSchemaNames.length;i<e;++i){var schemaName=schema.relatedSchemaNames[i];$('<option>').text(schemaName).val(schemaName).appendTo($addRelatedButton);if(this.schemaRepository){this.schemaRepository.getSchema({name:schemaName,onSuccess:function(schema){$('#'+selectId).find('option').each(function(){var $option=$(this);if($option.val()===schema.name){$option.text(schema.getLabel());};});}});};};$addRelatedButton.change(function(){var val=$(this).val();$(this).val('');if(val){_this._addRelatedDocument(doc._id,val);};return false;});};};if(this.dispatchService&&doc.nunaliit_geom&&this.dispatchService.isEventTypeRegistered('findOnMap')){var showFindOnMapButton=false;if(doc.nunaliit_layers&&doc.nunaliit_layers.length>0){var m={type:'mapGetLayers',layers:{}};this.dispatchService.synchronousCall(DH,m);for(var i=0,e=doc.nunaliit_layers.length;i<e;++i){var layerId=doc.nunaliit_layers[i];if(m.layers[layerId]){showFindOnMapButton=true;};};};if(showFindOnMapButton){$('<a href="#"></a>').addClass('n2DisplayTiled_current_button n2DisplayTiled_current_button_find_on_map').text(_loc('Find on Map')).appendTo($btnDiv).click(function(){_this._performFindOnMap(doc);return false;});};};if(doc&&doc.nunaliit_layer_definition&&this.dispatchService&&this.dispatchService.isEventTypeRegistered('addLayerToMap')){$('<a href="#"></a>').addClass('n2DisplayTiled_current_button n2DisplayTiled_current_button_add_layer').text(_loc('Add Layer')).appendTo($btnDiv).click(function(){_this._performAddLayerToMap(doc);return false;});};if(doc){$('<a href="#"></a>').addClass('n2DisplayTiled_current_button n2DisplayTiled_current_button_tree_view').text(_loc('Tree View')).appendTo($btnDiv).click(function(){_this._performTreeView(doc);return false;});};};},_currentDocReferencesUpdated:function(){if(this.currentDetails&&this.currentDetails.doc&&this.currentDetails.referenceDocIds){var refDocIds={};for(var i=0,e=this.currentDetails.referenceDocIds.length;i<e;++i){var linkDocId=this.currentDetails.referenceDocIds[i];refDocIds[linkDocId]=true;};var idsToRemove=[];for(var docId in this.displayedDocuments){if(docId===this.currentDetails.docId){}else if(!refDocIds[docId]){idsToRemove.push(docId);};};for(var i=0,e=idsToRemove.length;i<e;++i){this._removeDisplayedDocument(idsToRemove[i]);};for(var docId in refDocIds){this._addDisplayedDocument(docId);};this.displayedDocumentsOrder=null;this._updateDisplayedDocuments();};},_updateDisplayedDocuments:function(){var _this=this;var neededInfoIds=[];for(var docId in this.displayedDocuments){if(!this.displayedDocuments[docId].info){neededInfoIds.push(docId);};};if(neededInfoIds.length>0){this.documentInfoFunction({docIds:neededInfoIds,display:this,onSuccess:function(docInfos){for(var i=0,e=docInfos.length;i<e;++i){var docInfo=docInfos[i];var docId=docInfo.id;if(_this.displayedDocuments[docId]){_this.displayedDocuments[docId].info=docInfo;};};performUpdate();},onError:function(errorMsg){$n2.log('Unable to obtain document information',errorMsg);}});}else{performUpdate();};function performUpdate(){_this._getDisplayDiv();var sortedDocIds=null;if(_this.displayedDocumentsOrder){sortedDocIds=_this.displayedDocumentsOrder;var infos=[];for(var i=0,e=sortedDocIds.length;i<e;++i){var docId=sortedDocIds[i];if(_this.displayedDocuments[docId]&&_this.displayedDocuments[docId].info){infos.push(_this.displayedDocuments[docId].info);};};_this.filter.display(infos,_this);infos=_this.filter.filter(infos,_this);sortedDocIds=[];for(var i=0,e=infos.length;i<e;++i){var info=infos[i];sortedDocIds.push(info.id);};}else{var infos=[];for(var docId in _this.displayedDocuments){if(_this.displayedDocuments[docId].info){infos.push(_this.displayedDocuments[docId].info);};};_this.filter.display(infos,_this);infos=_this.filter.filter(infos,_this);_this.sortFunction(infos);var alreadySorted={};sortedDocIds=[];if(_this.currentDetails&&_this.currentDetails.docId){sortedDocIds.push(_this.currentDetails.docId);alreadySorted[_this.currentDetails.docId]=true;};for(var i=0,e=infos.length;i<e;++i){var docId=infos[i].id;if(!alreadySorted[docId]){sortedDocIds.push(docId);alreadySorted[docId]=true;};};};_this.grid.updateTiles(sortedDocIds);_this.grid.isDirty=true;_this.grid.redraw(true);for(var i=0,e=sortedDocIds.length;i<e;++i){var docId=sortedDocIds[i];_this._requestDocumentWithId(docId);};};},_changeDisplayedDocuments:function(docIds,docsById){var displayDocsByIds={};for(var i=0,e=docIds.length;i<e;++i){var docId=docIds[i];displayDocsByIds[docId]=true;};for(var docId in this.displayedDocuments){if(!displayDocsByIds[docId]){this._removeDisplayedDocument(docId);};};for(var i=0,e=docIds.length;i<e;++i){var docId=docIds[i];var doc=null;if(docsById&&docsById[docId]){doc=docsById[docId];};this._addDisplayedDocument(docId,doc);};this.displayedDocumentsOrder=docIds;this._updateDisplayedDocuments();},_addDisplayedDocument:function(docId,doc){if(!this.displayedDocuments[docId]){this.displayedDocuments[docId]={id:docId};};if(doc){this.displayedDocuments[docId].doc=doc;};},_removeDisplayedDocument:function(docId){if(this.displayedDocuments[docId]){delete this.displayedDocuments[docId];};},_receiveDocumentContent:function(doc){var _this=this;var $set=this._getDisplayDiv();var docId=doc._id;if(this.displayedDocuments[docId]){this.displayedDocuments[docId].doc=doc;};if(doc._id===this.currentDetails.docId){var update=false;if(!this.currentDetails.doc){this.currentDetails.doc=doc;update=true;}else{if(doc._rev!==this.currentDetails.doc._rev){this.currentDetails.doc=doc;update=true;};};if(update){this.relatedDocumentDiscoveryProcess.getRelatedDocumentIds({doc:doc,onSuccess:function(doc,refDocIds){if(_this.currentDetails.docId===doc._id){_this.currentDetails.referenceDocIds=refDocIds;_this._currentDocReferencesUpdated();};},onError:function(err){$n2.log('Error obtaining reference ids',err);}});};};var waitClassName='n2DisplayTiled_wait_brief_'+$n2.utils.stringToHtmlId(docId);$set.find('.'+waitClassName).each(function(){var $div=$(this);if(_this.showService){_this.showService.displayBriefDescription($div,{},doc);};$div.removeClass(waitClassName);});var waitClassName='n2DisplayTiled_wait_current_'+$n2.utils.stringToHtmlId(docId);$set.find('.'+waitClassName).each(function(){var $div=$(this).empty();$('<div>').addClass('n2DisplayTiled_current_buttons').appendTo($div);var $content=$('<div>').appendTo($div);if(_this.showService){_this.showService.displayDocument($content,{},doc);}else{$content.text(doc._id);};_this._displayDocumentButtons(doc,_this.currentDetails.schema);$div.removeClass(waitClassName);});var includesImage=false;var includesAudio=false;var includesVideo=false;var thumbnailName=null;var schemaName=null;if(doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var att=doc.nunaliit_attachments.files[attName];if(att.source){}else{if('image'===att.fileClass){includesImage=true;}else if('audio'===att.fileClass){includesAudio=true;}else if('video'===att.fileClass){includesVideo=true;};if(att.thumbnail){thumbnailName=att.thumbnail;};};};};if(doc.nunaliit_schema){schemaName=doc.nunaliit_schema;};$set.find('.n2DisplayTiled_tile_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $tile=$(this);$tile.removeClass('n2DisplayTiled_tile_image n2DisplayTiled_tile_audio n2DisplayTiled_tile_video');if(includesVideo){$tile.addClass('n2DisplayTiled_tile_video');}else if(includesAudio){$tile.addClass('n2DisplayTiled_tile_audio');}else if(includesImage){$tile.addClass('n2DisplayTiled_tile_image');};if(schemaName){$tile.addClass('n2DisplayTiled_tile_schema_'+$n2.utils.stringToHtmlId(schemaName));};});if(thumbnailName){if(doc.nunaliit_attachments.files[thumbnailName]&&doc.nunaliit_attachments.files[thumbnailName].status==='attached'){}else{thumbnailName=null;};};if(thumbnailName){var url=this.documentSource.getDocumentAttachmentUrl(doc,thumbnailName);if(url){$set.find('.n2DisplayTiled_wait_thumb_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $div=$(this);$div.empty();$('<img>').attr('src',url).appendTo($div);});};};if(doc.nunaliit_schema&&this.schemaRepository){this.schemaRepository.getSchema({name:doc.nunaliit_schema,onSuccess:function(schema){schemaLoaded(doc,schema);},onError:function(err){schemaLoaded(doc,null);}});}else{schemaLoaded(doc,null);};if(this.currentDetails.doc&&doc._id!==this.currentDetails.docId){this.relatedDocumentDiscoveryProcess.areDocumentsRelated({selectedDoc:this.currentDetails.doc,relatedDoc:doc,onRelated:function(selectedDoc,relatedDoc){if(selectedDoc._id===_this.currentDetails.docId){var refIndex=-1;if(_this.currentDetails.referenceDocIds){refIndex=_this.currentDetails.referenceDocIds.indexOf(doc._id);};if(refIndex<0){if(!_this.currentDetails.referenceDocIds){_this.currentDetails.referenceDocIds=[];};_this.currentDetails.referenceDocIds.push(doc._id);_this._currentDocReferencesUpdated();};};},onNotRelated:function(selectedDoc,relatedDoc){if(selectedDoc._id===_this.currentDetails.docId){var refIndex=-1;if(_this.currentDetails.referenceDocIds){refIndex=_this.currentDetails.referenceDocIds.indexOf(doc._id);};if(refIndex>=0){_this.currentDetails.referenceDocIds.splice(refIndex,1);_this._currentDocReferencesUpdated();};};},onError:function(err){$n2.log('Error in displayTiled. Unable to check relation.',err);}});};function schemaLoaded(doc,schema){if(_this.currentDetails.docId===doc._id){if(schema&&!_this.currentDetails.schema){_this.currentDetails.schema=schema;_this._displayDocumentButtons(doc,schema);}else if(_this.currentDetails.schema&&!schema){_this.currentDetails.schema=null;_this._displayDocumentButtons(doc,null);}else if(_this.currentDetails.schema&&schema&&_this.currentDetails.schema.name!==schema.name){_this.currentDetails.schema=schema;_this._displayDocumentButtons(doc,schema);};};};},_addRelatedDocument:function(docId,schemaName){this.createRelatedDocProcess.createDocumentFromSchemaNames({schemaNames:[schemaName],relatedDocId:docId,onSuccess:function(docId){}});},_performDocumentEdit:function(doc){var _this=this;this.documentSource.getDocument({docId:doc._id,onSuccess:function(doc){_this._dispatch({type:'editInitiate',docId:doc._id,doc:doc});},onError:function(errorMsg){$n2.log('Unable to load document: '+errorMsg);}});},_performDocumentDelete:function(doc){if(confirm(_loc('You are about to delete this document. Do you want to proceed?'))){this.documentSource.deleteDocument({doc:doc,onSuccess:function(){}});};},_performFindOnMap:function(doc){if(!doc.nunaliit_geom){$n2.log('Error: can not find nunaliit_geom for "Find on Map"');return;};var x=(doc.nunaliit_geom.bbox[0]+doc.nunaliit_geom.bbox[2])/2;var y=(doc.nunaliit_geom.bbox[1]+doc.nunaliit_geom.bbox[3])/2;var visible=false;var layerIdToTurnOn=null;var m={type:'mapGetLayers',layers:{}};this.dispatchService.synchronousCall(DH,m);for(var i=0,e=doc.nunaliit_layers.length;i<e;++i){var layerId=doc.nunaliit_layers[i];if(m.layers[layerId]){if(m.layers[layerId].visible){visible=true;}else{layerIdToTurnOn=layerId;};};};if(!visible){this._dispatch({type:'setMapLayerVisibility',layerId:layerIdToTurnOn,visible:true});};this._dispatch({type:'findOnMap',fid:doc._id,srsName:'EPSG:4326',x:x,y:y});},_performAddLayerToMap:function(doc){var layerDefinition=doc.nunaliit_layer_definition;var layerId=layerDefinition.id;if(!layerId){layerId=doc._id;};var layerDef={name:layerDefinition.name,type:'couchdb',options:{layerName:layerId,documentSource:this.documentSource}};this._dispatch({type:'addLayerToMap',layer:layerDef,options:{setExtent:{bounds:layerDefinition.bbox,crs:'EPSG:4326'}}});},_performTreeView:function(doc){new $n2.couchDisplay.TreeDocumentViewer({doc:doc});},_reclaimDisplayDiv:function(){var _this=this;var $set=this._getDisplayDiv();var $filters=$set.find('.n2DisplayTiled_filters');var $current=$set.find('.n2DisplayTiled_info');var $docs=$set.find('.n2DisplayTiled_documents');if($filters.length<1||$current.length<1||$docs.length<1){$set.empty();$filters=$('<div>').addClass('n2DisplayTiled_filters').appendTo($set);$current=$('<div>').addClass('n2DisplayTiled_info').appendTo($set);$docs=$('<div>').addClass('n2DisplayTiled_documents').appendTo($set);this.currentDetails={};this.grid=new Tiles.Grid($docs);this.grid.createTile=function(docId){var $elem=$('<div>').addClass('n2DisplayTiled_tile').addClass('n2DisplayTiled_tile_'+$n2.utils.stringToHtmlId(docId)).attr('n2DocId',docId);$elem.hover(_this.hoverInFn,_this.hoverOutFn);var tile=new Tiles.Tile(docId,$elem);if(_this.currentDetails&&_this.currentDetails.docId===docId){$elem.addClass('n2DisplayTiled_tile_current');_this._generateCurrentDocumentContent($elem,docId);}else{_this._generateDocumentContent($elem,docId);};return tile;};this.filter=this.filterFactory.get($filters,function(){_this._documentFilterChanged();});};},_adjustCurrentTile:function(docId){var _this=this;var $set=this._getDisplayDiv();var $docs=$set.find('.n2DisplayTiled_documents');var targetClass=null;if(docId){targetClass='n2DisplayTiled_tile_'+$n2.utils.stringToHtmlId(docId);};$docs.find('.n2DisplayTiled_tile_current').each(function(){var $elem=$(this);if(targetClass&&$elem.hasClass(targetClass)){}else{$elem.removeClass('n2DisplayTiled_tile_current');var id=$elem.attr('n2DocId');_this._generateDocumentContent($elem,id);};});if(targetClass){$docs.find('.'+targetClass).each(function(){var $elem=$(this);if($elem.hasClass('n2DisplayTiled_tile_current')){}else{$elem.addClass('n2DisplayTiled_tile_current');var id=$elem.attr('n2DocId');_this._generateCurrentDocumentContent($elem,id);};});};},_getDisplayDiv:function(){var divId=this.displayPanelName;return $('#'+divId);},_dispatch:function(m){var dispatcher=this.dispatchService;if(dispatcher){dispatcher.send(DH,m);};},_getBooleanOption:function(optionName){var flag=false;if(this.boolOptions[optionName]){flag=true;};var cs=this.customService;if(cs&&!flag){var o=cs.getOption(optionName);if(o){flag=true;};};return flag;},_getCachedDocumentFromId:function(docId){if(this.displayedDocuments&&this.displayedDocuments[docId]&&this.displayedDocuments[docId].doc){return this.displayedDocuments[docId].doc;};if(this.currentDetails&&this.currentDetails.docId===docId&&this.currentDetails.doc){return this.currentDetails.doc;};return null;},_requestDocumentWithId:function(docId){var doc=this._getCachedDocumentFromId(docId);if(doc){this._receiveDocumentContent(doc);return;};if(this.requestService){this.requestService.requestDocument(docId);};},_generateCurrentDocumentContent:function($elem,docId){$elem.empty();var waitClassName='n2DisplayTiled_wait_current_'+$n2.utils.stringToHtmlId(docId);$('<div>').addClass(waitClassName).addClass('n2DisplayTiled_tile_content').text(docId).appendTo($elem);},_generateDocumentContent:function($elem,docId){var _this=this;$elem.empty();$('<div>').addClass('n2DisplayTiled_thumb n2DisplayTiled_wait_thumb_'+$n2.utils.stringToHtmlId(docId)).appendTo($elem);$('<div>').addClass('n2DisplayTiled_wait_brief_'+$n2.utils.stringToHtmlId(docId)).addClass('n2DisplayTiled_tile_brief').text(docId).appendTo($elem);var clickInstalled=$elem.attr('n2Click');if(!clickInstalled){$elem.click(function(){_this._dispatch({type:'userSelect',docId:docId});});$elem.attr('n2Click','installed');};},_performIntervalTask:function(){var $set=this._getDisplayDiv();var $docs=$set.find('.n2DisplayTiled_documents');if(this.currentDetails&&this.currentDetails.docId){var $currentTile=$docs.find('.n2DisplayTiled_tile_current').find('.n2DisplayTiled_tile_content');if($currentTile.length>0){var height=$currentTile.height();if(height!=this.currentDetails.height){this.currentDetails.height=height;var cellSize=this.grid.cellSize;this.grid.template=null;this.grid.templateFactory=new GridTemplateDocument(height,cellSize);this.grid.redraw(true);};};};},_documentFilterChanged:function(){this._updateDisplayedDocuments();}});var SchemaFilter=$n2.Class({elemId:null,changeCallback:null,schemaRepository:null,selectedSchema:null,initialize:function(elem,changeCallback,schemaRepository){var $elem=$(elem);this.elemId=$elem.attr('id');if(!this.elemId){this.elemId=$n2.getUniqueId();$elem.attr('id',this.elemId);};this.changeCallback=changeCallback;this.schemaRepository=schemaRepository;},display:function(infos){var _this=this;var schemas={};if(infos){for(var i=0,e=infos.length;i<e;++i){var info=infos[i];if(info.schema){schemas[info.schema]=true;};};};var schemaNames=[];for(var schemaName in schemas){schemaNames.push(schemaName);};this.schemaRepository.getSchemas({names:schemaNames,onSuccess:function(schemas){_this._displaySchemas(schemas);},onError:function(err){$n2.log('Error getting schemas for displaying schema filter',err);}});},filter:function(infos){if(this.selectedSchema){var filteredInfos=[];for(var i=0,e=infos.length;i<e;++i){var info=infos[i];if(info.schema===this.selectedSchema){filteredInfos.push(info);};};return filteredInfos;}else{return infos;};},_getElem:function(){return $('#'+this.elemId);},_displaySchemas:function(schemas){var _this=this;var $elem=this._getElem();$elem.empty();var clickFn=function(){var $a=$(this);var schemaName=$a.attr('n2SchemaName');schemaName=schemaName?schemaName:null;_this._schemaSelected(schemaName);return false;};$('<a>').attr('href','#').text(_loc('All')).addClass('n2DisplayTiled_filter').addClass('n2DisplayTiled_filter_all').appendTo($elem).click(clickFn);var keepCurrentSelection=false;for(var i=0,e=schemas.length;i<e;++i){var schema=schemas[i];if(schema.name===this.selectedSchema){keepCurrentSelection=true;};var schemaLabel=schema.name;if(schema.label){schemaLabel=_loc(schema.label);};$('<a>').attr('href','#').attr('n2SchemaName',schema.name).text(schemaLabel).addClass('n2DisplayTiled_filter_schema').addClass('n2DisplayTiled_filter_schema_'+$n2.utils.stringToHtmlId(schema.name)).appendTo($elem).click(clickFn);};if(!keepCurrentSelection){this.selectedSchema=null;};this._adjustSelection();},_adjustSelection:function(){var $elem=this._getElem();$elem.find('.n2DisplayTiled_filter_selected').removeClass('n2DisplayTiled_filter_selected');if(this.selectedSchema){$elem.find('.n2DisplayTiled_filter_schema_'+$n2.utils.stringToHtmlId(this.selectedSchema)).addClass('n2DisplayTiled_filter_selected');}else{$elem.find('.n2DisplayTiled_filter_all').addClass('n2DisplayTiled_filter_selected');};},_schemaSelected:function(schemaName){this.selectedSchema=schemaName;this._adjustSelection();this.changeCallback();}});var SchemaFilterFactory=$n2.Class({schemaRepository:null,initialize:function(opts_){var opts=$n2.extend({schemaRepository:null},opts_);this.schemaRepository=opts.schemaRepository;},get:function(elem,changeCallback){return new SchemaFilter(elem,changeCallback,this.schemaRepository);}});var ReferenceRelatedDocumentDiscovery=$n2.Class({documentSource:null,initialize:function(opts_){var opts=$n2.extend({documentSource:null},opts_);this.documentSource=opts.documentSource;},getRelatedDocumentIds:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(doc,refDocIds){},onError:function(err){}},opts_);var doc=opts.doc;this.documentSource.getReferencesFromId({docId:doc._id,onSuccess:loadedRefIds,onError:function(errorMsg){opts.onError(errorMsg);}});function loadedRefIds(referenceIds){var docIdMap={};var references=[];$n2.couchUtils.extractLinks(doc,references);for(var i=0,e=references.length;i<e;++i){var linkDocId=references[i].doc;docIdMap[linkDocId]=true;};for(var i=0,e=referenceIds.length;i<e;++i){var linkDocId=referenceIds[i];docIdMap[linkDocId]=true;};var refDocIds=[];for(var docId in docIdMap){refDocIds.push(docId);};opts.onSuccess(doc,refDocIds);};},areDocumentsRelated:function(opts_){var opts=$n2.extend({selectedDoc:null,relatedDoc:null,onRelated:function(selectedDoc,relatedDoc){},onNotRelated:function(selectedDoc,relatedDoc){},onError:function(err){}},opts_);var selectedDoc=opts.selectedDoc;var relatedDoc=opts.relatedDoc;var references=[];$n2.couchUtils.extractLinks(selectedDoc,references);for(var i=0,e=references.length;i<e;++i){var linkDocId=references[i].doc;if(linkDocId===relatedDoc._id){opts.onRelated(selectedDoc,relatedDoc);return;};};var references=[];$n2.couchUtils.extractLinks(relatedDoc,references);for(var i=0,e=references.length;i<e;++i){var linkDocId=references[i].doc;if(linkDocId===selectedDoc._id){opts.onRelated(selectedDoc,relatedDoc);return;};};opts.onNotRelated(selectedDoc,relatedDoc);}});$n2.couchDisplayTiles={TiledDisplay:TiledDisplay,SchemaFilterFactory:SchemaFilterFactory,ReferenceRelatedDocumentDiscovery:ReferenceRelatedDocumentDiscovery};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchSearch';function SplitSearchTerms(line){if(!line)return null;var map=$n2.couchUtils.extractSearchTerms(line,false);var searchTerms=[];for(var term in map){var folded=map[term].folded;if(folded){searchTerms.push(folded);};};return searchTerms;};var SearchRequest=$n2.Class({options:null,searchResults:null,initialize:function(searchTermsLine,opts_){this.options=$n2.extend({designDoc:null,db:null,dateService:null,searchView:'text-search',searchLimit:25,onlyFinalResults:false,strict:false,onSuccess:function(searchResults){},onError:function(err){$n2.reportErrorForced(err);}},opts_);var searchTerms=searchTermsLine;if(typeof(searchTermsLine)==='string'){searchTerms=SplitSearchTerms(searchTerms);}else if($n2.isArray(searchTermsLine)){searchTermsLine=searchTerms.join(' ');}else{this.options.onError('Search terms must be a string or an array');return;};var dateIntervals=null;if(this.options.dateService){var dateStrings=$n2.date.findAllDateStrings(searchTermsLine);if(dateStrings&&dateStrings.length){dateIntervals=[];for(var i=0,e=dateStrings.length;i<e;++i){dateIntervals.push(dateStrings[i].interval);};};};this.searchResults={terms:[],actionReturnedCount:0,pending:searchTerms.length,map:{},sorted:[],list:[]};if(dateIntervals){this.searchResults.pending+=dateIntervals.length;};if(!searchTerms.length){this._returnSearchResults();return;};for(var i=0,e=searchTerms.length;i<e;++i){var t=searchTerms[i].toLowerCase();this.searchResults.terms.push(t);};var _this=this;for(var i=0,e=this.searchResults.terms.length;i<e;++i){var term=this.searchResults.terms[i];this.options.designDoc.queryView({viewName:this.options.searchView,startkey:[term,0],endkey:[term,{}],onSuccess:function(rows){var termResults=[];for(var i=0,e=rows.length;i<e;++i){termResults.push({docId:rows[i].id,index:rows[i].key[1]});};_this._receiveSearchResults(termResults);},onError:function(err){_this.searchResults=null;_this.options.onError(err);}});};if(dateIntervals){for(var i=0,e=dateIntervals.length;i<e;++i){this.options.dateService.getDocIdsFromInterval({interval:dateIntervals[i],onSuccess:function(docIds){var dateResults=[];for(var i=0,e=docIds.length;i<e;++i){dateResults.push({docId:docIds[i],index:0});};_this._receiveSearchResults(dateResults);},onError:function(err){_this.searchResults=null;_this.options.onError(err);}});};};},abortSearch:function(){this.searchResults=null;},_receiveSearchResults:function(interimResults){var searchResults=this.searchResults;if(!searchResults)return;--searchResults.pending;++searchResults.actionReturnedCount;if(this.options.strict&&searchResults.actionReturnedCount>1){var docIdsReturned={};for(var i=0,e=interimResults.length;i<e;++i){var docId=interimResults[i].docId;var index=interimResults[i].index;docIdsReturned[docId]=true;if(searchResults.map[docId]){var m=searchResults.map[docId];++m.terms;if(m.index>index)m.index=index;}else{};};var docIdsToDelete=[];for(var docId in searchResults.map){if(!docIdsReturned[docId]){docIdsToDelete.push(docId);};};for(var i=0,e=docIdsToDelete.length;i<e;++i){delete searchResults.map[docIdsToDelete[i]];};searchResults.sorted=[];for(var docId in searchResults.map){searchResults.sorted.push(searchResults.map[docId]);};}else{for(var i=0,e=interimResults.length;i<e;++i){var docId=interimResults[i].docId;var index=interimResults[i].index;if(searchResults.map[docId]){var m=searchResults.map[docId];++m.terms;if(m.index>index)m.index=index;}else{var m={id:docId,index:index,terms:1,contentRequested:false};searchResults.map[docId]=m;searchResults.sorted.push(m);};};};this._returnSearchResults();},_returnSearchResults:function(){var searchResults=this.searchResults;if(!searchResults)return;var _this=this;if(this.options.onlyFinalResults){if(searchResults.pending>0){return;};};searchResults.sorted.sort(function(a,b){if(a.terms>b.terms){return-1;}else if(a.terms<b.terms){return 1;}else{if(a.index<b.index){return-1;}else if(a.index>b.index){return 1;};};return 0;});if((searchResults.terms.length-searchResults.pending)<=1){searchResults.list=searchResults.sorted;}else{searchResults.list=[];if(searchResults.sorted.length>0){var termCount=searchResults.sorted[0].terms;for(var i=0,e=searchResults.sorted.length;i<e;++i){var r=searchResults.sorted[i];if(r.terms>=termCount){searchResults.list.push(r);};};};};this.options.onSuccess(searchResults);}});var LookAheadService=$n2.Class({options:null,lookAheadMap:null,lookAheadCounter:null,initialize:function(opts_){this.options=opts_;this.lookAheadMap={};this.lookAheadCounter=0;},queryPrefix:function(prefix,callback){var _this=this;var words=this._retrievePrefix(prefix);if(words){callback(prefix,words);return;};this.options.designDoc.queryView({viewName:this.options.lookAheadView,listName:this.options.lookAheadList,startkey:[prefix,null],endkey:[prefix+'\u9999',{}],top:this.options.lookAheadLimit,group:true,onlyRows:false,reduce:true,onSuccess:function(response){var rows=response.rows;var words=[];for(var i=0,e=rows.length;i<e;++i){words.push(rows[i][0]);};_this._cachePrefix({prefix:prefix,words:words,full:response.all_rows});if(0==words.length){callback(prefix,null);}else{callback(prefix,words);};},onError:function(){callback(prefix,null);}});},queryTerms:function(terms,callback){if(null===terms||0==terms.length){callback(null);return;};var index=terms.length-1;while(index>=0){var lastTerm=terms[index];if(''===lastTerm){--index;}else{var previousWords=null;if(index>0){previousWords=terms.slice(0,index);};break;};};lastTerm=lastTerm.toLowerCase();if(!lastTerm){callback(null);return;};if(lastTerm.length<this.options.lookAheadPrefixMin){callback(null);return;};var previousWordsString='';if(previousWords){previousWordsString=previousWords.join(' ')+' ';};this.queryPrefix(lastTerm,function(prefix,words){if(null===words){callback(null);}else{var results=[];for(var i=0,e=words.length;i<e;++i){results.push(previousWordsString+words[i]);};callback(results);};});},_cachePrefix:function(prefixResult){this.lookAheadMap[prefixResult.prefix]=prefixResult;prefixResult.counter=this.lookAheadCounter;++(this.lookAheadCounter);var keysToDelete=[];var cachedMap=this.lookAheadMap;var limit=this.lookAheadCounter-this.options.lookAheadCacheSize;for(var key in cachedMap){if(cachedMap[key].counter<limit){keysToDelete.push(key);};};for(var i=0,e=keysToDelete.length;i<e;++i){delete cachedMap[keysToDelete[i]];};},_retrievePrefix:function(prefix){if(this.lookAheadMap[prefix]){return this.lookAheadMap[prefix].words;};var sub=prefix.substring(0,prefix.length-1);while(sub.length>=this.options.lookAheadPrefixMin){if(this.lookAheadMap[sub]&&this.lookAheadMap[sub].full){var cachedWords=this.lookAheadMap[sub].words;var words=[];for(var i=0,e=cachedWords.length;i<e;++i){var word=cachedWords[i];if(word.length>=prefix.length){if(word.substr(0,prefix.length)===prefix){words.push(word);};};};return words;};sub=sub.substring(0,sub.length-1);};return null;},getJqAutoCompleteSource:function(){var _this=this;return function(request,cb){_this._jqAutoComplete(request,cb);};},_jqAutoComplete:function(request,cb){var terms=SplitSearchTerms(request.term);var callback=cb;this.queryTerms(terms,callback);}});var SearchInput=$n2.Class({options:null,searchServer:null,textInputId:null,searchButtonId:null,keyPressedSinceLastSearch:null,dispatchHandle:null,initialize:function(opts_,server_){this.options=$n2.extend({textInput:null,searchButton:null,initialSearchText:null,displayFn:null,dispatchService:null},opts_);var _this=this;this.searchServer=server_;this.keyPressedSinceLastSearch=false;if(this.options.dispatchService){var f=function(m){_this._handle(m);};this.options.dispatchService.register(DH,'searchInitiate',f);this.options.dispatchService.register(DH,'selected',f);this.options.dispatchService.register(DH,'unselected',f);};var $textInput=this.options.textInput;this.textInputId=$n2.utils.getElementIdentifier($textInput);this.options.textInput=null;if(this.options.searchButton){var $searchButton=this.options.searchButton;var searchButtonId=$searchButton.attr('id');if(!searchButtonId){searchButtonId=$n2.getUniqueId();$searchButton.attr('id',searchButtonId);};this.searchButtonId=searchButtonId;this.options.searchButton=null;};if(!this.options.initialSearchText){this.options.initialSearchText='';};this._install();},getTextInput:function(){return $('#'+this.textInputId);},getSearchButton:function(){if(this.searchButtonId){return $('#'+this.searchButtonId);};return null;},getSearchLine:function(){var $textInput=this.getTextInput();var line=$textInput.val();if(line&&line.length>0){if(line===this.options.initialSearchText){return'';}else{return line;};}else{return'';};},performSearch:function(line){var _this=this;if(this.options.dispatchService){this.options.dispatchService.send(DH,{type:'searchInitiate',searchLine:line});}else if(this.searchServer){this.searchServer.submitRequest(line,{onSuccess:function(searchResults){_this._processSearchResults(searchResults);},onError:function(err){_this._processSearchError(err);}});};this.keyPressedSinceLastSearch=false;this._displayWait();},_install:function(){var _this=this;var $textInput=this.getTextInput();if(this.options.initialSearchText){$textInput.val(this.options.initialSearchText);};if($textInput.autocomplete){$textInput.autocomplete({source:this._getJqAutoCompleteSource()});};$textInput.keydown(function(e){_this._keyDown(e);});$textInput.focus(function(e){_this._focus(e);});$textInput.blur(function(e){_this._blur(e);});var $searchButton=this.getSearchButton();if($searchButton){$searchButton.click(function(e){_this._clickSearch(e);});};},_focus:function(e){var $textInput=this.getTextInput();if(this.options.initialSearchText){var value=$textInput.val();if(this.options.initialSearchText===value){$textInput.val('');};};$textInput.select();},_blur:function(e){if(this.options.initialSearchText){var $textInput=this.getTextInput();var value=$textInput.val();if(''===value){$textInput.val(this.options.initialSearchText);};};},_keyDown:function(e){var charCode=null;if(null===e){e=window.event;};if(null!==e){if(e.keyCode){charCode=e.keyCode;};};this.keyPressedSinceLastSearch=true;if(13===charCode||null===charCode){var line=this.getSearchLine();if(line.length>0){this._closeLookAhead();this.performSearch(line);this._closeLookAhead();};};},_clickSearch:function(e){var line=this.getSearchLine();if(line.length>0){this._closeLookAhead();this.performSearch(line);this._closeLookAhead();};},_closeLookAhead:function($textInput){if(!$textInput){$textInput=this.getTextInput();};if($textInput.autocomplete){$textInput.autocomplete('close');};},_processSearchResults:function(searchResults){var _this=this;if(this.options.displayFn){searchResults.type='results';this.options.displayFn(searchResults);}else if(this.options.dispatchService){this.options.dispatchService.send(DH,{type:'searchResults',results:searchResults});}else{$n2.log('Unable to return search results');};},_processSearchError:function(err){if(this.options.displayFn){var display={type:'error',error:err};this.options.displayFn(display);}else if(this.options.dispatchService){this.options.dispatchService.send(DH,{type:'searchResults',error:err});};},_displayWait:function(){if(this.options.displayFn){this.options.displayFn({type:'wait'});};},_getJqAutoCompleteSource:function(){var _this=this;return function(request,cb){_this._jqAutoComplete(request,cb);};},_jqAutoComplete:function(request,cb){var _this=this;var lookAheadService=this.searchServer.getLookAheadService();lookAheadService._jqAutoComplete(request,function(res){if(_this.keyPressedSinceLastSearch){cb(res);}else{cb(null);};});},_handle:function(m){if('searchInitiate'===m.type){var $textInput=this.getTextInput();$textInput.val(m.searchLine);}else if('selected'===m.type||'unselected'===m.type){var $textInput=this.getTextInput();if(this.options.initialSearchText){$textInput.val(this.options.initialSearchText);}else{$textInput.val('');};};}});var SearchServer=$n2.Class({options:null,lookAheadService:null,initialize:function(opts_){this.options=$n2.extend({designDoc:null,db:null,dateService:null,directory:null,searchView:'text-search',searchLimit:25,lookAheadView:'text-lookahead',lookAheadList:'text-lookahead',lookAheadLimit:5,lookAheadPrefixMin:3,lookAheadCacheSize:10},opts_);var _this=this;this.lookAheadService=null;var d=this._getDispatcher();if(d){var f=function(m){_this._handle(m);};var h=d.getHandle('n2.couchSearch');d.register(h,'searchInitiate',f);};},getLookAheadService:function(){if(null===this.lookAheadService){this.lookAheadService=new LookAheadService(this.options);};return this.lookAheadService;},submitRequest:function(searchTerms,opts_){var requestOptions=$n2.extend({designDoc:this.options.designDoc,db:this.options.db,dateService:this.options.dateService,searchView:this.options.searchView,searchLimit:this.options.searchLimit},opts_);return new SearchRequest(searchTerms,requestOptions);},getJqAutoCompleteSource:function(){return this.getLookAheadService().getJqAutoCompleteSource();},installSearch:function(opts_){return new SearchInput(opts_,this);},installSearchWidget:function(opts_){var opts=$n2.extend({elem:null,label:null,useButton:false,buttonLabel:null,doNotDisable:false},opts_);var customService=this._getCustomService();var $elem=$(opts.elem);var searchWidgetLabel=opts.label;if(null===searchWidgetLabel&&customService){searchWidgetLabel=customService.getOption('searchWidgetText',null);};if(null===searchWidgetLabel){searchWidgetLabel=_loc('search the atlas');};$elem.empty();var searchInput=$('<input type="text">').addClass('search_panel_input').val(searchWidgetLabel).appendTo($elem);if(opts.doNotDisable){}else{searchInput.addClass('n2_disable_on_edit');};var searchButtonLabel=opts.buttonLabel;if(null===searchButtonLabel&&customService){searchButtonLabel=customService.getOption('searchButtonText',null);};if(null===searchButtonLabel){searchButtonLabel=_loc('Search');};var searchButton=null;if(opts.useButton){searchButton=$('<input type="button">').val(searchButtonLabel).appendTo($elem);};return new SearchInput({textInput:searchInput,initialSearchText:searchWidgetLabel,dispatchService:this._getDispatcher(),searchButton:searchButton},this);},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_getCustomService:function(){var cs=null;if(this.options.directory){cs=this.options.directory.customService;};return cs;},_handle:function(m){if('searchInitiate'===m.type){var searchTerms=m.searchLine;var dispatcher=this._getDispatcher();var h=dispatcher.getHandle('n2.couchSearch');this.submitRequest(searchTerms,{onSuccess:function(searchResults){dispatcher.send(h,{type:'searchResults',results:searchResults});},onError:function(err){dispatcher.send(h,{type:'searchError',error:err});}});};}});$n2.couchSearch={SearchServer:SearchServer,SearchRequest:SearchRequest};})(jQuery,nunaliit2);;(function($,$n2){if(typeof(OpenLayers)==='undefined')return;OpenLayers.Format.Couch=OpenLayers.Class(OpenLayers.Format,{initialize:function(options){OpenLayers.Format.prototype.initialize.apply(this,[options]);},read:function(docs){try{var results=[];for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];var id=null;var geom=null;if(doc._id){id=doc._id;};if(doc.nunaliit_geom.wkt){geom=OpenLayers.Geometry.fromWKT(doc.nunaliit_geom.wkt);if(geom){if(!$n2.olUtils.isValidGeom(geom)){geom=null;};};if(!geom){$n2.log('Invalid WKT('+doc._id+'): '+doc.nunaliit_geom.wkt);};};if(id&&geom){var f=new OpenLayers.Feature.Vector(geom,doc);f.fid=id;results.push(f);}else{$n2.log('Invalid feature',doc);};};return results;}catch(e){$n2.log('Error during CouchDB format read',e);}
return null;},write:function(features){var result=[];for(var i=0,e=features.length;i<e;++i){var f=features[i];var data=f.data;if(null==data){data={};};if(f.fid){data._id=f.fid;};var geom=f.geometry;if(f.layer.projection&&f.layer.map.projection&&f.layer.projection.getCode()!=f.layer.map.projection.getCode()){geom=geom.clone();geom.transform(f.layer.map.projection,f.layer.projection);};if(!data.nunaliit_geom)data.nunaliit_geom={nunaliit_type:'geometry'};data.nunaliit_geom.wkt=geom.toString();var bbox=geom.getBounds();data.nunaliit_geom.bbox=[bbox.left,bbox.bottom,bbox.right,bbox.top];result.push(data);};return result;},CLASS_NAME:"OpenLayers.Format.Couch"});OpenLayers.Protocol.Couch=OpenLayers.Class(OpenLayers.Protocol,{documentSource:null,layerName:null,callback:null,scope:null,notifications:null,wildcarded:false,sourceProjection:null,dbProjection:null,initialize:function(options){options=options||{};if(!options.format){options.format=new OpenLayers.Format.Couch();};if(!options.dbProjection){options.dbProjection=new OpenLayers.Projection('EPSG:4326');};OpenLayers.Protocol.prototype.initialize.apply(this,arguments);},destroy:function(){OpenLayers.Protocol.prototype.destroy.apply(this);},read:function(options){var _this=this;if(this.notifications&&this.notifications.readStart){this.notifications.readStart();};OpenLayers.Protocol.prototype.read.apply(this,arguments);options=OpenLayers.Util.applyDefaults(options,this.options);var resp=new OpenLayers.Protocol.Response({requestType:'read'});var bounds=this.getBboxFromFilter(options.filter);var fids=this.getFidsFromFilter(options.filter);var layerName=('string'===typeof(options.layerName)?options.layerName:null);var projectionCode=null;if(this.sourceProjection){projectionCode=this.sourceProjection.getCode();};this.documentSource.getDocumentsFromGeographicFilter({docIds:fids,layerId:layerName,bbox:bounds,projectionCode:projectionCode,onSuccess:function(docs){_this.handleRead(resp,options,docs);},onError:function(errorMsg){$n2.log(errorMsg);if(_this.notifications&&_this.notifications.readEnd){_this.notifications.readEnd();};}});return resp;},handleRead:function(resp,options,docs){var _this=this;if(options.callback){resp.features=this.format.read(docs);if(this.sourceProjection&&this.dbProjection&&this.sourceProjection.getCode()!==this.dbProjection.getCode()){for(var i=0,e=resp.features.length;i<e;++i){resp.features[i].geometry.transform(this.dbProjection,this.sourceProjection);};};$n2.olUtils.sortFeatures(resp.features);resp.code=OpenLayers.Protocol.Response.SUCCESS;options.callback.call(options.scope,resp);window.setTimeout(function(){if(_this.notifications&&_this.notifications.readEnd){_this.notifications.readEnd();};},0);};},create:function(features,options){options=OpenLayers.Util.applyDefaults(options,this.options);var documents=this.format.write(features);if(options.layerName){for(var i=0,e=documents.length;i<e;++i){var doc=documents[i];if(!doc.nunaliit_layers){doc.nunaliit_layers=[];};if(jQuery.inArray(options.layerName,doc.nunaliit_layers)<0){doc.nunaliit_layers.push(options.layerName);};};};var resp=new OpenLayers.Protocol.Response({reqFeatures:features,requestType:"create"});var _this=this;this.db.bulkDocuments(documents,{onSuccess:function(docIds){_this.handleCreate(resp,options,docIds);},onError:function(errorMsg){$n2.reportError(errorMsg);}});return resp;},handleCreate:function(resp,options,docIds){var features=resp.reqFeatures;var insertedFeatures=[];if(features.length!=docIds.length){$n2.reportError($n2.ERROR_NO_SUPRESS,'Invalid feature bulk create');}else{for(var i=0,e=docIds.length;i<e;++i){var f=features[i];var d=docIds[i];if(d.error){if(d.reason){$n2.reportError($n2.ERROR_NO_SUPRESS,d.error+' : '+d.reason);}else{$n2.reportError($n2.ERROR_NO_SUPRESS,d.error);};}else{f.fid=d.id;if(f.data){f.data._id=d.id;f.data._rev=d.rev;};if(f.attribute){f.attribute._id=d.id;f.attribute._rev=d.rev;};insertedFeatures.push(f);};};};if(options.callback&&insertedFeatures.length>0){resp.features=insertedFeatures;resp.code=OpenLayers.Protocol.Response.SUCCESS;options.callback.call(options.scope,resp);}},update:function(feature,options){options=options||{};options=OpenLayers.Util.applyDefaults(options,this.options);var documents=this.format.write([feature]);var resp=new OpenLayers.Protocol.Response({reqFeatures:feature,requestType:"update"});var _this=this;this.db.updateDocument({data:documents[0],onSuccess:function(docInfo){_this.handleUpdate(resp,options,docInfo);},onError:function(errorMsg){$n2.reportError(errorMsg);}});return resp;},handleUpdate:function(resp,options,docInfo){var feature=resp.reqFeatures;if(feature.data){feature.data._rev=docInfo.rev;};if(feature.attribute){feature.attribute._rev=docInfo.rev;};if(options.callback){resp.features=[feature];resp.code=OpenLayers.Protocol.Response.SUCCESS;options.callback.call(options.scope,resp);}},"delete":function(feature,options){options=options||{};options=OpenLayers.Util.applyDefaults(options,this.options);var resp=new OpenLayers.Protocol.Response({reqFeatures:feature,requestType:"delete"});var _this=this;this.db.deleteDocument({data:feature.data,onSuccess:function(docInfo){_this.handleDelete(resp,options,docInfo);},onError:function(errorMsg){$n2.reportError(errorMsg);}});return resp;},handleDelete:function(resp,options){if(options.callback){resp.code=OpenLayers.Protocol.Response.SUCCESS;options.callback.call(options.scope,resp);}},commit:function(features,options){options=OpenLayers.Util.applyDefaults(options,this.options);var resp=[],nResponses=0;var types={};types[OpenLayers.State.INSERT]=[];types[OpenLayers.State.UPDATE]=[];types[OpenLayers.State.DELETE]=[];var feature,list,requestFeatures=[];for(var i=0,len=features.length;i<len;++i){feature=features[i];list=types[feature.state];if(list){list.push(feature);requestFeatures.push(feature);}}
var nRequests=(types[OpenLayers.State.INSERT].length>0?1:0)+
types[OpenLayers.State.UPDATE].length+
types[OpenLayers.State.DELETE].length;var success=true;var finalResponse=new OpenLayers.Protocol.Response({reqFeatures:requestFeatures});function insertCallback(response){var len=response.features?response.features.length:0;var fids=new Array(len);for(var i=0;i<len;++i){fids[i]=response.features[i].fid;}
finalResponse.insertIds=fids;callback.apply(this,[response]);}
function callback(response){this.callUserCallback(response,options);success=success&&response.success();nResponses++;if(nResponses>=nRequests){if(options.callback){finalResponse.code=success?OpenLayers.Protocol.Response.SUCCESS:OpenLayers.Protocol.Response.FAILURE;options.callback.apply(options.scope,[finalResponse]);}}}
var queue=types[OpenLayers.State.INSERT];if(queue.length>0){resp.push(this.create(queue,OpenLayers.Util.applyDefaults({callback:insertCallback,scope:this},options.create)));}
queue=types[OpenLayers.State.UPDATE];for(var i=queue.length-1;i>=0;--i){resp.push(this.update(queue[i],OpenLayers.Util.applyDefaults({callback:callback,scope:this},options.update)));}
queue=types[OpenLayers.State.DELETE];for(var i=queue.length-1;i>=0;--i){resp.push(this["delete"](queue[i],OpenLayers.Util.applyDefaults({callback:callback,scope:this},options["delete"])));}
return resp;},abort:function(response){if(response){}},callUserCallback:function(resp,options){var opt=options[resp.requestType];if(opt&&opt.callback){opt.callback.call(opt.scope,resp);}},getBboxFromFilter:function(filter){if(!filter)return null;if(filter.type===OpenLayers.Filter.Spatial.BBOX){return[filter.value.left,filter.value.bottom,filter.value.right,filter.value.top]}
if(filter.filters){for(var i=0,e=filter.filters.length;i<e;++i){var bounds=this.getBboxFromFilter(filter.filters[i]);if(bounds)return bounds;}}
return null;},getFidsFromFilter:function(filter){if(!filter)return null;if(filter.CLASS_NAME==='OpenLayers.Filter.FeatureId'){return filter.fids;}
if(filter.filters){for(var i=0,e=filter.filters.length;i<e;++i){var fids=this.getFidsFromFilter(filter.filters[i]);if(fids)return fids;}}
return null;},CLASS_NAME:"OpenLayers.Protocol.Couch"});(function(){var o=OpenLayers.Protocol.Couch.COMP_TYPE_TO_OP_STR={};o[OpenLayers.Filter.Comparison.EQUAL_TO]="eq";o[OpenLayers.Filter.Comparison.NOT_EQUAL_TO]="ne";o[OpenLayers.Filter.Comparison.LESS_THAN]="lt";o[OpenLayers.Filter.Comparison.LESS_THAN_OR_EQUAL_TO]="lte";o[OpenLayers.Filter.Comparison.GREATER_THAN]="gt";o[OpenLayers.Filter.Comparison.GREATER_THAN_OR_EQUAL_TO]="gte";o[OpenLayers.Filter.Comparison.LIKE]="ilike";})();})(jQuery,nunaliit2);;(function($n2){var configuration=null;var pendingRequests=[];var processingRequests=false;function uploadRequest(request){var userName=null;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext){userName=sessionContext.name;};var nowTime=(new Date()).getTime();var data={nunaliit_type:'translationRequest',nunaliit_schema:'translationRequest',str:request.str,lang:request.lang,packageName:request.packageName};if(userName){data.nunaliit_created={nunaliit_type:'actionstamp',name:userName,time:nowTime,action:'created'};data.nunaliit_last_updated={nunaliit_type:'actionstamp',name:userName,time:nowTime,action:'updated'};configuration.db.createDocument({data:data,onSuccess:verifyRequests,onError:function(errorMsg){$n2.reportError(errorMsg);verifyRequests();}});}else{$n2.log('User not logged in. Translation requests ignored.');};};function verifyRequests(){if(pendingRequests.length<1){processingRequests=false;return;};var request=pendingRequests.shift();var startkey=[request.lang,request.str];configuration.designDoc.queryView({viewName:configuration.lookupViewName,startkey:startkey,endkey:startkey,onSuccess:function(results){if(results.length<1){uploadRequest(request);}else{verifyRequests();}},onError:function(errorMsg){$n2.log(errorMsg);verifyRequests();}});};function processPendingRequests(){if(configuration&&pendingRequests.length>0&&false==processingRequests){processingRequests=true;verifyRequests();};};function sendTranslationRequest(request){$n2.log('Translate '+request.str+' to '+request.lang+' ('+request.packageName+')');pendingRequests.push(request);processPendingRequests();};function loadTranslatedStrings(){var lang=$n2.l10n.getLocale().lang;var url=configuration.designDoc.ddUrl
+'_list/'+configuration.scriptList
+'/'+configuration.translatedViewName
+'?startkey="'+lang
+'"&endkey="'+lang
+'"'
+'&include_docs=true&reduce=false';if($n2.scripts){var coreLocation=$n2.scripts.getCoreScriptLocation();$n2.scripts.loadScript(url,coreLocation);};};var defaultOptions={db:null,designDoc:null,lookupViewName:'l10n-all',translatedViewName:'l10n-translated',scriptList:'l10n'};function Configure(opt_){configuration=$n2.extend({},defaultOptions,opt_);loadTranslatedStrings();processPendingRequests();};function getLocalizedString(str,packageName,args){if(typeof(str)==='string'){return $n2.l10n.getLocalizedString(str,packageName,args);};if(str.nunaliit_type==='localized'){var locale=$n2.l10n.getLocale();var lang=locale.lang;if(typeof(str[lang])==='string'){var result=str[lang];if(args&&args.length>0){result=$n2.utils.formatString(result,args);};result.nunaliit_lang=lang;return result;};if(typeof(str.en)==='string'){var result=str.en;if(args&&args.length>0){result=$n2.utils.formatString(result,args);};result.nunaliit_lang='en';result.nunaliit_lang_fallback=true;return result;};for(var fbLang in str){if('nunaliit_type'===fbLang){}else{var result=str[fbLang];if(args&&args.length>0){result=$n2.utils.formatString(result,args);};result.nunaliit_lang=fbLang;result.nunaliit_lang_fallback=true;return result;};};};return null;};$n2.l10n.sendTranslationRequest=sendTranslationRequest;$n2.couchL10n={Configure:Configure,getLocalizedString:getLocalizedString};})(nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};function adjustDocument(doc){$n2.couchDocument.adjustDocument(doc);};function isAdmin(){var admin=false;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext&&sessionContext.roles){if($n2.inArray('_admin',sessionContext.roles)!==-1){admin=true;};if($n2.inArray('administrator',sessionContext.roles)!==-1){admin=true;};if(typeof(n2atlas)==='object'&&typeof(n2atlas.name)==='string'){var dbAdmin=n2atlas.name+'_administrator';if($n2.inArray(dbAdmin,sessionContext.roles)!==-1){admin=true;};};};return admin;};function canEditDoc(data){if(isAdmin()){return true;};var userName=null;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext){userName=sessionContext.name;};if(data.nunaliit_created&&data.nunaliit_created.nunaliit_type&&data.nunaliit_created.nunaliit_type==='actionstamp'&&data.nunaliit_created.name===userName){return true;};return false;};function canDeleteDoc(data){if(isAdmin()){return true;};var userName=null;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext){userName=sessionContext.name;};if(data.nunaliit_created&&data.nunaliit_created.nunaliit_type&&data.nunaliit_created.nunaliit_type==='actionstamp'&&data.nunaliit_created.name===userName){return true;};return false;};function documentContainsMedia(doc){var containsMedia=false;if(doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){containsMedia=true;};};return containsMedia;};function documentContainsApprovedMedia(doc){var containsApprovedMedia=false;if(doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var att=doc.nunaliit_attachments.files[attName];if(att.status==='approved'||att.status==='attached'){containsApprovedMedia=true;};};};return containsApprovedMedia;};function documentContainsDeniedMedia(doc){var containsDeniedMedia=false;if(doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var att=doc.nunaliit_attachments.files[attName];if(att.status==='denied'){containsDeniedMedia=true;};};};return containsDeniedMedia;};$n2.couchMap={adjustDocument:adjustDocument,isAdmin:isAdmin,canEditDoc:canEditDoc,canDeleteDoc:canDeleteDoc,documentContainsMedia:documentContainsMedia,documentContainsApprovedMedia:documentContainsApprovedMedia,documentContainsDeniedMedia:documentContainsDeniedMedia};})(nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var addContributionSchema=new $n2.form.Schema({title:null,okButton:true,cancelButton:true,attributes:[{name:'title',label:_loc('Title'),selector:'nunaliit_contribution.title',type:'text',className:'contributionTitle',description:'The title of the contribution'},{name:'description',label:_loc('Description'),selector:'nunaliit_contribution.description',type:'textarea',className:'contributionDescription',description:'The creator of the entity'},{name:'media',label:_loc('Media'),type:'file',description:'Media associated with contribution'}]});var defaultOptions={db:null,designDoc:null,showService:null,uploads:null,searchView:'upload-type-text-search',contributionFromReferenceView:'contributions',addContributionSchema:addContributionSchema};$n2.couchContributions=$n2.Class({options:null,lookAheadCounter:null,lookAheadMap:null,initialize:function(options_){this.options=$n2.extend({},defaultOptions,options_);this.lookAheadCounter=0;this.lookAheadMap={};},performContributionSearch:function(opts_){var opt=$n2.extend({searchTerms:null,uploadType:null,searchLimit:25,docsOnly:true,onSuccess:function(docs){},onError:function(error){}},opts_);var searchTerms=opt.searchTerms;var searchResults={pending:searchTerms.length,map:{},sorted:[]};for(var i=0,e=searchTerms.length;i<e;++i){this.options.designDoc.queryView({viewName:this.options.searchView,startkey:[opt.uploadType,searchTerms[i],0],endkey:[opt.uploadType,searchTerms[i],{}],limit:opt.searchLimit,onSuccess:function(rows){ReportSearchResults(rows);}});};function ReportSearchResults(rows){--searchResults.pending;for(var i=0,e=rows.length;i<e;++i){var doc=rows[i].value;var index=rows[i].key[2];if(searchResults.map[doc._id]){var m=searchResults.map[doc._id];++m.terms;if(m.index>index)m.index=index;}else{var m={doc:doc,id:doc._id,index:index,terms:1};searchResults.map[doc._id]=m;searchResults.sorted.push(m);}};if(searchResults.pending>0)return;searchResults.sorted.sort(function(a,b){if(a.terms>b.terms){return-1;}else if(a.terms<b.terms){return 1;}else{if(a.index<b.index){return-1;}else if(a.index>b.index){return 1;};};return 0;});var result=[];for(var i=0,e=searchResults.sorted.length;i<e;++i){if(i>opt.searchLimit)break;var m=searchResults.sorted[i];if(opt.docsOnly){result.push(m.doc);}else{result.push(m);};};opt.onSuccess(result);};},displayContributionSelection:function($elem,contributionDocs,opts_){var opt=$n2.extend({onSuccess:function(doc){},onError:function(error){}},opts_);$elem.empty();for(var i=0,e=contributionDocs.length;i<e;++i){var contributionDoc=contributionDocs[i];var $div=$('<div class="couchContributionSelect" style="border:1px solid #000000"></div>');$elem.append($div);this.displayContribution($div,contributionDoc);installSelection($div,contributionDoc);}
function installSelection($div,contributionDoc){$div.click(function(){opt.onSuccess(contributionDoc);});}},displayContribution:function($elem,contributionDoc){$elem.empty();var docUrl=this.options.db.getDocumentUrl(contributionDoc);if(contributionDoc.converted){var linkDiv=null;if(contributionDoc.gcrc_upload_type==='image'&&contributionDoc.thumbnail){linkDiv=$('<div class="contribution_media_icon_wrapper"><img src="'+docUrl+'/thumbnail"/></div>');}else if(contributionDoc.gcrc_upload_type==='image'){linkDiv=$('<div class="contribution_media_icon_wrapper"><div class="contribution_media_icon contribution_image_icon"></div></div>');}else if(contributionDoc.gcrc_upload_type==='audio'){linkDiv=$('<div class="contribution_media_icon_wrapper"><div class="contribution_media_icon contribution_audio_icon"></div></div>');}else if(contributionDoc.gcrc_upload_type==='video'&&contributionDoc.thumbnail){linkDiv=$('<div class="contribution_media_icon_wrapper"><img src="'+docUrl+'/thumbnail"/></div>');}else if(contributionDoc.gcrc_upload_type==='video'){linkDiv=$('<div class="contribution_media_icon_wrapper"><div class="contribution_media_icon contribution_video_icon"></div></div>');};if(null!=linkDiv){$elem.append(linkDiv);var cb=createMediaCallback(contributionDoc.gcrc_upload_type,docUrl,contributionDoc);linkDiv.click(cb);};};if(contributionDoc.nunaliit_contribution&&contributionDoc.nunaliit_contribution.nunaliit_type&&contributionDoc.nunaliit_contribution.nunaliit_type=='contribution'){if(contributionDoc.nunaliit_contribution.title){$elem.append($('<div>'+_loc('Title')+': '+contributionDoc.nunaliit_contribution.title+'</div>'));};if(contributionDoc.nunaliit_contribution.description){$elem.append($('<div>'+_loc('Description')+': '+contributionDoc.nunaliit_contribution.description+'</div>'));};};$elem.append($('<div>'+_loc('id')+': '+contributionDoc._id+'</div>'));if(contributionDoc.original){$elem.append($('<div>file: '+contributionDoc.original.name+' ('+contributionDoc.original.mimeType+')</div>'));};var createdByUser=null;var createdTime=null;if(contributionDoc.nunaliit_created){if(contributionDoc.nunaliit_created.name){createdByUser=contributionDoc.nunaliit_created.name;var $createdByDiv=$('<div>'+_loc('Created by')+': <span></span></div>');if(this.options.showService){this.options.showService.printUserName($createdByDiv.find('span'),createdByUser,{showHandle:true});}else{$createdByDiv.find('span').text(createdByUser);};if(contributionDoc.nunaliit_created.time){createdTime=contributionDoc.nunaliit_created.time;var dateStr=(new Date(createdTime)).toString();$createdByDiv.append($('<span> on '+dateStr+'</span>'));};$elem.append($createdByDiv);};};if(contributionDoc.nunaliit_last_updated){if(contributionDoc.nunaliit_last_updated.name){var lastUpdatedByUser=contributionDoc.nunaliit_last_updated.name;var lastUpdatedTime=contributionDoc.nunaliit_last_updated.time;if(lastUpdatedByUser!=createdByUser||lastUpdatedTime!=createdTime){var $lastUpdatedDiv=$('<div>'+_loc('Last updated by')+': <span></span></div>');if(this.options.showService){this.options.showService.printUserName($lastUpdatedDiv.find('span'),lastUpdatedByUser,{showHandle:true});}else{$lastUpdatedDiv.find('span').text(lastUpdatedByUser);};if(lastUpdatedTime){var dateStr=(new Date(lastUpdatedTime)).toString();$lastUpdatedDiv.append($('<span> on '+dateStr+'</span>'));};$elem.append($lastUpdatedDiv);};};};$elem.append($('<div style="clear:both"></div>'));function createMediaCallback(uploadType,docUrl,doc){return function(){var mediaOptions={url:docUrl+'/converted'};if(doc.nunaliit_contribution&&doc.nunaliit_contribution.title){mediaOptions.title=doc.nunaliit_contribution.title;};if(doc.nunaliit_created&&doc.nunaliit_created.name){mediaOptions.author=doc.nunaliit_created.name;};if(doc.nunaliit_contribution&&doc.nunaliit_contribution.description){mediaOptions.description=doc.nunaliit_contribution.description;};if(uploadType==='image'){mediaOptions.type='image';$n2.mediaDisplay.displayMedia(mediaOptions);}else if(uploadType==='video'){mediaOptions.type='video';$n2.mediaDisplay.displayMedia(mediaOptions);}else if(uploadType==='audio'){mediaOptions.type='audio';$n2.mediaDisplay.displayMedia(mediaOptions);};};};},searchTextBox:function(opt_){var _this=this;var opt=$n2.extend({elem:null,lookAheadView:'text-lookahead',lookAheadList:'text-lookahead',lookAheadLimit:5,lookAheadPrefixMin:3,lookAheadCacheSize:10,onSuccess:function(terms){}},opt_);var $elem=opt.elem;if(typeof($elem)==='string'){$elem=$('#'+$elem);}else{$elem=$($elem);};var $lookUpDiv=$('<div class="couchLookahead"></div>');var divider=$('<div class="couchLookaheadDivider"></div>');divider.append($lookUpDiv);var $input=$('<input type="text"/>');var holder=$('<div></div>');holder.append($input).append(divider);$elem.empty().append(holder);var skipKeyUp=false;$input.keypress(SearchInputKeyPressed);$input.keyup(SearchInputKeyUp);function SearchInputKeyPressed(evt){var charCode=null;if(null!=evt&&null!=evt.which){charCode=evt.which;}else if(null!=window.event&&null!=window.event.keyCode){charCode=window.event.keyCode;};if(13==charCode||null==charCode){ProcessSearchInput();};};function SearchInputKeyUp(evt){if(skipKeyUp){skipKeyUp=false;}else{ProcessLookAhead();};};function ProcessSearchInput(){skipKeyUp=true;var searchTerms=GetSearchTerms();opt.onSuccess(searchTerms);CloseLookAhead();};function ProcessLookAhead(){var searchTerms=GetSearchTerms();var index=searchTerms.length-1;if(index>=0){var lastTerm=searchTerms[index];var previousWords=null;if(index>0){previousWords=searchTerms.slice(0,index);};};if(!lastTerm){CloseLookAhead();return;};if(lastTerm.length<opt.lookAheadPrefixMin){CloseLookAhead();return;};var previousWordsString='';if(previousWords){previousWordsString=previousWords.join(' ')+' ';};QueryLookAhead(lastTerm,function(prefix,words){$lookUpDiv.empty();if(words.length>0){$lookUpDiv.css('display','block');}else{$lookUpDiv.css('display','none');};for(var i=0,e=words.length;i<e;++i){var offered=words[i].substring(prefix.length);var line=$('<div class="couchLookaheadLine '
+(i%2?'couchLookaheadLineOdd':'couchLookaheadLineEven')+'">'
+'<span class="couchLookaheadTyped">'
+previousWordsString+prefix+'</span>'
+'<span class="offered">'+offered+'</span>'
+'</div>');installClick(line,previousWordsString+words[i]);$lookUpDiv.append(line);};});function installClick($elem,wordString){$elem.click(function(){$input.val(wordString);var terms=wordString.split(' ');opt.onSuccess(terms);CloseLookAhead();});};};function CloseLookAhead(){$lookUpDiv.css('display','none');};function GetSearchTerms(){var searchTerms=$input.val();searchTerms=searchTerms.split(/[ \t\r\n]+/);return searchTerms;};function QueryLookAhead(prefix,callback){if(_this.lookAheadMap[prefix]){callback(prefix,_this.lookAheadMap[prefix].words);return;};var sub=prefix.substring(0,prefix.length-1);while(sub.length>=opt.lookAheadPrefixMin){if(_this.lookAheadMap[sub]&&_this.lookAheadMap[sub].full){callback(prefix,_this.lookAheadMap[sub].words);return;};sub=sub.substring(0,sub.length-1);};_this.options.designDoc.queryView({viewName:opt.lookAheadView,listName:opt.lookAheadList,startkey:prefix,endkey:prefix+'\u9999',top:opt.lookAheadLimit,group:true,onlyRows:false,reduce:true,onSuccess:function(response){var rows=response.rows;var words=[];for(var i=0,e=rows.length;i<e;++i){words.push(rows[i][0]);};_this.lookAheadMap[prefix]={prefix:prefix,words:words,full:response.all_rows,counter:_this.lookAheadCounter};++_this.lookAheadCounter;var keysToDelete=[];for(var key in _this.lookAheadMap){if(_this.lookAheadMap[key].counter<(_this.lookAheadCounter-opt.lookAheadCacheSize)){keysToDelete.push(key);};};for(var i=0,e=keysToDelete.length;i<e;++i){delete _this.lookAheadMap[keysToDelete[i]];};callback(prefix,words);}});};},searchContributions:function(opt_){var _this=this;var opt=$n2.extend({elem:null,uploadType:null,onSuccess:function(selectedContribution){}},opt_);var $elem=opt.elem;if(typeof($elem)==='string'){$elem=$('#'+$elem);}else{$elem=$($elem);};var $search=$('<div></div>');var $result=$('<div></div>');$elem.empty().append($search).append($result);this.searchTextBox({elem:$search,onSuccess:function(terms){_this.performContributionSearch({searchTerms:terms,uploadType:opt.uploadType,onSuccess:receiveContributions});}});function receiveContributions(contributions){_this.displayContributionSelection($result,contributions,{onSuccess:selectedContribution});}
function selectedContribution(contribution){$elem.empty();opt.onSuccess(contribution);}},getContributionsForReference:function(opt_){var _this=this;var opt=$n2.extend({docId:null,onSuccess:function(contributions){},onError:function(err){$n2.reportError(err);}},opt_);var docId=opt.docId;if(null==docId){opt.onError('DocId must be supplied when contributions are retrieved');return;};this.options.designDoc.queryView({viewName:this.options.contributionFromReferenceView,startkey:docId,endkey:docId,onSuccess:function(rows){var contributions=[];for(var i=0,e=rows.length;i<e;++i){contributions.push(rows[i].value);};opt.onSuccess(contributions);},onError:opt.onError});},buildAddContributionForm:function(opt_){var _this=this;var opt=$n2.extend({elem:null,referenceDocId:null,replyContributionId:null,onSuccess:function(){},onCancel:function(){}},opt_);var $elem=opt.elem;if(typeof($elem)==='string'){$elem=$('#'+$elem);}else{$elem=$($elem);};var contributionDoc={nunaliit_contribution:{nunaliit_type:'contribution'}};if(opt.referenceDocId){contributionDoc.nunaliit_contribution.reference={nunaliit_type:'reference',doc:opt.referenceDocId};};if(opt.replyContributionId){contributionDoc.nunaliit_contribution.reply={nunaliit_type:'reference',doc:opt.replyContributionId};};$n2.couchDocument.adjustDocument(contributionDoc);var form=this.options.addContributionSchema.createForm($elem,contributionDoc,{preOK:function(){_this.options.uploads.getWelcome({onSuccess:function(welcomeData){_this.options.db.createDocument({data:contributionDoc,onSuccess:function(docInfo){var $form=$(form.form);$form.prepend($('<input type="hidden" name="id" value="'+docInfo.id+'"/>'));$form.prepend($('<input type="hidden" name="rev" value="'+docInfo.rev+'"/>'));_this.options.uploads.submitForm({form:$form,onSuccess:opt.onSuccess,onError:function(err){$n2.reportError('Error uploading file: '+err);}});},onError:function(err){$n2.reportError('Unable to reach database to submit document: '+err);}});},onError:function(){$n2.reportError('Unable to reach atlas server');}});return false;},postCancel:opt.onCancel});}});})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchRequests';$n2.couchRequests=$n2.Class({options:null,currentRequests:null,scheduled:null,userListeners:null,documentListeners:null,initialize:function(options_){this.options=$n2.extend({},{db:null,userDb:null,designDoc:null,dispatchService:null,userServerUrl:null},options_);var _this=this;this.currentRequests={};this.scheduled=false;this.userListeners=[];this.documentListeners=[];if(this.options.dispatchService){var f=function(m){_this._handleMessage(m);};this.options.dispatchService.register(DH,'requestDocument',f);this.options.dispatchService.register(DH,'requestUserDocument',f);this.options.dispatchService.register(DH,'requestUserDocumentComplete',f);};},addUserListener:function(listener){if(typeof(listener)==='function'){this.userListeners.push(listener);};},addDocumentListener:function(listener){if(typeof(listener)==='function'){this.documentListeners.push(listener);};},requestUser:function(userName){if(!this.currentRequests.users){this.currentRequests.users={};};this.currentRequests.users[userName]=1;this._schedule();},requestCompleteUserDocument:function(userName){if(!this.currentRequests.completeUsers){this.currentRequests.completeUsers={};};this.currentRequests.completeUsers[userName]=1;this._schedule();},requestDocument:function(docId,cbFn){if(!this.currentRequests.docs){this.currentRequests.docs={};};if(!this.currentRequests.docs[docId]){this.currentRequests.docs[docId]=[];};if(cbFn){this.currentRequests.docs[docId].push(cbFn);};this._schedule();},_schedule:function(){if(this.scheduled)return;var _this=this;this.scheduled=true;setTimeout(function(){_this.scheduled=false;_this._performRequests();},0);},_performRequests:function(){var _this=this;var requests=this.currentRequests;this.currentRequests={};if(requests.users&&this.options.userServerUrl){var params=[];for(var userName in requests.users){params.push({name:'user',value:userName});};var url=this.options.userServerUrl+'getUsers';$.ajax({url:url,type:'GET',async:true,traditional:true,data:params,dataType:'json',success:function(result){if(result.users){for(var i=0,e=result.users.length;i<e;++i){var user=result.users[i];_this._callUserListeners(user);};};},error:function(XMLHttpRequest,textStatus,errorThrown){}});}else if(requests.users&&this.options.userDb){for(var userName in requests.users){this.options.userDb.getUser({name:userName,onSuccess:function(user){_this._callUserListeners(user);},onError:function(err){}});};};if(requests.completeUsers&&this.options.userServerUrl){var params=[];for(var userName in requests.completeUsers){params.push({name:'user',value:userName});};var url=this.options.userServerUrl+'getUserDocuments';$.ajax({url:url,type:'GET',async:true,traditional:true,data:params,dataType:'json',success:function(result){if(result.users){for(var i=0,e=result.users.length;i<e;++i){var user=result.users[i];_this._callCompleteUserListeners(user);};};},error:function(XMLHttpRequest,textStatus,errorThrown){}});};var cachedDocs=null;if(requests.docs&&this.options.db){var docIds=[];for(var docId in requests.docs){var cachedDoc=this._getCachedDoc(docId);if(cachedDoc){if(!cachedDocs){cachedDocs=[];};cachedDocs.push(cachedDoc);}else{docIds.push(docId);};};if(docIds.length){this.options.db.getDocuments({docIds:docIds,onSuccess:function(docs){_this._callDocumentListeners(docs,requests);}});};};if(null!==cachedDocs){this._callDocumentListeners(cachedDocs,requests);};},_callUserListeners:function(userDoc){this._dispatch({type:'userInfo',userInfo:userDoc});for(var j=0,f=this.userListeners.length;j<f;++j){var listener=this.userListeners[j];listener(userDoc);};},_callCompleteUserListeners:function(userDoc){this._dispatch({type:'userDocument',userDoc:userDoc});},_callDocumentListeners:function(docs,requests){for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];this._dispatch({type:'documentVersion',docId:doc._id,rev:doc._rev});this._dispatch({type:'documentContent',docId:doc._id,doc:doc});for(var j=0,f=this.documentListeners.length;j<f;++j){var listener=this.documentListeners[j];listener(doc);};var docId=doc._id;if(requests.docs&&requests.docs[docId]){for(var j=0,f=requests.docs[docId].length;j<f;++j){var listener=requests.docs[docId][j];listener(doc);};};};},_getDispatcher:function(){var d=null;if(this.options.dispatchService){d=this.options.dispatchService;};return d;},_dispatch:function(m){var dispatcher=this._getDispatcher();if(dispatcher){dispatcher.send(DH,m);};},_handleMessage:function(m){if('requestDocument'===m.type){var docId=m.docId;this.requestDocument(docId);}else if('requestUserDocument'===m.type){var userId=m.userId;this.requestUser(userId);}else if('requestUserDocumentComplete'===m.type){var userId=m.userId;this.requestCompleteUserDocument(userId);};},_getCachedDoc:function(docId){var dispatcher=this._getDispatcher();if(dispatcher){var m={type:'cacheRetrieveDocument',docId:docId,doc:null};dispatcher.synchronousCall(DH,m);if(m.doc){return m.doc;};};return null;}});})(jQuery,nunaliit2);;(function($,$n2){var DH='n2.couch.sound';function defaultInstallSound(info){};function defaultHandleDocumentSound(info_,cb_){cb_(info_);};var HoverSoundService=$n2.Class({options:null,dispatcher:null,requestService:null,currentFocusSoundDocId:null,initialize:function(options_){var _this=this;this.options=$n2.extend({db:null,serviceDirectory:null,handleDocumentSound:defaultHandleDocumentSound},options_);this.currentFocusSoundDocId=null;if(this.options.serviceDirectory){this.dispatcher=this.options.serviceDirectory.dispatchService;this.requestService=this.options.serviceDirectory.requestService;};if(this.dispatcher){var f=function(m){_this._handleDispatch(m);};this.dispatcher.register(DH,'focusOn',f);this.dispatcher.register(DH,'focusOff',f);this.dispatcher.register(DH,'playHoverSoundOn',f);this.dispatcher.register(DH,'playHoverSoundOff',f);this.dispatcher.register(DH,'playSoundOn',f);this.dispatcher.register(DH,'playSoundOff',f);};},handleFeatureHover:function(feature,opts_){if(!feature)return;var data=feature.attributes;if(!data){data=feature.data;};if(!data){return;};this.findDocumentHoverSound(data,opts_);},findDocumentHoverSound:function(data,opts_){var opts=$n2.extend({installSoundFn:defaultInstallSound,handleDocumentSound:this.options.handleDocumentSound},opts_);var _this=this;if(!data)return;var info={docId:data._id,doc:data,soundUrl:null,installSoundFn:opts.installSoundFn};opts.handleDocumentSound(info,function(info_){_this._defaultDocumentSound(info_);});},_defaultDocumentSound:function(info){var _this=this;if(info.soundUrl){info.installSoundFn(info);}else{GetHoverSoundUrlFromDocument({db:this.options.db,serviceDirectory:this.options.serviceDirectory,doc:info.doc,onSuccess:function(soundUrl){info.soundUrl=soundUrl;info.installSoundFn(info);}});};},_handleDispatch:function(m){var _this=this;if(m.type==='focusOn'){if(m.doc){if(this.currentFocusSoundDocId){this._removeFocusSound(this.currentFocusSoundDocId);};this.currentFocusSoundDocId=m.doc._id;this.findDocumentHoverSound(m.doc,{installSoundFn:function(info){_this._installFocusSound(info);}});}else if(m.docId){if(this.currentFocusSoundDocId){this._removeFocusSound(this.currentFocusSoundDocId);};this.currentFocusSoundDocId=m.docId;if(this.requestService){this.requestService.requestDocument(m.docId,function(doc){_this.findDocumentHoverSound(doc,{installSoundFn:function(info){_this._installFocusSound(info);}});});};};}else if(m.type==='focusOff'){if(m.doc){this._removeFocusSound(m.doc._id);}else if(m.docId){this._removeFocusSound(m.docId);};}else if(m.type==='playHoverSoundOn'){if(m.doc){this._initiatePlaySound(m.doc._id);this.findDocumentHoverSound(m.doc,{installSoundFn:function(info){_this._installPlaySound(info);}});};}else if(m.type==='playHoverSoundOff'){if(m.doc){this._removePlaySound(m.doc._id);};}else if(m.type==='playSoundOn'){if(m.id&&m.url){this._initiatePlaySound(m.id);var info={docId:m.id,soundUrl:m.url};this._installPlaySound(info);};}else if(m.type==='playSoundOff'){if(m.id){this._removePlaySound(m.id);};};},_installFocusSound:function(info){var docId=info.docId;var url=info.soundUrl;if(url&&this.currentFocusSoundDocId===docId){var $div=this._getFocusSoundDiv();this._insertSoundElement($div,url);};},_removeFocusSound:function(docId){if(this.currentFocusSoundDocId===docId){var $div=this._getFocusSoundDiv();$div.empty();this.currentFocusSoundDocId=null;};},_initiatePlaySound:function(docId){var divId='n2CouchPlaySound_'+$n2.utils.stringToHtmlId(docId);var $div=$('#'+divId);if($div.length<1){$div=$('<div id="'+divId+'"></div>');this._getSoundDiv().append($div);};},_installPlaySound:function(info){var docId=info.docId;var url=info.soundUrl;var $div=$('#n2CouchPlaySound_'+$n2.utils.stringToHtmlId(docId));this._insertSoundElement($div,url);},_removePlaySound:function(docId){var $div=$('#n2CouchPlaySound_'+$n2.utils.stringToHtmlId(docId));$div.remove();},_getSoundDiv:function(){var $div=$('#n2CouchSound');if($div.length<1){$div=$('<div id="n2CouchSound"></div>');$('body').append($div);};return $div;},_getFocusSoundDiv:function(){var $div=$('#n2CouchFocusSound');if($div.length<1){var $parent=this._getSoundDiv();$div=$('<div id="n2CouchFocusSound"></div>');$parent.append($div);};return $div;},_insertSoundElement:function($div,url){$div.html('<embed src="'+url+'" hidden="true" autostart="true" loop="false"/>');}});var GetHoverSoundUrlFromDocument=function(opts_){var opts=$n2.extend({db:null,serviceDirectory:null,doc:null,onSuccess:function(soundUrl){},onError:function(err){}},opts_);var data=opts.doc;var requestService=null;if(opts&&opts.serviceDirectory){requestService=opts.serviceDirectory.requestService;};if(!requestService){opts.onError('Request service not available');return;};if(data.sound&&data.sound.nunaliit_type&&data.sound.nunaliit_type==='reference'&&data.sound.doc){var soundUrl=opts.db.getAttachmentUrl(data.sound.doc,'converted');opts.onSuccess(soundUrl);return;};if(data.nunaliit_attachments&&data.nunaliit_attachments.nunaliit_type==='attachment_descriptions'&&data.nunaliit_attachments.files){var hoverSoundAttName=null;for(var attName in data.nunaliit_attachments.files){var attDesc=data.nunaliit_attachments.files[attName];if(attDesc&&attDesc.data&&attDesc.data.hoverSound){hoverSoundAttName=attName;break;};};if(hoverSoundAttName){var soundUrl=opts.db.getAttachmentUrl(data,attName);opts.onSuccess(soundUrl);return;};};if(data.nunaliit_hoverSound&&data.nunaliit_hoverSound.nunaliit_type==='reference'&&data.nunaliit_hoverSound.doc){var soundDocId=data.nunaliit_hoverSound.doc;requestService.requestDocument(soundDocId,function(doc){if(doc&&doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var attDesc=doc.nunaliit_attachments.files[attName];if(doc._attachments&&doc._attachments[attName]&&attDesc.fileClass=='audio'){var soundUrl=opts.db.getAttachmentUrl(doc._id,attName);opts.onSuccess(soundUrl);return;};};};opts.onError('Can not find sound url');});return;};opts.onError('Can not find sound url');};var DocumentContainsHoverSound=function(data){if(data.sound&&data.sound.nunaliit_type&&data.sound.nunaliit_type==='reference'&&data.sound.doc){return true;};if(data.nunaliit_attachments&&data.nunaliit_attachments.nunaliit_type==='attachment_descriptions'&&data.nunaliit_attachments.files){var hoverSoundAttName=null;for(var attName in data.nunaliit_attachments.files){var attDesc=data.nunaliit_attachments.files[attName];if(attDesc&&attDesc.data&&attDesc.data.hoverSound){hoverSoundAttName=attName;break;};};if(hoverSoundAttName){return true;};};if(data.nunaliit_hoverSound&&data.nunaliit_hoverSound.nunaliit_type==='reference'&&data.nunaliit_hoverSound.doc){return true;};return false;};$n2.couchSound={HoverSoundService:HoverSoundService,GetHoverSoundUrlFromDocument:GetHoverSoundUrlFromDocument,DocumentContainsHoverSound:DocumentContainsHoverSound};})(jQuery,nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var Notifier=$n2.Class({options:null,initialize:function(options_){this.options=$n2.extend({dbChangeNotifier:null,directory:null},options_);var _this=this;if(this.options.dbChangeNotifier){this.options.dbChangeNotifier.addListener(function(changes){_this._dbChanges(changes);});};},_dbChanges:function(changes){$n2.log('update',changes);var lastSeq=changes.last_seq;var results=changes.results;var dispatcher=this._getDispatcher();if(dispatcher){var dHandle=dispatcher.getHandle('n2.couchServerSide');for(var i=0,e=results.length;i<e;++i){var updateRecord=results[i];var isAdded=false;var latestRev=null;if(updateRecord.changes){for(var l=0,k=updateRecord.changes.length;l<k;++l){latestRev=updateRecord.changes[l].rev;if(latestRev.substr(0,2)==='1-'){isAdded=true;};};};if(latestRev){dispatcher.send(dHandle,{type:'documentVersion',docId:updateRecord.id,rev:latestRev});};if(updateRecord.deleted){dispatcher.send(dHandle,{type:'documentDeleted',docId:updateRecord.id});}else if(isAdded){dispatcher.send(dHandle,{type:'documentCreated',docId:updateRecord.id});}else{dispatcher.send(dHandle,{type:'documentUpdated',docId:updateRecord.id});};};};},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;}});$n2.couchServerSide={Notifier:Notifier,DefaultNotifier:null};})(nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchAuth';var defaultError=function(err,options){var acc=[];if(err){acc.push(''+err.message);var cause=err.cause;while(cause){acc.push('\n>'+cause.message);cause=cause.cause;};}else{acc.push(_loc('<Unknown error>'));};alert(acc.join(''));};var AuthService=$n2.Class({options:null,couchServer:null,loginStateListeners:null,lastAuthSessionCookie:null,lastSessionContext:null,userServiceAvailable:null,autoRegistrationAvailable:null,currentUserDoc:null,initialize:function(options_){var _this=this;this.options=$n2.extend({onSuccess:function(result,options){},onError:defaultError,atlasDb:null,schemaRepository:null,disableCreateUserButton:false,directory:null,listeners:null,autoRefresh:true,prompt:_loc('Please login'),refreshIntervalInSec:2,userServerUrl:null},options_);this.loginStateListeners=[];this.lastAuthSessionCookie=null;this.lastSessionContext=null;this.userServiceAvailable=false;this.autoRegistrationAvailable=false;if(this.options.atlasDb){this.couchServer=this.options.atlasDb.server;}else{$n2.log('Couch Server must be specified for CouchDb AuthService');this.options.onError(_loc('Server must be specified for CouchDb AuthService'));return;};if(this.options.listeners){this.addListeners(this.options.listeners);delete this.options.listeners;};var initOnSuccess=this.options.onSuccess;delete this.options.onSuccess;var initOnError=this.options.onError;delete this.options.onError;var optWithCallbacks=$n2.extend({},this.options,{onSuccess:initOnSuccess,onError:initOnError});this.couchServer.getSession().refreshContext({onSuccess:onSuccess,onError:onError});this.couchServer.getSession().addChangedContextListener(function(sessionContext){_this._handleSessionContextChange(sessionContext);});if(this.options.autoRefresh&&this.options.refreshIntervalInSec>0&&typeof(setInterval)==='function'){setInterval(function(){_this.couchServer.getSession().refreshContext({onError:function(){}});},(1000*this.options.refreshIntervalInSec));setInterval(function(){var cookie=$n2.cookie.getCookie('NunaliitAuth');if(cookie!==_this.lastAuthSessionCookie){_this.lastAuthSessionCookie=cookie;_this.couchServer.getSession().refreshContext({onError:function(){}});};},2000);};var dispatcher=this._getDispatcher();if(dispatcher){var fn=function(m){_this._handleEvent(m);};dispatcher.register(DH,'login',fn);dispatcher.register(DH,'loginShowForm',fn);dispatcher.register(DH,'logout',fn);dispatcher.register(DH,'authIsLoggedIn',fn);};if(this.options.userServerUrl){var url=this.options.userServerUrl;$.ajax({url:url,type:'GET',async:true,traditional:true,data:null,dataType:'json',success:function(result){_this.userServiceAvailable=true;if(result.autoRegistration){_this.autoRegistrationAvailable=true;};},error:function(XMLHttpRequest,textStatus,errorThrown){}});};function onSuccess(context){$n2.log("Login(adjustCookies) successful",context,_this.options);initOnSuccess(context,optWithCallbacks);_this._notifyListeners();};function onError(error){$n2.log('Login(adjustCookies) error: '+error);var err={message:'Problem initializing authentication library',cause:{message:error}};initOnError(err,optWithCallbacks);_this._notifyListeners();};},addListeners:function(listeners){var _this=this;var cUser=this._getCurrentListenerInfo();if(typeof(listeners)=='function'){addListener(listeners);}else if($n2.isArray(listeners)){for(var loop=0;loop<listeners.length;++loop){var listener=listeners[loop];if(typeof(listener)==='function'){addListener(listener);};};};function addListener(listener){_this.loginStateListeners.push(listener);try{listener(cUser);}catch(e){$n2.log('CouchAuthService: EXCEPTION caught in listener (add)',e);};};},_notifyListeners:function(){var context=this._getAuthContext();var userName=null;if(context){userName=context.name;};var isAdmin=false;if(context&&context.roles&&this.doRolesContainAdmin(context.roles)){isAdmin=true;};$n2.cookie.setCookie({name:'NunaliitAuth',value:userName,path:'/'});var $body=$('body');if(userName){$body.removeClass('nunaliit_logged_out');$body.addClass('nunaliit_logged_in');}else{$body.removeClass('nunaliit_logged_in');$body.addClass('nunaliit_logged_out');};if(isAdmin){$body.addClass('nunaliit_user_administrator');}else{$body.removeClass('nunaliit_user_administrator');};if(userName){this._dispatch({type:'authLoggedIn',user:context});}else{this._dispatch({type:'authLoggedOut'});};var cUser=this._getCurrentListenerInfo();for(var loop=0;loop<this.loginStateListeners.length;++loop){var listener=this.loginStateListeners[loop];if(listener){try{listener(cUser);}catch(e){$n2.log('CouchAuthService: EXCEPTION caught in listener (notify)',e);};};};},_getCurrentListenerInfo:function(){var context=this._getAuthContext();var info=null;if(context&&context.name){info={name:context.name,roles:context.roles};};return info;},login:function(opts_){var opts=$n2.extend({username:null,password:null,onSuccess:function(context){},onError:function(errMsg){}},opts_);var _this=this;var username=opts.username;var password=opts.password;if(typeof(username)!=='string'||typeof(password)!=='string'){opts.onError('Name and password must be provided when logging in');return;};if(this.userServiceAvailable){var url=this.options.userServerUrl+'getUser';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{email:username},dataType:'json',success:function(userDoc){if(userDoc.name){username=userDoc.name;};doLogin();},error:doLogin});}else{doLogin();};function doLogin(){_this.couchServer.getSession().login({name:username,password:password,onSuccess:checkUserAgreement,onError:function(err){$n2.log('Unable to log in: '+err);onError(_loc('Invalid e-mail and/or password'));}});};function checkUserAgreement(sessionResult){_this.couchServer.getUserDb().getUser({name:username,onSuccess:function(userDoc){var atlasName=_this._getAtlasName();var agreementRole='nunaliit_agreement_'+atlasName;if(userDoc&&userDoc.roles){for(var i=0,e=userDoc.roles.length;i<e;++i){var role=userDoc.roles[i];if(role===agreementRole){checkUserQuestionnaire(sessionResult,userDoc);return;};};};proposeNewUserAgreement(sessionResult,userDoc);},onError:function(err){var isAdmin=false;if(sessionResult&&sessionResult.roles){for(var i=0,e=sessionResult.roles.length;i<e;++i){var role=sessionResult.roles[i];if('_admin'===role){isAdmin=true;break;};};};if(isAdmin){checkUserQuestionnaire(sessionResult,null);}else{$n2.log('Unable to obtain user information: '+err);onError(_loc('Unable to obtain information about user'));};}});};function proposeNewUserAgreement(sessionResult,userDoc){_this.options.atlasDb.getDocument({docId:'org.nunaliit.user_agreement',onSuccess:function(doc){if(doc&&doc.nunaliit_user_agreement&&doc.nunaliit_user_agreement.content&&doc.nunaliit_user_agreement.enabled){var agreementContent=doc.nunaliit_user_agreement.content;if(typeof doc.nunaliit_user_agreement.content==='object'&&doc.nunaliit_user_agreement.content.nunaliit_type==='localized'){agreementContent=_loc(doc.nunaliit_user_agreement.content);};var accepted=false;var diagId=$n2.getUniqueId();var $diag=$('<div>').attr('id',diagId);var $content=$('<div>').addClass('n2Auth_user_agreement_dialog').appendTo($diag);$('<div>').addClass('n2Auth_user_agreement_label').text(_loc('User agreement has changed. You must accept before you can authenticate.')).appendTo($content);$('<textarea>').addClass('n2Auth_user_agreement_content').attr('readonly','readonly').val(agreementContent).appendTo($content);var $buttons=$('<div>').addClass('n2Auth_user_agreement_buttons').appendTo($content);$('<button>').addClass('n2_button_ok').text(_loc('Accept')).click(function(){accepted=true;var $diag=$('#'+diagId);$diag.dialog('close');acceptUserAgreement(agreementContent,sessionResult,userDoc);}).appendTo($buttons);$('<button>').addClass('n2_button_cancel').text(_loc('Reject')).click(function(){var $diag=$('#'+diagId);$diag.dialog('close');}).appendTo($buttons);$diag.dialog({autoOpen:true,title:_loc('User Agreement and Terms of Service'),modal:true,width:'auto',close:function(event,ui){var $diag=$('#'+diagId);$diag.remove();if(!accepted){onError(_loc('User refused agreement'));};}});}else{acceptUserAgreement('',sessionResult,userDoc);};},onError:function(err){$n2.log('Error getting user agreement: '+err);onError(_loc('Unable to obtain user agreement'));}});};function acceptUserAgreement(userAgreement,sessionResult,userDoc){var url=_this.options.userServerUrl+'acceptUserAgreement';$.ajax({url:url,type:'POST',async:true,traditional:true,data:{userAgreement:userAgreement},dataType:'json',success:function(){checkUserQuestionnaire(sessionResult,userDoc);},error:function(XMLHttpRequest,textStatus,errorThrown){onError(_loc('Error attempting to accept user agreement'));}});};function checkUserQuestionnaire(sessionResult,userDoc){if(!userDoc){onLoginCompleted(sessionResult,userDoc);return;};if(_this.options.schemaRepository){_this.options.schemaRepository.getSchema({name:'nunaliit_user_questions',onSuccess:function(schema){var defaultAnswers=schema.createObject();if(!defaultAnswers.version){$n2.log('User questions found without a version number. Ignored.');onLoginCompleted(sessionResult,userDoc);return;};var atlasName=_this._getAtlasName();var answers=null;if(userDoc&&userDoc.nunaliit_answers){answers=userDoc.nunaliit_answers[atlasName];};var interventionRequired=false;if(!answers){interventionRequired=true;answers=defaultAnswers;}else if(answers.version!=defaultAnswers.version){interventionRequired=true;};if(interventionRequired){gatherUserAnswers(sessionResult,userDoc,schema,answers);}else{onLoginCompleted(sessionResult,userDoc);};},onError:function(err){onLoginCompleted(sessionResult,userDoc);}});}else{onLoginCompleted(sessionResult,userDoc);};};function gatherUserAnswers(sessionResult,userDoc,schema,answers){var diagId=$n2.getUniqueId();var $diag=$('<div>').attr('id',diagId);var $content=$('<div>').addClass('n2Auth_user_questions_dialog').appendTo($diag);var $elem=$('<div>').addClass('n2Auth_user_questions_form').appendTo($content);schema.form(answers,$elem);var $buttons=$('<div>').addClass('n2Auth_user_questions_buttons').appendTo($content);$('<button>').addClass('n2_button_ok').text(_loc('OK')).click(function(){var $diag=$('#'+diagId);$diag.dialog('close');saveUserAnswers(sessionResult,userDoc,answers);}).appendTo($buttons);$('<button>').addClass('n2_button_cancel').text(_loc('Remind me later')).click(function(){var $diag=$('#'+diagId);$diag.dialog('close');onLoginCompleted(sessionResult,userDoc);}).appendTo($buttons);$diag.dialog({autoOpen:true,title:_loc('User Questionnaire'),modal:true,width:'auto',close:function(event,ui){var $diag=$('#'+diagId);$diag.remove();}});};function saveUserAnswers(sessionResult,userDoc,answers){_this.couchServer.getUserDb().getUser({name:userDoc.name,onSuccess:function(userDoc){var atlasName=_this._getAtlasName();if(!userDoc.nunaliit_answers){userDoc.nunaliit_answers={};};userDoc.nunaliit_answers[atlasName]=answers;_this.couchServer.getUserDb().updateDocument({data:userDoc,onSuccess:reloadUserDoc,onError:errorSavingAnswers});},onError:errorSavingAnswers});function errorSavingAnswers(err){$n2.log('Error saving user answers',err);alert(_loc('There was a problem saving your answers. You will be prompted again next time you log in.'));onLoginCompleted(sessionResult);};function reloadUserDoc(){_this.couchServer.getUserDb().getUser({id:userDoc._id,onSuccess:function(updatedUserDoc){onLoginCompleted(sessionResult,updatedUserDoc);},onError:function(err){$n2.log('Error retrieving updated version of user document',err);onLoginCompleted(sessionResult,userDoc);}});};};function onLoginCompleted(result,userDoc){var context=_this.couchServer.getSession().getContext();$n2.log('Login successful',context,opts);if(context&&context.name){opts.onSuccess(context);_this._notifyListeners();}else{doErrorNotification();};};function onError(err){_this.couchServer.getSession().logout({onError:function(){}});$n2.log('Login error',err);doErrorNotification(err);};function doErrorNotification(err){if(err){opts.onError(err);}else{opts.onError(_loc('Invalid e-mail and/or password'));};_this._notifyListeners();};},_fillDialogWithLogin:function(dialogId,opts_){var opts=$n2.extend({prompt:null,userName:null,onSuccess:function(context){},onError:function(err){}},opts_);var _this=this;var $dialog=$('#'+dialogId);var $authDiag=$('<div class="n2Auth_login"></div>');var $authForm=$('<form></form>').appendTo($authDiag);var $userLine=$('<div class="n2Auth_login_user_line"></div>').appendTo($authForm);var nameLabel=_loc('user name');if(this.autoRegistrationAvailable){nameLabel=_loc('e-mail address');};var nameValue='';if(opts.userName){nameValue=opts.userName;};$('<div class="n2Auth_login_label"></div>').text(nameLabel).appendTo($userLine);var $labelDiv=$('<div class="n2Auth_login_input"></div>').appendTo($userLine);$('<input class="n2Auth_user_input n2Auth_input_field" type="text" name="username"/>').val(nameValue).appendTo($labelDiv);$('<div class="n2Auth_login_end"></div>').appendTo($userLine);var $pwLine=$('<div class="n2Auth_login_pw_line"></div>').appendTo($authForm);$('<div class="n2Auth_login_label"></div>').text(_loc('password')).appendTo($pwLine);$('<div class="n2Auth_login_input"><input class="n2Auth_pw_input n2Auth_input_field" type="password" name="password"/></div>').appendTo($pwLine);$('<div class="n2Auth_login_end"></div>').appendTo($pwLine);var $buttonLine=$('<div class="n2Auth_login_button_line"></div>').appendTo($authForm);$('<input type="submit" class="n2Auth_button_login"></input>').appendTo($buttonLine).val(_loc('Login')).click(function(){performLogin();return false;});$('<input type="button" class="n2Auth_button_cancel"></input>').appendTo($buttonLine).val(_loc('Cancel')).click(function(){var $dialog=$('#'+dialogId);$dialog.dialog('close');});$('<div class="n2Auth_login_end"></div>').appendTo($buttonLine);if(!this._shouldDisableCreateUserButton()){var $createLine=$('<div class="n2Auth_login_create_line"></div>').appendTo($authDiag);$('<a class="n2Auth_button_createUser" href="#"></a>').appendTo($createLine).text(_loc('Create a new user')).click(function(){var $dialog=$('#'+dialogId);var userName=$dialog.find('.n2Auth_user_input').val();opts.userName=userName;_this._fillDialogWithUserCreation(dialogId,opts);return false;});$('<div class="n2Auth_login_end"></div>').appendTo($createLine);};if(this.autoRegistrationAvailable){var $recoverLine=$('<div class="n2Auth_login_recover_line"></div>').appendTo($authDiag);$('<a class="n2Auth_button_recoverPassword" href="#"></a>').appendTo($recoverLine).text(_loc('I have forgotten my password')).click(function(){var $dialog=$('#'+dialogId);var userName=$dialog.find('.n2Auth_user_input').val();opts.userName=userName;_this._fillDialogWithPasswordRecovery(dialogId,opts);return false;});$('<div class="n2Auth_login_end"></div>').appendTo($recoverLine);};$dialog.empty().append($authDiag);if(opts.prompt){$dialog.dialog('option','title',opts.prompt);}else{$dialog.dialog('option','title',_loc('Please login'));};function performLogin(){var $dialog=$('#'+dialogId);var user=$dialog.find('.n2Auth_user_input').val();var password=$dialog.find('.n2Auth_pw_input').val();_this.login({username:user,password:password,onSuccess:opts.onSuccess,onError:opts.onError});};},_fillDialogWithUserCreation:function(dialogId,opts_){if(this.autoRegistrationAvailable){this._fillDialogWithUserAutoRegistration(dialogId,opts_);return;};var opts=$n2.extend({prompt:null,userName:null,onSuccess:function(context){},onError:function(err){}},opts_);var _this=this;var $dialog=$('#'+dialogId);$dialog.html(['<div class="n2Auth_create">','<div class="n2Auth_create_user_line">','<div class="n2Auth_create_label"></div>','<div class="n2Auth_create_input"><input class="n2Auth_user_input n2Auth_input_field" type="text"/></div>','<div class="n2Auth_create_end"></div>','</div>','<div class="n2Auth_create_display_line">','<div class="n2Auth_create_label"></div>','<div class="n2Auth_create_input"><input class="n2Auth_display_input n2Auth_input_field" type="text"/></div>','<div class="n2Auth_create_end"></div>','</div>','<div class="n2Auth_create_pw_line">','<div class="n2Auth_create_label"></div>','<div class="n2Auth_create_input"><input class="n2Auth_pw_input n2Auth_input_field" type="password"/></div>','<div class="n2Auth_create_end"></div>','</div>','<div class="n2Auth_create_pw2_line">','<div class="n2Auth_create_label"></div>','<div class="n2Auth_create_input"><input class="n2Auth_pw_input2 n2Auth_input_field" type="password"/></div>','<div class="n2Auth_create_end"></div>','</div>','<div class="n2Auth_create_button_line">','<button class="n2Auth_button_create"></button>','<button class="n2Auth_button_cancel"></button>','</div>','</div>'].join(''));$dialog.find('.n2Auth_create_user_line .n2Auth_create_label').text(_loc('user name'));$dialog.find('.n2Auth_create_display_line .n2Auth_create_label').text(_loc('display name'));$dialog.find('.n2Auth_create_pw_line .n2Auth_create_label').text(_loc('password'));$dialog.find('.n2Auth_create_pw2_line .n2Auth_create_label').text(_loc('confirm password'));if(opts.userName){$dialog.find('.n2Auth_user_input').val(opts.userName);};$dialog.find('.n2Auth_button_create').text(_loc('Create User')).button({icons:{primary:'ui-icon-check'}}).click(function(){performUserCreation();return false;});$dialog.find('.n2Auth_button_cancel').text(_loc('Cancel')).button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);var userName=$dialog.find('.n2Auth_user_input').val();opts.userName=userName;_this._fillDialogWithLogin(dialogId,opts);return false;});$dialog.find('.n2Auth_input_field').keydown(function(e){var charCode=null;if(null===e){e=window.event;};if(null!==e){if(e.keyCode){charCode=e.keyCode;};};if(13===charCode){performUserCreation();};});$dialog.dialog('option','title',_loc('User Creation'));function performUserCreation(){var $dialog=$('#'+dialogId);var user=$dialog.find('.n2Auth_user_input').val();var display=$dialog.find('.n2Auth_display_input').val();var password=$dialog.find('.n2Auth_pw_input').val();var password2=$dialog.find('.n2Auth_pw_input2').val();if(null==user||user.length<3){alert(_loc('User name should have at least 3 characters'));return false;};if(password!=password2){alert(_loc('The two passwords should match'));return false;};if(null==password||password.length<6){alert(_loc('Password should have at least 6 characters'));return false;};if(null==display||display.length<1){display=user;};_this.couchServer.getUserDb().createUser({name:user,password:password,display:display,onSuccess:function(){_this.login({username:user,password:password,onSuccess:opts.onSuccess,onError:function(err){alert(_loc('User created but unable to log in: ')+err);}});},onError:function(err){alert(_loc('Unable to create user: ')+err);}});};},_fillDialogWithUserAutoRegistration:function(dialogId,opts_){var opts=$n2.extend({prompt:null,userName:null,onSuccess:function(context){},onError:function(err){}},opts_);var _this=this;var $dialog=$('#'+dialogId);$dialog.empty();var $form=$('<div>').addClass('n2Auth_create').appendTo($dialog);var emailValue='';if(opts.userName){emailValue=opts.userName;};var $line=$('<div>').addClass('n2Auth_create_email_line').appendTo($form);$('<div>').addClass('n2Auth_create_label').text(_loc('e-mail address')).appendTo($line);var $input=$('<div>').addClass('n2Auth_create_input').appendTo($line);$('<input type="text">').addClass('n2Auth_email_input n2Auth_input_field').appendTo($input).val(emailValue).keydown(function(e){var charCode=null;if(null===e){e=window.event;};if(null!==e){if(e.keyCode){charCode=e.keyCode;};};if(13===charCode){performUserRegistration();};});$('<div>').addClass('n2Auth_create_end').appendTo($line);var $line=$('<div>').addClass('n2Auth_create_button_line').appendTo($form);$('<button>').addClass('n2Auth_button_create').text(_loc('Create User')).appendTo($line).button({icons:{primary:'ui-icon-check'}}).click(function(){performUserRegistration();return false;});$('<button>').addClass('n2Auth_button_cancel').text(_loc('Cancel')).appendTo($line).button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);var email=$dialog.find('.n2Auth_email_input').val();opts.userName=email;_this._fillDialogWithLogin(dialogId,opts);return false;});$dialog.dialog('option','title',_loc('User Registration'));function performUserRegistration(){var $dialog=$('#'+dialogId);var email=$dialog.find('.n2Auth_email_input').val();if(email){email=$n2.trim(email);};if(!email){alert(_loc('E-Mail address must be specified'));return false;};var url=_this.options.userServerUrl+'initUserCreation';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{email:email},dataType:'json',success:function(result){if(result.error){alert(_loc('Unable to register user: ')+result.error);}else{reportSuccess();};},error:function(XMLHttpRequest,textStatus,errorThrown){alert(_loc('Unable to register user: ')+textStatus);}});};function reportSuccess(){var $dialog=$('#'+dialogId);$dialog.empty();var $form=$('<div>').addClass('n2Auth_registered').appendTo($dialog);var $line=$('<div>').addClass('n2Auth_registered_line').appendTo($form).text(_loc('User registration initiated. Check for e-mail to complete user creation'));var $line=$('<div>').addClass('n2Auth_registered_button_line').appendTo($form);$('<button>').addClass('n2Auth_button_ok').text(_loc('OK')).appendTo($line).button({icons:{primary:'ui-icon-check'}}).click(function(){opts.onSuccess();return false;});$dialog.dialog('option','title',_loc('Registration Initiated'));};},_fillDialogWithPasswordRecovery:function(dialogId,opts_){var opts=$n2.extend({prompt:null,userName:null,onSuccess:function(context){},onError:function(err){}},opts_);var _this=this;var $dialog=$('#'+dialogId);$dialog.empty();var $form=$('<div>').addClass('n2Auth_recoverPassword').appendTo($dialog);var userName='';if(opts.userName){userName=opts.userName;};var $line=$('<div>').addClass('n2Auth_recoverPassword_email_line').appendTo($form);$('<div>').addClass('n2Auth_recoverPassword_label').text(_loc('e-mail address')).appendTo($line);var $input=$('<div>').addClass('n2Auth_recoverPassword_input').appendTo($line);$('<input type="text">').addClass('n2Auth_email_input n2Auth_input_field').appendTo($input).val(userName).keydown(function(e){var charCode=null;if(null===e){e=window.event;};if(null!==e){if(e.keyCode){charCode=e.keyCode;};};if(13===charCode){performPasswordRecovery();};});$('<div>').addClass('n2Auth_recoverPassword_end').appendTo($line);var $line=$('<div>').addClass('n2Auth_recoverPassword_button_line').appendTo($form);$('<button>').addClass('n2Auth_button_recover').text(_loc('Reset Password')).appendTo($line).button({icons:{primary:'ui-icon-check'}}).click(function(){performPasswordRecovery();return false;});$('<button>').addClass('n2Auth_button_cancel').text(_loc('Cancel')).appendTo($line).button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);var email=$dialog.find('.n2Auth_email_input').val();opts.userName=email;_this._fillDialogWithLogin(dialogId,opts);return false;});$dialog.dialog('option','title',_loc('Recover Password'));function performPasswordRecovery(){var $dialog=$('#'+dialogId);var email=$dialog.find('.n2Auth_email_input').val();if(email){email=$n2.trim(email);};if(!email){alert(_loc('E-Mail address must be specified'));return false;};var url=_this.options.userServerUrl+'initPasswordRecovery';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{email:email},dataType:'json',success:function(result){if(result.error){alert(_loc('Unable to recover password: ')+result.error);}else{reportSuccess();};},error:function(XMLHttpRequest,textStatus,errorThrown){alert(_loc('Unable to recover password: ')+textStatus);}});};function reportSuccess(){var $dialog=$('#'+dialogId);$dialog.empty();var $form=$('<div>').addClass('n2Auth_registered').appendTo($dialog);var $line=$('<div>').addClass('n2Auth_registered_line').appendTo($form).text(_loc('Password recovery initiated. Check for an e-mail to complete password recovery'));var $line=$('<div>').addClass('n2Auth_registered_button_line').appendTo($form);$('<button>').addClass('n2Auth_button_ok').text(_loc('OK')).appendTo($line).button({icons:{primary:'ui-icon-check'}}).click(function(){opts.onSuccess();return false;});$dialog.dialog('option','title',_loc('Password Recovery Initiated'));};},showLoginForm:function(opts_){var opts=$.extend({prompt:this.options.prompt,onSuccess:function(context){},onError:$n2.reportErrorForced},opts_);var dialogId=$n2.getUniqueId();var $dialog=$('<div id="'+dialogId+'"></div>');$(document.body).append($dialog);this._fillDialogWithLogin(dialogId,{prompt:opts.prompt,onSuccess:function(context){$('#'+dialogId).dialog('close');opts.onSuccess(context);},onError:function(err){$('#'+dialogId).dialog('close');opts.onError(err);}});var dialogOptions={autoOpen:true,modal:true,width:'auto',close:function(event,ui){var diag=$('#'+dialogId);diag.remove();}};if(opts.prompt){dialogOptions.title=opts.prompt;}
$dialog.dialog(dialogOptions);},logout:function(opts_){var opts=$n2.extend({onSuccess:function(context){},onError:function(err){}},opts_);var _this=this;this.couchServer.getSession().logout({onSuccess:onSuccess,onError:opts.onError});function onSuccess(result){$n2.log("Logout successful",result);opts.onSuccess(result);_this._notifyListeners();};},editUser:function(opts_){var opts=$n2.extend({userName:null,onSuccess:function(context){},onError:function(err){}},opts_);var _this=this;var userName=opts.userName;if(!userName){var context=this._getAuthContext();if(context&&context.name){userName=context.name;};};if(!userName){opts.onError('No user name provided');return;};this.couchServer.getUserDb().getUser({name:userName,onSuccess:userDocLoaded,onError:function(err){var userDoc={_id:'org.couchdb.user:'+userName,name:userName,display:'',nunaliit_emails:[],roles:[],type:'user'};userDocLoaded(userDoc);}});function userDocLoaded(userDoc){var userService=_this._getUserService();if(userService){var $dialog=$('<div>').addClass('n2Auth_userEdit').appendTo($(document.body));var dialogId=$n2.utils.getElementIdentifier($dialog);userService.startEdit({userDoc:userDoc,elem:$dialog,onSavedFn:function(userDoc){var requestService=_this._getRequestService();if(requestService&&userDoc&&userDoc.name){requestService.requestUser(userDoc.name);};},onFinishedFn:function(){var diag=$('#'+dialogId);diag.dialog('close');}});var dialogOptions={autoOpen:true,modal:true,width:'auto',title:_loc('Edit User'),close:function(event,ui){var diag=$('#'+dialogId);diag.remove();}};$dialog.dialog(dialogOptions);};};},getCurrentUserName:function(){var context=this._getAuthContext();if(context&&context.name){return context.name;};return null;},getCurrentUserRoles:function(){var context=this._getAuthContext();if(context&&context.roles){return context.roles;};return null;},doRolesContainAdmin:function(roles){var admin=false;if(roles&&roles.length){if($.inArray('_admin',roles)>=0){admin=true;};if($.inArray('administrator',roles)>=0){admin=true;};if(typeof(n2atlas)==='object'&&typeof(n2atlas.name)==='string'){var dbAdmin=n2atlas.name+'_administrator';if($.inArray(dbAdmin,roles)>=0){admin=true;};};};return admin;},_getAuthContext:function(){return this.couchServer.getSession().getContext();},isLoggedIn:function(){var authContext=this._getAuthContext();if(authContext&&authContext.name){return true;};return false;},createAuthWidget:function(opts_){var dispatchService=null;var customService=null;if(this.options.directory){dispatchService=this.options.directory.dispatchService;customService=this.options.directory.customService;};var widgetOptions={elemId:null,elem:null,authService:this,dispatchService:dispatchService};if(customService){var label=customService.getOption('authWidgetLoginLabel');if(label)widgetOptions.labelLogin=label;label=customService.getOption('authWidgetLogoutLabel');if(label)widgetOptions.labelLogout=label;label=customService.getOption('authWidgetWelcomeLabel');if(label)widgetOptions.labelWelcome=label;};var opts=$n2.extend(widgetOptions,opts_);return new AuthWidget(opts);},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_getUserService:function(){var us=null;if(this.options.directory){us=this.options.directory.userService;};return us;},_getRequestService:function(){var rs=null;if(this.options.directory){rs=this.options.directory.requestService;};return rs;},_dispatch:function(m){var dispatcher=this._getDispatcher();if(dispatcher){var h=dispatcher.getHandle('n2.couchAuth');dispatcher.send(h,m);};},_handleSessionContextChange:function(sessionContext){var _this=this;var same=$n2.couch.compareSessionContexts(this.lastSessionContext,sessionContext);if(!same){this.lastSessionContext=sessionContext;this.currentUserDoc=null;this._notifyListeners();if(sessionContext.name){this.couchServer.getUserDb().getUser({name:sessionContext.name,onSuccess:function(userDoc){if(userDoc.name===_this.lastSessionContext.name){_this._handleCurrentUserDoc(userDoc);};},onError:function(err){if(sessionContext.name===_this.lastSessionContext.name){_this._handleCurrentUserDoc(null);};}});};};},_handleCurrentUserDoc:function(userDoc){this.currentUserDoc=userDoc;var $body=$('body');if(this.currentUserDoc&&this.currentUserDoc.nunaliit_options&&this.currentUserDoc.nunaliit_options.advanced){$body.addClass('nunaliit_user_advanced');}else{$body.removeClass('nunaliit_user_advanced');};if(userDoc){this._dispatch({type:'authCurrentUserDoc',userDoc:userDoc});};this._updateUserDocWithLoggedIn();},_handleEvent:function(m){if(m&&m.type==='login'){this.login({username:m.username,password:m.password});}else if(m&&m.type==='loginShowForm'){this.showLoginForm();}else if(m&&m.type==='logout'){this.logout();}else if(m&&m.type==='authIsLoggedIn'){if(this.isLoggedIn()){m.isLoggedIn=true;m.context=this.lastSessionContext;m.userDoc=this.currentUserDoc;};};},_getCustomService:function(){var cs=null;if(this.options.directory){cs=this.options.directory.customService;};return cs;},_shouldDisableCreateUserButton:function(){var flag=this.options.disableCreateUserButton;var customService=this._getCustomService();if(customService&&!flag){var o=customService.getOption('disableCreateUserButton');if(typeof(o)!=='undefined'){flag=o;};};return flag;},_updateUserDocWithLoggedIn:function(){var userDoc=this.currentUserDoc;if(userDoc&&n2atlas&&n2atlas.name){if(userDoc.nunaliit_atlases&&userDoc.nunaliit_atlases[n2atlas.name]&&userDoc.nunaliit_atlases[n2atlas.name].auth){}else{if(!userDoc.nunaliit_atlases){userDoc.nunaliit_atlases={};};if(!userDoc.nunaliit_atlases[n2atlas.name]){userDoc.nunaliit_atlases[n2atlas.name]={name:n2atlas.name};};userDoc.nunaliit_atlases[n2atlas.name].auth=true;this.couchServer.getUserDb().updateDocument({data:userDoc,onSuccess:function(){},onError:function(err){$n2.log('Unable to save user\'s authentication flag to user db',err);}});};};},_getAtlasName:function(){var atlasName='atlas';if(typeof n2atlas==='object'&&n2atlas.name){atlasName=n2atlas.name;};return atlasName;}});var AuthWidget=$n2.Class({authService:null,elemId:null,currentUserName:null,currentUserDisplay:null,labelLogin:null,labelLogout:null,labelWelcome:null,initialize:function(options_){var opts=$n2.extend({elemId:null,elem:null,authService:null,dispatchService:null,labelLogin:null,labelLogout:null,labelWelcome:null},options_);var _this=this;this.authService=opts.authService;this.dispatchService=opts.dispatchService;this.labelLogin=opts.labelLogin;this.labelLogout=opts.labelLogout;this.labelWelcome=opts.labelWelcome;this.elemId=opts.elemId;if(!this.elemId&&opts.elem){this.elemId=$n2.utils.getElementIdentifier(opts.elem);};if(this.dispatchService){var f=function(m,addr,d){_this._handleDispatch(m,addr,d);};this.dispatchService.register(DH,'authLoggedIn',f);this.dispatchService.register(DH,'authLoggedOut',f);this.dispatchService.register(DH,'authCurrentUserDoc',f);this.dispatchService.register(DH,'userInfo',f);this.dispatchService.register(DH,'userDocument',f);var m={type:'authIsLoggedIn',isLoggedIn:false};this.dispatchService.synchronousCall(DH,m);if(m.isLoggedIn){if(m.context&&m.context.name){this.currentUserName=m.context.name;};if(m.userDoc&&m.userDoc.display){this.currentUserDisplay=m.userDoc.display;};}else{this.currentUserName=null;this.currentUserDisplay=null;};this._loginStateChanged();};},_getElem:function(){return $('#'+this.elemId);},_handleDispatch:function(m,addr,dispatcher){var $elem=this._getElem();if($elem.length<1){dispatcher.deregister(addr);return;};if('authLoggedIn'===m.type){var ctxt=m.user;if(this.currentUserName!==ctxt.name){this.currentUserName=ctxt.name;this.currentUserDisplay=null;this._loginStateChanged();};}else if('authLoggedOut'===m.type){this.currentUserName=null;this.currentUserDisplay=null;this._loginStateChanged();}else if('authCurrentUserDoc'===m.type){var userDoc=m.userDoc;if(userDoc&&userDoc.display!==this.currentUserDisplay){this.currentUserDisplay=userDoc.display;this._loginStateChanged();};}else if('userInfo'===m.type){if(m.userInfo&&this.currentUserName===m.userInfo.name){this.currentUserDisplay=m.userInfo.display;this._loginStateChanged();};}else if('userDocument'===m.type){if(m.userDoc&&this.currentUserName===m.userDoc.name){this.currentUserDisplay=m.userDoc.display;this._loginStateChanged();};};},_loginStateChanged:function(){var $login=this._getElem();if($login.length<1)return;$login.empty();var authService=this.authService;if(authService){var href=null;var displayName=null;var buttonText=null;var clickFn=null;var greetingFn=null;var greetingClass=null;if(this.currentUserName){href='javascript:Logout';displayName=this.currentUserDisplay;if(!displayName)displayName=this.currentUserName;greetingClass='nunaliit_login_greeting_name';buttonText=this.labelLogout?this.labelLogout:_loc('Logout');clickFn=function(){authService.logout();return false;};greetingFn=function(){authService.editUser({userName:null});return false;};}else{href='javascript:Login';displayName=this.labelWelcome?this.labelWelcome:_loc('Welcome');greetingClass='nunaliit_login_greeting_welcome';buttonText=this.labelLogin?this.labelLogin:_loc('Login');clickFn=function(){authService.showLoginForm();return false;};};var aElem=$('<a class="nunaliit_login_link"></a>').attr("href",href).text(buttonText);var linkInnerContainer=$('<div class="nunaliit_login_link_inner_container"></div>').append(aElem);var linkOuterContainer=$('<div class="nunaliit_login_link_outer_container"></div>').append(linkInnerContainer).click(clickFn);var nameElem=$('<span></span>').text(displayName);var greetingInner=$('<div class="nunaliit_login_greeting_inner_container"></div>').append(nameElem);var greetingOuter=$('<div class="nunaliit_login_greeting_outer_container"></div>').addClass(greetingClass).append(greetingInner);if(greetingFn){greetingOuter.addClass('nunaliit_login_greeting_with_editor').click(greetingFn);};$login.empty().append(greetingOuter).append(linkOuterContainer);};}});$n2.couchAuth={AuthService:AuthService,AuthWidget:AuthWidget};})(jQuery,nunaliit2);;(function($,$n2){var DH='n2.couchModule';var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};function isSrsNameSupported(srsName){if(typeof(OpenLayers)!=='undefined'&&OpenLayers.Projection&&OpenLayers.Projection.transforms&&OpenLayers.Projection.transforms[srsName]){return true;};if(typeof(Proj4js)!=='undefined'&&Proj4js.Proj){var proj=new Proj4js.Proj(srsName);if(proj.readyToUse){return true;};};return false;};var Module=$n2.Class({moduleDoc:null,atlasDb:null,initialize:function(moduleDoc,atlasDb){this.moduleDoc=moduleDoc;this.atlasDb=atlasDb;},getModuleInfo:function(){var moduleInfo=null;if(this.moduleDoc){moduleInfo=this.moduleDoc.nunaliit_module;};return moduleInfo;},getMapInfo:function(){var mapInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){mapInfo=moduleInfo.map;};return mapInfo;},getDisplayInfo:function(){var displayInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){displayInfo=moduleInfo.display;};return displayInfo;},getEditInfo:function(){var editInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){editInfo=moduleInfo.edit;};return editInfo;},getSearchInfo:function(){var searchInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){searchInfo=moduleInfo.search;};return searchInfo;},displayIntro:function(opts_){var opts=$n2.extend({elem:null,showService:null,onLoaded:function(){}},opts_);var $elem=opts.elem;var introInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){introInfo=moduleInfo.introduction;};if(!introInfo){$elem.empty();return false;}else{if('html'===introInfo.type&&introInfo.content){$elem.empty();var $outer=$('<div>').addClass('n2ModuleIntro n2ModuleIntro_html').appendTo($elem);var content=$n2.couchL10n.getLocalizedString(introInfo.content);if(content){$outer.html(content);};opts.onLoaded();return true;}else if('text'===introInfo.type&&introInfo.content){$elem.empty();var $outer=$('<div>').addClass('n2ModuleIntro n2ModuleIntro_text').appendTo($elem);var content=$n2.couchL10n.getLocalizedString(introInfo.content);if(content){var $wrapper=$('<div>').text(content);$outer.empty().append($wrapper);if(opts.showService){$wrapper.addClass('n2s_preserveSpaces');opts.showService.fixElementAndChildren($wrapper);};};opts.onLoaded();return true;}else if('attachment'===introInfo.type&&introInfo.attachmentName&&this.atlasDb){var displayId=$n2.getUniqueId();$elem.empty();$('<div>').attr('id',displayId).addClass('n2ModuleIntro n2ModuleIntro_attachment').appendTo($elem);var localeStr=$n2.l10n.getStringForLocale(introInfo.attachmentName);if(localeStr.str){var attUrl=this.atlasDb.getAttachmentUrl(this.moduleDoc,localeStr.str);$.ajax({url:attUrl,type:'get',async:true,success:function(intro){if(localeStr.fallback){var $inner=$('<span class="n2_localized_string n2_localize_fallback"></span>');$('<span class="n2_localize_fallback_lang"></span>').text('('+localeStr.lang+')').appendTo($inner);$('<span></span>').html(intro).appendTo($inner);$('#'+displayId).empty().append($inner);}else{$('#'+displayId).html(intro);};opts.onLoaded();},error:function(XMLHttpRequest,textStatus,errorThrown){$n2.log('Unable to obtain module intro: '+textStatus);}});};return true;}else{$elem.empty();return false;};}}});var ModuleDisplay=$n2.Class({config:null,module:null,mapControl:null,displayControl:null,titleName:null,moduleTitleName:null,contentName:null,mapName:null,mapInteractionName:null,sidePanelName:null,filterPanelName:null,searchPanelName:null,loginPanelNames:null,navigationName:null,navigationDoc:null,languageSwitcherName:null,helpButtonName:null,helpDialogId:null,styleMapFn:null,styles:null,initialize:function(opts_){var opts=$n2.extend({moduleName:null,moduleDoc:null,config:null,titleName:'title',moduleTitleName:'module_title',contentName:null,mapName:'map',mapInteractionName:'map_interaction_div',sidePanelName:'side',filterPanelName:'filters',searchPanelName:null,loginPanelName:'login',loginPanels:null,navigationName:'navigation',navigationDoc:null,languageSwitcherName:null,helpButtonName:null,styleMapFn:null,onSuccess:function(moduleDisplay){},onError:function(err){$n2.reportErrorForced(errorMsg);}},opts_);var _this=this;if(!opts.moduleName&&!opts.moduleDoc){opts.onError('"moduleName" or "moduleDoc" must be specified');return;};this.config=opts.config;if(!this.config){opts.onError('"config" must be specified');return;};this.contentName=opts.contentName;this.mapName=opts.mapName;this.mapInteractionName=opts.mapInteractionName;this.sidePanelName=opts.sidePanelName;this.filterPanelName=opts.filterPanelName;this.searchPanelName=opts.searchPanelName;this.navigationName=opts.navigationName;this.navigationDoc=opts.navigationDoc;this.titleName=opts.titleName;this.moduleTitleName=opts.moduleTitleName;this.languageSwitcherName=opts.languageSwitcherName;this.helpButtonName=opts.helpButtonName;this.styleMapFn=opts.styleMapFn;this.loginPanelNames=[];if(opts.loginPanels){$(opts.loginPanels).each(function(){var $loginPanel=$(this);var id=$loginPanel.attr('id');if(!id){id=$n2.getUniqueId();$loginPanel.attr('id',id);};_this.loginPanelNames.push(id);});}else if(opts.loginPanelName){this.loginPanelNames.push(opts.loginPanelName);};var config=this.config;var atlasDb=config.atlasDb;var atlasDesign=config.atlasDesign;var documentSource=config.documentSource;var customService=this._getCustomService();var d=this._getDispatcher();if(d){d.register(DH,'unselected',function(m){_this._initSidePanel();});};for(var i=0,e=this.loginPanelNames.length;i<e;++i){var loginPanelName=this.loginPanelNames[i];config.directory.authService.createAuthWidget({elemId:loginPanelName});};if(!$n2.isDefined(opts.moduleDoc)){atlasDb.getDocument({docId:opts.moduleName,onSuccess:moduleDocumentLoaded,onError:function(err){opts.onError('Unable to load module: '+err);}});}else{moduleDocumentLoaded(opts.moduleDoc);};if(this.navigationDoc){var navDocNeeded=false;if($('#'+this.navigationName).length>0){$('#'+this.navigationName).empty();navDocNeeded=true;};if($('#'+this.titleName).length>0){$('#'+this.titleName).empty();navDocNeeded=true;};if(navDocNeeded){atlasDb.getDocument({docId:this.navigationDoc,onSuccess:function(doc){_this._navigationDocumentLoaded(doc);},onError:function(err){$n2.log('Error obtaining navigation document '+_this.navigationDoc,err);}});};};function moduleDocumentLoaded(moduleDoc){if(!moduleDoc.nunaliit_module){opts.onError('Loaded document does not include module information');return;};_this.module=new Module(moduleDoc,atlasDb);var moduleInfo=_this.module.getModuleInfo();var mapInfo=_this.module.getMapInfo();var displayInfo=_this.module.getDisplayInfo();var editInfo=_this.module.getEditInfo();var searchInfo=_this.module.getSearchInfo();if(_this.contentName){var $contentDiv=$('#'+_this.contentName).empty();if(mapInfo){_this.mapName=$n2.getUniqueId();$('<div></div>').attr('id',_this.mapName).addClass('n2_content_map').appendTo($contentDiv);$contentDiv.addClass('n2_content_contains_map');_this.mapInteractionName=$n2.getUniqueId();$('<div></div>').attr('id',_this.mapInteractionName).addClass('n2_content_map_interaction').appendTo($contentDiv);}else{_this.mapName=null;_this.mapInteractionName=null;$contentDiv.addClass('n2_content_contains_no_map');};if(searchInfo&&searchInfo.disabled){_this.searchPanelName=null;$contentDiv.addClass('n2_content_contains_no_search');}else if(_this.searchPanelName){$contentDiv.addClass('n2_content_contains_no_search');}else{_this.searchPanelName=$n2.getUniqueId();$('<div></div>').attr('id',_this.searchPanelName).addClass('n2_content_searchInput').appendTo($contentDiv);$contentDiv.addClass('n2_content_contains_search');};_this.sidePanelName=$n2.getUniqueId();$('<div></div>').attr('id',_this.sidePanelName).addClass('n2_content_text').appendTo($contentDiv);$contentDiv.addClass('n2_content_contains_text');};_this.styles=new $n2.mapStyles.MapFeatureStyles((mapInfo?mapInfo.styles:null));_this._initSidePanel();if(moduleInfo&&moduleInfo.title){var title=$n2.couchL10n.getLocalizedString(moduleInfo.title);if(title){document.title=title;_this._installModuleTitle($('#'+opts.moduleTitleName),title);};}else{var title=_loc('Nunaliit Atlas');document.title=title;_this._installModuleTitle($('#'+opts.moduleTitleName),title);};if(_this.languageSwitcherName&&_this.config.directory.languageService){_this.config.directory.languageService.drawWidget({elemId:_this.languageSwitcherName});};if(moduleInfo.help&&_this.helpButtonName){_this._installHelpButton();};var displayFormat='classic';if(customService){displayFormat=customService.getOption('displayFormat',displayFormat);};if(displayFormat==='tiled'){$('body').addClass('n2_display_format_tiled');_this.displayControl=new $n2.couchDisplayTiles.TiledDisplay({documentSource:documentSource,displayPanelName:_this.sidePanelName,showService:config.directory.showService,editor:config.couchEditor,uploadService:config.directory.uploadService,authService:config.directory.authService,requestService:config.directory.requestService,schemaRepository:config.directory.schemaRepository,customService:config.directory.customService,dispatchService:config.directory.dispatchService});}else{if('classic'!==displayFormat){$n2.log('Unknown display format: '+displayFormat+' Reverting to classic display.');};var displayOptions={documentSource:documentSource,displayPanelName:_this.sidePanelName,showService:_this.config.directory.showService,editor:_this.config.couchEditor,uploadService:_this.config.directory.uploadService,serviceDirectory:_this.config.directory};if(displayInfo&&displayInfo.displayOnlyRelatedSchemas){displayOptions.displayOnlyRelatedSchemas=displayInfo.displayOnlyRelatedSchemas;};if(displayInfo&&displayInfo.displayBriefInRelatedInfo){displayOptions.displayBriefInRelatedInfo=displayInfo.displayBriefInRelatedInfo;};_this.displayControl=new $n2.couchDisplay.Display(displayOptions);var defaultDisplaySchemaName='object';if(displayInfo&&displayInfo.defaultSchemaName){defaultDisplaySchemaName=displayInfo.defaultSchemaName;};config.directory.schemaRepository.getSchema({name:defaultDisplaySchemaName,onSuccess:function(schema){if(_this.displayControl.setSchema){_this.displayControl.setSchema(schema);};}});};config.couchEditor.setPanelName(_this.sidePanelName);var defaultEditSchemaName='object';if(editInfo&&editInfo.defaultSchemaName){defaultEditSchemaName=editInfo.defaultSchemaName;};config.directory.schemaRepository.getSchema({name:defaultEditSchemaName,onSuccess:function(schema){config.couchEditor.options.defaultEditSchema=schema;}});if(editInfo&&editInfo.newDocumentSchemaNames){if('ALL_SCHEMAS'===editInfo.newDocumentSchemaNames){config.couchEditor.setSchemas($n2.CouchEditor.Constants.ALL_SCHEMAS);}else if(editInfo.newDocumentSchemaNames.length){config.directory.schemaRepository.getSchemas({names:editInfo.newDocumentSchemaNames,onSuccess:function(schemas){config.couchEditor.setSchemas(schemas);},onError:function(err){$n2.log('Error obtaining new edit document schemas: '+err);}});};};if(_this.searchPanelName){config.directory.searchService.installSearchWidget({elem:$('#'+_this.searchPanelName)});};if(mapInfo){_this._initializeMap({config:config,onSuccess:opts.onSuccess,onError:opts.onError});}else{opts.onSuccess(_this);};};},_initializeMap:function(opts_){var opts=$n2.extend({config:null,onSuccess:function(moduleDisplay){},onError:function(err){}},opts_);var _this=this;var mapInfo=_this.module.getMapInfo();var addPointsOnly=false;if(mapInfo&&mapInfo.addPointsOnly){addPointsOnly=mapInfo.addPointsOnly;};var toggleClick=false;if(mapInfo&&mapInfo.toggleClick){toggleClick=mapInfo.toggleClick;};var dbSearchEngine={relMediaPath:'./'};if(mapInfo&&mapInfo.dbSearchEngine){dbSearchEngine=mapInfo.dbSearchEngine;};var mapOptions={dbSearchEngine:dbSearchEngine,mapIdentifier:_this.mapName,mapInteractionDivName:_this.mapInteractionName,mapCoordinateSpecifications:{initialBounds:null},uniqueIdentifier:'_id',addPointsOnly:addPointsOnly,overlays:[],toggleClick:toggleClick,sidePanelName:_this.sidePanelName,filterPanelName:_this.filterPanelName,saveFeature:_this.config.couchEditor,mapDisplay:{},directory:_this.config.directory,layerSwitcher:{suppress:false,initiallyOpened:false}};if(mapInfo&&mapInfo.layerSelector){if(mapInfo.layerSelector.suppress){mapOptions.layerSwitcher.suppress=true;};if(mapInfo.layerSelector.initiallyOpened){mapOptions.layerSwitcher.initiallyOpened=true;};};var initialBounds=null;if(mapInfo&&mapInfo.coordinates){initialBounds=mapInfo.coordinates.initialBounds;if(mapInfo.coordinates.srsName){if(false==isSrsNameSupported(mapInfo.coordinates.srsName)){var msg=_loc('The projection {srsName} is not supported. Atlas may no function properly.',{srsName:mapInfo.coordinates.srsName});alert(msg);};mapOptions.mapDisplay.srsName=mapInfo.coordinates.srsName;mapOptions.mapCoordinateSpecifications.srsName=mapInfo.coordinates.srsName;}else{mapOptions.mapDisplay.srsName='EPSG:4326';mapOptions.mapCoordinateSpecifications.srsName='EPSG:4326';};if(mapInfo.backgrounds){for(var i=0,e=mapInfo.backgrounds.length;i<e;++i){if('Google Maps'===mapInfo.backgrounds[i].type){mapOptions.mapDisplay.srsName='EPSG:900913';}else if('osm'===mapInfo.backgrounds[i].type){mapOptions.mapDisplay.srsName='EPSG:900913';}else if('stamen'===mapInfo.backgrounds[i].type){mapOptions.mapDisplay.srsName='EPSG:900913';};};};};if(mapInfo&&mapInfo.backgrounds){mapOptions.mapDisplay.backgrounds=[];for(var i=0,e=mapInfo.backgrounds.length;i<e;++i){var l=$n2.extend({},mapInfo.backgrounds[i]);if(l.type==='image'){if(l.options&&l.options.attachmentName){var url=_this.config.atlasDb.getAttachmentUrl(this.module.moduleDoc,l.options.attachmentName);l.options.url=url;};if(l.options&&l.options.extent&&mapOptions.mapDisplay.srsName!=mapOptions.mapCoordinateSpecifications.srsName){var defProj=new OpenLayers.Projection(mapOptions.mapCoordinateSpecifications.srsName);var mapProj=new OpenLayers.Projection(mapOptions.mapDisplay.srsName);var bl=new OpenLayers.Geometry.Point(l.options.extent[0],l.options.extent[1]);var tr=new OpenLayers.Geometry.Point(l.options.extent[2],l.options.extent[3]);bl.transform(defProj,mapProj);tr.transform(defProj,mapProj);l.options.extent[0]=bl.x;l.options.extent[1]=bl.y;l.options.extent[2]=tr.x;l.options.extent[3]=tr.y;};};mapOptions.mapDisplay.backgrounds.push(l);};};if(mapInfo&&mapInfo.overlays){var styleMapFn=_this.styleMapFn;if(!styleMapFn){styleMapFn=function(layerInfo_){return _this.styles.getStyleMapForLayerInfo(layerInfo_);};};for(var i=0,e=mapInfo.overlays.length;i<e;++i){var layerInfo=mapInfo.overlays[i];var layerDefinition={id:layerInfo.id,name:layerInfo.name,type:layerInfo.type,visibility:layerInfo.visibility,featurePopupHtmlFn:_this.config.popupHtmlFn,featurePopupDelay:0,styleMapFn:styleMapFn,useHoverSound:true,clustering:false};if($n2.isDefined(layerInfo.gutter)){layerDefinition.gutter=layerInfo.gutter;};if($n2.isDefined(layerInfo.displayInLayerSwitcher)){layerDefinition.displayInLayerSwitcher=layerInfo.displayInLayerSwitcher;};if('couchdb'===layerInfo.type){layerDefinition.options=$n2.extend({viewName:'geom',layerName:null,documentSource:_this.config.documentSource},layerInfo.options);if(!layerDefinition.options.layerName){layerDefinition.options.layerName=layerDefinition.id;};if(!layerDefinition.id&&layerDefinition.options&&layerDefinition.options.layerName){layerDefinition.id=layerDefinition.options.layerName;};}else{layerDefinition.options=layerInfo.options;};if(layerInfo.featurePopupDelayMs){layerDefinition.featurePopupDelay=layerInfo.featurePopupDelayMs;};if(typeof(layerInfo.useHoverSound)==='boolean'){layerDefinition.useHoverSound=layerInfo.useHoverSound;};if(layerInfo.clustering){layerDefinition.clustering=layerInfo.clustering;};mapOptions.overlays.push(layerDefinition);};};for(var i=0,e=mapOptions.overlays.length;i<e;++i){var layerDefinition=mapOptions.overlays[i];if(layerDefinition.type==='couchdb'){layerDefinition.sourceSrsName=mapOptions.mapDisplay.srsName;};};if(!initialBounds){opts.onError('Initial map extent not specified');return;};if(mapInfo&&mapInfo.coordinates&&mapInfo.coordinates.autoInitialBounds){computeAutoInitialBounds(mapOptions,initialBounds,mapInfo.coordinates.autoInitialBounds);}else{initialBoundsComputed(mapOptions,initialBounds);};function computeAutoInitialBounds(mapOptions,initialBounds,autoInitialBounds){var layerBoundingBox=null;var layersPending=0;for(var i=0,e=mapOptions.overlays.length;i<e;++i){var layerDef=mapOptions.overlays[i];if(layerDef.type==='couchdb'){++layersPending;var documentSource=layerDef.options.documentSource;var layerName=layerDef.options.layerName;documentSource.getGeographicBoundingBox({layerId:layerName,onSuccess:function(bbox){reportLayer(bbox);},onError:function(errorMsg){$n2.log('Error computing bounds for layer '+layerName+': '+errorMsg);reportLayer(null);}});};};testDone();function reportLayer(bounds){--layersPending;if(null==bounds){}else if(false==_this._isValidBounds(bounds)){}else{if(null==layerBoundingBox){layerBoundingBox=bounds;}else{if(layerBoundingBox[0]>bounds[0])layerBoundingBox[0]=bounds[0];if(layerBoundingBox[1]>bounds[1])layerBoundingBox[1]=bounds[1];if(layerBoundingBox[2]<bounds[2])layerBoundingBox[2]=bounds[2];if(layerBoundingBox[3]<bounds[3])layerBoundingBox[3]=bounds[3];};};testDone();};function testDone(){if(layersPending>0){return;};if(null==layerBoundingBox){initialBoundsComputed(mapOptions,initialBounds);return;};if(false==_this._isValidBounds(layerBoundingBox)){$n2.log('Invalid bounding box reported for layer in database.',layerBoundingBox);initialBoundsComputed(mapOptions,initialBounds);return;};var userInitialBounds=new OpenLayers.Bounds(initialBounds[0],initialBounds[1],initialBounds[2],initialBounds[3]);var layerInitialBounds=new OpenLayers.Bounds(layerBoundingBox[0],layerBoundingBox[1],layerBoundingBox[2],layerBoundingBox[3]);if(mapOptions.mapCoordinateSpecifications.srsName!=='EPSG:4326'){var userProj=new OpenLayers.Projection(mapOptions.mapCoordinateSpecifications.srsName);var dbProj=new OpenLayers.Projection('EPSG:4326');layerInitialBounds.transform(dbProj,userProj);};if(userInitialBounds.containsBounds(layerInitialBounds)){initialBoundsComputed(mapOptions,initialBounds);}else if(layerInitialBounds.getWidth()<userInitialBounds.getWidth()||layerInitialBounds.getHeight()<userInitialBounds.getHeight()){if(layerInitialBounds.getWidth()<userInitialBounds.getWidth()){var l=userInitialBounds.getWidth()/2;var m=(layerInitialBounds.left+layerInitialBounds.right)/2;layerInitialBounds.left=m-l;layerInitialBounds.right=m+l;};if(layerInitialBounds.getHeight()<userInitialBounds.getHeight()){var l=userInitialBounds.getHeight()/2;var m=(layerInitialBounds.bottom+layerInitialBounds.top)/2;layerInitialBounds.bottom=m-l;layerInitialBounds.top=m+l;};initialBoundsComputed(mapOptions,[layerInitialBounds.left,layerInitialBounds.bottom,layerInitialBounds.right,layerInitialBounds.top]);}else{initialBoundsComputed(mapOptions,[layerInitialBounds.left,layerInitialBounds.bottom,layerInitialBounds.right,layerInitialBounds.top]);};};};function initialBoundsComputed(mapOptions,initialBounds){mapOptions.mapCoordinateSpecifications.initialBounds=initialBounds;var mapInfo=_this.module.getMapInfo();if(mapInfo&&mapInfo.coordinates&&mapInfo.coordinates.maxExtent){mapOptions.mapCoordinateSpecifications.maxExtent=mapInfo.coordinates.maxExtent;}else if(mapOptions.mapDisplay.srsName!==null&&mapOptions.mapDisplay.srsName!=='EPSG:4326'){mapOptions.mapCoordinateSpecifications.maxExtent=mapOptions.mapCoordinateSpecifications.initialBounds;};_this.mapControl=nunaliit2.mapAndControls(mapOptions);$n2.log('module',_this);_this.mapControl.contributions=_this.config.contributions;_this.mapControl.requests=_this.config.directory.requestService;opts.onSuccess(_this);};},_navigationDocumentLoaded:function(doc){if(doc&&doc.nunaliit_navigation){var $title=$('#'+this.titleName);if($title.length>0){if(doc.nunaliit_navigation.title){var title=$n2.couchL10n.getLocalizedString(doc.nunaliit_navigation.title);$title.text(title);}else{$title.empty();};};var $nav=$('#'+this.navigationName);if($nav.length>0){$nav.empty();if(doc.nunaliit_navigation.items&&doc.nunaliit_navigation.items.length>0){var $ul=$('<ul></ul>');$nav.append($ul);insertItems($ul,doc.nunaliit_navigation.items);};};};function insertItems($ul,items){for(var i=0,e=items.length;i<e;++i){var item=items[i];var $li=$('<li></li>');$ul.append($li);if(item.title&&item.href){var $a=$('<a></a>');$a.attr('href',item.href);var title=$n2.couchL10n.getLocalizedString(item.title);$a.text(title);$li.append($a);}else if(item.title){var $span=$('<span></span>');var title=$n2.couchL10n.getLocalizedString(item.title);$span.text(title);$li.append($span);};if(item.items&&item.items.length>0){var $innerUl=$('<ul></ul>');$li.append($innerUl);insertItems($innerUl,item.items);};};};},_initSidePanel:function(){var _this=this;var customService=this._getCustomService();var $elem=$('#'+this.sidePanelName);var displayIntroFn=customService.getOption('moduleDisplayIntroFunction',null);if(displayIntroFn){displayIntroFn({elem:$elem,config:this.config,moduleDisplay:this});}else{this.module.displayIntro({elem:$elem,showService:this._getShowService(),onLoaded:function(){_this._sendDispatchMessage({type:'loadedModuleContent'});}});};},_getDispatcher:function(){var d=null;if(this.config.directory){d=this.config.directory.dispatchService;};return d;},_getShowService:function(){var ss=null;if(this.config.directory){ss=this.config.directory.showService;};return ss;},_getCustomService:function(){var cs=null;if(this.config.directory){cs=this.config.directory.customService;};return cs;},_sendDispatchMessage:function(m){var d=this._getDispatcher();if(d){d.send(DH,m);};},_isValidBounds:function(bounds){if(!bounds.length)return false;if(bounds.length<4)return false;if(bounds[0]<-180||bounds[0]>180)return false;if(bounds[2]<-180||bounds[2]>180)return false;if(bounds[1]<-90||bounds[1]>90)return false;if(bounds[3]<-90||bounds[3]>90)return false;return true;},_installModuleTitle:function($elem,text){var _this=this;var $a=$('<a class="nunaliit_module_title_link" href="#"></a>');$a.text(text);$elem.empty().append($a);$a.click(function(e){var d=_this._getDispatcher();if(d){d.send(DH,{type:'mapResetExtent'});};return true;});},_installHelpButton:function(){var _this=this;var $elem=$('#'+this.helpButtonName);if($elem.length<1)return;$elem.empty();var moduleInfo=this.module.getModuleInfo();if(moduleInfo.help&&moduleInfo.help.nunaliit_type==='reference'&&moduleInfo.help.doc){this.config.atlasDb.getDocument({docId:moduleInfo.help.doc,onSuccess:function(doc){if(doc&&doc.nunaliit_help&&doc.nunaliit_help.type==='html'&&doc.nunaliit_help.content){helpContentHtml(doc.nunaliit_help.content);}else{$n2.log('Do not know how to interpret help document');$elem.attr('n2_error','Do not know how to interpret help document');};},onError:function(err){$n2.log('Unable to load help document',err);$elem.attr('n2_error','Unable to load help document'+err);}});}else{$n2.log('Do not know how to handle help information');$elem.attr('n2_error','Do not know how to handle help information');};function helpContentHtml(baseContent){var content=_loc(baseContent);var $a=$('<a class="nunaliit_module_help_button" href="#"></a>');$a.text(_loc('Help'));$('#'+_this.helpButtonName).empty().append($a);$a.click(function(){if(!_this.helpDialogId){_this.helpDialogId=$n2.getUniqueId();};var $dialog=$('#'+_this.helpDialogId);if($dialog.length>0){var isOpen=$dialog.dialog('isOpen');if(isOpen){$dialog.dialog('close');}else{$dialog.dialog('open');};}else{$dialog=$('<div id="'+_this.helpDialogId+'" class="n2module_help_content"></div>');$dialog.html(content).appendTo($('body'));var initialHeight=$dialog.height();var windowHeight=$(window).height();var diagMaxHeight=Math.floor(windowHeight*0.8);var dialogOptions={autoOpen:true,dialogClass:'n2module_help_dialog',title:_loc('Help'),modal:false,width:400,position:{my:'right top',at:'right bottom',of:$('#'+_this.helpButtonName+' .nunaliit_module_help_button')},close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};if(initialHeight>diagMaxHeight){dialogOptions.height=diagMaxHeight;};$dialog.dialog(dialogOptions);};});};}});$n2.couchModule={ModuleDisplay:ModuleDisplay};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2',args);};var Export=$n2.Class('Export',{serverUrl:null,initialize:function(opts_){var opts=$n2.extend({url:null},opts_);this.serverUrl=opts.url;},checkAvailable:function(opts_){var opts=$n2.extend({onAvailable:function(){},onNotAvailable:function(){}},opts_);if(!this.serverUrl){opts.onNotAvailable();return;};var _this=this;$.ajax({url:this.serverUrl+'welcome',type:'GET',dataType:'json',success:function(data,textStatus,jqXHR){if(data&&data.ok){opts.onAvailable();}else{opts.onNotAvailable();};},error:function(jqXHR,textStatus,errorThrown){opts.onNotAvailable();}});},exportByDocIds:function(opts_){var opts=$n2.extend({docIds:null,targetWindow:null,geometryType:'all',contentType:null,fileName:null,onError:$n2.reportError},opts_);if(!opts.docIds){onError('docIds must be provided when exporting by docIds');};var target='';if(opts.targetWindow){target=' target="'+opts.targetWindow+'"';};var url=this.serverUrl+'export';if(opts.fileName){url=url+'/'+opts.fileName;};var $form=$('<form action="'+url+'" method="POST"'+target+'></form>');$('<input type="hidden" name="format" value="geojson"></input>').appendTo($form);$('<input type="hidden" name="method" value="doc-id"></input>').appendTo($form);$('<input type="hidden" name="filter"></input>').val(opts.geometryType).appendTo($form);if(opts.contentType){$('<input type="hidden" name="contentType"></input>').val(opts.contentType).appendTo($form);};for(var i=0,e=opts.docIds.length;i<e;++i){var docId=opts.docIds[i];$('<input type="hidden" name="name"></input>').val(docId).appendTo($form);};$('body').append($form);$form.submit();}});$n2.couchExport={Export:Export};})(jQuery,nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DispatchSupport=$n2.Class('DispatchSupport',{options:null,dispatcherHandle:null,docCreatedCb:null,docUpdatedCb:null,docRevisionMap:null,initialize:function(opts_){this.options=$n2.extend({db:null,directory:null},opts_);var _this=this;this.docRevisionMap={};this.docCreatedCb=function(doc){_this._docUploaded(doc,true);};this.docUpdatedCb=function(doc){_this._docUploaded(doc,false);};var dispatcher=this._getDispatcher();if(dispatcher){this.dispatcherHandle=dispatcher.getHandle('n2.couchDispatchSupport');var f=function(m){_this._handleDispatch(m);};dispatcher.register(this.dispatcherHandle,'documentCreated',f);dispatcher.register(this.dispatcherHandle,'documentUpdated',f);dispatcher.register(this.dispatcherHandle,'editClosed',f);};},_handleDispatch:function(m){if('documentCreated'===m.type){var requestService=this._getRequestService();if(requestService){requestService.requestDocument(m.docId,this.docCreatedCb);};}else if('documentUpdated'===m.type){var requestService=this._getRequestService();if(requestService){requestService.requestDocument(m.docId,this.docUpdatedCb);};}else if('editClosed'===m.type){};},_docUploaded:function(doc,created){if(doc.nunaliit_geom){var type=created?'featureCreated':'featureUpdated';this._dispatch({type:type,docId:doc._id,doc:doc});};var type=created?'documentContentCreated':'documentContentUpdated';this._dispatch({type:type,docId:doc._id,doc:doc});},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_dispatch:function(m){var dispatcher=this._getDispatcher();if(dispatcher){dispatcher.send(this.dispatcherHandle,m);};},_getRequestService:function(){var r=null;if(this.options.directory){r=this.options.directory.requestService;};return r;}});$n2.couchDispatchSupport={DispatchSupport:DispatchSupport};})(nunaliit2);;(function($n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchEvents';var EventSupport=$n2.Class('EventSupport',{options:null,dispatchCallback:null,handler:null,registeredEvents:null,initialize:function(opts_){this.options=$n2.extend({directory:null},opts_);var _this=this;this.registeredEvents={};this.handler=function(m){_this._defaultHandler(m);};this.dispatchCallback=function(m){_this.handler(m);};this.register('userSelect');this.register('userUnselect');this.register('userFocusOn');this.register('userFocusOff');},register:function(type){if(!this.registeredEvents[type]){var d=this._getDispatcher();if(d){d.register(DH,type,this.dispatchCallback);};this.registeredEvents[type]=true;};},setHandler:function(handler){if(typeof(handler)==='function'){this.handler=handler;};},getHandler:function(){return this.handler;},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_dispatch:function(m){var d=this._getDispatcher();if(d){d.send(DH,m);};},_defaultHandler:function(m){if('userSelect'===m.type){var forward={type:'selected'};for(var key in m){if('type'===key){forward.type='selected';}else{forward[key]=m[key];};};this._dispatch(forward);}else if('userUnselect'===m.type){this._dispatch({type:'unselected',docId:m.docId,doc:m.doc,feature:m.feature});}else if('userFocusOn'===m.type){this._dispatch({type:'focusOn',docId:m.docId,doc:m.doc,feature:m.feature});}else if('userFocusOff'===m.type){this._dispatch({type:'focusOff',docId:m.docId,doc:m.doc,feature:m.feature});};}});$n2.couchEvents={EventSupport:EventSupport};})(nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};function isKeyEditingAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;return true;}
function isValueEditingAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;return true;};function isKeyDeletionAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;return true;};function _parseError(XMLHttpRequest,textStatus){var err=$n2.utils.parseHttpJsonError(XMLHttpRequest,textStatus);if(err.tokenExpired){return _loc('The information is expired.');};if(err.userUpdated){return _loc('Unable to complete operation because the user information has been updated.');};return _loc('Unable to complete operation : {err}',{err:err.error});};var UserEditor=$n2.Class({userDoc:null,userSchema:null,schemaEditorService:null,configService:null,originalDoc:null,userDb:null,elemId:null,schemaEditor:null,treeEditor:null,onPreSaveFn:null,onSavedFn:null,onPreDeleteFn:null,onDeletedFn:null,onCancelledFn:null,onFinishedFn:null,initialize:function(opts_){var opts=$n2.extend({userDoc:null,userDb:null,elem:null,elemId:null,userSchema:null,schemaRepository:null,schemaEditorService:null,configService:null,onPreSaveFn:function(userDoc){return true;},onSavedFn:function(userDoc){},onPreDeleteFn:function(userDoc){return true;},onDeletedFn:function(userDoc){},onCancelledFn:function(userDoc){},onFinishedFn:function(userDoc){}},opts_);var _this=this;this.userDoc=opts.userDoc;this.userDb=opts.userDb;this.onPreSaveFn=opts.onPreSaveFn;this.onSavedFn=opts.onSavedFn;this.onPreDeleteFn=opts.onPreDeleteFn;this.onDeletedFn=opts.onDeletedFn;this.onCancelledFn=opts.onCancelledFn;this.onFinishedFn=opts.onFinishedFn;this.schemaEditorService=opts.schemaEditorService;this.configService=opts.configService;this.originalDoc=$n2.extend(true,{},this.userDoc);if(!this.userDoc.nunaliit_emails){this.userDoc.nunaliit_emails=[];};this.elemId=opts.elemId;if(opts.elem){var $elem=$(opts.elem);var id=$elem.attr('id');if(!id){id=$n2.getUniqueId();$elem.attr('id',id);};this.elemId=id;};if(opts.userSchema){userSchemaLoaded(opts.userSchema);}else if(opts.schemaRepository){opts.schemaRepository.getSchema({name:'user',onSuccess:function(schema){userSchemaLoaded(schema);},onError:function(){userSchemaLoaded(null);}});}else{userSchemaLoaded(null);};function userSchemaLoaded(userSchema){_this.userSchema=userSchema;_this._display();};},documentUpdated:function(){this._refresh();},_getElem:function(){return $('#'+this.elemId);},_getCouchServer:function(){return this.userDb.server;},_display:function(){var _this=this;var doc=this.userDoc;var $elem=this._getElem();$elem.empty();var $editor=$('<div class="n2UserEdit_editor"></div>').appendTo($elem);var $editorsContainer=$('<div class="n2UserEdit_editorContainer"></div>').appendTo($editor);var usingAccordion=false;if(this.userSchema&&this.schemaEditorService){usingAccordion=true;$n2.schema.GlobalAttributes.disableKeyUpEvents=true;$('<h3><a href="#">'+_loc('Form View')+'</a></h3>').appendTo($editorsContainer);var $schemaContainer=$('<div class="n2UserEdit_schemaEditor"></div>').appendTo($editorsContainer);this.schemaEditor=this.schemaEditorService.editDocument({doc:doc,schema:this.userSchema,$div:$schemaContainer,onChanged:function(){if(_this.treeEditor){_this.treeEditor.refresh();};}});};if(usingAccordion){$('<h3><a href="#">'+_loc('Tree View')+'</a></h3>').appendTo($editorsContainer);};var $treeContainer=$('<div class="n2UserEdit_treeEditor"></div>').appendTo($editorsContainer);var objectTree=new $n2.tree.ObjectTree($treeContainer,doc);this.treeEditor=new $n2.tree.ObjectTreeEditor(objectTree,doc,{onObjectChanged:function(){if(_this.schemaEditor){_this.schemaEditor.refresh();};},isKeyEditingAllowed:isKeyEditingAllowed,isValueEditingAllowed:isValueEditingAllowed,isKeyDeletionAllowed:isKeyDeletionAllowed});if(usingAccordion){$editorsContainer.accordion({heightStyle:'content',autoHeight:false,clearStyle:true});};var $buttons=$('<div class="n2UserEdit_buttons"></div>').appendTo($editor);$('<input type="button"/>').addClass('n2UserEdit_saveButton').val(_loc('Save')).appendTo($buttons).click(function(){_this._save();return false;});$('<input type="button"/>').addClass('n2UserEdit_deleteButton').val(_loc('Delete')).appendTo($buttons).click(function(){_this._delete();return false;});$('<input type="button"/>').addClass('n2UserEdit_rolesButton').val(_loc('Roles')).appendTo($buttons).click(function(e){_this._rolesDialog(doc,function(roles){if(roles.length>0){doc.roles=roles;}else if(doc.roles){delete doc.roles;};_this.treeEditor.refresh();});return false;});$('<input type="button"/>').addClass('n2UserEdit_passwordButton').val(_loc('Set Password')).appendTo($buttons).click(function(e){_this._passwordDialog();return false;});$('<input type="button"/>').addClass('n2UserEdit_cancelButton').val(_loc('Cancel')).appendTo($buttons).click(function(e){_this._cancel();return false;});},_refresh:function(){this.treeEditor.refresh();},_rolesDialog:function(userDoc,selectedRolesFn){var diagId=$n2.getUniqueId();var $rolesDialog=$('<div id="'+diagId+'" class="n2_roles_dialog"></div>');$('<div class="n2_roles_list"></div>').appendTo($rolesDialog).append($('<div class="olkit_wait"></div>'));var $buttons=$('<div class="n2_roles_buttons"></div>').appendTo($rolesDialog);$('<input type="button"/>').val(_loc('OK')).appendTo($buttons).click(function(){var $dialog=$('#'+diagId);var roles=[];$dialog.find('input[type=checkbox]:checked').each(function(){var $input=$(this);roles.push($input.attr('name'));});selectedRolesFn(roles);$dialog.dialog('close');});$('<input type="button"/>').val(_loc('Cancel')).appendTo($buttons).click(function(){$('#'+diagId).dialog('close');});var dialogOptions={autoOpen:true,title:_loc('Select Roles'),modal:true,width:740,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$rolesDialog.dialog(dialogOptions);if(this.configService){this.configService.getNunaliitServerRoles({onSuccess:function(roles){loadedRoles(roles);},onError:function(err){loadedRoles([]);}});}else{loadedRoles([]);};function loadedRoles(roles){var roleMap={};for(var i=0,e=roles.length;i<e;++i){roleMap[roles[i]]=false;};if(userDoc.roles){for(var i=0,e=userDoc.roles.length;i<e;++i){roleMap[userDoc.roles[i]]=true;};};roles=[];for(var role in roleMap){roles.push(role);};roles.sort();var $list=$('#'+diagId).find('.n2_roles_list');$list.empty();for(var i=0,e=roles.length;i<e;++i){var role=roles[i];var $div=$('<div></div>');var id=$n2.getUniqueId();var $input=$('<input type="checkbox"/>').attr('name',role).attr('id',id).appendTo($div);if(roleMap[role]){$input.attr('checked',"checked");};$('<label/>').attr('for',id).text(role).appendTo($div);$list.append($div);};};},_passwordDialog:function(){var _this=this;var diagId=$n2.getUniqueId();var $passwordDialog=$('<div id="'+diagId+'" class="n2User_setPassword_dialog"></div>');var $passwordInputs=$('<div class="n2User_setPassword_inputs"></div>').appendTo($passwordDialog);var id=$n2.getUniqueId();var $div=$('<div></div>').appendTo($passwordInputs);$('<label/>').attr('for',id).text(_loc('Enter password:')).appendTo($div);$('<input type="password" name="password"/>').attr('id',id).appendTo($div);var id=$n2.getUniqueId();var $div=$('<div></div>').appendTo($passwordInputs);$('<label/>').attr('for',id).text(_loc('Confirm password:')).appendTo($div);$('<input type="password" name="confirm"/>').attr('id',id).appendTo($div);var $buttons=$('<div class="n2User_setPassword_buttons"></div>').appendTo($passwordDialog);$('<input type="button"/>').val(_loc('OK')).appendTo($buttons).click(function(){var $dialog=$('#'+diagId);var pw1=$dialog.find('input[name=password]').val();var pw2=$dialog.find('input[name=confirm]').val();if(pw1!=pw2){alert(_loc('Passwords do not match'));}else if(pw1.length<6){alert(_loc('Password is too short'));}else{_this.userDb.computeUserPassword({userDoc:_this.userDoc,password:pw1,onSuccess:function(){_this._refresh();$dialog.dialog('close');},onError:function(errMsg){alert(_loc('Unable to set password: ')+errMsg);}});};});$('<input type="button"/>').val(_loc('Cancel')).appendTo($buttons).click(function(){$('#'+diagId).dialog('close');});var dialogOptions={autoOpen:true,title:_loc('Change Password'),modal:true,width:740,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$passwordDialog.dialog(dialogOptions);},_save:function(){var _this=this;this.onPreSaveFn(this.userDoc);this.userDb.updateUser({user:this.userDoc,onSuccess:function(docInfo){_this.userDoc._rev=docInfo.rev;_this.originalDoc=$n2.extend(true,{},_this.userDoc);_this._refresh();_this.onSavedFn(_this.userDoc);_this.onFinishedFn(_this.userDoc);},onError:function(errMsg){alert(_loc('Unable to save user document: ')+errMsg);}});},_delete:function(){var _this=this;if(false==confirm('You are about delete a user configuration object. Do you wish to proceed?')){return;};this.onPreDeleteFn(this.userDoc);this.userDb.deleteUser({user:this.userDoc,onSuccess:function(){var $elem=_this._getElem();$elem.empty();_this.onDeletedFn(_this.userDoc);_this.onFinishedFn(_this.userDoc);},onError:function(errMsg){alert(_loc('Unable to delete user document: ')+errMsg);}});},_cancel:function(){var patch=patcher.computePatch(this.originalDoc,this.userDoc);if(patch){if(false==confirm(_loc('Document was modified and changes will be lost. Do you wish to continue?'))){return;};};var $elem=this._getElem();$elem.empty();this.onCancelledFn(this.userDoc);this.onFinishedFn(this.userDoc);}});var UserService=$n2.Class({userDb:null,userServerUrl:null,userSchema:null,schemaRepository:null,schemaEditorService:null,configService:null,initialize:function(opts_){var opts=$n2.extend({userDb:null,userServerUrl:null,configService:null,userSchema:null,schemaRepository:null,schemaEditorService:null},opts_);this.userDb=opts.userDb;this.userServerUrl=opts.userServerUrl;this.configService=opts.configService;this.userSchema=opts.userSchema;this.schemaRepository=opts.schemaRepository;this.schemaEditorService=opts.schemaEditorService;},startEdit:function(opts_){var opts=$n2.extend({userSchema:this.userSchema,schemaRepository:this.schemaRepository,schemaEditorService:this.schemaEditorService},opts_,{userDb:this.userDb,configService:this.configService});return new UserEditor(opts);},initiateUserCreation:function(opts_){var opts=$n2.extend({emailAddress:null,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'initUserCreation';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{email:opts.emailAddress},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},validateUserCreation:function(opts_){var opts=$n2.extend({token:null,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'validateUserCreation';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{token:opts.token},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},completeUserCreation:function(opts_){var opts=$n2.extend({token:null,displayName:null,password:null,sendEmailPasswordReminder:false,userAgreement:null,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'completeUserCreation';$.ajax({url:url,type:'POST',async:true,traditional:true,data:{token:opts.token,display:opts.displayName,password:opts.password,emailPassword:opts.sendEmailPasswordReminder,userAgreement:opts.userAgreement},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},initiatePasswordRecovery:function(opts_){var opts=$n2.extend({emailAddress:null,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'initPasswordRecovery';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{email:opts.emailAddress},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},validatePasswordRecovery:function(opts_){var opts=$n2.extend({token:null,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'validatePasswordRecovery';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{token:opts.token},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},completePasswordRecovery:function(opts_){var opts=$n2.extend({token:null,password:null,sendEmailPasswordReminder:false,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'completePasswordRecovery';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{token:opts.token,password:opts.password,emailPassword:opts.sendEmailPasswordReminder},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},generatePassword:function(opts_){var opts=$n2.extend({onSuccess:function(password){},onError:function(err){}},opts_);var url=this.userServerUrl+'generatePassword';$.ajax({url:url,type:'GET',async:true,traditional:true,data:{},dataType:'json',success:function(result){if(result.error){opts.onError(result.error);}else{opts.onSuccess(result.password);};},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});},acceptUserAgreement:function(opts_){var opts=$n2.extend({userAgreement:null,onSuccess:function(){},onError:function(err){}},opts_);var url=this.userServerUrl+'acceptUserAgreement';$.ajax({url:url,type:'POST',async:true,traditional:true,data:{userAgreement:opts.userAgreement},dataType:'json',success:function(result){opts.onSuccess();},error:function(XMLHttpRequest,textStatus,errorThrown){var err=_parseError(XMLHttpRequest,textStatus);opts.onError(err);}});}});$n2.couchUser={UserEditor:UserEditor,UserService:UserService};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var HelpDocument=$n2.Class({db:null,doc:null,initialize:function(opts_){var opts=$n2.extend({db:null,doc:null},opts_);this.db=opts.db;this.doc=opts.doc;},getHtmlDescription:function(opts_){var opts=$n2.extend({onSuccess:function(html){},onError:function(err){}},opts_);var doc=this.doc;if(doc&&doc.nunaliit_help&&doc.nunaliit_help.nunaliit_type==='help'){var help=doc.nunaliit_help;if('attachment'===help.type){this._getAttachment(opts);return;}else if('html'===help.type){this._getHtml(opts);return;}else if('text'===help.type){this._getText(opts);return;}};opts.onError(_loc('Invalid help document content'));},_getAttachment:function(opts){var doc=this.doc;if(doc.nunaliit_help.attachmentName){var localeStr=$n2.l10n.getStringForLocale(doc.nunaliit_help.attachmentName);if(localeStr.str){var attUrl=this.db.getAttachmentUrl(doc,localeStr.str);$.ajax({url:attUrl,type:'get',async:true,success:function(intro){if(localeStr.fallback){var $outer=$('<span class="n2_localized_string n2_localize_fallback"></span>');$('<span class="n2_localize_fallback_lang"></span>').text('('+localeStr.lang+')').appendTo($outer);$('<span></span>').html(intro).appendTo($outer);opts.onSuccess($outer.html());}else{opts.onSuccess(intro);};},error:function(XMLHttpRequest,textStatus,errorThrown){opts.onError(_loc('Error fetching attachment from help document'));}});return;};};opts.onError(_loc('Invalid attachment in help document'));},_getHtml:function(opts){var doc=this.doc;if(doc.nunaliit_help.content){var localeStr=$n2.l10n.getStringForLocale(doc.nunaliit_help.content);if(localeStr.str){if(localeStr.fallback){var $outer=$('<span class="n2_localized_string n2_localize_fallback"></span>');$('<span class="n2_localize_fallback_lang"></span>').text('('+localeStr.lang+')').appendTo($outer);$('<span></span>').html(localeStr.str).appendTo($outer);opts.onSuccess($outer.html());}else{opts.onSuccess(localeStr.str);};return;};};opts.onError(_loc('Invalid content in help document'));},_getText:function(opts){var doc=this.doc;if(doc.nunaliit_help.content){var localeStr=$n2.l10n.getStringForLocale(doc.nunaliit_help.content);if(localeStr.str){if(localeStr.fallback){var $outer=$('<span class="n2_localized_string n2_localize_fallback"></span>');$('<span class="n2_localize_fallback_lang"></span>').text('('+localeStr.lang+')').appendTo($outer);$('<span></span>').text(localeStr.str).appendTo($outer);opts.onSuccess($outer.html());}else{var $outer=$('<span class="n2_localized_string"></span>').text(localeStr.str);opts.onSuccess($outer.html());};return;};};opts.onError(_loc('Invalid content in help document'));}});var LoadHelpDocument=function(opts_){var opts=$n2.extend({db:null,id:null,onSuccess:function(helpDoc){},onError:function(err){}},opts_);if(!opts.db){opts.onError(_loc('A database must be provided'));};if(!opts.id){opts.onError(_loc('A document identifier must be provided'));};opts.db.getDocument({docId:opts.id,onSuccess:function(doc){var hd=new HelpDocument({db:opts.db,doc:doc});opts.onSuccess(hd);},onError:function(errorMsg){opts.onError(_loc('Unable to access help document: {{docId}}',{docId:opts.id}));}});};var CheckBrowserCompliance=function(opts_){var opts=$n2.extend({db:null,helpDocumentId:'help.browsers'},opts_);var browserInfo=$n2.utils.getBrowserInfo();if(browserInfo&&browserInfo.browser==='Explorer'){if(typeof(browserInfo.version)==='number'){if(browserInfo.version==9||browserInfo.version<8){reportUnsupportedBrowser(opts);};};};function reportUnsupportedBrowser(opts){LoadHelpDocument({db:opts.db,id:opts.helpDocumentId,onSuccess:function(helpDoc){helpDoc.getHtmlDescription({onSuccess:function(html){openDialog(html);},onError:error});},onError:error});function error(){alert(_loc('Your browser is not supported by this web site.'));};};function openDialog(htmlContent){var helpDialogId=$n2.getUniqueId();var $dialog=$('<div id="'+helpDialogId+'" class="n2module_help_content"></div>');$dialog.html(htmlContent).appendTo($('body'));var initialHeight=$dialog.height();var windowHeight=$(window).height();var diagMaxHeight=Math.floor(windowHeight*0.8);var dialogOptions={autoOpen:true,dialogClass:'n2module_help_dialog',title:_loc('Unsupported Browser'),modal:true,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};if(initialHeight>diagMaxHeight){dialogOptions.height=diagMaxHeight;};$dialog.dialog(dialogOptions);};};$n2.couchHelp={LoadHelpDocument:LoadHelpDocument,CheckBrowserCompliance:CheckBrowserCompliance};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var DH='n2.couchDocument';function adjustDocument(doc){var userName=null;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext){userName=sessionContext.name;};var nowTime=(new Date()).getTime();if(userName){if(null==doc.nunaliit_created){doc.nunaliit_created={nunaliit_type:'actionstamp',name:userName,time:nowTime,action:'created'};};doc.nunaliit_last_updated={nunaliit_type:'actionstamp',name:userName,time:nowTime,action:'updated'};};var dates=[];$n2.couchUtils.extractSpecificType(doc,'date',dates);for(var i=0,e=dates.length;i<e;++i){var d=dates[i];if(d.date){try{var dateInt=$n2.date.parseUserDate(d.date);d.min=dateInt.min;d.max=dateInt.max;}catch(e){if(d.min)delete d.min;if(d.max)delete d.max;};};};}
var CouchDataSource=$n2.Class($n2.document.DataSource,{db:null,designDoc:null,dispatchService:null,geometryRepository:null,initialize:function(opts_){var opts=$n2.extend({id:null,db:null,dispatchService:null},opts_);$n2.document.DataSource.prototype.initialize.call(this,opts);this.db=opts.db;this.dispatchService=opts.dispatchService;this.designDoc=this.db.getDesignDoc({ddName:'atlas'});this.geometryRepository=new GeometryRepository({db:this.db,designDoc:this.designDoc,dispatchService:this.dispatchService});},createDocument:function(opts_){var opts=$n2.extend({doc:{},onSuccess:function(doc){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var _this=this;var doc=opts.doc;adjustDocument(doc);this.db.createDocument({data:doc,onSuccess:function(docInfo){doc._id=docInfo.id;doc._rev=docInfo.rev;doc.__n2Source=this;_this._dispatch({type:'documentVersion',docId:docInfo.id,rev:docInfo.rev});_this._dispatch({type:'documentCreated',docId:docInfo.id});opts.onSuccess(doc);},onError:opts.onError});},getDocument:function(opts_){var opts=$n2.extend({docId:null,rev:null,revs_info:false,revisions:false,conflicts:false,deleted_conflicts:false,onSuccess:function(doc){},onError:function(errorMsg){}},opts_);this.db.getDocument({docId:opts.docId,rev:opts.rev,revs_info:opts.revs_info,revisions:opts.revisions,conflicts:opts.conflicts,deleted_conflicts:opts.deleted_conflicts,onSuccess:function(doc){doc.__n2Source=this;opts.onSuccess(doc);},onError:opts.onError});},getDocumentAttachmentUrl:function(doc,attachmentName){return this.db.getAttachmentUrl(doc,attachmentName);},verifyDocumentExistence:function(opts_){var opts=$n2.extend({docIds:null,onSuccess:function(info){},onError:function(errorMsg){}},opts_);var docIds=opts.docIds;this.db.getDocumentRevisions({docIds:docIds,onSuccess:function(info){var result={};for(var id in info){result[id]={rev:info[id]};};opts.onSuccess(result);},onError:opts.onError});},updateDocument:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(doc){},onError:function(errorMsg){}},opts_);var _this=this;var doc=opts.doc;adjustDocument(doc);var copy={};for(var key in doc){if(key==='__n2Source'){}else{copy[key]=doc[key];};};this.db.updateDocument({data:copy,onSuccess:function(docInfo){doc._rev=docInfo.rev;_this._dispatch({type:'documentVersion',docId:docInfo.id,rev:docInfo.rev});_this._dispatch({type:'documentUpdated',docId:docInfo.id});opts.onSuccess(doc);},onError:opts.onError});},deleteDocument:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var _this=this;var doc=opts.doc;var copy={};for(var key in doc){if(key==='__n2Source'){}else{copy[key]=doc[key];};};this.db.deleteDocument({data:copy,onSuccess:function(docInfo){_this._dispatch({type:'documentDeleted',docId:doc._id});opts.onSuccess();},onError:opts.onError});},getLayerDefinitions:function(opts_){var opts=$n2.extend({onSuccess:function(layerDefinitions){},onError:function(errorMsg){}},opts_);this.designDoc.queryView({viewName:'layer-definitions',onSuccess:function(rows){var layerIdentifiers=[];for(var i=0,e=rows.length;i<e;++i){if(rows[i].nunaliit_layer_definition){var d=rows[i].nunaliit_layer_definition;if(!d.id){d.id=rows[i]._id;};layerIdentifiers.push(d);};};opts.onSuccess(layerIdentifiers);},onError:opts.onError});},getDocumentInfoFromIds:function(opts_){var opts=$n2.extend({docIds:null,onSuccess:function(docInfos){},onError:function(errorMsg){}},opts_);this.designDoc.queryView({viewName:'info',keys:opts.docIds,onSuccess:function(rows){var infos=[];for(var i=0,e=rows.length;i<e;++i){infos.push(rows[i].value);};opts.onSuccess(infos);},onError:opts.onError});},getReferencesFromId:function(opts_){var opts=$n2.extend({docId:null,onSuccess:function(referenceIds){},onError:function(errorMsg){}},opts_);this.designDoc.queryView({viewName:'link-references',startkey:opts.docId,endkey:opts.docId,onSuccess:function(rows){var refIdMap={};for(var i=0,e=rows.length;i<e;++i){refIdMap[rows[i].id]=true;};var refIds=[];for(var refId in refIdMap){refIds.push(refId);};opts.onSuccess(refIds);},onError:opts.onError});},getDocumentsFromGeographicFilter:function(opts_){var opts=$n2.extend({docIds:null,layerId:null,bbox:null,projectionCode:null,onSuccess:function(docs){},onError:function(errorMsg){}},opts_);var callerSuccess=opts.onSuccess;opts.onSuccess=function(docs){for(var i=0,e=docs.length;i<e;++i){docs[i].__n2Source=this;};callerSuccess(docs);};this.geometryRepository.getDocumentsFromGeographicFilter(opts);},getGeographicBoundingBox:function(opts_){this.geometryRepository.getGeographicBoundingBox(opts_);},getReferencesFromOrigin:function(opts_){var opts=$n2.extend({docId:null,onSuccess:function(originReferenceIds){},onError:function(errorMsg){}},opts_);this.designDoc.queryView({viewName:'nunaliit-origin',startkey:opts.docId,endkey:opts.docId,onSuccess:function(rows){var refIdMap={};for(var i=0,e=rows.length;i<e;++i){refIdMap[rows[i].id]=true;};var refIds=[];for(var refId in refIdMap){refIds.push(refId);};opts.onSuccess(refIds);},onError:opts.onError});},getUniqueIdentifier:function(opts_){var opts=$n2.extend({onSuccess:function(uuid){},onError:function(errorMsg){}},opts_);var server=this.db.server;server.getUniqueId(opts);},_dispatch:function(m){if(this.dispatchService){this.dispatchService.send(DH,m);};}});var GeometryRepository=$n2.Class({db:null,designDoc:null,dispatchService:null,dbProjection:null,poles:null,mapProjectionMaxWidth:null,initialize:function(opts_){var opts=$n2.extend({db:null,designDoc:null,dispatchService:null},opts_);this.db=opts.db;this.designDoc=opts.designDoc;this.dispatchService=opts.dispatchService;this.dbProjection=new OpenLayers.Projection('EPSG:4326');this.poles={n:{},s:{}};this.mapProjectionMaxWidth={};},getDocumentsFromGeographicFilter:function(opts_){var opts=$n2.extend({docIds:null,layerId:null,bbox:null,projectionCode:null,onSuccess:function(docs){},onError:function(errorMsg){}},opts_);var _this=this;var viewQuery={viewName:'geom',onSuccess:handleDocs,onError:opts.onError};var bounds=opts.bbox;var fids=opts.docIds;var layerName=('string'===typeof(opts.layerId)?opts.layerId:null);if(bounds&&opts.projectionCode&&opts.projectionCode!=this.dbProjection.getCode()){var mapProjection=new OpenLayers.Projection(opts.projectionCode);var mapBounds=new OpenLayers.Bounds(bounds[0],bounds[1],bounds[2],bounds[3]);var dbBounds=mapBounds.clone().transform(mapProjection,this.dbProjection);var np=this._getPole(true,mapProjection);if(np&&mapBounds.contains(np.x,np.y)){var northBoundary=new OpenLayers.Bounds(-180,90,180,90);dbBounds.extend(northBoundary);};var sp=this._getPole(false,mapProjection);if(sp&&mapBounds.contains(sp.x,sp.y)){var southBoundary=new OpenLayers.Bounds(-180,-90,180,-90);dbBounds.extend(southBoundary);};bounds=[dbBounds.left,dbBounds.bottom,dbBounds.right,dbBounds.top];var maxWidth=this._getMapMaxWidth(mapProjection);if(maxWidth&&maxWidth<=(mapBounds.right-mapBounds.left)){bounds[0]=-180;bounds[2]=180;};};$n2.couchGeom.selectTileViewFromBounds(viewQuery,bounds,layerName,fids);this.designDoc.queryView(viewQuery);function handleDocs(rows){var docIds=[];var docs=[];while(rows.length>0){var row=rows.pop();var docId=row.id;if(_this.dispatchService){var m={type:'cacheRetrieveDocument',docId:docId,doc:null};_this.dispatchService.synchronousCall(DH,m);if(m.doc){docs.push(m.doc);}else{docIds.push(docId);};}else{docIds.push(docId);};};if(docIds.length>0){_this.db.getDocuments({docIds:docIds,onSuccess:function(docs_){for(var i=0,e=docs_.length;i<e;++i){docs.push(docs_[i]);};opts.onSuccess(docs);},onError:opts.onError});}else{opts.onSuccess(docs);};};},getGeographicBoundingBox:function(opts_){var opts=$n2.extend({layerId:null,bbox:null,onSuccess:function(bbox){},onError:function(errorMsg){}},opts_);this.designDoc.queryView({viewName:'geom-layer-bbox',startkey:opts.layerId,endkey:opts.layerId,onlyRows:true,reduce:true,onSuccess:function(rows){if(rows.length>0){opts.onSuccess(rows[0].value);}else{opts.onSuccess(null);};},onError:opts.onError});},_getPole:function(isNorth,mapProjection){var projCode=mapProjection.getCode();var label=isNorth?'n':'s';if(this.poles[label][projCode])return this.poles[label][projCode];if(isNorth){var p=new OpenLayers.Geometry.Point(0,90);}else{var p=new OpenLayers.Geometry.Point(0,-90);};var error=false;var previousFn=null;if(typeof(Proj4js)!=='undefined'){previousFn=Proj4js.reportError;Proj4js.reportError=function(m){error=true;};};p.transform(this.dbProjection,mapProjection);if(error){p=null;};if(previousFn){Proj4js.reportError=previousFn;};this.poles[label][projCode]=p;return p;},_getMapMaxWidth:function(proj){var projCode=proj.getCode();if(this.mapProjectionMaxWidth[projCode]){return this.mapProjectionMaxWidth[projCode];};if(proj&&proj.proj&&proj.proj.projName==='merc'){var w=new OpenLayers.Geometry.Point(-180,0);var e=new OpenLayers.Geometry.Point(180,0);var error=false;var previousFn=null;if(typeof(Proj4js)!=='undefined'){previousFn=Proj4js.reportError;Proj4js.reportError=function(m){error=true;};};w.transform(this.dbProjection,proj);e.transform(this.dbProjection,proj);if(error){w=null;e=null;};if(previousFn){Proj4js.reportError=previousFn;};if(e&&w){this.mapProjectionMaxWidth[projCode]=w.x-e.x;};};return this.mapProjectionMaxWidth[projCode];}});var CouchDataSourceWithSubmissionDb=$n2.Class(CouchDataSource,{submissionDb:null,submissionServerUrl:null,submissionServerDb:null,isSubmissionDataSource:null,initialize:function(opts_){var opts=$n2.extend({submissionDb:null,submissionServletUrl:null},opts_);CouchDataSource.prototype.initialize.call(this,opts);var _this=this;this.isSubmissionDataSource=true;this.submissionDb=opts.submissionDb;this.submissionServerUrl=opts.submissionServerUrl;var submissionServer=$n2.couch.getServer({pathToServer:this.submissionServerUrl,skipSessionInitialization:true,userDbName:'_users',onSuccess:function(server){_this.submissionServerDb=server.getDb({dbName:'submissionDb'});},onError:function(err){$n2.log("Unable to initialize submission server",err);alert(_loc('Unable to initialize submission database'));}});},createDocument:function(opts_){var opts=$n2.extend({doc:{},onSuccess:function(doc){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var _this=this;if(!opts.doc){opts.onError('Document must be provided');};if(opts.doc._id){onUuidComputed(opts.doc._id);}else{var server=this.db.server;if(server){server.getUniqueId({onSuccess:onUuidComputed,onError:opts.onError});};};function onUuidComputed(docId){var doc=opts.doc;doc._id=docId;adjustDocument(doc);_this.submissionServerDb.createDocument({data:doc,onSuccess:function(docInfo){_this._warnUser();doc.__n2Source=this;opts.onSuccess(doc);},onError:opts.onError});};},updateDocument:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(doc){},onError:function(errorMsg){}},opts_);var _this=this;var doc=opts.doc;adjustDocument(doc);var copy={};for(var key in doc){if(key==='__n2Source'){}else{copy[key]=doc[key];};};this.submissionServerDb.updateDocument({data:copy,onSuccess:function(docInfo){_this._warnUser();opts.onSuccess(doc);},onError:opts.onError});},deleteDocument:function(opts_){var opts=$n2.extend({doc:null,onSuccess:function(){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var _this=this;var doc=opts.doc;this.submissionServerDb.deleteDocument({data:doc,onSuccess:function(docInfo){_this._warnUser();opts.onSuccess(doc);},onError:opts.onError});},_warnUser:function(){var shouldWarnUser=true;var c=$n2.cookie.getCookie('nunaliit_submissions');if(c){shouldWarnUser=false;};if(shouldWarnUser){var diagId=$n2.getUniqueId();var $diag=$('<div>').attr('id',diagId).addClass('n2_submission_warning_dialog');var $text=$('<div>').addClass('n2_submission_warning_text').appendTo($diag);$('<span>').text(_loc('Submissions to the database will not appear until they are approved')).appendTo($diag);var $mem=$('<div>').addClass('n2_submission_warning_memory').appendTo($diag);var cbId=$n2.getUniqueId();$('<input type="checkbox">').attr('id',cbId).appendTo($mem);$('<label>').attr('for',cbId).text(_loc('Do not show this warning again')).appendTo($mem);var $buttons=$('<div>').addClass('n2_submission_warning_buttons').appendTo($diag);$('<button>').addClass('n2_button_ok').appendTo($buttons).text(_loc('OK')).click(function(){var $diag=$('#'+diagId);$diag.dialog('close');});$diag.dialog({autoOpen:true,title:_loc('Warning on Database Submissions'),modal:true,width:'auto',close:function(event,ui){var $diag=$('#'+diagId);var $cb=$diag.find('input[type=checkbox]');var disable=false;if($cb.length>0){disable=$cb.is(':checked')};$diag.remove();if(disable){$n2.cookie.setCookie({name:'nunaliit_submissions',value:'do not warn',end:(60*60*24*365),path:'/'});};}});};}});$n2.couchDocument={CouchDataSource:CouchDataSource,CouchDataSourceWithSubmissionDb:CouchDataSourceWithSubmissionDb,adjustDocument:adjustDocument};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str,args){return $n2.loc(str,'nunaliit2-couch',args);};var Attachment=$n2.Class({doc:null,attName:null,mediaRelativePath:null,initialize:function(opts_){var opts=$n2.extend({doc:null,attName:null,mediaRelativePath:null},opts_);this.doc=opts_.doc;this.attName=opts_.attName;this.mediaRelativePath=opts_.mediaRelativePath;},getName:function(){return this.attName;},getStatus:function(){var att=this._getAtt();return att.status;},getMediaFileUrl:function(){var att=this._getAtt();if(att&&att.mediaFile&&this.mediaRelativePath){return this.mediaRelativePath+att.mediaFile;};return null;},getStructure:function(){return this._getAtt();},getThumbnailAttachment:function(){var thumbAtt=null;var att=this._getAtt();if(att){var thumbName=att.thumbnail;if(thumbName){var otherAtt=this._getAtt(thumbName);if(otherAtt){thumbAtt=new Attachment({doc:this.doc,attName:thumbName,mediaRelativePath:this.mediaRelativePath});};};};return thumbAtt;},getOriginalAttachment:function(){var originalAtt=null;var att=this._getAtt();if(att){var originalName=att.originalAttachment;if(originalName){var otherAtt=this._getAtt(originalName);if(otherAtt){originalAtt=new Attachment({doc:this.doc,attName:originalName,mediaRelativePath:this.mediaRelativePath});};};};return originalAtt;},getSourceAttachment:function(){var originalAtt=null;var att=this._getAtt();if(att){var sourceName=att.source;if(sourceName){var otherAtt=this._getAtt(sourceName);if(otherAtt){originalAtt=new Attachment({doc:this.doc,attName:sourceName,mediaRelativePath:this.mediaRelativePath});};};};return originalAtt;},changeStatus:function(status){var att=this._getAtt();if(att){att.status=status;var thumbName=att.thumbnail;if(null!=thumbName){var thumbAtt=this._getAtt(thumbName);if(thumbAtt){thumbAtt.status=status;};};var originalName=att.originalAttachment;if(null!=originalName){var originalAtt=this._getAtt(originalName);if(originalAtt){originalAtt.status=status;};};};},_getAtt:function(name){name=name?name:this.attName;if(this.doc&&this.doc.nunaliit_attachments&&this.doc.nunaliit_attachments.files&&this.doc.nunaliit_attachments.files[name]){return this.doc.nunaliit_attachments.files[name];};return null;}});function getAttachmentFromName(doc,attachmentName,mediaRelativePath){var att=null;if(doc&&doc.nunaliit_attachments&&doc.nunaliit_attachments.files&&doc.nunaliit_attachments.files[attachmentName]){att=new Attachment({doc:doc,attName:attachmentName,mediaRelativePath:mediaRelativePath});};return att;};function getAttachments(doc,mediaRelativePath){var result=[];if(doc&&doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var att=new Attachment({doc:doc,attName:attName,mediaRelativePath:mediaRelativePath});if(att){result.push(att);};};};return result;};var AttachmentService=$n2.Class({mediaRelativePath:null,initialize:function(opts_){var opts=$n2.extend({mediaRelativePath:null},opts_);this.mediaRelativePath=opts.mediaRelativePath;},getAttachments:function(doc){return getAttachments(doc,this.mediaRelativePath);},getAttachment:function(doc,attachmentName){return getAttachmentFromName(doc,attachmentName,this.mediaRelativePath);}});$n2.couchAttachment={AttachmentService:AttachmentService,getAttachments:getAttachments,getAttachmentFromName:getAttachmentFromName};})(jQuery,nunaliit2);